#!/usr/bin/env python
# -*- coding: utf-8 -*- 

#
# Generated  by xsd2parser.py.
#

import sys
import getopt
import re as re_

etree_ = None
Verbose_import_ = False
(   XMLParser_import_none, XMLParser_import_lxml,
    XMLParser_import_elementtree
    ) = range(3)
XMLParser_import_library = None
try:
    # lxml
    from lxml import etree as etree_
    XMLParser_import_library = XMLParser_import_lxml
    if Verbose_import_:
        print("running with lxml.etree")
except ImportError:
    try:
        # cElementTree from Python 2.5+
        import xml.etree.cElementTree as etree_
        XMLParser_import_library = XMLParser_import_elementtree
        if Verbose_import_:
            print("running with cElementTree on Python 2.5+")
    except ImportError:
        try:
            # ElementTree from Python 2.5+
            import xml.etree.ElementTree as etree_
            XMLParser_import_library = XMLParser_import_elementtree
            if Verbose_import_:
                print("running with ElementTree on Python 2.5+")
        except ImportError:
            try:
                # normal cElementTree install
                import cElementTree as etree_
                XMLParser_import_library = XMLParser_import_elementtree
                if Verbose_import_:
                    print("running with cElementTree")
            except ImportError:
                try:
                    # normal ElementTree install
                    import elementtree.ElementTree as etree_
                    XMLParser_import_library = XMLParser_import_elementtree
                    if Verbose_import_:
                        print("running with ElementTree")
                except ImportError:
                    raise ImportError("Failed to import ElementTree from any known place")

def parsexml_(*args, **kwargs):
    if (XMLParser_import_library == XMLParser_import_lxml and
        'parser' not in kwargs):
        # Use the lxml ElementTree compatible parser so that, e.g.,
        #   we ignore comments.
        kwargs['parser'] = etree_.ETCompatXMLParser()
    doc = etree_.parse(*args, **kwargs)
    return doc

#
# User methods
#
# Calls to the methods in these classes are generated by xsd2parser.py.
# You can replace these methods by re-implementing the following class
#   in a module named generatedssuper.py.

try:
    from generatedssuper import GeneratedsSuper
except ImportError, exp:

    class GeneratedsSuper(object):
        def gds_format_string(self, input_data, input_name=''):
            return input_data
        def gds_validate_string(self, input_data, node, input_name=''):
            return input_data
        def gds_format_integer(self, input_data, input_name=''):
            return '%d' % input_data
        def gds_validate_integer(self, input_data, node, input_name=''):
            return input_data
        def gds_format_integer_list(self, input_data, input_name=''):
            return '%s' % input_data
        def gds_validate_integer_list(self, input_data, node, input_name=''):
            values = input_data.split()
            for value in values:
                try:
                    fvalue = float(value)
                except (TypeError, ValueError), exp:
                    raise_parse_error(node, 'Requires sequence of integers')
            return input_data
        def gds_format_float(self, input_data, input_name=''):
            return '%f' % input_data
        def gds_validate_float(self, input_data, node, input_name=''):
            return input_data
        def gds_format_float_list(self, input_data, input_name=''):
            return '%s' % input_data
        def gds_validate_float_list(self, input_data, node, input_name=''):
            values = input_data.split()
            for value in values:
                try:
                    fvalue = float(value)
                except (TypeError, ValueError), exp:
                    raise_parse_error(node, 'Requires sequence of floats')
            return input_data
        def gds_format_double(self, input_data, input_name=''):
            return '%e' % input_data
        def gds_validate_double(self, input_data, node, input_name=''):
            return input_data
        def gds_format_double_list(self, input_data, input_name=''):
            return '%s' % input_data
        def gds_validate_double_list(self, input_data, node, input_name=''):
            values = input_data.split()
            for value in values:
                try:
                    fvalue = float(value)
                except (TypeError, ValueError), exp:
                    raise_parse_error(node, 'Requires sequence of doubles')
            return input_data
        def gds_format_boolean(self, input_data, input_name=''):
            return '%s' % input_data
        def gds_validate_boolean(self, input_data, node, input_name=''):
            return input_data
        def gds_format_boolean_list(self, input_data, input_name=''):
            return '%s' % input_data
        def gds_validate_boolean_list(self, input_data, node, input_name=''):
            values = input_data.split()
            for value in values:
                if value not in ('true', '1', 'false', '0', ):
                    raise_parse_error(node, 'Requires sequence of booleans ("true", "1", "false", "0")')
            return input_data
        def gds_str_lower(self, instring):
            return instring.lower()
        def get_path_(self, node):
            path_list = []
            self.get_path_list_(node, path_list)
            path_list.reverse()
            path = '/'.join(path_list)
            return path
        Tag_strip_pattern_ = re_.compile(r'\{.*\}')
        def get_path_list_(self, node, path_list):
            if node is None:
                return
            tag = GeneratedsSuper.Tag_strip_pattern_.sub('', node.tag)
            if tag:
                path_list.append(tag)
            self.get_path_list_(node.getparent(), path_list)
        def get_class_obj_(self, node, default_class=None):
            class_obj1 = default_class
            if 'xsi' in node.nsmap:
                classname = node.get('{%s}type' % node.nsmap['xsi'])
                if classname is not None:
                    names = classname.split(':')
                    if len(names) == 2:
                        classname = names[1]
                    class_obj2 = globals().get(classname)
                    if class_obj2 is not None:
                        class_obj1 = class_obj2
            return class_obj1
        def gds_build_any(self, node, type_name=None):
            return None


#
# If you have installed IPython you can uncomment and use the following.
# IPython is available from http://ipython.scipy.org/.
#

## from IPython.Shell import IPShellEmbed
## args = ''
## ipshell = IPShellEmbed(args,
##     banner = 'Dropping into IPython',
##     exit_msg = 'Leaving Interpreter, back to program.')

# Then use the following line where and when you want to drop into the
# IPython shell:
#    ipshell('<some message> -- Entering ipshell.\nHit Ctrl-D to exit')

#
# Globals
#

ExternalEncoding = 'utf-8'
Tag_pattern_ = re_.compile(r'({.*})?(.*)')
String_cleanup_pat_ = re_.compile(r"[\n\r\s]+")
Namespace_extract_pat_ = re_.compile(r'{(.*)}(.*)')

#
# Support/utility functions.
#

def showIndent(outfile, level):
    for idx in range(level):
        outfile.write('    ')

def quote_xml(inStr):
    if not inStr:
        return ''
    s1 = (isinstance(inStr, basestring) and inStr or
          '%s' % inStr)
    s1 = s1.replace('&', '&amp;')
    s1 = s1.replace('<', '&lt;')
    s1 = s1.replace('>', '&gt;')
    return s1

def quote_attrib(inStr):
    s1 = (isinstance(inStr, basestring) and inStr or
          '%s' % inStr)
    s1 = s1.replace('&', '&amp;')
    s1 = s1.replace('<', '&lt;')
    s1 = s1.replace('>', '&gt;')
    if '"' in s1:
        if "'" in s1:
            s1 = '"%s"' % s1.replace('"', "&quot;")
        else:
            s1 = "'%s'" % s1
    else:
        s1 = '"%s"' % s1
    return s1

def quote_python(inStr):
    s1 = inStr
    if s1.find("'") == -1:
        if s1.find('\n') == -1:
            return "'%s'" % s1
        else:
            return "'''%s'''" % s1
    else:
        if s1.find('"') != -1:
            s1 = s1.replace('"', '\\"')
        if s1.find('\n') == -1:
            return '"%s"' % s1
        else:
            return '"""%s"""' % s1

def get_all_text_(node):
    if node.text is not None:
        text = node.text
    else:
        text = ''
    for child in node:
        if child.tail is not None:
            text += child.tail
    return text

def find_attr_value_(attr_name, node):
    attrs = node.attrib
    attr_parts = attr_name.split(':')
    value = None
    if len(attr_parts) == 1:
        value = attrs.get(attr_name)
    elif len(attr_parts) == 2:
        prefix, name = attr_parts
        namespace = node.nsmap.get(prefix)
        if namespace is not None:
            value = attrs.get('{%s}%s' % (namespace, name, ))
    return value

def build_object(node, name):
    type_name_ = node.attrib.get('{http://www.w3.org/2001/XMLSchema-instance}type')
    if type_name_ is None:
       type_name_ = node.attrib.get('type')
    if type_name_ is not None:
       type_names_ = type_name_.split(':')
       if len(type_names_) == 1:
          type_name_ = type_names_[0]
       else:
          type_name_ = type_names_[1]
    else:
       type_name_ = name

    if type_name_ not in globals():
       type_name_ = name

    class_ = globals()[type_name_]
    obj_ = class_.factory()
    obj_.build(node)

    return obj_


class GDSParseError(Exception):
    pass

def raise_parse_error(node, msg):
    if XMLParser_import_library == XMLParser_import_lxml:
        msg = '%s (element %s/line %d)' % (msg, node.tag, node.sourceline, )
    else:
        msg = '%s (element %s)' % (msg, node.tag, )
    raise GDSParseError(msg)


class MixedContainer:
    # Constants for category:
    CategoryNone = 0
    CategoryText = 1
    CategorySimple = 2
    CategoryComplex = 3
    # Constants for content_type:
    TypeNone = 0
    TypeText = 1
    TypeString = 2
    TypeInteger = 3
    TypeFloat = 4
    TypeDecimal = 5
    TypeDouble = 6
    TypeBoolean = 7
    def __init__(self, category, content_type, name, value):
        self.category = category
        self.content_type = content_type
        self.name = name
        self.value = value
    def getCategory(self):
        return self.category
    def getContenttype(self, content_type):
        return self.content_type
    def getValue(self):
        return self.value
    def getName(self):
        return self.name
    def export(self, outfile, level, name, namespace):
        if self.category == MixedContainer.CategoryText:
            # Prevent exporting empty content as empty lines.
            if self.value.strip(): 
                outfile.write(self.value)
        elif self.category == MixedContainer.CategorySimple:
            self.exportSimple(outfile, level, name)
        else:    # category == MixedContainer.CategoryComplex
            self.value.export(outfile, level, namespace,name)
    def exportSimple(self, outfile, level, name):
        if self.content_type == MixedContainer.TypeString:
            outfile.write('<%s>%s</%s>' % (self.name, self.value, self.name))
        elif self.content_type == MixedContainer.TypeInteger or \
                self.content_type == MixedContainer.TypeBoolean:
            outfile.write('<%s>%d</%s>' % (self.name, self.value, self.name))
        elif self.content_type == MixedContainer.TypeFloat or \
                self.content_type == MixedContainer.TypeDecimal:
            outfile.write('<%s>%f</%s>' % (self.name, self.value, self.name))
        elif self.content_type == MixedContainer.TypeDouble:
            outfile.write('<%s>%g</%s>' % (self.name, self.value, self.name))
    def exportLiteral(self, outfile, level, name):
        if self.category == MixedContainer.CategoryText:
            showIndent(outfile, level)
            outfile.write('model_.MixedContainer(%d, %d, "%s", "%s"),\n' % \
                (self.category, self.content_type, self.name, self.value))
        elif self.category == MixedContainer.CategorySimple:
            showIndent(outfile, level)
            outfile.write('model_.MixedContainer(%d, %d, "%s", "%s"),\n' % \
                (self.category, self.content_type, self.name, self.value))
        else:    # category == MixedContainer.CategoryComplex
            showIndent(outfile, level)
            outfile.write('model_.MixedContainer(%d, %d, "%s",\n' % \
                (self.category, self.content_type, self.name,))
            self.value.exportLiteral(outfile, level + 1)
            showIndent(outfile, level)
            outfile.write(')\n')


class MemberSpec_(object):
    def __init__(self, name='', data_type='', container=0, attribute=0, prohibited=0):
        self.name = name
        self.data_type = data_type
        self.container = container
        self.attribute = attribute
        self.prohibited = prohibited
    def set_name(self, name): self.name = name
    def get_name(self): return self.name
    def set_data_type(self, data_type): self.data_type = data_type
    def get_data_type_chain(self): return self.data_type
    def get_data_type(self):
        if isinstance(self.data_type, list):
            if len(self.data_type) > 0:
                return self.data_type[-1]
            else:
                return 'xs:string'
        else:
            return self.data_type
    def set_container(self, container): self.container = container
    def get_container(self): return self.container
    def set_attribute(self, attribute): self.attribute = attribute
    def get_attribute(self): return self.attribute
    def set_prohibited(self, prohibited): self.prohibited = prohibited
    def get_prohibited(self): return self.prohibited

def _cast(typ, value):
    if typ is None or value is None:
        return value
    return typ(value)

#
# Data representation classes.
#

class TZDU_MT000003UV_CareGiver(GeneratedsSuper):
    member_data_items_ = [
        MemberSpec_('nullFlavor', 'NullFlavor', 0, 1, 0),
        MemberSpec_('classCode', 'RoleClassCaregiver', 0, 1, 0),
        MemberSpec_('realmCode', 'CS', 1, 0, 0),
        MemberSpec_('typeId', 'II', 0, 0, 0),
        MemberSpec_('templateId', 'II', 1, 0, 0),
        MemberSpec_('id', 'II', 1, 0, 0),
        MemberSpec_('code', 'CE', 0, 0, 0),
        MemberSpec_('effectiveTime', 'SXCM_TS', 1, 0, 0),
        MemberSpec_('careGiverScoper', 'TZDU_MT000003UV.CareProvider', 0, 0, 0),
        ]
    subclass = None
    superclass = None
    def __init__(self, nullFlavor=None, classCode=None, realmCode=None, typeId=None, templateId=None, id=None, code=None, effectiveTime=None, careGiverScoper=None):
        self.nullFlavor = _cast(None, nullFlavor)
        self.classCode = _cast(None, classCode)
        if realmCode is None:
            self.realmCode = []
        else:
            self.realmCode = realmCode
        self.typeId = typeId
        if templateId is None:
            self.templateId = []
        else:
            self.templateId = templateId
        if id is None:
            self.id = []
        else:
            self.id = id
        self.code = code
        if effectiveTime is None:
            self.effectiveTime = []
        else:
            self.effectiveTime = effectiveTime
        self.careGiverScoper = careGiverScoper
    def factory(*args_, **kwargs_):
        if TZDU_MT000003UV_CareGiver.subclass:
            return TZDU_MT000003UV_CareGiver.subclass(*args_, **kwargs_)
        else:
            return TZDU_MT000003UV_CareGiver(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_realmCode(self): return self.realmCode
    def set_realmCode(self, realmCode): self.realmCode = realmCode
    def add_realmCode(self, value): self.realmCode.append(value)
    def insert_realmCode(self, index, value): self.realmCode[index] = value
    realmCodeProp = property(get_realmCode, set_realmCode)
    def get_typeId(self): return self.typeId
    def set_typeId(self, typeId): self.typeId = typeId
    typeIdProp = property(get_typeId, set_typeId)
    def get_templateId(self): return self.templateId
    def set_templateId(self, templateId): self.templateId = templateId
    def add_templateId(self, value): self.templateId.append(value)
    def insert_templateId(self, index, value): self.templateId[index] = value
    templateIdProp = property(get_templateId, set_templateId)
    def get_id(self): return self.id
    def set_id(self, id): self.id = id
    def add_id(self, value): self.id.append(value)
    def insert_id(self, index, value): self.id[index] = value
    idProp = property(get_id, set_id)
    def get_code(self): return self.code
    def set_code(self, code): self.code = code
    codeProp = property(get_code, set_code)
    def get_effectiveTime(self): return self.effectiveTime
    def set_effectiveTime(self, effectiveTime): self.effectiveTime = effectiveTime
    def add_effectiveTime(self, value): self.effectiveTime.append(value)
    def insert_effectiveTime(self, index, value): self.effectiveTime[index] = value
    effectiveTimeProp = property(get_effectiveTime, set_effectiveTime)
    def get_careGiverScoper(self): return self.careGiverScoper
    def set_careGiverScoper(self, careGiverScoper): self.careGiverScoper = careGiverScoper
    careGiverScoperProp = property(get_careGiverScoper, set_careGiverScoper)
    def get_nullFlavor(self): return self.nullFlavor
    def set_nullFlavor(self, nullFlavor): self.nullFlavor = nullFlavor
    nullFlavorProp = property(get_nullFlavor, set_nullFlavor)
    def validate_NullFlavor(self, value):
        # Validate type NullFlavor, a restriction on cs.
        pass
    def get_classCode(self): return self.classCode
    def set_classCode(self, classCode): self.classCode = classCode
    classCodeProp = property(get_classCode, set_classCode)
    def validate_RoleClassCaregiver(self, value):
        # Validate type RoleClassCaregiver, a restriction on cs.
        pass
    def export(self, outfile, level, namespace_='', name_='TZDU_MT000003UV.CareGiver', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='TZDU_MT000003UV.CareGiver')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='TZDU_MT000003UV.CareGiver'):
        if self.nullFlavor is not None and 'nullFlavor' not in already_processed:
            already_processed.append('nullFlavor')
            outfile.write(' nullFlavor=%s' % (quote_attrib(self.nullFlavor), ))
        if self.classCode is not None and 'classCode' not in already_processed:
            already_processed.append('classCode')
            outfile.write(' classCode=%s' % (quote_attrib(self.classCode), ))
    def exportChildren(self, outfile, level, namespace_='', name_='TZDU_MT000003UV.CareGiver', fromsubclass_=False):
        for realmCode_ in self.realmCode:
            realmCode_.export(outfile, level, namespace_, name_='realmCode')
        if self.typeId is not None:
            self.typeId.export(outfile, level, namespace_, name_='typeId')
        for templateId_ in self.templateId:
            templateId_.export(outfile, level, namespace_, name_='templateId')
        for id_ in self.id:
            id_.export(outfile, level, namespace_, name_='id')
        if self.code is not None:
            self.code.export(outfile, level, namespace_, name_='code')
        for effectiveTime_ in self.effectiveTime:
            effectiveTime_.export(outfile, level, namespace_, name_='effectiveTime')
        if self.careGiverScoper is not None:
            self.careGiverScoper.export(outfile, level, namespace_, name_='careGiverScoper')
    def hasContent_(self):
        if (
            self.realmCode or
            self.typeId is not None or
            self.templateId or
            self.id or
            self.code is not None or
            self.effectiveTime or
            self.careGiverScoper is not None
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('nullFlavor', node)
        if value is not None and 'nullFlavor' not in already_processed:
            already_processed.append('nullFlavor')
            self.nullFlavor = value
            self.validate_NullFlavor(self.nullFlavor)    # validate type NullFlavor
        value = find_attr_value_('classCode', node)
        if value is not None and 'classCode' not in already_processed:
            already_processed.append('classCode')
            self.classCode = value
            self.validate_RoleClassCaregiver(self.classCode)    # validate type RoleClassCaregiver
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'realmCode':
            obj_ = build_object(child_, 'CS')
            self.realmCode.append(obj_)
        elif nodeName_ == 'typeId':
            obj_ = build_object(child_, 'II')
            self.set_typeId(obj_)
        elif nodeName_ == 'templateId':
            obj_ = build_object(child_, 'II')
            self.templateId.append(obj_)
        elif nodeName_ == 'id':
            obj_ = build_object(child_, 'II')
            self.id.append(obj_)
        elif nodeName_ == 'code':
            obj_ = build_object(child_, 'CE')
            self.set_code(obj_)
        elif nodeName_ == 'effectiveTime':
            obj_ = build_object(child_, 'SXCM_TS')
            self.effectiveTime.append(obj_)
        elif nodeName_ == 'careGiverScoper':
            obj_ = build_object(child_, 'TZDU_MT000003UV_CareProvider')
            self.set_careGiverScoper(obj_)
# end class TZDU_MT000003UV_CareGiver


class TZDU_MT000003UV_CareProvider(GeneratedsSuper):
    member_data_items_ = [
        MemberSpec_('nullFlavor', 'NullFlavor', 0, 1, 0),
        MemberSpec_('determinerCode', 'EntityDeterminerSpecific', 0, 1, 0),
        MemberSpec_('classCode', 'EntityClassPerson', 0, 1, 0),
        MemberSpec_('realmCode', 'CS', 1, 0, 0),
        MemberSpec_('typeId', 'II', 0, 0, 0),
        MemberSpec_('templateId', 'II', 1, 0, 0),
        MemberSpec_('id', 'II', 1, 0, 0),
        ]
    subclass = None
    superclass = None
    def __init__(self, nullFlavor=None, determinerCode=None, classCode=None, realmCode=None, typeId=None, templateId=None, id=None):
        self.nullFlavor = _cast(None, nullFlavor)
        self.determinerCode = _cast(None, determinerCode)
        self.classCode = _cast(None, classCode)
        if realmCode is None:
            self.realmCode = []
        else:
            self.realmCode = realmCode
        self.typeId = typeId
        if templateId is None:
            self.templateId = []
        else:
            self.templateId = templateId
        if id is None:
            self.id = []
        else:
            self.id = id
    def factory(*args_, **kwargs_):
        if TZDU_MT000003UV_CareProvider.subclass:
            return TZDU_MT000003UV_CareProvider.subclass(*args_, **kwargs_)
        else:
            return TZDU_MT000003UV_CareProvider(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_realmCode(self): return self.realmCode
    def set_realmCode(self, realmCode): self.realmCode = realmCode
    def add_realmCode(self, value): self.realmCode.append(value)
    def insert_realmCode(self, index, value): self.realmCode[index] = value
    realmCodeProp = property(get_realmCode, set_realmCode)
    def get_typeId(self): return self.typeId
    def set_typeId(self, typeId): self.typeId = typeId
    typeIdProp = property(get_typeId, set_typeId)
    def get_templateId(self): return self.templateId
    def set_templateId(self, templateId): self.templateId = templateId
    def add_templateId(self, value): self.templateId.append(value)
    def insert_templateId(self, index, value): self.templateId[index] = value
    templateIdProp = property(get_templateId, set_templateId)
    def get_id(self): return self.id
    def set_id(self, id): self.id = id
    def add_id(self, value): self.id.append(value)
    def insert_id(self, index, value): self.id[index] = value
    idProp = property(get_id, set_id)
    def get_nullFlavor(self): return self.nullFlavor
    def set_nullFlavor(self, nullFlavor): self.nullFlavor = nullFlavor
    nullFlavorProp = property(get_nullFlavor, set_nullFlavor)
    def validate_NullFlavor(self, value):
        # Validate type NullFlavor, a restriction on cs.
        pass
    def get_determinerCode(self): return self.determinerCode
    def set_determinerCode(self, determinerCode): self.determinerCode = determinerCode
    determinerCodeProp = property(get_determinerCode, set_determinerCode)
    def validate_EntityDeterminerSpecific(self, value):
        # Validate type EntityDeterminerSpecific, a restriction on cs.
        pass
    def get_classCode(self): return self.classCode
    def set_classCode(self, classCode): self.classCode = classCode
    classCodeProp = property(get_classCode, set_classCode)
    def validate_EntityClassPerson(self, value):
        # Validate type EntityClassPerson, a restriction on cs.
        pass
    def export(self, outfile, level, namespace_='', name_='TZDU_MT000003UV.CareProvider', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='TZDU_MT000003UV.CareProvider')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='TZDU_MT000003UV.CareProvider'):
        if self.nullFlavor is not None and 'nullFlavor' not in already_processed:
            already_processed.append('nullFlavor')
            outfile.write(' nullFlavor=%s' % (quote_attrib(self.nullFlavor), ))
        if self.determinerCode is not None and 'determinerCode' not in already_processed:
            already_processed.append('determinerCode')
            outfile.write(' determinerCode=%s' % (quote_attrib(self.determinerCode), ))
        if self.classCode is not None and 'classCode' not in already_processed:
            already_processed.append('classCode')
            outfile.write(' classCode=%s' % (quote_attrib(self.classCode), ))
    def exportChildren(self, outfile, level, namespace_='', name_='TZDU_MT000003UV.CareProvider', fromsubclass_=False):
        for realmCode_ in self.realmCode:
            realmCode_.export(outfile, level, namespace_, name_='realmCode')
        if self.typeId is not None:
            self.typeId.export(outfile, level, namespace_, name_='typeId')
        for templateId_ in self.templateId:
            templateId_.export(outfile, level, namespace_, name_='templateId')
        for id_ in self.id:
            id_.export(outfile, level, namespace_, name_='id')
    def hasContent_(self):
        if (
            self.realmCode or
            self.typeId is not None or
            self.templateId or
            self.id
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('nullFlavor', node)
        if value is not None and 'nullFlavor' not in already_processed:
            already_processed.append('nullFlavor')
            self.nullFlavor = value
            self.validate_NullFlavor(self.nullFlavor)    # validate type NullFlavor
        value = find_attr_value_('determinerCode', node)
        if value is not None and 'determinerCode' not in already_processed:
            already_processed.append('determinerCode')
            self.determinerCode = value
            self.validate_EntityDeterminerSpecific(self.determinerCode)    # validate type EntityDeterminerSpecific
        value = find_attr_value_('classCode', node)
        if value is not None and 'classCode' not in already_processed:
            already_processed.append('classCode')
            self.classCode = value
            self.validate_EntityClassPerson(self.classCode)    # validate type EntityClassPerson
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'realmCode':
            obj_ = build_object(child_, 'CS')
            self.realmCode.append(obj_)
        elif nodeName_ == 'typeId':
            obj_ = build_object(child_, 'II')
            self.set_typeId(obj_)
        elif nodeName_ == 'templateId':
            obj_ = build_object(child_, 'II')
            self.templateId.append(obj_)
        elif nodeName_ == 'id':
            obj_ = build_object(child_, 'II')
            self.id.append(obj_)
# end class TZDU_MT000003UV_CareProvider


class TZDU_MT000003UV_Insurer(GeneratedsSuper):
    member_data_items_ = [
        MemberSpec_('nullFlavor', 'NullFlavor', 0, 1, 0),
        MemberSpec_('determinerCode', 'EntityDeterminerSpecific', 0, 1, 0),
        MemberSpec_('classCode', 'EntityClassOrganization', 0, 1, 0),
        MemberSpec_('realmCode', 'CS', 1, 0, 0),
        MemberSpec_('typeId', 'II', 0, 0, 0),
        MemberSpec_('templateId', 'II', 1, 0, 0),
        MemberSpec_('id', 'II', 1, 0, 0),
        ]
    subclass = None
    superclass = None
    def __init__(self, nullFlavor=None, determinerCode=None, classCode=None, realmCode=None, typeId=None, templateId=None, id=None):
        self.nullFlavor = _cast(None, nullFlavor)
        self.determinerCode = _cast(None, determinerCode)
        self.classCode = _cast(None, classCode)
        if realmCode is None:
            self.realmCode = []
        else:
            self.realmCode = realmCode
        self.typeId = typeId
        if templateId is None:
            self.templateId = []
        else:
            self.templateId = templateId
        if id is None:
            self.id = []
        else:
            self.id = id
    def factory(*args_, **kwargs_):
        if TZDU_MT000003UV_Insurer.subclass:
            return TZDU_MT000003UV_Insurer.subclass(*args_, **kwargs_)
        else:
            return TZDU_MT000003UV_Insurer(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_realmCode(self): return self.realmCode
    def set_realmCode(self, realmCode): self.realmCode = realmCode
    def add_realmCode(self, value): self.realmCode.append(value)
    def insert_realmCode(self, index, value): self.realmCode[index] = value
    realmCodeProp = property(get_realmCode, set_realmCode)
    def get_typeId(self): return self.typeId
    def set_typeId(self, typeId): self.typeId = typeId
    typeIdProp = property(get_typeId, set_typeId)
    def get_templateId(self): return self.templateId
    def set_templateId(self, templateId): self.templateId = templateId
    def add_templateId(self, value): self.templateId.append(value)
    def insert_templateId(self, index, value): self.templateId[index] = value
    templateIdProp = property(get_templateId, set_templateId)
    def get_id(self): return self.id
    def set_id(self, id): self.id = id
    def add_id(self, value): self.id.append(value)
    def insert_id(self, index, value): self.id[index] = value
    idProp = property(get_id, set_id)
    def get_nullFlavor(self): return self.nullFlavor
    def set_nullFlavor(self, nullFlavor): self.nullFlavor = nullFlavor
    nullFlavorProp = property(get_nullFlavor, set_nullFlavor)
    def validate_NullFlavor(self, value):
        # Validate type NullFlavor, a restriction on cs.
        pass
    def get_determinerCode(self): return self.determinerCode
    def set_determinerCode(self, determinerCode): self.determinerCode = determinerCode
    determinerCodeProp = property(get_determinerCode, set_determinerCode)
    def validate_EntityDeterminerSpecific(self, value):
        # Validate type EntityDeterminerSpecific, a restriction on cs.
        pass
    def get_classCode(self): return self.classCode
    def set_classCode(self, classCode): self.classCode = classCode
    classCodeProp = property(get_classCode, set_classCode)
    def validate_EntityClassOrganization(self, value):
        # Validate type EntityClassOrganization, a restriction on cs.
        pass
    def export(self, outfile, level, namespace_='', name_='TZDU_MT000003UV.Insurer', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='TZDU_MT000003UV.Insurer')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='TZDU_MT000003UV.Insurer'):
        if self.nullFlavor is not None and 'nullFlavor' not in already_processed:
            already_processed.append('nullFlavor')
            outfile.write(' nullFlavor=%s' % (quote_attrib(self.nullFlavor), ))
        if self.determinerCode is not None and 'determinerCode' not in already_processed:
            already_processed.append('determinerCode')
            outfile.write(' determinerCode=%s' % (quote_attrib(self.determinerCode), ))
        if self.classCode is not None and 'classCode' not in already_processed:
            already_processed.append('classCode')
            outfile.write(' classCode=%s' % (quote_attrib(self.classCode), ))
    def exportChildren(self, outfile, level, namespace_='', name_='TZDU_MT000003UV.Insurer', fromsubclass_=False):
        for realmCode_ in self.realmCode:
            realmCode_.export(outfile, level, namespace_, name_='realmCode')
        if self.typeId is not None:
            self.typeId.export(outfile, level, namespace_, name_='typeId')
        for templateId_ in self.templateId:
            templateId_.export(outfile, level, namespace_, name_='templateId')
        for id_ in self.id:
            id_.export(outfile, level, namespace_, name_='id')
    def hasContent_(self):
        if (
            self.realmCode or
            self.typeId is not None or
            self.templateId or
            self.id
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('nullFlavor', node)
        if value is not None and 'nullFlavor' not in already_processed:
            already_processed.append('nullFlavor')
            self.nullFlavor = value
            self.validate_NullFlavor(self.nullFlavor)    # validate type NullFlavor
        value = find_attr_value_('determinerCode', node)
        if value is not None and 'determinerCode' not in already_processed:
            already_processed.append('determinerCode')
            self.determinerCode = value
            self.validate_EntityDeterminerSpecific(self.determinerCode)    # validate type EntityDeterminerSpecific
        value = find_attr_value_('classCode', node)
        if value is not None and 'classCode' not in already_processed:
            already_processed.append('classCode')
            self.classCode = value
            self.validate_EntityClassOrganization(self.classCode)    # validate type EntityClassOrganization
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'realmCode':
            obj_ = build_object(child_, 'CS')
            self.realmCode.append(obj_)
        elif nodeName_ == 'typeId':
            obj_ = build_object(child_, 'II')
            self.set_typeId(obj_)
        elif nodeName_ == 'templateId':
            obj_ = build_object(child_, 'II')
            self.templateId.append(obj_)
        elif nodeName_ == 'id':
            obj_ = build_object(child_, 'II')
            self.id.append(obj_)
# end class TZDU_MT000003UV_Insurer


class TZDU_MT000003UV_Organization(GeneratedsSuper):
    member_data_items_ = [
        MemberSpec_('nullFlavor', 'NullFlavor', 0, 1, 0),
        MemberSpec_('determinerCode', 'EntityDeterminerSpecific', 0, 1, 0),
        MemberSpec_('classCode', 'EntityClassOrganization', 0, 1, 0),
        MemberSpec_('realmCode', 'CS', 1, 0, 0),
        MemberSpec_('typeId', 'II', 0, 0, 0),
        MemberSpec_('templateId', 'II', 1, 0, 0),
        MemberSpec_('id', 'II', 1, 0, 0),
        ]
    subclass = None
    superclass = None
    def __init__(self, nullFlavor=None, determinerCode=None, classCode=None, realmCode=None, typeId=None, templateId=None, id=None):
        self.nullFlavor = _cast(None, nullFlavor)
        self.determinerCode = _cast(None, determinerCode)
        self.classCode = _cast(None, classCode)
        if realmCode is None:
            self.realmCode = []
        else:
            self.realmCode = realmCode
        self.typeId = typeId
        if templateId is None:
            self.templateId = []
        else:
            self.templateId = templateId
        if id is None:
            self.id = []
        else:
            self.id = id
    def factory(*args_, **kwargs_):
        if TZDU_MT000003UV_Organization.subclass:
            return TZDU_MT000003UV_Organization.subclass(*args_, **kwargs_)
        else:
            return TZDU_MT000003UV_Organization(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_realmCode(self): return self.realmCode
    def set_realmCode(self, realmCode): self.realmCode = realmCode
    def add_realmCode(self, value): self.realmCode.append(value)
    def insert_realmCode(self, index, value): self.realmCode[index] = value
    realmCodeProp = property(get_realmCode, set_realmCode)
    def get_typeId(self): return self.typeId
    def set_typeId(self, typeId): self.typeId = typeId
    typeIdProp = property(get_typeId, set_typeId)
    def get_templateId(self): return self.templateId
    def set_templateId(self, templateId): self.templateId = templateId
    def add_templateId(self, value): self.templateId.append(value)
    def insert_templateId(self, index, value): self.templateId[index] = value
    templateIdProp = property(get_templateId, set_templateId)
    def get_id(self): return self.id
    def set_id(self, id): self.id = id
    def add_id(self, value): self.id.append(value)
    def insert_id(self, index, value): self.id[index] = value
    idProp = property(get_id, set_id)
    def get_nullFlavor(self): return self.nullFlavor
    def set_nullFlavor(self, nullFlavor): self.nullFlavor = nullFlavor
    nullFlavorProp = property(get_nullFlavor, set_nullFlavor)
    def validate_NullFlavor(self, value):
        # Validate type NullFlavor, a restriction on cs.
        pass
    def get_determinerCode(self): return self.determinerCode
    def set_determinerCode(self, determinerCode): self.determinerCode = determinerCode
    determinerCodeProp = property(get_determinerCode, set_determinerCode)
    def validate_EntityDeterminerSpecific(self, value):
        # Validate type EntityDeterminerSpecific, a restriction on cs.
        pass
    def get_classCode(self): return self.classCode
    def set_classCode(self, classCode): self.classCode = classCode
    classCodeProp = property(get_classCode, set_classCode)
    def validate_EntityClassOrganization(self, value):
        # Validate type EntityClassOrganization, a restriction on cs.
        pass
    def export(self, outfile, level, namespace_='', name_='TZDU_MT000003UV.Organization', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='TZDU_MT000003UV.Organization')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='TZDU_MT000003UV.Organization'):
        if self.nullFlavor is not None and 'nullFlavor' not in already_processed:
            already_processed.append('nullFlavor')
            outfile.write(' nullFlavor=%s' % (quote_attrib(self.nullFlavor), ))
        if self.determinerCode is not None and 'determinerCode' not in already_processed:
            already_processed.append('determinerCode')
            outfile.write(' determinerCode=%s' % (quote_attrib(self.determinerCode), ))
        if self.classCode is not None and 'classCode' not in already_processed:
            already_processed.append('classCode')
            outfile.write(' classCode=%s' % (quote_attrib(self.classCode), ))
    def exportChildren(self, outfile, level, namespace_='', name_='TZDU_MT000003UV.Organization', fromsubclass_=False):
        for realmCode_ in self.realmCode:
            realmCode_.export(outfile, level, namespace_, name_='realmCode')
        if self.typeId is not None:
            self.typeId.export(outfile, level, namespace_, name_='typeId')
        for templateId_ in self.templateId:
            templateId_.export(outfile, level, namespace_, name_='templateId')
        for id_ in self.id:
            id_.export(outfile, level, namespace_, name_='id')
    def hasContent_(self):
        if (
            self.realmCode or
            self.typeId is not None or
            self.templateId or
            self.id
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('nullFlavor', node)
        if value is not None and 'nullFlavor' not in already_processed:
            already_processed.append('nullFlavor')
            self.nullFlavor = value
            self.validate_NullFlavor(self.nullFlavor)    # validate type NullFlavor
        value = find_attr_value_('determinerCode', node)
        if value is not None and 'determinerCode' not in already_processed:
            already_processed.append('determinerCode')
            self.determinerCode = value
            self.validate_EntityDeterminerSpecific(self.determinerCode)    # validate type EntityDeterminerSpecific
        value = find_attr_value_('classCode', node)
        if value is not None and 'classCode' not in already_processed:
            already_processed.append('classCode')
            self.classCode = value
            self.validate_EntityClassOrganization(self.classCode)    # validate type EntityClassOrganization
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'realmCode':
            obj_ = build_object(child_, 'CS')
            self.realmCode.append(obj_)
        elif nodeName_ == 'typeId':
            obj_ = build_object(child_, 'II')
            self.set_typeId(obj_)
        elif nodeName_ == 'templateId':
            obj_ = build_object(child_, 'II')
            self.templateId.append(obj_)
        elif nodeName_ == 'id':
            obj_ = build_object(child_, 'II')
            self.id.append(obj_)
# end class TZDU_MT000003UV_Organization


class TZDU_MT000003UV_Patient(GeneratedsSuper):
    member_data_items_ = [
        MemberSpec_('nullFlavor', 'NullFlavor', 0, 1, 0),
        MemberSpec_('classCode', 'RoleClassPatient', 0, 1, 0),
        MemberSpec_('realmCode', 'CS', 1, 0, 0),
        MemberSpec_('typeId', 'II', 0, 0, 0),
        MemberSpec_('templateId', 'II', 1, 0, 0),
        MemberSpec_('id', 'II', 1, 0, 0),
        MemberSpec_('effectiveTime', 'SXCM_TS', 1, 0, 0),
        MemberSpec_('patientPerson', 'TZDU_MT000003UV.Person', 0, 0, 0),
        MemberSpec_('providerOrganization', 'TZDU_MT000003UV.Organization', 0, 0, 0),
        ]
    subclass = None
    superclass = None
    def __init__(self, nullFlavor=None, classCode=None, realmCode=None, typeId=None, templateId=None, id=None, effectiveTime=None, patientPerson=None, providerOrganization=None):
        self.nullFlavor = _cast(None, nullFlavor)
        self.classCode = _cast(None, classCode)
        if realmCode is None:
            self.realmCode = []
        else:
            self.realmCode = realmCode
        self.typeId = typeId
        if templateId is None:
            self.templateId = []
        else:
            self.templateId = templateId
        if id is None:
            self.id = []
        else:
            self.id = id
        if effectiveTime is None:
            self.effectiveTime = []
        else:
            self.effectiveTime = effectiveTime
        self.patientPerson = patientPerson
        self.providerOrganization = providerOrganization
    def factory(*args_, **kwargs_):
        if TZDU_MT000003UV_Patient.subclass:
            return TZDU_MT000003UV_Patient.subclass(*args_, **kwargs_)
        else:
            return TZDU_MT000003UV_Patient(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_realmCode(self): return self.realmCode
    def set_realmCode(self, realmCode): self.realmCode = realmCode
    def add_realmCode(self, value): self.realmCode.append(value)
    def insert_realmCode(self, index, value): self.realmCode[index] = value
    realmCodeProp = property(get_realmCode, set_realmCode)
    def get_typeId(self): return self.typeId
    def set_typeId(self, typeId): self.typeId = typeId
    typeIdProp = property(get_typeId, set_typeId)
    def get_templateId(self): return self.templateId
    def set_templateId(self, templateId): self.templateId = templateId
    def add_templateId(self, value): self.templateId.append(value)
    def insert_templateId(self, index, value): self.templateId[index] = value
    templateIdProp = property(get_templateId, set_templateId)
    def get_id(self): return self.id
    def set_id(self, id): self.id = id
    def add_id(self, value): self.id.append(value)
    def insert_id(self, index, value): self.id[index] = value
    idProp = property(get_id, set_id)
    def get_effectiveTime(self): return self.effectiveTime
    def set_effectiveTime(self, effectiveTime): self.effectiveTime = effectiveTime
    def add_effectiveTime(self, value): self.effectiveTime.append(value)
    def insert_effectiveTime(self, index, value): self.effectiveTime[index] = value
    effectiveTimeProp = property(get_effectiveTime, set_effectiveTime)
    def get_patientPerson(self): return self.patientPerson
    def set_patientPerson(self, patientPerson): self.patientPerson = patientPerson
    patientPersonProp = property(get_patientPerson, set_patientPerson)
    def get_providerOrganization(self): return self.providerOrganization
    def set_providerOrganization(self, providerOrganization): self.providerOrganization = providerOrganization
    providerOrganizationProp = property(get_providerOrganization, set_providerOrganization)
    def get_nullFlavor(self): return self.nullFlavor
    def set_nullFlavor(self, nullFlavor): self.nullFlavor = nullFlavor
    nullFlavorProp = property(get_nullFlavor, set_nullFlavor)
    def validate_NullFlavor(self, value):
        # Validate type NullFlavor, a restriction on cs.
        pass
    def get_classCode(self): return self.classCode
    def set_classCode(self, classCode): self.classCode = classCode
    classCodeProp = property(get_classCode, set_classCode)
    def validate_RoleClassPatient(self, value):
        # Validate type RoleClassPatient, a restriction on cs.
        pass
    def export(self, outfile, level, namespace_='', name_='TZDU_MT000003UV.Patient', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='TZDU_MT000003UV.Patient')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='TZDU_MT000003UV.Patient'):
        if self.nullFlavor is not None and 'nullFlavor' not in already_processed:
            already_processed.append('nullFlavor')
            outfile.write(' nullFlavor=%s' % (quote_attrib(self.nullFlavor), ))
        if self.classCode is not None and 'classCode' not in already_processed:
            already_processed.append('classCode')
            outfile.write(' classCode=%s' % (quote_attrib(self.classCode), ))
    def exportChildren(self, outfile, level, namespace_='', name_='TZDU_MT000003UV.Patient', fromsubclass_=False):
        for realmCode_ in self.realmCode:
            realmCode_.export(outfile, level, namespace_, name_='realmCode')
        if self.typeId is not None:
            self.typeId.export(outfile, level, namespace_, name_='typeId')
        for templateId_ in self.templateId:
            templateId_.export(outfile, level, namespace_, name_='templateId')
        for id_ in self.id:
            id_.export(outfile, level, namespace_, name_='id')
        for effectiveTime_ in self.effectiveTime:
            effectiveTime_.export(outfile, level, namespace_, name_='effectiveTime')
        if self.patientPerson is not None:
            self.patientPerson.export(outfile, level, namespace_, name_='patientPerson')
        if self.providerOrganization is not None:
            self.providerOrganization.export(outfile, level, namespace_, name_='providerOrganization')
    def hasContent_(self):
        if (
            self.realmCode or
            self.typeId is not None or
            self.templateId or
            self.id or
            self.effectiveTime or
            self.patientPerson is not None or
            self.providerOrganization is not None
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('nullFlavor', node)
        if value is not None and 'nullFlavor' not in already_processed:
            already_processed.append('nullFlavor')
            self.nullFlavor = value
            self.validate_NullFlavor(self.nullFlavor)    # validate type NullFlavor
        value = find_attr_value_('classCode', node)
        if value is not None and 'classCode' not in already_processed:
            already_processed.append('classCode')
            self.classCode = value
            self.validate_RoleClassPatient(self.classCode)    # validate type RoleClassPatient
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'realmCode':
            obj_ = build_object(child_, 'CS')
            self.realmCode.append(obj_)
        elif nodeName_ == 'typeId':
            obj_ = build_object(child_, 'II')
            self.set_typeId(obj_)
        elif nodeName_ == 'templateId':
            obj_ = build_object(child_, 'II')
            self.templateId.append(obj_)
        elif nodeName_ == 'id':
            obj_ = build_object(child_, 'II')
            self.id.append(obj_)
        elif nodeName_ == 'effectiveTime':
            obj_ = build_object(child_, 'SXCM_TS')
            self.effectiveTime.append(obj_)
        elif nodeName_ == 'patientPerson':
            obj_ = build_object(child_, 'TZDU_MT000003UV_Person')
            self.set_patientPerson(obj_)
        elif nodeName_ == 'providerOrganization':
            obj_ = build_object(child_, 'TZDU_MT000003UV_Organization')
            self.set_providerOrganization(obj_)
# end class TZDU_MT000003UV_Patient


class TZDU_MT000003UV_PatientUpdate(GeneratedsSuper):
    member_data_items_ = [
        MemberSpec_('moodCode', 'ActMoodEventOccurrence', 0, 1, 0),
        MemberSpec_('classCode', 'ActClassAction', 0, 1, 0),
        MemberSpec_('realmCode', 'CS', 1, 0, 0),
        MemberSpec_('typeId', 'II', 0, 0, 0),
        MemberSpec_('templateId', 'II', 1, 0, 0),
        MemberSpec_('code', 'CD', 0, 0, 0),
        MemberSpec_('recordTarget', 'TZDU_MT000003UV.RecordTarget', 1, 0, 0),
        ]
    subclass = None
    superclass = None
    def __init__(self, moodCode=None, classCode=None, realmCode=None, typeId=None, templateId=None, code=None, recordTarget=None):
        self.moodCode = _cast(None, moodCode)
        self.classCode = _cast(None, classCode)
        if realmCode is None:
            self.realmCode = []
        else:
            self.realmCode = realmCode
        self.typeId = typeId
        if templateId is None:
            self.templateId = []
        else:
            self.templateId = templateId
        self.code = code
        if recordTarget is None:
            self.recordTarget = []
        else:
            self.recordTarget = recordTarget
    def factory(*args_, **kwargs_):
        if TZDU_MT000003UV_PatientUpdate.subclass:
            return TZDU_MT000003UV_PatientUpdate.subclass(*args_, **kwargs_)
        else:
            return TZDU_MT000003UV_PatientUpdate(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_realmCode(self): return self.realmCode
    def set_realmCode(self, realmCode): self.realmCode = realmCode
    def add_realmCode(self, value): self.realmCode.append(value)
    def insert_realmCode(self, index, value): self.realmCode[index] = value
    realmCodeProp = property(get_realmCode, set_realmCode)
    def get_typeId(self): return self.typeId
    def set_typeId(self, typeId): self.typeId = typeId
    typeIdProp = property(get_typeId, set_typeId)
    def get_templateId(self): return self.templateId
    def set_templateId(self, templateId): self.templateId = templateId
    def add_templateId(self, value): self.templateId.append(value)
    def insert_templateId(self, index, value): self.templateId[index] = value
    templateIdProp = property(get_templateId, set_templateId)
    def get_code(self): return self.code
    def set_code(self, code): self.code = code
    codeProp = property(get_code, set_code)
    def get_recordTarget(self): return self.recordTarget
    def set_recordTarget(self, recordTarget): self.recordTarget = recordTarget
    def add_recordTarget(self, value): self.recordTarget.append(value)
    def insert_recordTarget(self, index, value): self.recordTarget[index] = value
    recordTargetProp = property(get_recordTarget, set_recordTarget)
    def get_moodCode(self): return self.moodCode
    def set_moodCode(self, moodCode): self.moodCode = moodCode
    moodCodeProp = property(get_moodCode, set_moodCode)
    def validate_ActMoodEventOccurrence(self, value):
        # Validate type ActMoodEventOccurrence, a restriction on cs.
        pass
    def get_classCode(self): return self.classCode
    def set_classCode(self, classCode): self.classCode = classCode
    classCodeProp = property(get_classCode, set_classCode)
    def validate_ActClassAction(self, value):
        # Validate type ActClassAction, a restriction on cs.
        pass
    def export(self, outfile, level, namespace_='', name_='TZDU_MT000003UV.PatientUpdate', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='TZDU_MT000003UV.PatientUpdate')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='TZDU_MT000003UV.PatientUpdate'):
        if self.moodCode is not None and 'moodCode' not in already_processed:
            already_processed.append('moodCode')
            outfile.write(' moodCode=%s' % (quote_attrib(self.moodCode), ))
        if self.classCode is not None and 'classCode' not in already_processed:
            already_processed.append('classCode')
            outfile.write(' classCode=%s' % (quote_attrib(self.classCode), ))
    def exportChildren(self, outfile, level, namespace_='', name_='TZDU_MT000003UV.PatientUpdate', fromsubclass_=False):
        for realmCode_ in self.realmCode:
            realmCode_.export(outfile, level, namespace_, name_='realmCode')
        if self.typeId is not None:
            self.typeId.export(outfile, level, namespace_, name_='typeId')
        for templateId_ in self.templateId:
            templateId_.export(outfile, level, namespace_, name_='templateId')
        if self.code is not None:
            self.code.export(outfile, level, namespace_, name_='code')
        for recordTarget_ in self.recordTarget:
            recordTarget_.export(outfile, level, namespace_, name_='recordTarget')
    def hasContent_(self):
        if (
            self.realmCode or
            self.typeId is not None or
            self.templateId or
            self.code is not None or
            self.recordTarget
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('moodCode', node)
        if value is not None and 'moodCode' not in already_processed:
            already_processed.append('moodCode')
            self.moodCode = value
            self.validate_ActMoodEventOccurrence(self.moodCode)    # validate type ActMoodEventOccurrence
        value = find_attr_value_('classCode', node)
        if value is not None and 'classCode' not in already_processed:
            already_processed.append('classCode')
            self.classCode = value
            self.validate_ActClassAction(self.classCode)    # validate type ActClassAction
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'realmCode':
            obj_ = build_object(child_, 'CS')
            self.realmCode.append(obj_)
        elif nodeName_ == 'typeId':
            obj_ = build_object(child_, 'II')
            self.set_typeId(obj_)
        elif nodeName_ == 'templateId':
            obj_ = build_object(child_, 'II')
            self.templateId.append(obj_)
        elif nodeName_ == 'code':
            obj_ = build_object(child_, 'CD')
            self.set_code(obj_)
        elif nodeName_ == 'recordTarget':
            obj_ = build_object(child_, 'TZDU_MT000003UV_RecordTarget')
            self.recordTarget.append(obj_)
# end class TZDU_MT000003UV_PatientUpdate


class TZDU_MT000003UV_Person(GeneratedsSuper):
    member_data_items_ = [
        MemberSpec_('nullFlavor', 'NullFlavor', 0, 1, 0),
        MemberSpec_('determinerCode', 'EntityDeterminerSpecific', 0, 1, 0),
        MemberSpec_('classCode', 'EntityClassPerson', 0, 1, 0),
        MemberSpec_('realmCode', 'CS', 1, 0, 0),
        MemberSpec_('typeId', 'II', 0, 0, 0),
        MemberSpec_('templateId', 'II', 1, 0, 0),
        MemberSpec_('id', 'II', 1, 0, 0),
        MemberSpec_('name', 'EN', 1, 0, 0),
        MemberSpec_('telecom', 'TEL', 1, 0, 0),
        MemberSpec_('administrativeGenderCode', 'CE', 0, 0, 0),
        MemberSpec_('birthTime', 'TS', 0, 0, 0),
        MemberSpec_('deceasedInd', 'BL', 0, 0, 0),
        MemberSpec_('deceasedTime', 'TS', 0, 0, 0),
        MemberSpec_('addr', 'AD', 1, 0, 0),
        MemberSpec_('asPolicyHolder', 'TZDU_MT000003UV.PolicyHolder', 1, 0, 0),
        MemberSpec_('asCareGiver', 'TZDU_MT000003UV.CareGiver', 1, 0, 0),
        ]
    subclass = None
    superclass = None
    def __init__(self, nullFlavor=None, determinerCode=None, classCode=None, realmCode=None, typeId=None, templateId=None, id=None, name=None, telecom=None, administrativeGenderCode=None, birthTime=None, deceasedInd=None, deceasedTime=None, addr=None, asPolicyHolder=None, asCareGiver=None):
        self.nullFlavor = _cast(None, nullFlavor)
        self.determinerCode = _cast(None, determinerCode)
        self.classCode = _cast(None, classCode)
        if realmCode is None:
            self.realmCode = []
        else:
            self.realmCode = realmCode
        self.typeId = typeId
        if templateId is None:
            self.templateId = []
        else:
            self.templateId = templateId
        if id is None:
            self.id = []
        else:
            self.id = id
        if name is None:
            self.name = []
        else:
            self.name = name
        if telecom is None:
            self.telecom = []
        else:
            self.telecom = telecom
        self.administrativeGenderCode = administrativeGenderCode
        self.birthTime = birthTime
        self.deceasedInd = deceasedInd
        self.deceasedTime = deceasedTime
        if addr is None:
            self.addr = []
        else:
            self.addr = addr
        if asPolicyHolder is None:
            self.asPolicyHolder = []
        else:
            self.asPolicyHolder = asPolicyHolder
        if asCareGiver is None:
            self.asCareGiver = []
        else:
            self.asCareGiver = asCareGiver
    def factory(*args_, **kwargs_):
        if TZDU_MT000003UV_Person.subclass:
            return TZDU_MT000003UV_Person.subclass(*args_, **kwargs_)
        else:
            return TZDU_MT000003UV_Person(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_realmCode(self): return self.realmCode
    def set_realmCode(self, realmCode): self.realmCode = realmCode
    def add_realmCode(self, value): self.realmCode.append(value)
    def insert_realmCode(self, index, value): self.realmCode[index] = value
    realmCodeProp = property(get_realmCode, set_realmCode)
    def get_typeId(self): return self.typeId
    def set_typeId(self, typeId): self.typeId = typeId
    typeIdProp = property(get_typeId, set_typeId)
    def get_templateId(self): return self.templateId
    def set_templateId(self, templateId): self.templateId = templateId
    def add_templateId(self, value): self.templateId.append(value)
    def insert_templateId(self, index, value): self.templateId[index] = value
    templateIdProp = property(get_templateId, set_templateId)
    def get_id(self): return self.id
    def set_id(self, id): self.id = id
    def add_id(self, value): self.id.append(value)
    def insert_id(self, index, value): self.id[index] = value
    idProp = property(get_id, set_id)
    def get_name(self): return self.name
    def set_name(self, name): self.name = name
    def add_name(self, value): self.name.append(value)
    def insert_name(self, index, value): self.name[index] = value
    nameProp = property(get_name, set_name)
    def get_telecom(self): return self.telecom
    def set_telecom(self, telecom): self.telecom = telecom
    def add_telecom(self, value): self.telecom.append(value)
    def insert_telecom(self, index, value): self.telecom[index] = value
    telecomProp = property(get_telecom, set_telecom)
    def get_administrativeGenderCode(self): return self.administrativeGenderCode
    def set_administrativeGenderCode(self, administrativeGenderCode): self.administrativeGenderCode = administrativeGenderCode
    administrativeGenderCodeProp = property(get_administrativeGenderCode, set_administrativeGenderCode)
    def get_birthTime(self): return self.birthTime
    def set_birthTime(self, birthTime): self.birthTime = birthTime
    birthTimeProp = property(get_birthTime, set_birthTime)
    def get_deceasedInd(self): return self.deceasedInd
    def set_deceasedInd(self, deceasedInd): self.deceasedInd = deceasedInd
    deceasedIndProp = property(get_deceasedInd, set_deceasedInd)
    def get_deceasedTime(self): return self.deceasedTime
    def set_deceasedTime(self, deceasedTime): self.deceasedTime = deceasedTime
    deceasedTimeProp = property(get_deceasedTime, set_deceasedTime)
    def get_addr(self): return self.addr
    def set_addr(self, addr): self.addr = addr
    def add_addr(self, value): self.addr.append(value)
    def insert_addr(self, index, value): self.addr[index] = value
    addrProp = property(get_addr, set_addr)
    def get_asPolicyHolder(self): return self.asPolicyHolder
    def set_asPolicyHolder(self, asPolicyHolder): self.asPolicyHolder = asPolicyHolder
    def add_asPolicyHolder(self, value): self.asPolicyHolder.append(value)
    def insert_asPolicyHolder(self, index, value): self.asPolicyHolder[index] = value
    asPolicyHolderProp = property(get_asPolicyHolder, set_asPolicyHolder)
    def get_asCareGiver(self): return self.asCareGiver
    def set_asCareGiver(self, asCareGiver): self.asCareGiver = asCareGiver
    def add_asCareGiver(self, value): self.asCareGiver.append(value)
    def insert_asCareGiver(self, index, value): self.asCareGiver[index] = value
    asCareGiverProp = property(get_asCareGiver, set_asCareGiver)
    def get_nullFlavor(self): return self.nullFlavor
    def set_nullFlavor(self, nullFlavor): self.nullFlavor = nullFlavor
    nullFlavorProp = property(get_nullFlavor, set_nullFlavor)
    def validate_NullFlavor(self, value):
        # Validate type NullFlavor, a restriction on cs.
        pass
    def get_determinerCode(self): return self.determinerCode
    def set_determinerCode(self, determinerCode): self.determinerCode = determinerCode
    determinerCodeProp = property(get_determinerCode, set_determinerCode)
    def validate_EntityDeterminerSpecific(self, value):
        # Validate type EntityDeterminerSpecific, a restriction on cs.
        pass
    def get_classCode(self): return self.classCode
    def set_classCode(self, classCode): self.classCode = classCode
    classCodeProp = property(get_classCode, set_classCode)
    def validate_EntityClassPerson(self, value):
        # Validate type EntityClassPerson, a restriction on cs.
        pass
    def export(self, outfile, level, namespace_='', name_='TZDU_MT000003UV.Person', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='TZDU_MT000003UV.Person')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='TZDU_MT000003UV.Person'):
        if self.nullFlavor is not None and 'nullFlavor' not in already_processed:
            already_processed.append('nullFlavor')
            outfile.write(' nullFlavor=%s' % (quote_attrib(self.nullFlavor), ))
        if self.determinerCode is not None and 'determinerCode' not in already_processed:
            already_processed.append('determinerCode')
            outfile.write(' determinerCode=%s' % (quote_attrib(self.determinerCode), ))
        if self.classCode is not None and 'classCode' not in already_processed:
            already_processed.append('classCode')
            outfile.write(' classCode=%s' % (quote_attrib(self.classCode), ))
    def exportChildren(self, outfile, level, namespace_='', name_='TZDU_MT000003UV.Person', fromsubclass_=False):
        for realmCode_ in self.realmCode:
            realmCode_.export(outfile, level, namespace_, name_='realmCode')
        if self.typeId is not None:
            self.typeId.export(outfile, level, namespace_, name_='typeId')
        for templateId_ in self.templateId:
            templateId_.export(outfile, level, namespace_, name_='templateId')
        for id_ in self.id:
            id_.export(outfile, level, namespace_, name_='id')
        for name_ in self.name:
            name_.export(outfile, level, namespace_, name_='name')
        for telecom_ in self.telecom:
            telecom_.export(outfile, level, namespace_, name_='telecom')
        if self.administrativeGenderCode is not None:
            self.administrativeGenderCode.export(outfile, level, namespace_, name_='administrativeGenderCode')
        if self.birthTime is not None:
            self.birthTime.export(outfile, level, namespace_, name_='birthTime')
        if self.deceasedInd is not None:
            self.deceasedInd.export(outfile, level, namespace_, name_='deceasedInd')
        if self.deceasedTime is not None:
            self.deceasedTime.export(outfile, level, namespace_, name_='deceasedTime')
        for addr_ in self.addr:
            addr_.export(outfile, level, namespace_, name_='addr')
        for asPolicyHolder_ in self.asPolicyHolder:
            asPolicyHolder_.export(outfile, level, namespace_, name_='asPolicyHolder')
        for asCareGiver_ in self.asCareGiver:
            asCareGiver_.export(outfile, level, namespace_, name_='asCareGiver')
    def hasContent_(self):
        if (
            self.realmCode or
            self.typeId is not None or
            self.templateId or
            self.id or
            self.name or
            self.telecom or
            self.administrativeGenderCode is not None or
            self.birthTime is not None or
            self.deceasedInd is not None or
            self.deceasedTime is not None or
            self.addr or
            self.asPolicyHolder or
            self.asCareGiver
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('nullFlavor', node)
        if value is not None and 'nullFlavor' not in already_processed:
            already_processed.append('nullFlavor')
            self.nullFlavor = value
            self.validate_NullFlavor(self.nullFlavor)    # validate type NullFlavor
        value = find_attr_value_('determinerCode', node)
        if value is not None and 'determinerCode' not in already_processed:
            already_processed.append('determinerCode')
            self.determinerCode = value
            self.validate_EntityDeterminerSpecific(self.determinerCode)    # validate type EntityDeterminerSpecific
        value = find_attr_value_('classCode', node)
        if value is not None and 'classCode' not in already_processed:
            already_processed.append('classCode')
            self.classCode = value
            self.validate_EntityClassPerson(self.classCode)    # validate type EntityClassPerson
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'realmCode':
            obj_ = build_object(child_, 'CS')
            self.realmCode.append(obj_)
        elif nodeName_ == 'typeId':
            obj_ = build_object(child_, 'II')
            self.set_typeId(obj_)
        elif nodeName_ == 'templateId':
            obj_ = build_object(child_, 'II')
            self.templateId.append(obj_)
        elif nodeName_ == 'id':
            obj_ = build_object(child_, 'II')
            self.id.append(obj_)
        elif nodeName_ == 'name':
            obj_ = build_object(child_, 'EN')
            self.name.append(obj_)
        elif nodeName_ == 'telecom':
            obj_ = build_object(child_, 'TEL')
            self.telecom.append(obj_)
        elif nodeName_ == 'administrativeGenderCode':
            obj_ = build_object(child_, 'CE')
            self.set_administrativeGenderCode(obj_)
        elif nodeName_ == 'birthTime':
            obj_ = build_object(child_, 'TS')
            self.set_birthTime(obj_)
        elif nodeName_ == 'deceasedInd':
            obj_ = build_object(child_, 'BL')
            self.set_deceasedInd(obj_)
        elif nodeName_ == 'deceasedTime':
            obj_ = build_object(child_, 'TS')
            self.set_deceasedTime(obj_)
        elif nodeName_ == 'addr':
            obj_ = build_object(child_, 'AD')
            self.addr.append(obj_)
        elif nodeName_ == 'asPolicyHolder':
            obj_ = build_object(child_, 'TZDU_MT000003UV_PolicyHolder')
            self.asPolicyHolder.append(obj_)
        elif nodeName_ == 'asCareGiver':
            obj_ = build_object(child_, 'TZDU_MT000003UV_CareGiver')
            self.asCareGiver.append(obj_)
# end class TZDU_MT000003UV_Person


class TZDU_MT000003UV_PolicyHolder(GeneratedsSuper):
    member_data_items_ = [
        MemberSpec_('nullFlavor', 'NullFlavor', 0, 1, 0),
        MemberSpec_('classCode', 'RoleClassPolicyHolder', 0, 1, 0),
        MemberSpec_('realmCode', 'CS', 1, 0, 0),
        MemberSpec_('typeId', 'II', 0, 0, 0),
        MemberSpec_('templateId', 'II', 1, 0, 0),
        MemberSpec_('id', 'II', 1, 0, 0),
        MemberSpec_('effectiveTime', 'SXCM_TS', 1, 0, 0),
        MemberSpec_('underwritingInsurer', 'TZDU_MT000003UV.Insurer', 0, 0, 0),
        ]
    subclass = None
    superclass = None
    def __init__(self, nullFlavor=None, classCode=None, realmCode=None, typeId=None, templateId=None, id=None, effectiveTime=None, underwritingInsurer=None):
        self.nullFlavor = _cast(None, nullFlavor)
        self.classCode = _cast(None, classCode)
        if realmCode is None:
            self.realmCode = []
        else:
            self.realmCode = realmCode
        self.typeId = typeId
        if templateId is None:
            self.templateId = []
        else:
            self.templateId = templateId
        if id is None:
            self.id = []
        else:
            self.id = id
        if effectiveTime is None:
            self.effectiveTime = []
        else:
            self.effectiveTime = effectiveTime
        self.underwritingInsurer = underwritingInsurer
    def factory(*args_, **kwargs_):
        if TZDU_MT000003UV_PolicyHolder.subclass:
            return TZDU_MT000003UV_PolicyHolder.subclass(*args_, **kwargs_)
        else:
            return TZDU_MT000003UV_PolicyHolder(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_realmCode(self): return self.realmCode
    def set_realmCode(self, realmCode): self.realmCode = realmCode
    def add_realmCode(self, value): self.realmCode.append(value)
    def insert_realmCode(self, index, value): self.realmCode[index] = value
    realmCodeProp = property(get_realmCode, set_realmCode)
    def get_typeId(self): return self.typeId
    def set_typeId(self, typeId): self.typeId = typeId
    typeIdProp = property(get_typeId, set_typeId)
    def get_templateId(self): return self.templateId
    def set_templateId(self, templateId): self.templateId = templateId
    def add_templateId(self, value): self.templateId.append(value)
    def insert_templateId(self, index, value): self.templateId[index] = value
    templateIdProp = property(get_templateId, set_templateId)
    def get_id(self): return self.id
    def set_id(self, id): self.id = id
    def add_id(self, value): self.id.append(value)
    def insert_id(self, index, value): self.id[index] = value
    idProp = property(get_id, set_id)
    def get_effectiveTime(self): return self.effectiveTime
    def set_effectiveTime(self, effectiveTime): self.effectiveTime = effectiveTime
    def add_effectiveTime(self, value): self.effectiveTime.append(value)
    def insert_effectiveTime(self, index, value): self.effectiveTime[index] = value
    effectiveTimeProp = property(get_effectiveTime, set_effectiveTime)
    def get_underwritingInsurer(self): return self.underwritingInsurer
    def set_underwritingInsurer(self, underwritingInsurer): self.underwritingInsurer = underwritingInsurer
    underwritingInsurerProp = property(get_underwritingInsurer, set_underwritingInsurer)
    def get_nullFlavor(self): return self.nullFlavor
    def set_nullFlavor(self, nullFlavor): self.nullFlavor = nullFlavor
    nullFlavorProp = property(get_nullFlavor, set_nullFlavor)
    def validate_NullFlavor(self, value):
        # Validate type NullFlavor, a restriction on cs.
        pass
    def get_classCode(self): return self.classCode
    def set_classCode(self, classCode): self.classCode = classCode
    classCodeProp = property(get_classCode, set_classCode)
    def validate_RoleClassPolicyHolder(self, value):
        # Validate type RoleClassPolicyHolder, a restriction on cs.
        pass
    def export(self, outfile, level, namespace_='', name_='TZDU_MT000003UV.PolicyHolder', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='TZDU_MT000003UV.PolicyHolder')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='TZDU_MT000003UV.PolicyHolder'):
        if self.nullFlavor is not None and 'nullFlavor' not in already_processed:
            already_processed.append('nullFlavor')
            outfile.write(' nullFlavor=%s' % (quote_attrib(self.nullFlavor), ))
        if self.classCode is not None and 'classCode' not in already_processed:
            already_processed.append('classCode')
            outfile.write(' classCode=%s' % (quote_attrib(self.classCode), ))
    def exportChildren(self, outfile, level, namespace_='', name_='TZDU_MT000003UV.PolicyHolder', fromsubclass_=False):
        for realmCode_ in self.realmCode:
            realmCode_.export(outfile, level, namespace_, name_='realmCode')
        if self.typeId is not None:
            self.typeId.export(outfile, level, namespace_, name_='typeId')
        for templateId_ in self.templateId:
            templateId_.export(outfile, level, namespace_, name_='templateId')
        for id_ in self.id:
            id_.export(outfile, level, namespace_, name_='id')
        for effectiveTime_ in self.effectiveTime:
            effectiveTime_.export(outfile, level, namespace_, name_='effectiveTime')
        if self.underwritingInsurer is not None:
            self.underwritingInsurer.export(outfile, level, namespace_, name_='underwritingInsurer')
    def hasContent_(self):
        if (
            self.realmCode or
            self.typeId is not None or
            self.templateId or
            self.id or
            self.effectiveTime or
            self.underwritingInsurer is not None
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('nullFlavor', node)
        if value is not None and 'nullFlavor' not in already_processed:
            already_processed.append('nullFlavor')
            self.nullFlavor = value
            self.validate_NullFlavor(self.nullFlavor)    # validate type NullFlavor
        value = find_attr_value_('classCode', node)
        if value is not None and 'classCode' not in already_processed:
            already_processed.append('classCode')
            self.classCode = value
            self.validate_RoleClassPolicyHolder(self.classCode)    # validate type RoleClassPolicyHolder
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'realmCode':
            obj_ = build_object(child_, 'CS')
            self.realmCode.append(obj_)
        elif nodeName_ == 'typeId':
            obj_ = build_object(child_, 'II')
            self.set_typeId(obj_)
        elif nodeName_ == 'templateId':
            obj_ = build_object(child_, 'II')
            self.templateId.append(obj_)
        elif nodeName_ == 'id':
            obj_ = build_object(child_, 'II')
            self.id.append(obj_)
        elif nodeName_ == 'effectiveTime':
            obj_ = build_object(child_, 'SXCM_TS')
            self.effectiveTime.append(obj_)
        elif nodeName_ == 'underwritingInsurer':
            obj_ = build_object(child_, 'TZDU_MT000003UV_Insurer')
            self.set_underwritingInsurer(obj_)
# end class TZDU_MT000003UV_PolicyHolder


class TZDU_MT000003UV_RecordTarget(GeneratedsSuper):
    member_data_items_ = [
        MemberSpec_('nullFlavor', 'NullFlavor', 0, 1, 0),
        MemberSpec_('typeCode', 'ParticipationRecordTarget', 0, 1, 0),
        MemberSpec_('realmCode', 'CS', 1, 0, 0),
        MemberSpec_('typeId', 'II', 0, 0, 0),
        MemberSpec_('templateId', 'II', 1, 0, 0),
        MemberSpec_('patient', 'TZDU_MT000003UV.Patient', 0, 0, 0),
        ]
    subclass = None
    superclass = None
    def __init__(self, nullFlavor=None, typeCode=None, realmCode=None, typeId=None, templateId=None, patient=None):
        self.nullFlavor = _cast(None, nullFlavor)
        self.typeCode = _cast(None, typeCode)
        if realmCode is None:
            self.realmCode = []
        else:
            self.realmCode = realmCode
        self.typeId = typeId
        if templateId is None:
            self.templateId = []
        else:
            self.templateId = templateId
        self.patient = patient
    def factory(*args_, **kwargs_):
        if TZDU_MT000003UV_RecordTarget.subclass:
            return TZDU_MT000003UV_RecordTarget.subclass(*args_, **kwargs_)
        else:
            return TZDU_MT000003UV_RecordTarget(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_realmCode(self): return self.realmCode
    def set_realmCode(self, realmCode): self.realmCode = realmCode
    def add_realmCode(self, value): self.realmCode.append(value)
    def insert_realmCode(self, index, value): self.realmCode[index] = value
    realmCodeProp = property(get_realmCode, set_realmCode)
    def get_typeId(self): return self.typeId
    def set_typeId(self, typeId): self.typeId = typeId
    typeIdProp = property(get_typeId, set_typeId)
    def get_templateId(self): return self.templateId
    def set_templateId(self, templateId): self.templateId = templateId
    def add_templateId(self, value): self.templateId.append(value)
    def insert_templateId(self, index, value): self.templateId[index] = value
    templateIdProp = property(get_templateId, set_templateId)
    def get_patient(self): return self.patient
    def set_patient(self, patient): self.patient = patient
    patientProp = property(get_patient, set_patient)
    def get_nullFlavor(self): return self.nullFlavor
    def set_nullFlavor(self, nullFlavor): self.nullFlavor = nullFlavor
    nullFlavorProp = property(get_nullFlavor, set_nullFlavor)
    def validate_NullFlavor(self, value):
        # Validate type NullFlavor, a restriction on cs.
        pass
    def get_typeCode(self): return self.typeCode
    def set_typeCode(self, typeCode): self.typeCode = typeCode
    typeCodeProp = property(get_typeCode, set_typeCode)
    def validate_ParticipationRecordTarget(self, value):
        # Validate type ParticipationRecordTarget, a restriction on cs.
        pass
    def export(self, outfile, level, namespace_='', name_='TZDU_MT000003UV.RecordTarget', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='TZDU_MT000003UV.RecordTarget')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='TZDU_MT000003UV.RecordTarget'):
        if self.nullFlavor is not None and 'nullFlavor' not in already_processed:
            already_processed.append('nullFlavor')
            outfile.write(' nullFlavor=%s' % (quote_attrib(self.nullFlavor), ))
        if self.typeCode is not None and 'typeCode' not in already_processed:
            already_processed.append('typeCode')
            outfile.write(' typeCode=%s' % (quote_attrib(self.typeCode), ))
    def exportChildren(self, outfile, level, namespace_='', name_='TZDU_MT000003UV.RecordTarget', fromsubclass_=False):
        for realmCode_ in self.realmCode:
            realmCode_.export(outfile, level, namespace_, name_='realmCode')
        if self.typeId is not None:
            self.typeId.export(outfile, level, namespace_, name_='typeId')
        for templateId_ in self.templateId:
            templateId_.export(outfile, level, namespace_, name_='templateId')
        if self.patient is not None:
            self.patient.export(outfile, level, namespace_, name_='patient', )
    def hasContent_(self):
        if (
            self.realmCode or
            self.typeId is not None or
            self.templateId or
            self.patient is not None
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('nullFlavor', node)
        if value is not None and 'nullFlavor' not in already_processed:
            already_processed.append('nullFlavor')
            self.nullFlavor = value
            self.validate_NullFlavor(self.nullFlavor)    # validate type NullFlavor
        value = find_attr_value_('typeCode', node)
        if value is not None and 'typeCode' not in already_processed:
            already_processed.append('typeCode')
            self.typeCode = value
            self.validate_ParticipationRecordTarget(self.typeCode)    # validate type ParticipationRecordTarget
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'realmCode':
            obj_ = build_object(child_, 'CS')
            self.realmCode.append(obj_)
        elif nodeName_ == 'typeId':
            obj_ = build_object(child_, 'II')
            self.set_typeId(obj_)
        elif nodeName_ == 'templateId':
            obj_ = build_object(child_, 'II')
            self.templateId.append(obj_)
        elif nodeName_ == 'patient':
            obj_ = build_object(child_, 'TZDU_MT000003UV_Patient')
            self.set_patient(obj_)
# end class TZDU_MT000003UV_RecordTarget


class ANY(GeneratedsSuper):
    """Defines the basic properties of every data value. This is an
    abstract type, meaning that no value can be just a data value
    without belonging to any concrete type. Every concrete type is a
    specialization of this general abstract DataValue type. An
    exceptional value expressing missing information and possibly
    the reason why the information is missing."""
    member_data_items_ = [
        MemberSpec_('nullFlavor', 'NullFlavor', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = None
    def __init__(self, nullFlavor=None, valueOf_=None, mixedclass_=None, content_=None, extensiontype_=None):
        self.nullFlavor = _cast(None, nullFlavor)
        self.valueOf_ = valueOf_
        self.extensiontype_ = extensiontype_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if ANY.subclass:
            return ANY.subclass(*args_, **kwargs_)
        else:
            return ANY(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_nullFlavor(self): return self.nullFlavor
    def set_nullFlavor(self, nullFlavor): self.nullFlavor = nullFlavor
    nullFlavorProp = property(get_nullFlavor, set_nullFlavor)
    def validate_NullFlavor(self, value):
        # Validate type NullFlavor, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def get_extensiontype_(self): return self.extensiontype_
    def set_extensiontype_(self, extensiontype_): self.extensiontype_ = extensiontype_
    def export(self, outfile, level, namespace_='', name_='ANY', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='ANY')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='ANY'):
        if self.nullFlavor is not None and 'nullFlavor' not in already_processed:
            already_processed.append('nullFlavor')
            outfile.write(' nullFlavor=%s' % (quote_attrib(self.nullFlavor), ))
        if self.extensiontype_ is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            outfile.write(' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"')
            outfile.write(' xsi:type="%s"' % self.extensiontype_)
    def exportChildren(self, outfile, level, namespace_='', name_='ANY', fromsubclass_=False):
        pass
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('nullFlavor', node)
        if value is not None and 'nullFlavor' not in already_processed:
            already_processed.append('nullFlavor')
            self.nullFlavor = value
            self.validate_NullFlavor(self.nullFlavor)    # validate type NullFlavor
        value = find_attr_value_('xsi:type', node)
        if value is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            self.extensiontype_ = value
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class ANY


class BL(ANY):
    """The Boolean type stands for the values of two-valued logic. A
    Boolean value can be either true or false, or, as any other
    value may be NULL."""
    member_data_items_ = [
        MemberSpec_('value', 'bl', 0, 1, 0),
        ]
    subclass = None
    superclass = ANY
    def __init__(self, nullFlavor=None, value=None):
        super(BL, self).__init__(nullFlavor, )
        self.value = _cast(None, value)
        pass
    def factory(*args_, **kwargs_):
        if BL.subclass:
            return BL.subclass(*args_, **kwargs_)
        else:
            return BL(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_value(self): return self.value
    def set_value(self, value): self.value = value
    valueProp = property(get_value, set_value)
    def validate_bl(self, value):
        # Validate type bl, a restriction on xs:boolean.
        pass
    def export(self, outfile, level, namespace_='', name_='BL', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='BL')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='BL'):
        super(BL, self).exportAttributes(outfile, level, already_processed, namespace_, name_='BL')
        if self.value is not None and 'value' not in already_processed:
            already_processed.append('value')
            outfile.write(' value=%s' % (quote_attrib(self.value), ))
    def exportChildren(self, outfile, level, namespace_='', name_='BL', fromsubclass_=False):
        super(BL, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            super(BL, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('value', node)
        if value is not None and 'value' not in already_processed:
            already_processed.append('value')
            if value in ('true', '1'):
                self.value = True
            elif value in ('false', '0'):
                self.value = False
            else:
                raise_parse_error(node, 'Bad boolean attribute')
            self.validate_bl(self.value)    # validate type bl
        super(BL, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        super(BL, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class BL


class ANYNonNull(ANY):
    """The BooleanNonNull type is used where a Boolean cannot have a null
    value. A Boolean value can be either true or false."""
    member_data_items_ = [
        MemberSpec_('nullFlavor', 'NullFlavor', 0, 1, 1),
        ]
    subclass = None
    superclass = ANY
    def __init__(self, nullFlavor=None, extensiontype_=None):
        super(ANYNonNull, self).__init__(nullFlavor, extensiontype_, )
        self.nullFlavor = _cast(None, nullFlavor)
        self.extensiontype_ = extensiontype_
    def factory(*args_, **kwargs_):
        if ANYNonNull.subclass:
            return ANYNonNull.subclass(*args_, **kwargs_)
        else:
            return ANYNonNull(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_nullFlavor(self): return self.nullFlavor
    def set_nullFlavor(self, nullFlavor): self.nullFlavor = nullFlavor
    nullFlavorProp = property(get_nullFlavor, set_nullFlavor)
    def validate_NullFlavor(self, value):
        # Validate type NullFlavor, a restriction on cs.
        pass
    def get_extensiontype_(self): return self.extensiontype_
    def set_extensiontype_(self, extensiontype_): self.extensiontype_ = extensiontype_
    def export(self, outfile, level, namespace_='', name_='ANYNonNull', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='ANYNonNull')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='ANYNonNull'):
        already_processed.append('nullFlavor')
        super(ANYNonNull, self).exportAttributes(outfile, level, already_processed, namespace_, name_='ANYNonNull')
        if self.extensiontype_ is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            outfile.write(' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"')
            outfile.write(' xsi:type="%s"' % self.extensiontype_)
    def exportChildren(self, outfile, level, namespace_='', name_='ANYNonNull', fromsubclass_=False):
        super(ANYNonNull, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            super(ANYNonNull, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('nullFlavor', node)
        if value is not None and 'nullFlavor' not in already_processed:
            already_processed.append('nullFlavor')
            self.nullFlavor = value
            self.validate_NullFlavor(self.nullFlavor)    # validate type NullFlavor
        value = find_attr_value_('xsi:type', node)
        if value is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            self.extensiontype_ = value
        super(ANYNonNull, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class ANYNonNull


class BN(ANYNonNull):
    """The BooleanNonNull type is used where a Boolean cannot have a null
    value. A Boolean value can be either true or false."""
    member_data_items_ = [
        MemberSpec_('value', 'bn', 0, 1, 0),
        ]
    subclass = None
    superclass = ANYNonNull
    def __init__(self, nullFlavor=None, value=None):
        super(BN, self).__init__(nullFlavor, )
        self.value = _cast(None, value)
        pass
    def factory(*args_, **kwargs_):
        if BN.subclass:
            return BN.subclass(*args_, **kwargs_)
        else:
            return BN(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_value(self): return self.value
    def set_value(self, value): self.value = value
    valueProp = property(get_value, set_value)
    def validate_bn(self, value):
        # Validate type bn, a restriction on bl.
        pass
    def export(self, outfile, level, namespace_='', name_='BN', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='BN')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='BN'):
        super(BN, self).exportAttributes(outfile, level, already_processed, namespace_, name_='BN')
        if self.value is not None and 'value' not in already_processed:
            already_processed.append('value')
            outfile.write(' value=%s' % (quote_attrib(self.value), ))
    def exportChildren(self, outfile, level, namespace_='', name_='BN', fromsubclass_=False):
        super(BN, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            super(BN, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('value', node)
        if value is not None and 'value' not in already_processed:
            already_processed.append('value')
            self.value = value
            self.validate_bn(self.value)    # validate type bn
        super(BN, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        super(BN, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class BN


class BIN(ANY):
    """Binary data is a raw block of bits. Binary data is a protected type
    that MUST not be used outside the data type specification.
    Specifies the representation of the binary data that is the
    content of the binary data value."""
    member_data_items_ = [
        MemberSpec_('representation', 'BinaryDataEncoding', 0, 1, 0),
        MemberSpec_('valueOf_', 'ANY', 0, 0, 0),
        ]
    subclass = None
    superclass = ANY
    def __init__(self, nullFlavor=None, representation='TXT', valueOf_=None, mixedclass_=None, content_=None, extensiontype_=None):
        super(BIN, self).__init__(nullFlavor, valueOf_, mixedclass_, content_, extensiontype_, )
        self.representation = _cast(None, representation)
        self.valueOf_ = valueOf_
        self.extensiontype_ = extensiontype_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if BIN.subclass:
            return BIN.subclass(*args_, **kwargs_)
        else:
            return BIN(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_representation(self): return self.representation
    def set_representation(self, representation): self.representation = representation
    representationProp = property(get_representation, set_representation)
    def validate_BinaryDataEncoding(self, value):
        # Validate type BinaryDataEncoding, a restriction on xs:NMTOKEN.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def get_extensiontype_(self): return self.extensiontype_
    def set_extensiontype_(self, extensiontype_): self.extensiontype_ = extensiontype_
    def export(self, outfile, level, namespace_='', name_='BIN', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='BIN')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='BIN'):
        super(BIN, self).exportAttributes(outfile, level, already_processed, namespace_, name_='BIN')
        if self.representation is not None and 'representation' not in already_processed and self.representation != "TXT":
            already_processed.append('representation')
            outfile.write(' representation=%s' % (quote_attrib(self.representation), ))
        if self.extensiontype_ is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            outfile.write(' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"')
            outfile.write(' xsi:type="%s"' % self.extensiontype_)
    def exportChildren(self, outfile, level, namespace_='', name_='BIN', fromsubclass_=False):
        super(BIN, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(BIN, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(BIN, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('representation', node)
        if value is not None and 'representation' not in already_processed:
            already_processed.append('representation')
            self.representation = value
            self.validate_BinaryDataEncoding(self.representation)    # validate type BinaryDataEncoding
        value = find_attr_value_('xsi:type', node)
        if value is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            self.extensiontype_ = value
        super(BIN, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        super(BIN, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class BIN


class ED(BIN):
    """Data that is primarily intended for human interpretation or for
    further machine processing is outside the scope of HL7. This
    includes unformatted or formatted written language, multimedia
    data, or structured information as defined by a different
    standard (e.g., XML-signatures.) Instead of the data itself, an
    ED may contain only a reference (see TEL.) Note that the ST data
    type is a specialization of when the is text/plain. Identifies
    the type of the encapsulated data and identifies a method to
    interpret or render the data. For character based information
    the language property specifies the human language of the text.
    Indicates whether the raw byte data is compressed, and what
    compression algorithm was used. The integrity check is a short
    binary value representing a cryptographically strong checksum
    that is calculated over the binary data. The purpose of this
    property, when communicated with a reference is for anyone to
    validate later whether the reference still resolved to the same
    data that the reference resolved to when the encapsulated data
    value with reference was created. Specifies the algorithm used
    to compute the integrityCheck value."""
    member_data_items_ = [
        MemberSpec_('integrityCheckAlgorithm', 'IntegrityCheckAlgorithm', 0, 1, 0),
        MemberSpec_('integrityCheck', 'bin', 0, 1, 0),
        MemberSpec_('mediaType', 'cs', 0, 1, 0),
        MemberSpec_('language', 'cs', 0, 1, 0),
        MemberSpec_('compression', 'CompressionAlgorithm', 0, 1, 0),
        MemberSpec_('reference', 'TEL', 0, 0, 0),
        MemberSpec_('thumbnail', 'thumbnail', 0, 0, 0),
        MemberSpec_('valueOf_', 'BIN', 0, 0, 0),
        ]
    subclass = None
    superclass = BIN
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, valueOf_=None, mixedclass_=None, content_=None):
        super(ED, self).__init__(nullFlavor, representation, valueOf_, mixedclass_, content_, )
        self.integrityCheckAlgorithm = _cast(None, integrityCheckAlgorithm)
        self.integrityCheck = _cast(None, integrityCheck)
        self.mediaType = _cast(None, mediaType)
        self.language = _cast(None, language)
        self.compression = _cast(None, compression)
        self.reference = reference
        self.thumbnail = thumbnail
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if ED.subclass:
            return ED.subclass(*args_, **kwargs_)
        else:
            return ED(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_reference(self): return self.reference
    def set_reference(self, reference): self.reference = reference
    referenceProp = property(get_reference, set_reference)
    def get_thumbnail(self): return self.thumbnail
    def set_thumbnail(self, thumbnail): self.thumbnail = thumbnail
    thumbnailProp = property(get_thumbnail, set_thumbnail)
    def get_integrityCheckAlgorithm(self): return self.integrityCheckAlgorithm
    def set_integrityCheckAlgorithm(self, integrityCheckAlgorithm): self.integrityCheckAlgorithm = integrityCheckAlgorithm
    integrityCheckAlgorithmProp = property(get_integrityCheckAlgorithm, set_integrityCheckAlgorithm)
    def validate_IntegrityCheckAlgorithm(self, value):
        # Validate type IntegrityCheckAlgorithm, a restriction on cs.
        pass
    def get_integrityCheck(self): return self.integrityCheck
    def set_integrityCheck(self, integrityCheck): self.integrityCheck = integrityCheck
    integrityCheckProp = property(get_integrityCheck, set_integrityCheck)
    def validate_bin(self, value):
        # Validate type bin, a restriction on xs:base64Binary.
        pass
    def get_mediaType(self): return self.mediaType
    def set_mediaType(self, mediaType): self.mediaType = mediaType
    mediaTypeProp = property(get_mediaType, set_mediaType)
    def validate_cs(self, value):
        # Validate type cs, a restriction on xs:token.
        pass
    def get_language(self): return self.language
    def set_language(self, language): self.language = language
    languageProp = property(get_language, set_language)
    def get_compression(self): return self.compression
    def set_compression(self, compression): self.compression = compression
    compressionProp = property(get_compression, set_compression)
    def validate_CompressionAlgorithm(self, value):
        # Validate type CompressionAlgorithm, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='ED', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='ED')
        if self.hasContent_():
            if self.hasSimpleContent_():
                outfile.write('>')
            else:
                outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            if not self.hasSimpleContent_():
                showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='ED'):
        super(ED, self).exportAttributes(outfile, level, already_processed, namespace_, name_='ED')
        if self.integrityCheckAlgorithm is not None and 'integrityCheckAlgorithm' not in already_processed and self.integrityCheckAlgorithm != "SHA-1":
            already_processed.append('integrityCheckAlgorithm')
            outfile.write(' integrityCheckAlgorithm=%s' % (quote_attrib(self.integrityCheckAlgorithm), ))
        if self.integrityCheck is not None and 'integrityCheck' not in already_processed:
            already_processed.append('integrityCheck')
            outfile.write(' integrityCheck=%s' % (quote_attrib(self.integrityCheck), ))
        if self.mediaType is not None and 'mediaType' not in already_processed and self.mediaType != "text/plain":
            already_processed.append('mediaType')
            outfile.write(' mediaType=%s' % (quote_attrib(self.mediaType), ))
        if self.language is not None and 'language' not in already_processed:
            already_processed.append('language')
            outfile.write(' language=%s' % (quote_attrib(self.language), ))
        if self.compression is not None and 'compression' not in already_processed:
            already_processed.append('compression')
            outfile.write(' compression=%s' % (quote_attrib(self.compression), ))
    def exportChildren(self, outfile, level, namespace_='', name_='ED', fromsubclass_=False):
        super(ED, self).exportChildren(outfile, level, namespace_, name_, True)
        if self.reference is not None:
            self.reference.export(outfile, level, namespace_, name_='reference')
        if self.thumbnail is not None:
            self.thumbnail.export(outfile, level, namespace_, name_='thumbnail')
        if self.valueOf_ is not None:
            outfile.write(self.valueOf_)
        elif not fromsubclass_:
            for item_ in self.content_:
                item_.export(outfile, level, item_.name, namespace_)
    def hasContent_(self):
        if (
            self.reference is not None or
            self.thumbnail is not None or
            self.valueOf_ or
            super(ED, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(ED, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('integrityCheckAlgorithm', node)
        if value is not None and 'integrityCheckAlgorithm' not in already_processed:
            already_processed.append('integrityCheckAlgorithm')
            self.integrityCheckAlgorithm = value
            self.validate_IntegrityCheckAlgorithm(self.integrityCheckAlgorithm)    # validate type IntegrityCheckAlgorithm
        value = find_attr_value_('integrityCheck', node)
        if value is not None and 'integrityCheck' not in already_processed:
            already_processed.append('integrityCheck')
            self.integrityCheck = value
            self.validate_bin(self.integrityCheck)    # validate type bin
        value = find_attr_value_('mediaType', node)
        if value is not None and 'mediaType' not in already_processed:
            already_processed.append('mediaType')
            self.mediaType = value
            self.mediaType = ' '.join(self.mediaType.split())
            self.validate_cs(self.mediaType)    # validate type cs
        value = find_attr_value_('language', node)
        if value is not None and 'language' not in already_processed:
            already_processed.append('language')
            self.language = value
            self.language = ' '.join(self.language.split())
            self.validate_cs(self.language)    # validate type cs
        value = find_attr_value_('compression', node)
        if value is not None and 'compression' not in already_processed:
            already_processed.append('compression')
            self.compression = value
            self.validate_CompressionAlgorithm(self.compression)    # validate type CompressionAlgorithm
        super(ED, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'reference':
            obj_ = TEL.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'reference', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_reference'):
              self.add_reference(obj_.value)
            elif hasattr(self, 'set_reference'):
              self.set_reference(obj_.value)
        elif nodeName_ == 'thumbnail':
            obj_ = thumbnail.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'thumbnail', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_thumbnail'):
              self.add_thumbnail(obj_.value)
            elif hasattr(self, 'set_thumbnail'):
              self.set_thumbnail(obj_.value)
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        super(ED, self).buildChildren(child_, node, nodeName_, True)
# end class ED


class thumbnail(ED):
    """A thumbnail is an abbreviated rendition of the full data. A
    thumbnail requires significantly fewer resources than the full
    data, while still maintaining some distinctive similarity with
    the full data. A thumbnail is typically used with by-reference
    encapsulated data. It allows a user to select data more
    efficiently before actually downloading through the reference."""
    member_data_items_ = [
        MemberSpec_('reference', 'TEL', 0, 0, 0),
        MemberSpec_('thumbnail', 'thumbnail', 0, 0, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ED
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, valueOf_=None, mixedclass_=None, content_=None):
        super(thumbnail, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, valueOf_, mixedclass_, content_, )
        self.reference = reference
        self.thumbnail = thumbnail
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if thumbnail.subclass:
            return thumbnail.subclass(*args_, **kwargs_)
        else:
            return thumbnail(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_reference(self): return self.reference
    def set_reference(self, reference): self.reference = reference
    referenceProp = property(get_reference, set_reference)
    def get_thumbnail(self): return self.thumbnail
    def set_thumbnail(self, thumbnail): self.thumbnail = thumbnail
    thumbnailProp = property(get_thumbnail, set_thumbnail)
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='thumbnail', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='thumbnail')
        if self.hasContent_():
            if self.hasSimpleContent_():
                outfile.write('>')
            else:
                outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            if not self.hasSimpleContent_():
                showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='thumbnail'):
        super(thumbnail, self).exportAttributes(outfile, level, already_processed, namespace_, name_='thumbnail')
    def exportChildren(self, outfile, level, namespace_='', name_='thumbnail', fromsubclass_=False):
        if self.reference is not None:
            self.reference.export(outfile, level, namespace_, name_='reference')
        if self.thumbnail is not None:
            self.thumbnail.export(outfile, level, namespace_, name_='thumbnail')
        if self.valueOf_ is not None:
            outfile.write(self.valueOf_)
        elif not fromsubclass_:
            for item_ in self.content_:
                item_.export(outfile, level, item_.name, namespace_)
    def hasContent_(self):
        if (
            self.reference is not None or
            self.thumbnail is not None or
            self.valueOf_ or
            super(thumbnail, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(thumbnail, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        super(thumbnail, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'reference':
            obj_ = TEL.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'reference', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_reference'):
              self.add_reference(obj_.value)
            elif hasattr(self, 'set_reference'):
              self.set_reference(obj_.value)
        elif nodeName_ == 'thumbnail':
            obj_ = thumbnail.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'thumbnail', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_thumbnail'):
              self.add_thumbnail(obj_.value)
            elif hasattr(self, 'set_thumbnail'):
              self.set_thumbnail(obj_.value)
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
# end class thumbnail


class ST(ED):
    """The character string data type stands for text data, primarily
    intended for machine processing (e.g., sorting, querying,
    indexing, etc.) Used for names, symbols, and formal expressions."""
    member_data_items_ = [
        MemberSpec_('integrityCheckAlgorithm', 'IntegrityCheckAlgorithm', 0, 1, 1),
        MemberSpec_('language', 'cs', 0, 1, 0),
        MemberSpec_('mediaType', 'cs', 0, 1, 0),
        MemberSpec_('integrityCheck', 'bin', 0, 1, 1),
        MemberSpec_('representation', 'BinaryDataEncoding', 0, 1, 0),
        MemberSpec_('compression', 'CompressionAlgorithm', 0, 1, 1),
        MemberSpec_('reference', 'TEL', 0, 0, 0),
        MemberSpec_('thumbnail', 'thumbnail', 0, 0, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ED
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, valueOf_=None, mixedclass_=None, content_=None, extensiontype_=None):
        super(ST, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, valueOf_, mixedclass_, content_, )
        self.integrityCheckAlgorithm = _cast(None, integrityCheckAlgorithm)
        self.language = _cast(None, language)
        self.mediaType = _cast(None, mediaType)
        self.integrityCheck = _cast(None, integrityCheck)
        self.representation = _cast(None, representation)
        self.compression = _cast(None, compression)
        self.reference = reference
        self.thumbnail = thumbnail
        self.valueOf_ = valueOf_
        self.extensiontype_ = extensiontype_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if ST.subclass:
            return ST.subclass(*args_, **kwargs_)
        else:
            return ST(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_reference(self): return self.reference
    def set_reference(self, reference): self.reference = reference
    referenceProp = property(get_reference, set_reference)
    def get_thumbnail(self): return self.thumbnail
    def set_thumbnail(self, thumbnail): self.thumbnail = thumbnail
    thumbnailProp = property(get_thumbnail, set_thumbnail)
    def get_integrityCheckAlgorithm(self): return self.integrityCheckAlgorithm
    def set_integrityCheckAlgorithm(self, integrityCheckAlgorithm): self.integrityCheckAlgorithm = integrityCheckAlgorithm
    integrityCheckAlgorithmProp = property(get_integrityCheckAlgorithm, set_integrityCheckAlgorithm)
    def validate_IntegrityCheckAlgorithm(self, value):
        # Validate type IntegrityCheckAlgorithm, a restriction on cs.
        pass
    def get_language(self): return self.language
    def set_language(self, language): self.language = language
    languageProp = property(get_language, set_language)
    def validate_cs(self, value):
        # Validate type cs, a restriction on xs:token.
        pass
    def get_mediaType(self): return self.mediaType
    def set_mediaType(self, mediaType): self.mediaType = mediaType
    mediaTypeProp = property(get_mediaType, set_mediaType)
    def get_integrityCheck(self): return self.integrityCheck
    def set_integrityCheck(self, integrityCheck): self.integrityCheck = integrityCheck
    integrityCheckProp = property(get_integrityCheck, set_integrityCheck)
    def validate_bin(self, value):
        # Validate type bin, a restriction on xs:base64Binary.
        pass
    def get_representation(self): return self.representation
    def set_representation(self, representation): self.representation = representation
    representationProp = property(get_representation, set_representation)
    def validate_BinaryDataEncoding(self, value):
        # Validate type BinaryDataEncoding, a restriction on xs:NMTOKEN.
        pass
    def get_compression(self): return self.compression
    def set_compression(self, compression): self.compression = compression
    compressionProp = property(get_compression, set_compression)
    def validate_CompressionAlgorithm(self, value):
        # Validate type CompressionAlgorithm, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def get_extensiontype_(self): return self.extensiontype_
    def set_extensiontype_(self, extensiontype_): self.extensiontype_ = extensiontype_
    def export(self, outfile, level, namespace_='', name_='ST', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='ST')
        if self.hasContent_():
            if self.hasSimpleContent_():
                outfile.write('>')
            else:
                outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            if not self.hasSimpleContent_():
                showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='ST'):
        already_processed.append('integrityCheckAlgorithm')
        already_processed.append('integrityCheck')
        already_processed.append('compression')
        super(ST, self).exportAttributes(outfile, level, already_processed, namespace_, name_='ST')
        if self.language is not None and 'language' not in already_processed:
            already_processed.append('language')
            outfile.write(' language=%s' % (quote_attrib(self.language), ))
        if self.mediaType is not None and 'mediaType' not in already_processed:
            already_processed.append('mediaType')
            outfile.write(' mediaType=%s' % (quote_attrib(self.mediaType), ))
        if self.representation is not None and 'representation' not in already_processed:
            already_processed.append('representation')
            outfile.write(' representation=%s' % (quote_attrib(self.representation), ))
        if self.extensiontype_ is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            outfile.write(' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"')
            outfile.write(' xsi:type="%s"' % self.extensiontype_)
    def exportChildren(self, outfile, level, namespace_='', name_='ST', fromsubclass_=False):
        if self.reference is not None:
            self.reference.export(outfile, level, namespace_, name_='reference')
        if self.thumbnail is not None:
            self.thumbnail.export(outfile, level, namespace_, name_='thumbnail')
        if self.valueOf_ is not None:
            outfile.write(self.valueOf_)
        elif not fromsubclass_:
            for item_ in self.content_:
                item_.export(outfile, level, item_.name, namespace_)
    def hasContent_(self):
        if (
            self.reference is not None or
            self.thumbnail is not None or
            self.valueOf_ or
            super(ST, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(ST, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('integrityCheckAlgorithm', node)
        if value is not None and 'integrityCheckAlgorithm' not in already_processed:
            already_processed.append('integrityCheckAlgorithm')
            self.integrityCheckAlgorithm = value
            self.validate_IntegrityCheckAlgorithm(self.integrityCheckAlgorithm)    # validate type IntegrityCheckAlgorithm
        value = find_attr_value_('language', node)
        if value is not None and 'language' not in already_processed:
            already_processed.append('language')
            self.language = value
            self.language = ' '.join(self.language.split())
            self.validate_cs(self.language)    # validate type cs
        value = find_attr_value_('mediaType', node)
        if value is not None and 'mediaType' not in already_processed:
            already_processed.append('mediaType')
            self.mediaType = value
            self.mediaType = ' '.join(self.mediaType.split())
            self.validate_cs(self.mediaType)    # validate type cs
        value = find_attr_value_('integrityCheck', node)
        if value is not None and 'integrityCheck' not in already_processed:
            already_processed.append('integrityCheck')
            self.integrityCheck = value
            self.validate_bin(self.integrityCheck)    # validate type bin
        value = find_attr_value_('representation', node)
        if value is not None and 'representation' not in already_processed:
            already_processed.append('representation')
            self.representation = value
            self.validate_BinaryDataEncoding(self.representation)    # validate type BinaryDataEncoding
        value = find_attr_value_('compression', node)
        if value is not None and 'compression' not in already_processed:
            already_processed.append('compression')
            self.compression = value
            self.validate_CompressionAlgorithm(self.compression)    # validate type CompressionAlgorithm
        value = find_attr_value_('xsi:type', node)
        if value is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            self.extensiontype_ = value
        super(ST, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'reference':
            obj_ = TEL.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'reference', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_reference'):
              self.add_reference(obj_.value)
            elif hasattr(self, 'set_reference'):
              self.set_reference(obj_.value)
        elif nodeName_ == 'thumbnail':
            obj_ = ED.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'thumbnail', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_thumbnail'):
              self.add_thumbnail(obj_.value)
            elif hasattr(self, 'set_thumbnail'):
              self.set_thumbnail(obj_.value)
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
# end class ST


class CD(ANY):
    """A concept descriptor represents any kind of concept usually by
    giving a code defined in a code system. A concept descriptor can
    contain the original text or phrase that served as the basis of
    the coding and one or more translations into different coding
    systems. A concept descriptor can also contain qualifiers to
    describe, e.g., the concept of a "left foot" as a
    postcoordinated term built from the primary code "FOOT" and the
    qualifier "LEFT". In exceptional cases, the concept descriptor
    need not contain a code but only the original text describing
    that concept. The plain code symbol defined by the code system.
    For example, "784.0" is the code symbol of the ICD-9 code
    "784.0" for headache. Specifies the code system that defines the
    code. A common name of the coding system. If applicable, a
    version descriptor defined specifically for the given code
    system. A name or title for the code, under which the sending
    system shows the code value to its users."""
    member_data_items_ = [
        MemberSpec_('codeSystemVersion', 'st', 0, 1, 0),
        MemberSpec_('codeSystemName', 'st', 0, 1, 0),
        MemberSpec_('code', 'cs', 0, 1, 0),
        MemberSpec_('displayName', 'st', 0, 1, 0),
        MemberSpec_('codeSystem', 'uid', 0, 1, 0),
        MemberSpec_('originalText', 'ED', 0, 0, 0),
        MemberSpec_('qualifier', 'CR', 1, 0, 0),
        MemberSpec_('translation', 'CD', 1, 0, 0),
        MemberSpec_('valueOf_', 'ANY', 0, 0, 0),
        ]
    subclass = None
    superclass = ANY
    def __init__(self, nullFlavor=None, codeSystemVersion=None, codeSystemName=None, code=None, displayName=None, codeSystem=None, originalText=None, qualifier=None, translation=None, valueOf_=None, mixedclass_=None, content_=None, extensiontype_=None):
        super(CD, self).__init__(nullFlavor, valueOf_, mixedclass_, content_, extensiontype_, )
        self.codeSystemVersion = _cast(None, codeSystemVersion)
        self.codeSystemName = _cast(None, codeSystemName)
        self.code = _cast(None, code)
        self.displayName = _cast(None, displayName)
        self.codeSystem = _cast(None, codeSystem)
        self.originalText = originalText
        if qualifier is None:
            self.qualifier = []
        else:
            self.qualifier = qualifier
        if translation is None:
            self.translation = []
        else:
            self.translation = translation
        self.valueOf_ = valueOf_
        self.extensiontype_ = extensiontype_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if CD.subclass:
            return CD.subclass(*args_, **kwargs_)
        else:
            return CD(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_originalText(self): return self.originalText
    def set_originalText(self, originalText): self.originalText = originalText
    originalTextProp = property(get_originalText, set_originalText)
    def get_qualifier(self): return self.qualifier
    def set_qualifier(self, qualifier): self.qualifier = qualifier
    def add_qualifier(self, value): self.qualifier.append(value)
    def insert_qualifier(self, index, value): self.qualifier[index] = value
    qualifierProp = property(get_qualifier, set_qualifier)
    def get_translation(self): return self.translation
    def set_translation(self, translation): self.translation = translation
    def add_translation(self, value): self.translation.append(value)
    def insert_translation(self, index, value): self.translation[index] = value
    translationProp = property(get_translation, set_translation)
    def get_codeSystemVersion(self): return self.codeSystemVersion
    def set_codeSystemVersion(self, codeSystemVersion): self.codeSystemVersion = codeSystemVersion
    codeSystemVersionProp = property(get_codeSystemVersion, set_codeSystemVersion)
    def validate_st(self, value):
        # Validate type st, a restriction on xs:string.
        pass
    def get_codeSystemName(self): return self.codeSystemName
    def set_codeSystemName(self, codeSystemName): self.codeSystemName = codeSystemName
    codeSystemNameProp = property(get_codeSystemName, set_codeSystemName)
    def get_code(self): return self.code
    def set_code(self, code): self.code = code
    codeProp = property(get_code, set_code)
    def validate_cs(self, value):
        # Validate type cs, a restriction on xs:token.
        pass
    def get_displayName(self): return self.displayName
    def set_displayName(self, displayName): self.displayName = displayName
    displayNameProp = property(get_displayName, set_displayName)
    def get_codeSystem(self): return self.codeSystem
    def set_codeSystem(self, codeSystem): self.codeSystem = codeSystem
    codeSystemProp = property(get_codeSystem, set_codeSystem)
    def validate_uid(self, value):
        # Validate type uid, a restriction on None.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def get_extensiontype_(self): return self.extensiontype_
    def set_extensiontype_(self, extensiontype_): self.extensiontype_ = extensiontype_
    def export(self, outfile, level, namespace_='', name_='CD', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='CD')
        if self.hasContent_():
            if self.hasSimpleContent_():
                outfile.write('>')
            else:
                outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            if not self.hasSimpleContent_():
                showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='CD'):
        super(CD, self).exportAttributes(outfile, level, already_processed, namespace_, name_='CD')
        if self.codeSystemVersion is not None and 'codeSystemVersion' not in already_processed:
            already_processed.append('codeSystemVersion')
            outfile.write(' codeSystemVersion=%s' % (quote_attrib(self.codeSystemVersion), ))
        if self.codeSystemName is not None and 'codeSystemName' not in already_processed:
            already_processed.append('codeSystemName')
            outfile.write(' codeSystemName=%s' % (quote_attrib(self.codeSystemName), ))
        if self.code is not None and 'code' not in already_processed:
            already_processed.append('code')
            outfile.write(' code=%s' % (quote_attrib(self.code), ))
        if self.displayName is not None and 'displayName' not in already_processed:
            already_processed.append('displayName')
            outfile.write(' displayName=%s' % (quote_attrib(self.displayName), ))
        if self.codeSystem is not None and 'codeSystem' not in already_processed:
            already_processed.append('codeSystem')
            outfile.write(' codeSystem=%s' % (quote_attrib(self.codeSystem), ))
        if self.extensiontype_ is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            outfile.write(' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"')
            outfile.write(' xsi:type="%s"' % self.extensiontype_)
    def exportChildren(self, outfile, level, namespace_='', name_='CD', fromsubclass_=False):
        super(CD, self).exportChildren(outfile, level, namespace_, name_, True)
        if self.originalText is not None:
            self.originalText.export(outfile, level, namespace_, name_='originalText')
        for qualifier_ in self.qualifier:
            qualifier_.export(outfile, level, namespace_, name_='qualifier')
        for translation_ in self.translation:
            translation_.export(outfile, level, namespace_, name_='translation')
        if self.valueOf_ is not None:
            outfile.write(self.valueOf_)
        elif not fromsubclass_:
            for item_ in self.content_:
                item_.export(outfile, level, item_.name, namespace_)
    def hasContent_(self):
        if (
            self.originalText is not None or
            self.qualifier or
            self.translation or
            self.valueOf_ or
            super(CD, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(CD, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('codeSystemVersion', node)
        if value is not None and 'codeSystemVersion' not in already_processed:
            already_processed.append('codeSystemVersion')
            self.codeSystemVersion = value
            self.validate_st(self.codeSystemVersion)    # validate type st
        value = find_attr_value_('codeSystemName', node)
        if value is not None and 'codeSystemName' not in already_processed:
            already_processed.append('codeSystemName')
            self.codeSystemName = value
            self.validate_st(self.codeSystemName)    # validate type st
        value = find_attr_value_('code', node)
        if value is not None and 'code' not in already_processed:
            already_processed.append('code')
            self.code = value
            self.code = ' '.join(self.code.split())
            self.validate_cs(self.code)    # validate type cs
        value = find_attr_value_('displayName', node)
        if value is not None and 'displayName' not in already_processed:
            already_processed.append('displayName')
            self.displayName = value
            self.validate_st(self.displayName)    # validate type st
        value = find_attr_value_('codeSystem', node)
        if value is not None and 'codeSystem' not in already_processed:
            already_processed.append('codeSystem')
            self.codeSystem = value
            self.validate_uid(self.codeSystem)    # validate type uid
        value = find_attr_value_('xsi:type', node)
        if value is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            self.extensiontype_ = value
        super(CD, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'originalText':
            obj_ = ED.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'originalText', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_originalText'):
              self.add_originalText(obj_.value)
            elif hasattr(self, 'set_originalText'):
              self.set_originalText(obj_.value)
        elif nodeName_ == 'qualifier':
            obj_ = CR.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'qualifier', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_qualifier'):
              self.add_qualifier(obj_.value)
            elif hasattr(self, 'set_qualifier'):
              self.set_qualifier(obj_.value)
        elif nodeName_ == 'translation':
            obj_ = self.get_class_obj_(child_, CD)
            obj_ = CD.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'translation', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_translation'):
              self.add_translation(obj_.value)
            elif hasattr(self, 'set_translation'):
              self.set_translation(obj_.value)
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        super(CD, self).buildChildren(child_, node, nodeName_, True)
# end class CD


class CE(CD):
    """Coded data, consists of a coded value (CV) and, optionally, coded
    value(s) from other coding systems that identify the same
    concept. Used when alternative codes may exist. The plain code
    symbol defined by the code system. For example, "784.0" is the
    code symbol of the ICD-9 code "784.0" for headache. Specifies
    the code system that defines the code. A common name of the
    coding system. If applicable, a version descriptor defined
    specifically for the given code system. A name or title for the
    code, under which the sending system shows the code value to its
    users."""
    member_data_items_ = [
        MemberSpec_('codeSystemVersion', 'st', 0, 1, 0),
        MemberSpec_('codeSystemName', 'st', 0, 1, 0),
        MemberSpec_('code', 'cs', 0, 1, 0),
        MemberSpec_('displayName', 'st', 0, 1, 0),
        MemberSpec_('codeSystem', 'uid', 0, 1, 0),
        MemberSpec_('originalText', 'ED', 0, 0, 0),
        MemberSpec_('qualifier', 'CR', 0, 0, 0),
        MemberSpec_('translation', 'CD', 1, 0, 0),
        ]
    subclass = None
    superclass = CD
    def __init__(self, nullFlavor=None, codeSystemVersion=None, codeSystemName=None, code=None, displayName=None, codeSystem=None, originalText=None, qualifier=None, translation=None, extensiontype_=None):
        super(CE, self).__init__(nullFlavor, codeSystemVersion, codeSystemName, code, displayName, codeSystem, originalText, qualifier, translation, extensiontype_, )
        self.codeSystemVersion = _cast(None, codeSystemVersion)
        self.codeSystemName = _cast(None, codeSystemName)
        self.code = _cast(None, code)
        self.displayName = _cast(None, displayName)
        self.codeSystem = _cast(None, codeSystem)
        self.originalText = originalText
        self.qualifier = qualifier
        if translation is None:
            self.translation = []
        else:
            self.translation = translation
        self.extensiontype_ = extensiontype_
    def factory(*args_, **kwargs_):
        if CE.subclass:
            return CE.subclass(*args_, **kwargs_)
        else:
            return CE(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_originalText(self): return self.originalText
    def set_originalText(self, originalText): self.originalText = originalText
    originalTextProp = property(get_originalText, set_originalText)
    def get_qualifier(self): return self.qualifier
    def set_qualifier(self, qualifier): self.qualifier = qualifier
    qualifierProp = property(get_qualifier, set_qualifier)
    def get_translation(self): return self.translation
    def set_translation(self, translation): self.translation = translation
    def add_translation(self, value): self.translation.append(value)
    def insert_translation(self, index, value): self.translation[index] = value
    translationProp = property(get_translation, set_translation)
    def get_codeSystemVersion(self): return self.codeSystemVersion
    def set_codeSystemVersion(self, codeSystemVersion): self.codeSystemVersion = codeSystemVersion
    codeSystemVersionProp = property(get_codeSystemVersion, set_codeSystemVersion)
    def validate_st(self, value):
        # Validate type st, a restriction on xs:string.
        pass
    def get_codeSystemName(self): return self.codeSystemName
    def set_codeSystemName(self, codeSystemName): self.codeSystemName = codeSystemName
    codeSystemNameProp = property(get_codeSystemName, set_codeSystemName)
    def get_code(self): return self.code
    def set_code(self, code): self.code = code
    codeProp = property(get_code, set_code)
    def validate_cs(self, value):
        # Validate type cs, a restriction on xs:token.
        pass
    def get_displayName(self): return self.displayName
    def set_displayName(self, displayName): self.displayName = displayName
    displayNameProp = property(get_displayName, set_displayName)
    def get_codeSystem(self): return self.codeSystem
    def set_codeSystem(self, codeSystem): self.codeSystem = codeSystem
    codeSystemProp = property(get_codeSystem, set_codeSystem)
    def validate_uid(self, value):
        # Validate type uid, a restriction on None.
        pass
    def get_extensiontype_(self): return self.extensiontype_
    def set_extensiontype_(self, extensiontype_): self.extensiontype_ = extensiontype_
    def export(self, outfile, level, namespace_='', name_='CE', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='CE')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='CE'):
        super(CE, self).exportAttributes(outfile, level, already_processed, namespace_, name_='CE')
        if self.codeSystemVersion is not None and 'codeSystemVersion' not in already_processed:
            already_processed.append('codeSystemVersion')
            outfile.write(' codeSystemVersion=%s' % (quote_attrib(self.codeSystemVersion), ))
        if self.codeSystemName is not None and 'codeSystemName' not in already_processed:
            already_processed.append('codeSystemName')
            outfile.write(' codeSystemName=%s' % (quote_attrib(self.codeSystemName), ))
        if self.code is not None and 'code' not in already_processed:
            already_processed.append('code')
            outfile.write(' code=%s' % (quote_attrib(self.code), ))
        if self.displayName is not None and 'displayName' not in already_processed:
            already_processed.append('displayName')
            outfile.write(' displayName=%s' % (quote_attrib(self.displayName), ))
        if self.codeSystem is not None and 'codeSystem' not in already_processed:
            already_processed.append('codeSystem')
            outfile.write(' codeSystem=%s' % (quote_attrib(self.codeSystem), ))
        if self.extensiontype_ is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            outfile.write(' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"')
            outfile.write(' xsi:type="%s"' % self.extensiontype_)
    def exportChildren(self, outfile, level, namespace_='', name_='CE', fromsubclass_=False):
        if self.originalText is not None:
            self.originalText.export(outfile, level, namespace_, name_='originalText')
        if self.qualifier is not None:
            self.qualifier.export(outfile, level, namespace_, name_='qualifier')
        for translation_ in self.translation:
            translation_.export(outfile, level, namespace_, name_='translation')
    def hasContent_(self):
        if (
            self.originalText is not None or
            self.qualifier is not None or
            self.translation or
            super(CE, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('codeSystemVersion', node)
        if value is not None and 'codeSystemVersion' not in already_processed:
            already_processed.append('codeSystemVersion')
            self.codeSystemVersion = value
            self.validate_st(self.codeSystemVersion)    # validate type st
        value = find_attr_value_('codeSystemName', node)
        if value is not None and 'codeSystemName' not in already_processed:
            already_processed.append('codeSystemName')
            self.codeSystemName = value
            self.validate_st(self.codeSystemName)    # validate type st
        value = find_attr_value_('code', node)
        if value is not None and 'code' not in already_processed:
            already_processed.append('code')
            self.code = value
            self.code = ' '.join(self.code.split())
            self.validate_cs(self.code)    # validate type cs
        value = find_attr_value_('displayName', node)
        if value is not None and 'displayName' not in already_processed:
            already_processed.append('displayName')
            self.displayName = value
            self.validate_st(self.displayName)    # validate type st
        value = find_attr_value_('codeSystem', node)
        if value is not None and 'codeSystem' not in already_processed:
            already_processed.append('codeSystem')
            self.codeSystem = value
            self.validate_uid(self.codeSystem)    # validate type uid
        value = find_attr_value_('xsi:type', node)
        if value is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            self.extensiontype_ = value
        super(CE, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'originalText':
            obj_ = build_object(child_, 'ED')
            self.set_originalText(obj_)
        elif nodeName_ == 'qualifier':
            obj_ = build_object(child_, 'CR')
            self.set_qualifier(obj_)
        elif nodeName_ == 'translation':
            obj_ = build_object(child_, 'CD')
            self.translation.append(obj_)
# end class CE


class CV(CE):
    """Coded data, consists of a code, display name, code system, and
    original text. Used when a single code value must be sent. The
    plain code symbol defined by the code system. For example,
    "784.0" is the code symbol of the ICD-9 code "784.0" for
    headache. Specifies the code system that defines the code. A
    common name of the coding system. If applicable, a version
    descriptor defined specifically for the given code system. A
    name or title for the code, under which the sending system shows
    the code value to its users."""
    member_data_items_ = [
        MemberSpec_('codeSystemVersion', 'st', 0, 1, 0),
        MemberSpec_('codeSystemName', 'st', 0, 1, 0),
        MemberSpec_('code', 'cs', 0, 1, 0),
        MemberSpec_('displayName', 'st', 0, 1, 0),
        MemberSpec_('codeSystem', 'uid', 0, 1, 0),
        MemberSpec_('originalText', 'ED', 0, 0, 0),
        MemberSpec_('translation', 'CD', 0, 0, 0),
        ]
    subclass = None
    superclass = CE
    def __init__(self, nullFlavor=None, codeSystemVersion=None, codeSystemName=None, code=None, displayName=None, codeSystem=None, originalText=None, qualifier=None, translation=None, extensiontype_=None):
        super(CV, self).__init__(nullFlavor, codeSystemVersion, codeSystemName, code, displayName, codeSystem, originalText, qualifier, translation, extensiontype_, )
        self.codeSystemVersion = _cast(None, codeSystemVersion)
        self.codeSystemName = _cast(None, codeSystemName)
        self.code = _cast(None, code)
        self.displayName = _cast(None, displayName)
        self.codeSystem = _cast(None, codeSystem)
        self.originalText = originalText
        self.translation = translation
        self.extensiontype_ = extensiontype_
    def factory(*args_, **kwargs_):
        if CV.subclass:
            return CV.subclass(*args_, **kwargs_)
        else:
            return CV(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_originalText(self): return self.originalText
    def set_originalText(self, originalText): self.originalText = originalText
    originalTextProp = property(get_originalText, set_originalText)
    def get_translation(self): return self.translation
    def set_translation(self, translation): self.translation = translation
    translationProp = property(get_translation, set_translation)
    def get_codeSystemVersion(self): return self.codeSystemVersion
    def set_codeSystemVersion(self, codeSystemVersion): self.codeSystemVersion = codeSystemVersion
    codeSystemVersionProp = property(get_codeSystemVersion, set_codeSystemVersion)
    def validate_st(self, value):
        # Validate type st, a restriction on xs:string.
        pass
    def get_codeSystemName(self): return self.codeSystemName
    def set_codeSystemName(self, codeSystemName): self.codeSystemName = codeSystemName
    codeSystemNameProp = property(get_codeSystemName, set_codeSystemName)
    def get_code(self): return self.code
    def set_code(self, code): self.code = code
    codeProp = property(get_code, set_code)
    def validate_cs(self, value):
        # Validate type cs, a restriction on xs:token.
        pass
    def get_displayName(self): return self.displayName
    def set_displayName(self, displayName): self.displayName = displayName
    displayNameProp = property(get_displayName, set_displayName)
    def get_codeSystem(self): return self.codeSystem
    def set_codeSystem(self, codeSystem): self.codeSystem = codeSystem
    codeSystemProp = property(get_codeSystem, set_codeSystem)
    def validate_uid(self, value):
        # Validate type uid, a restriction on None.
        pass
    def get_extensiontype_(self): return self.extensiontype_
    def set_extensiontype_(self, extensiontype_): self.extensiontype_ = extensiontype_
    def export(self, outfile, level, namespace_='', name_='CV', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='CV')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='CV'):
        super(CV, self).exportAttributes(outfile, level, already_processed, namespace_, name_='CV')
        if self.codeSystemVersion is not None and 'codeSystemVersion' not in already_processed:
            already_processed.append('codeSystemVersion')
            outfile.write(' codeSystemVersion=%s' % (quote_attrib(self.codeSystemVersion), ))
        if self.codeSystemName is not None and 'codeSystemName' not in already_processed:
            already_processed.append('codeSystemName')
            outfile.write(' codeSystemName=%s' % (quote_attrib(self.codeSystemName), ))
        if self.code is not None and 'code' not in already_processed:
            already_processed.append('code')
            outfile.write(' code=%s' % (quote_attrib(self.code), ))
        if self.displayName is not None and 'displayName' not in already_processed:
            already_processed.append('displayName')
            outfile.write(' displayName=%s' % (quote_attrib(self.displayName), ))
        if self.codeSystem is not None and 'codeSystem' not in already_processed:
            already_processed.append('codeSystem')
            outfile.write(' codeSystem=%s' % (quote_attrib(self.codeSystem), ))
        if self.extensiontype_ is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            outfile.write(' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"')
            outfile.write(' xsi:type="%s"' % self.extensiontype_)
    def exportChildren(self, outfile, level, namespace_='', name_='CV', fromsubclass_=False):
        if self.originalText is not None:
            self.originalText.export(outfile, level, namespace_, name_='originalText')
        if self.translation is not None:
            self.translation.export(outfile, level, namespace_, name_='translation')
    def hasContent_(self):
        if (
            self.originalText is not None or
            self.translation is not None or
            super(CV, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('codeSystemVersion', node)
        if value is not None and 'codeSystemVersion' not in already_processed:
            already_processed.append('codeSystemVersion')
            self.codeSystemVersion = value
            self.validate_st(self.codeSystemVersion)    # validate type st
        value = find_attr_value_('codeSystemName', node)
        if value is not None and 'codeSystemName' not in already_processed:
            already_processed.append('codeSystemName')
            self.codeSystemName = value
            self.validate_st(self.codeSystemName)    # validate type st
        value = find_attr_value_('code', node)
        if value is not None and 'code' not in already_processed:
            already_processed.append('code')
            self.code = value
            self.code = ' '.join(self.code.split())
            self.validate_cs(self.code)    # validate type cs
        value = find_attr_value_('displayName', node)
        if value is not None and 'displayName' not in already_processed:
            already_processed.append('displayName')
            self.displayName = value
            self.validate_st(self.displayName)    # validate type st
        value = find_attr_value_('codeSystem', node)
        if value is not None and 'codeSystem' not in already_processed:
            already_processed.append('codeSystem')
            self.codeSystem = value
            self.validate_uid(self.codeSystem)    # validate type uid
        value = find_attr_value_('xsi:type', node)
        if value is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            self.extensiontype_ = value
        super(CV, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'originalText':
            obj_ = build_object(child_, 'ED')
            self.set_originalText(obj_)
        elif nodeName_ == 'translation':
            obj_ = build_object(child_, 'CD')
            self.set_translation(obj_)
# end class CV


class CS(CV):
    """Coded data, consists of a code, display name, code system, and
    original text. Used when a single code value must be sent. The
    plain code symbol defined by the code system. For example,
    "784.0" is the code symbol of the ICD-9 code "784.0" for
    headache."""
    member_data_items_ = [
        MemberSpec_('codeSystemVersion', 'st', 0, 1, 1),
        MemberSpec_('codeSystemName', 'st', 0, 1, 1),
        MemberSpec_('code', 'cs', 0, 1, 0),
        MemberSpec_('displayName', 'st', 0, 1, 1),
        MemberSpec_('codeSystem', 'uid', 0, 1, 1),
        ]
    subclass = None
    superclass = CV
    def __init__(self, nullFlavor=None, codeSystemVersion=None, codeSystemName=None, code=None, displayName=None, codeSystem=None, originalText=None, qualifier=None, translation=None):
        super(CS, self).__init__(nullFlavor, codeSystemVersion, codeSystemName, code, displayName, codeSystem, originalText, qualifier, translation, )
        self.codeSystemVersion = _cast(None, codeSystemVersion)
        self.codeSystemName = _cast(None, codeSystemName)
        self.code = _cast(None, code)
        self.displayName = _cast(None, displayName)
        self.codeSystem = _cast(None, codeSystem)
        pass
    def factory(*args_, **kwargs_):
        if CS.subclass:
            return CS.subclass(*args_, **kwargs_)
        else:
            return CS(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_codeSystemVersion(self): return self.codeSystemVersion
    def set_codeSystemVersion(self, codeSystemVersion): self.codeSystemVersion = codeSystemVersion
    codeSystemVersionProp = property(get_codeSystemVersion, set_codeSystemVersion)
    def validate_st(self, value):
        # Validate type st, a restriction on xs:string.
        pass
    def get_codeSystemName(self): return self.codeSystemName
    def set_codeSystemName(self, codeSystemName): self.codeSystemName = codeSystemName
    codeSystemNameProp = property(get_codeSystemName, set_codeSystemName)
    def get_code(self): return self.code
    def set_code(self, code): self.code = code
    codeProp = property(get_code, set_code)
    def validate_cs(self, value):
        # Validate type cs, a restriction on xs:token.
        pass
    def get_displayName(self): return self.displayName
    def set_displayName(self, displayName): self.displayName = displayName
    displayNameProp = property(get_displayName, set_displayName)
    def get_codeSystem(self): return self.codeSystem
    def set_codeSystem(self, codeSystem): self.codeSystem = codeSystem
    codeSystemProp = property(get_codeSystem, set_codeSystem)
    def validate_uid(self, value):
        # Validate type uid, a restriction on None.
        pass
    def export(self, outfile, level, namespace_='', name_='CS', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='CS')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='CS'):
        already_processed.append('codeSystemVersion')
        already_processed.append('codeSystemName')
        already_processed.append('displayName')
        already_processed.append('codeSystem')
        super(CS, self).exportAttributes(outfile, level, already_processed, namespace_, name_='CS')
        if self.code is not None and 'code' not in already_processed:
            already_processed.append('code')
            outfile.write(' code=%s' % (quote_attrib(self.code), ))
    def exportChildren(self, outfile, level, namespace_='', name_='CS', fromsubclass_=False):
        super(CS, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            super(CS, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('codeSystemVersion', node)
        if value is not None and 'codeSystemVersion' not in already_processed:
            already_processed.append('codeSystemVersion')
            self.codeSystemVersion = value
            self.validate_st(self.codeSystemVersion)    # validate type st
        value = find_attr_value_('codeSystemName', node)
        if value is not None and 'codeSystemName' not in already_processed:
            already_processed.append('codeSystemName')
            self.codeSystemName = value
            self.validate_st(self.codeSystemName)    # validate type st
        value = find_attr_value_('code', node)
        if value is not None and 'code' not in already_processed:
            already_processed.append('code')
            self.code = value
            self.code = ' '.join(self.code.split())
            self.validate_cs(self.code)    # validate type cs
        value = find_attr_value_('displayName', node)
        if value is not None and 'displayName' not in already_processed:
            already_processed.append('displayName')
            self.displayName = value
            self.validate_st(self.displayName)    # validate type st
        value = find_attr_value_('codeSystem', node)
        if value is not None and 'codeSystem' not in already_processed:
            already_processed.append('codeSystem')
            self.codeSystem = value
            self.validate_uid(self.codeSystem)    # validate type uid
        super(CS, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class CS


class CO(CV):
    """Coded data, where the domain from which the codeset comes is
    ordered. The Coded Ordinal data type adds semantics related to
    ordering so that models that make use of such domains may
    introduce model elements that involve statements about the order
    of the terms in a domain."""
    member_data_items_ = [
        ]
    subclass = None
    superclass = CV
    def __init__(self, nullFlavor=None, codeSystemVersion=None, codeSystemName=None, code=None, displayName=None, codeSystem=None, originalText=None, qualifier=None, translation=None):
        super(CO, self).__init__(nullFlavor, codeSystemVersion, codeSystemName, code, displayName, codeSystem, originalText, qualifier, translation, )
        pass
    def factory(*args_, **kwargs_):
        if CO.subclass:
            return CO.subclass(*args_, **kwargs_)
        else:
            return CO(*args_, **kwargs_)
    factory = staticmethod(factory)
    def export(self, outfile, level, namespace_='', name_='CO', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='CO')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='CO'):
        super(CO, self).exportAttributes(outfile, level, already_processed, namespace_, name_='CO')
    def exportChildren(self, outfile, level, namespace_='', name_='CO', fromsubclass_=False):
        super(CO, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            super(CO, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        super(CO, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        super(CO, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class CO


class CR(ANY):
    """A concept qualifier code with optionally named role. Both qualifier
    role and value codes must be defined by the coding system. For
    example, if SNOMED RT defines a concept "leg", a role relation
    "has-laterality", and another concept "left", the concept role
    relation allows to add the qualifier "has-laterality: left" to a
    primary code "leg" to construct the meaning "left leg".
    Indicates if the sense of the role name is inverted. This can be
    used in cases where the underlying code system defines inversion
    but does not provide reciprocal pairs of role names. By default,
    inverted is false."""
    member_data_items_ = [
        MemberSpec_('inverted', 'bn', 0, 1, 0),
        MemberSpec_('name', 'CV', 0, 0, 0),
        MemberSpec_('value', 'CD', 0, 0, 0),
        MemberSpec_('valueOf_', 'ANY', 0, 0, 0),
        ]
    subclass = None
    superclass = ANY
    def __init__(self, nullFlavor=None, inverted='false', name=None, value=None, valueOf_=None, mixedclass_=None, content_=None):
        super(CR, self).__init__(nullFlavor, valueOf_, mixedclass_, content_, )
        self.inverted = _cast(None, inverted)
        self.name = name
        self.value = value
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if CR.subclass:
            return CR.subclass(*args_, **kwargs_)
        else:
            return CR(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_name(self): return self.name
    def set_name(self, name): self.name = name
    nameProp = property(get_name, set_name)
    def get_value(self): return self.value
    def set_value(self, value): self.value = value
    valueProp = property(get_value, set_value)
    def get_inverted(self): return self.inverted
    def set_inverted(self, inverted): self.inverted = inverted
    invertedProp = property(get_inverted, set_inverted)
    def validate_bn(self, value):
        # Validate type bn, a restriction on bl.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='CR', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='CR')
        if self.hasContent_():
            if self.hasSimpleContent_():
                outfile.write('>')
            else:
                outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            if not self.hasSimpleContent_():
                showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='CR'):
        super(CR, self).exportAttributes(outfile, level, already_processed, namespace_, name_='CR')
        if self.inverted is not None and 'inverted' not in already_processed and self.inverted != "false":
            already_processed.append('inverted')
            outfile.write(' inverted=%s' % (quote_attrib(self.inverted), ))
    def exportChildren(self, outfile, level, namespace_='', name_='CR', fromsubclass_=False):
        super(CR, self).exportChildren(outfile, level, namespace_, name_, True)
        if self.name is not None:
            self.name.export(outfile, level, namespace_, name_='name')
        if self.value is not None:
            self.value.export(outfile, level, namespace_, name_='value')
        if self.valueOf_ is not None:
            outfile.write(self.valueOf_)
        elif not fromsubclass_:
            for item_ in self.content_:
                item_.export(outfile, level, item_.name, namespace_)
    def hasContent_(self):
        if (
            self.name is not None or
            self.value is not None or
            self.valueOf_ or
            super(CR, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(CR, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('inverted', node)
        if value is not None and 'inverted' not in already_processed:
            already_processed.append('inverted')
            self.inverted = value
            self.validate_bn(self.inverted)    # validate type bn
        super(CR, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'name':
            obj_ = self.get_class_obj_(child_, CV)
            obj_ = CV.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'name', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_name'):
              self.add_name(obj_.value)
            elif hasattr(self, 'set_name'):
              self.set_name(obj_.value)
        elif nodeName_ == 'value':
            obj_ = self.get_class_obj_(child_, CD)
            obj_ = CD.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'value', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_value'):
              self.add_value(obj_.value)
            elif hasattr(self, 'set_value'):
              self.set_value(obj_.value)
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        super(CR, self).buildChildren(child_, node, nodeName_, True)
# end class CR


class SC(ST):
    """An ST that optionally may have a code attached. The text must always
    be present if a code is present. The code is often a local code.
    The plain code symbol defined by the code system. For example,
    "784.0" is the code symbol of the ICD-9 code "784.0" for
    headache. Specifies the code system that defines the code. A
    common name of the coding system. If applicable, a version
    descriptor defined specifically for the given code system. A
    name or title for the code, under which the sending system shows
    the code value to its users."""
    member_data_items_ = [
        MemberSpec_('codeSystemVersion', 'st', 0, 1, 0),
        MemberSpec_('codeSystemName', 'st', 0, 1, 0),
        MemberSpec_('code', 'cs', 0, 1, 0),
        MemberSpec_('displayName', 'st', 0, 1, 0),
        MemberSpec_('codeSystem', 'uid', 0, 1, 0),
        MemberSpec_('valueOf_', 'ST', 0, 0, 0),
        ]
    subclass = None
    superclass = ST
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, codeSystemVersion=None, codeSystemName=None, code=None, displayName=None, codeSystem=None, valueOf_=None, mixedclass_=None, content_=None):
        super(SC, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, valueOf_, mixedclass_, content_, )
        self.codeSystemVersion = _cast(None, codeSystemVersion)
        self.codeSystemName = _cast(None, codeSystemName)
        self.code = _cast(None, code)
        self.displayName = _cast(None, displayName)
        self.codeSystem = _cast(None, codeSystem)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if SC.subclass:
            return SC.subclass(*args_, **kwargs_)
        else:
            return SC(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_codeSystemVersion(self): return self.codeSystemVersion
    def set_codeSystemVersion(self, codeSystemVersion): self.codeSystemVersion = codeSystemVersion
    codeSystemVersionProp = property(get_codeSystemVersion, set_codeSystemVersion)
    def validate_st(self, value):
        # Validate type st, a restriction on xs:string.
        pass
    def get_codeSystemName(self): return self.codeSystemName
    def set_codeSystemName(self, codeSystemName): self.codeSystemName = codeSystemName
    codeSystemNameProp = property(get_codeSystemName, set_codeSystemName)
    def get_code(self): return self.code
    def set_code(self, code): self.code = code
    codeProp = property(get_code, set_code)
    def validate_cs(self, value):
        # Validate type cs, a restriction on xs:token.
        pass
    def get_displayName(self): return self.displayName
    def set_displayName(self, displayName): self.displayName = displayName
    displayNameProp = property(get_displayName, set_displayName)
    def get_codeSystem(self): return self.codeSystem
    def set_codeSystem(self, codeSystem): self.codeSystem = codeSystem
    codeSystemProp = property(get_codeSystem, set_codeSystem)
    def validate_uid(self, value):
        # Validate type uid, a restriction on None.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='SC', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='SC')
        if self.hasContent_():
            if self.hasSimpleContent_():
                outfile.write('>')
            else:
                outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            if not self.hasSimpleContent_():
                showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='SC'):
        super(SC, self).exportAttributes(outfile, level, already_processed, namespace_, name_='SC')
        if self.codeSystemVersion is not None and 'codeSystemVersion' not in already_processed:
            already_processed.append('codeSystemVersion')
            outfile.write(' codeSystemVersion=%s' % (quote_attrib(self.codeSystemVersion), ))
        if self.codeSystemName is not None and 'codeSystemName' not in already_processed:
            already_processed.append('codeSystemName')
            outfile.write(' codeSystemName=%s' % (quote_attrib(self.codeSystemName), ))
        if self.code is not None and 'code' not in already_processed:
            already_processed.append('code')
            outfile.write(' code=%s' % (quote_attrib(self.code), ))
        if self.displayName is not None and 'displayName' not in already_processed:
            already_processed.append('displayName')
            outfile.write(' displayName=%s' % (quote_attrib(self.displayName), ))
        if self.codeSystem is not None and 'codeSystem' not in already_processed:
            already_processed.append('codeSystem')
            outfile.write(' codeSystem=%s' % (quote_attrib(self.codeSystem), ))
    def exportChildren(self, outfile, level, namespace_='', name_='SC', fromsubclass_=False):
        super(SC, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(SC, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(SC, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('codeSystemVersion', node)
        if value is not None and 'codeSystemVersion' not in already_processed:
            already_processed.append('codeSystemVersion')
            self.codeSystemVersion = value
            self.validate_st(self.codeSystemVersion)    # validate type st
        value = find_attr_value_('codeSystemName', node)
        if value is not None and 'codeSystemName' not in already_processed:
            already_processed.append('codeSystemName')
            self.codeSystemName = value
            self.validate_st(self.codeSystemName)    # validate type st
        value = find_attr_value_('code', node)
        if value is not None and 'code' not in already_processed:
            already_processed.append('code')
            self.code = value
            self.code = ' '.join(self.code.split())
            self.validate_cs(self.code)    # validate type cs
        value = find_attr_value_('displayName', node)
        if value is not None and 'displayName' not in already_processed:
            already_processed.append('displayName')
            self.displayName = value
            self.validate_st(self.displayName)    # validate type st
        value = find_attr_value_('codeSystem', node)
        if value is not None and 'codeSystem' not in already_processed:
            already_processed.append('codeSystem')
            self.codeSystem = value
            self.validate_uid(self.codeSystem)    # validate type uid
        super(SC, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        super(SC, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class SC


class II(ANY):
    """An identifier that uniquely identifies a thing or object. Examples
    are object identifier for HL7 RIM objects, medical record
    number, order id, service catalog item id, Vehicle
    Identification Number (VIN), etc. Instance identifiers are
    defined based on ISO object identifiers. A unique identifier
    that guarantees the global uniqueness of the instance
    identifier. The root alone may be the entire instance
    identifier. A character string as a unique identifier within the
    scope of the identifier root. A human readable name or mnemonic
    for the assigning authority. This name may be provided solely
    for the convenience of unaided humans interpreting an value and
    can have no computational meaning. Note: no automated processing
    must depend on the assigning authority name to be present in any
    form. Specifies if the identifier is intended for human display
    and data entry (displayable = true) as opposed to pure machine
    interoperation (displayable = false)."""
    member_data_items_ = [
        MemberSpec_('assigningAuthorityName', 'st', 0, 1, 0),
        MemberSpec_('root', 'uid', 0, 1, 0),
        MemberSpec_('displayable', 'bl', 0, 1, 0),
        MemberSpec_('extension', 'st', 0, 1, 0),
        MemberSpec_('valueOf_', 'ANY', 0, 0, 0),
        ]
    subclass = None
    superclass = ANY
    def __init__(self, nullFlavor=None, assigningAuthorityName=None, root=None, displayable=None, extension=None, valueOf_=None, mixedclass_=None, content_=None):
        super(II, self).__init__(nullFlavor, valueOf_, mixedclass_, content_, )
        self.assigningAuthorityName = _cast(None, assigningAuthorityName)
        self.root = _cast(None, root)
        self.displayable = _cast(None, displayable)
        self.extension = _cast(None, extension)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if II.subclass:
            return II.subclass(*args_, **kwargs_)
        else:
            return II(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_assigningAuthorityName(self): return self.assigningAuthorityName
    def set_assigningAuthorityName(self, assigningAuthorityName): self.assigningAuthorityName = assigningAuthorityName
    assigningAuthorityNameProp = property(get_assigningAuthorityName, set_assigningAuthorityName)
    def validate_st(self, value):
        # Validate type st, a restriction on xs:string.
        pass
    def get_root(self): return self.root
    def set_root(self, root): self.root = root
    rootProp = property(get_root, set_root)
    def validate_uid(self, value):
        # Validate type uid, a restriction on None.
        pass
    def get_displayable(self): return self.displayable
    def set_displayable(self, displayable): self.displayable = displayable
    displayableProp = property(get_displayable, set_displayable)
    def validate_bl(self, value):
        # Validate type bl, a restriction on xs:boolean.
        pass
    def get_extension(self): return self.extension
    def set_extension(self, extension): self.extension = extension
    extensionProp = property(get_extension, set_extension)
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='II', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='II')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='II'):
        super(II, self).exportAttributes(outfile, level, already_processed, namespace_, name_='II')
        if self.assigningAuthorityName is not None and 'assigningAuthorityName' not in already_processed:
            already_processed.append('assigningAuthorityName')
            outfile.write(' assigningAuthorityName=%s' % (quote_attrib(self.assigningAuthorityName), ))
        if self.root is not None and 'root' not in already_processed:
            already_processed.append('root')
            outfile.write(' root=%s' % (quote_attrib(self.root), ))
        if self.displayable is not None and 'displayable' not in already_processed:
            already_processed.append('displayable')
            outfile.write(' displayable=%s' % (quote_attrib(self.displayable), ))
        if self.extension is not None and 'extension' not in already_processed:
            already_processed.append('extension')
            outfile.write(' extension=%s' % (quote_attrib(self.extension), ))
    def exportChildren(self, outfile, level, namespace_='', name_='II', fromsubclass_=False):
        super(II, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(II, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(II, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('assigningAuthorityName', node)
        if value is not None and 'assigningAuthorityName' not in already_processed:
            already_processed.append('assigningAuthorityName')
            self.assigningAuthorityName = value
            self.validate_st(self.assigningAuthorityName)    # validate type st
        value = find_attr_value_('root', node)
        if value is not None and 'root' not in already_processed:
            already_processed.append('root')
            self.root = value
            self.validate_uid(self.root)    # validate type uid
        value = find_attr_value_('displayable', node)
        if value is not None and 'displayable' not in already_processed:
            already_processed.append('displayable')
            if value in ('true', '1'):
                self.displayable = True
            elif value in ('false', '0'):
                self.displayable = False
            else:
                raise_parse_error(node, 'Bad boolean attribute')
            self.validate_bl(self.displayable)    # validate type bl
        value = find_attr_value_('extension', node)
        if value is not None and 'extension' not in already_processed:
            already_processed.append('extension')
            self.extension = value
            self.validate_st(self.extension)    # validate type st
        super(II, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        super(II, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class II


class URL(ANY):
    """A telecommunications address specified according to Internet
    standard RFC 1738 [http://www.ietf.org/rfc/rfc1738.txt]. The URL
    specifies the protocol and the contact point defined by that
    protocol for the resource. Notable uses of the telecommunication
    address data type are for telephone and telefax numbers, e-mail
    addresses, Hypertext references, FTP references, etc."""
    member_data_items_ = [
        MemberSpec_('value', 'url', 0, 1, 0),
        MemberSpec_('valueOf_', 'ANY', 0, 0, 0),
        ]
    subclass = None
    superclass = ANY
    def __init__(self, nullFlavor=None, value=None, valueOf_=None, mixedclass_=None, content_=None, extensiontype_=None):
        super(URL, self).__init__(nullFlavor, valueOf_, mixedclass_, content_, extensiontype_, )
        self.value = _cast(None, value)
        self.valueOf_ = valueOf_
        self.extensiontype_ = extensiontype_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if URL.subclass:
            return URL.subclass(*args_, **kwargs_)
        else:
            return URL(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_value(self): return self.value
    def set_value(self, value): self.value = value
    valueProp = property(get_value, set_value)
    def validate_url(self, value):
        # Validate type url, a restriction on xs:anyURI.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def get_extensiontype_(self): return self.extensiontype_
    def set_extensiontype_(self, extensiontype_): self.extensiontype_ = extensiontype_
    def export(self, outfile, level, namespace_='', name_='URL', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='URL')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='URL'):
        super(URL, self).exportAttributes(outfile, level, already_processed, namespace_, name_='URL')
        if self.value is not None and 'value' not in already_processed:
            already_processed.append('value')
            outfile.write(' value=%s' % (quote_attrib(self.value), ))
        if self.extensiontype_ is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            outfile.write(' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"')
            outfile.write(' xsi:type="%s"' % self.extensiontype_)
    def exportChildren(self, outfile, level, namespace_='', name_='URL', fromsubclass_=False):
        super(URL, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(URL, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(URL, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('value', node)
        if value is not None and 'value' not in already_processed:
            already_processed.append('value')
            self.value = value
            self.validate_url(self.value)    # validate type url
        value = find_attr_value_('xsi:type', node)
        if value is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            self.extensiontype_ = value
        super(URL, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        super(URL, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class URL


class TEL(URL):
    """A telephone number (voice or fax), e-mail address, or other locator
    for a resource (information or service) mediated by
    telecommunication equipment. The address is specified as a URL
    qualified by time specification and use codes that help in
    deciding which address to use for a given time and purpose. One
    or more codes advising a system or user which telecommunication
    address in a set of like addresses to select for a given
    telecommunication need."""
    member_data_items_ = [
        MemberSpec_('use', 'set_TelecommunicationAddressUse', 0, 1, 0),
        MemberSpec_('useablePeriod', 'SXCM_TS', 1, 0, 0),
        MemberSpec_('valueOf_', 'URL', 0, 0, 0),
        ]
    subclass = None
    superclass = URL
    def __init__(self, nullFlavor=None, value=None, use=None, useablePeriod=None, valueOf_=None, mixedclass_=None, content_=None):
        super(TEL, self).__init__(nullFlavor, value, valueOf_, mixedclass_, content_, )
        self.use = _cast(None, use)
        if useablePeriod is None:
            self.useablePeriod = []
        else:
            self.useablePeriod = useablePeriod
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if TEL.subclass:
            return TEL.subclass(*args_, **kwargs_)
        else:
            return TEL(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_useablePeriod(self): return self.useablePeriod
    def set_useablePeriod(self, useablePeriod): self.useablePeriod = useablePeriod
    def add_useablePeriod(self, value): self.useablePeriod.append(value)
    def insert_useablePeriod(self, index, value): self.useablePeriod[index] = value
    useablePeriodProp = property(get_useablePeriod, set_useablePeriod)
    def get_use(self): return self.use
    def set_use(self, use): self.use = use
    useProp = property(get_use, set_use)
    def validate_set_TelecommunicationAddressUse(self, value):
        # Validate type set_TelecommunicationAddressUse, a restriction on TelecommunicationAddressUse.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='TEL', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='TEL')
        if self.hasContent_():
            if self.hasSimpleContent_():
                outfile.write('>')
            else:
                outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            if not self.hasSimpleContent_():
                showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='TEL'):
        super(TEL, self).exportAttributes(outfile, level, already_processed, namespace_, name_='TEL')
        if self.use is not None and 'use' not in already_processed:
            already_processed.append('use')
            outfile.write(' use=%s' % (quote_attrib(self.use), ))
    def exportChildren(self, outfile, level, namespace_='', name_='TEL', fromsubclass_=False):
        super(TEL, self).exportChildren(outfile, level, namespace_, name_, True)
        for useablePeriod_ in self.useablePeriod:
            useablePeriod_.export(outfile, level, namespace_, name_='useablePeriod')
        if self.valueOf_ is not None:
            outfile.write(self.valueOf_)
        elif not fromsubclass_:
            for item_ in self.content_:
                item_.export(outfile, level, item_.name, namespace_)
    def hasContent_(self):
        if (
            self.useablePeriod or
            self.valueOf_ or
            super(TEL, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(TEL, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('use', node)
        if value is not None and 'use' not in already_processed:
            already_processed.append('use')
            self.use = value
            self.validate_set_TelecommunicationAddressUse(self.use)    # validate type set_TelecommunicationAddressUse
        super(TEL, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'useablePeriod':
            obj_ = self.get_class_obj_(child_, SXCM_TS)
            obj_ = SXCM_TS.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'useablePeriod', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_useablePeriod'):
              self.add_useablePeriod(obj_.value)
            elif hasattr(self, 'set_useablePeriod'):
              self.set_useablePeriod(obj_.value)
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        super(TEL, self).buildChildren(child_, node, nodeName_, True)
# end class TEL


class ADXP(ST):
    """A character string that may have a type-tag signifying its role in
    the address. Typical parts that exist in about every address are
    street, house number, or post box, postal code, city, country
    but other roles may be defined regionally, nationally, or on an
    enterprise level (e.g. in military addresses). Addresses are
    usually broken up into lines, which are indicated by special
    line-breaking delimiter elements (e.g., DEL). Specifies whether
    an address part names the street, city, country, postal code,
    post box, etc. If the type is NULL the address part is
    unclassified and would simply appear on an address label as is."""
    member_data_items_ = [
        MemberSpec_('partType', 'AddressPartType', 0, 1, 0),
        MemberSpec_('valueOf_', 'ST', 0, 0, 0),
        ]
    subclass = None
    superclass = ST
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(ADXP, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if ADXP.subclass:
            return ADXP.subclass(*args_, **kwargs_)
        else:
            return ADXP(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_AddressPartType(self, value):
        # Validate type AddressPartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='ADXP', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='ADXP')
        if self.hasContent_():
            if self.hasSimpleContent_():
                outfile.write('>')
            else:
                outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            if not self.hasSimpleContent_():
                showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='ADXP'):
        super(ADXP, self).exportAttributes(outfile, level, already_processed, namespace_, name_='ADXP')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='ADXP', fromsubclass_=False):
        super(ADXP, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(ADXP, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(ADXP, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_AddressPartType(self.partType)    # validate type AddressPartType
        super(ADXP, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        super(ADXP, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class ADXP


class adxp_delimiter(ADXP):
    member_data_items_ = [
        MemberSpec_('partType', 'AddressPartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ADXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(adxp_delimiter, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if adxp_delimiter.subclass:
            return adxp_delimiter.subclass(*args_, **kwargs_)
        else:
            return adxp_delimiter(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_AddressPartType(self, value):
        # Validate type AddressPartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='adxp.delimiter', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.delimiter')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='adxp.delimiter'):
        super(adxp_delimiter, self).exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.delimiter')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='adxp.delimiter', fromsubclass_=False):
        super(adxp_delimiter, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(adxp_delimiter, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(adxp_delimiter, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_AddressPartType(self.partType)    # validate type AddressPartType
        super(adxp_delimiter, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class adxp_delimiter


class adxp_country(ADXP):
    member_data_items_ = [
        MemberSpec_('partType', 'AddressPartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ADXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(adxp_country, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if adxp_country.subclass:
            return adxp_country.subclass(*args_, **kwargs_)
        else:
            return adxp_country(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_AddressPartType(self, value):
        # Validate type AddressPartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='adxp.country', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.country')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='adxp.country'):
        super(adxp_country, self).exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.country')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='adxp.country', fromsubclass_=False):
        super(adxp_country, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(adxp_country, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(adxp_country, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_AddressPartType(self.partType)    # validate type AddressPartType
        super(adxp_country, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class adxp_country


class adxp_state(ADXP):
    member_data_items_ = [
        MemberSpec_('partType', 'AddressPartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ADXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(adxp_state, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if adxp_state.subclass:
            return adxp_state.subclass(*args_, **kwargs_)
        else:
            return adxp_state(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_AddressPartType(self, value):
        # Validate type AddressPartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='adxp.state', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.state')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='adxp.state'):
        super(adxp_state, self).exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.state')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='adxp.state', fromsubclass_=False):
        super(adxp_state, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(adxp_state, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(adxp_state, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_AddressPartType(self.partType)    # validate type AddressPartType
        super(adxp_state, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class adxp_state


class adxp_county(ADXP):
    member_data_items_ = [
        MemberSpec_('partType', 'AddressPartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ADXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(adxp_county, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if adxp_county.subclass:
            return adxp_county.subclass(*args_, **kwargs_)
        else:
            return adxp_county(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_AddressPartType(self, value):
        # Validate type AddressPartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='adxp.county', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.county')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='adxp.county'):
        super(adxp_county, self).exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.county')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='adxp.county', fromsubclass_=False):
        super(adxp_county, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(adxp_county, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(adxp_county, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_AddressPartType(self.partType)    # validate type AddressPartType
        super(adxp_county, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class adxp_county


class adxp_city(ADXP):
    member_data_items_ = [
        MemberSpec_('partType', 'AddressPartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ADXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(adxp_city, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if adxp_city.subclass:
            return adxp_city.subclass(*args_, **kwargs_)
        else:
            return adxp_city(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_AddressPartType(self, value):
        # Validate type AddressPartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='adxp.city', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.city')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='adxp.city'):
        super(adxp_city, self).exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.city')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='adxp.city', fromsubclass_=False):
        super(adxp_city, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(adxp_city, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(adxp_city, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_AddressPartType(self.partType)    # validate type AddressPartType
        super(adxp_city, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class adxp_city


class adxp_postalCode(ADXP):
    member_data_items_ = [
        MemberSpec_('partType', 'AddressPartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ADXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(adxp_postalCode, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if adxp_postalCode.subclass:
            return adxp_postalCode.subclass(*args_, **kwargs_)
        else:
            return adxp_postalCode(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_AddressPartType(self, value):
        # Validate type AddressPartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='adxp.postalCode', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.postalCode')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='adxp.postalCode'):
        super(adxp_postalCode, self).exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.postalCode')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='adxp.postalCode', fromsubclass_=False):
        super(adxp_postalCode, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(adxp_postalCode, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(adxp_postalCode, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_AddressPartType(self.partType)    # validate type AddressPartType
        super(adxp_postalCode, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class adxp_postalCode


class adxp_streetAddressLine(ADXP):
    member_data_items_ = [
        MemberSpec_('partType', 'AddressPartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ADXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(adxp_streetAddressLine, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if adxp_streetAddressLine.subclass:
            return adxp_streetAddressLine.subclass(*args_, **kwargs_)
        else:
            return adxp_streetAddressLine(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_AddressPartType(self, value):
        # Validate type AddressPartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='adxp.streetAddressLine', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.streetAddressLine')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='adxp.streetAddressLine'):
        super(adxp_streetAddressLine, self).exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.streetAddressLine')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='adxp.streetAddressLine', fromsubclass_=False):
        super(adxp_streetAddressLine, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(adxp_streetAddressLine, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(adxp_streetAddressLine, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_AddressPartType(self.partType)    # validate type AddressPartType
        super(adxp_streetAddressLine, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class adxp_streetAddressLine


class adxp_houseNumber(ADXP):
    member_data_items_ = [
        MemberSpec_('partType', 'AddressPartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ADXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(adxp_houseNumber, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if adxp_houseNumber.subclass:
            return adxp_houseNumber.subclass(*args_, **kwargs_)
        else:
            return adxp_houseNumber(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_AddressPartType(self, value):
        # Validate type AddressPartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='adxp.houseNumber', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.houseNumber')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='adxp.houseNumber'):
        super(adxp_houseNumber, self).exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.houseNumber')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='adxp.houseNumber', fromsubclass_=False):
        super(adxp_houseNumber, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(adxp_houseNumber, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(adxp_houseNumber, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_AddressPartType(self.partType)    # validate type AddressPartType
        super(adxp_houseNumber, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class adxp_houseNumber


class adxp_houseNumberNumeric(ADXP):
    member_data_items_ = [
        MemberSpec_('partType', 'AddressPartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ADXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(adxp_houseNumberNumeric, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if adxp_houseNumberNumeric.subclass:
            return adxp_houseNumberNumeric.subclass(*args_, **kwargs_)
        else:
            return adxp_houseNumberNumeric(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_AddressPartType(self, value):
        # Validate type AddressPartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='adxp.houseNumberNumeric', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.houseNumberNumeric')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='adxp.houseNumberNumeric'):
        super(adxp_houseNumberNumeric, self).exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.houseNumberNumeric')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='adxp.houseNumberNumeric', fromsubclass_=False):
        super(adxp_houseNumberNumeric, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(adxp_houseNumberNumeric, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(adxp_houseNumberNumeric, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_AddressPartType(self.partType)    # validate type AddressPartType
        super(adxp_houseNumberNumeric, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class adxp_houseNumberNumeric


class adxp_direction(ADXP):
    member_data_items_ = [
        MemberSpec_('partType', 'AddressPartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ADXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(adxp_direction, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if adxp_direction.subclass:
            return adxp_direction.subclass(*args_, **kwargs_)
        else:
            return adxp_direction(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_AddressPartType(self, value):
        # Validate type AddressPartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='adxp.direction', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.direction')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='adxp.direction'):
        super(adxp_direction, self).exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.direction')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='adxp.direction', fromsubclass_=False):
        super(adxp_direction, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(adxp_direction, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(adxp_direction, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_AddressPartType(self.partType)    # validate type AddressPartType
        super(adxp_direction, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class adxp_direction


class adxp_streetName(ADXP):
    member_data_items_ = [
        MemberSpec_('partType', 'AddressPartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ADXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(adxp_streetName, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if adxp_streetName.subclass:
            return adxp_streetName.subclass(*args_, **kwargs_)
        else:
            return adxp_streetName(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_AddressPartType(self, value):
        # Validate type AddressPartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='adxp.streetName', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.streetName')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='adxp.streetName'):
        super(adxp_streetName, self).exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.streetName')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='adxp.streetName', fromsubclass_=False):
        super(adxp_streetName, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(adxp_streetName, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(adxp_streetName, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_AddressPartType(self.partType)    # validate type AddressPartType
        super(adxp_streetName, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class adxp_streetName


class adxp_streetNameBase(ADXP):
    member_data_items_ = [
        MemberSpec_('partType', 'AddressPartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ADXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(adxp_streetNameBase, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if adxp_streetNameBase.subclass:
            return adxp_streetNameBase.subclass(*args_, **kwargs_)
        else:
            return adxp_streetNameBase(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_AddressPartType(self, value):
        # Validate type AddressPartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='adxp.streetNameBase', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.streetNameBase')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='adxp.streetNameBase'):
        super(adxp_streetNameBase, self).exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.streetNameBase')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='adxp.streetNameBase', fromsubclass_=False):
        super(adxp_streetNameBase, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(adxp_streetNameBase, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(adxp_streetNameBase, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_AddressPartType(self.partType)    # validate type AddressPartType
        super(adxp_streetNameBase, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class adxp_streetNameBase


class adxp_streetNameType(ADXP):
    member_data_items_ = [
        MemberSpec_('partType', 'AddressPartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ADXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(adxp_streetNameType, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if adxp_streetNameType.subclass:
            return adxp_streetNameType.subclass(*args_, **kwargs_)
        else:
            return adxp_streetNameType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_AddressPartType(self, value):
        # Validate type AddressPartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='adxp.streetNameType', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.streetNameType')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='adxp.streetNameType'):
        super(adxp_streetNameType, self).exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.streetNameType')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='adxp.streetNameType', fromsubclass_=False):
        super(adxp_streetNameType, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(adxp_streetNameType, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(adxp_streetNameType, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_AddressPartType(self.partType)    # validate type AddressPartType
        super(adxp_streetNameType, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class adxp_streetNameType


class adxp_additionalLocator(ADXP):
    member_data_items_ = [
        MemberSpec_('partType', 'AddressPartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ADXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(adxp_additionalLocator, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if adxp_additionalLocator.subclass:
            return adxp_additionalLocator.subclass(*args_, **kwargs_)
        else:
            return adxp_additionalLocator(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_AddressPartType(self, value):
        # Validate type AddressPartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='adxp.additionalLocator', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.additionalLocator')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='adxp.additionalLocator'):
        super(adxp_additionalLocator, self).exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.additionalLocator')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='adxp.additionalLocator', fromsubclass_=False):
        super(adxp_additionalLocator, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(adxp_additionalLocator, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(adxp_additionalLocator, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_AddressPartType(self.partType)    # validate type AddressPartType
        super(adxp_additionalLocator, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class adxp_additionalLocator


class adxp_unitID(ADXP):
    member_data_items_ = [
        MemberSpec_('partType', 'AddressPartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ADXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(adxp_unitID, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if adxp_unitID.subclass:
            return adxp_unitID.subclass(*args_, **kwargs_)
        else:
            return adxp_unitID(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_AddressPartType(self, value):
        # Validate type AddressPartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='adxp.unitID', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.unitID')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='adxp.unitID'):
        super(adxp_unitID, self).exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.unitID')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='adxp.unitID', fromsubclass_=False):
        super(adxp_unitID, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(adxp_unitID, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(adxp_unitID, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_AddressPartType(self.partType)    # validate type AddressPartType
        super(adxp_unitID, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class adxp_unitID


class adxp_unitType(ADXP):
    member_data_items_ = [
        MemberSpec_('partType', 'AddressPartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ADXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(adxp_unitType, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if adxp_unitType.subclass:
            return adxp_unitType.subclass(*args_, **kwargs_)
        else:
            return adxp_unitType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_AddressPartType(self, value):
        # Validate type AddressPartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='adxp.unitType', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.unitType')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='adxp.unitType'):
        super(adxp_unitType, self).exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.unitType')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='adxp.unitType', fromsubclass_=False):
        super(adxp_unitType, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(adxp_unitType, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(adxp_unitType, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_AddressPartType(self.partType)    # validate type AddressPartType
        super(adxp_unitType, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class adxp_unitType


class adxp_careOf(ADXP):
    member_data_items_ = [
        MemberSpec_('partType', 'AddressPartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ADXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(adxp_careOf, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if adxp_careOf.subclass:
            return adxp_careOf.subclass(*args_, **kwargs_)
        else:
            return adxp_careOf(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_AddressPartType(self, value):
        # Validate type AddressPartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='adxp.careOf', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.careOf')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='adxp.careOf'):
        super(adxp_careOf, self).exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.careOf')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='adxp.careOf', fromsubclass_=False):
        super(adxp_careOf, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(adxp_careOf, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(adxp_careOf, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_AddressPartType(self.partType)    # validate type AddressPartType
        super(adxp_careOf, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class adxp_careOf


class adxp_censusTract(ADXP):
    member_data_items_ = [
        MemberSpec_('partType', 'AddressPartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ADXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(adxp_censusTract, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if adxp_censusTract.subclass:
            return adxp_censusTract.subclass(*args_, **kwargs_)
        else:
            return adxp_censusTract(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_AddressPartType(self, value):
        # Validate type AddressPartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='adxp.censusTract', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.censusTract')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='adxp.censusTract'):
        super(adxp_censusTract, self).exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.censusTract')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='adxp.censusTract', fromsubclass_=False):
        super(adxp_censusTract, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(adxp_censusTract, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(adxp_censusTract, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_AddressPartType(self.partType)    # validate type AddressPartType
        super(adxp_censusTract, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class adxp_censusTract


class adxp_deliveryAddressLine(ADXP):
    member_data_items_ = [
        MemberSpec_('partType', 'AddressPartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ADXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(adxp_deliveryAddressLine, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if adxp_deliveryAddressLine.subclass:
            return adxp_deliveryAddressLine.subclass(*args_, **kwargs_)
        else:
            return adxp_deliveryAddressLine(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_AddressPartType(self, value):
        # Validate type AddressPartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='adxp.deliveryAddressLine', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.deliveryAddressLine')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='adxp.deliveryAddressLine'):
        super(adxp_deliveryAddressLine, self).exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.deliveryAddressLine')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='adxp.deliveryAddressLine', fromsubclass_=False):
        super(adxp_deliveryAddressLine, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(adxp_deliveryAddressLine, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(adxp_deliveryAddressLine, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_AddressPartType(self.partType)    # validate type AddressPartType
        super(adxp_deliveryAddressLine, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class adxp_deliveryAddressLine


class adxp_deliveryInstallationType(ADXP):
    member_data_items_ = [
        MemberSpec_('partType', 'AddressPartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ADXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(adxp_deliveryInstallationType, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if adxp_deliveryInstallationType.subclass:
            return adxp_deliveryInstallationType.subclass(*args_, **kwargs_)
        else:
            return adxp_deliveryInstallationType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_AddressPartType(self, value):
        # Validate type AddressPartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='adxp.deliveryInstallationType', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.deliveryInstallationType')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='adxp.deliveryInstallationType'):
        super(adxp_deliveryInstallationType, self).exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.deliveryInstallationType')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='adxp.deliveryInstallationType', fromsubclass_=False):
        super(adxp_deliveryInstallationType, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(adxp_deliveryInstallationType, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(adxp_deliveryInstallationType, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_AddressPartType(self.partType)    # validate type AddressPartType
        super(adxp_deliveryInstallationType, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class adxp_deliveryInstallationType


class adxp_deliveryInstallationArea(ADXP):
    member_data_items_ = [
        MemberSpec_('partType', 'AddressPartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ADXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(adxp_deliveryInstallationArea, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if adxp_deliveryInstallationArea.subclass:
            return adxp_deliveryInstallationArea.subclass(*args_, **kwargs_)
        else:
            return adxp_deliveryInstallationArea(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_AddressPartType(self, value):
        # Validate type AddressPartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='adxp.deliveryInstallationArea', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.deliveryInstallationArea')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='adxp.deliveryInstallationArea'):
        super(adxp_deliveryInstallationArea, self).exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.deliveryInstallationArea')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='adxp.deliveryInstallationArea', fromsubclass_=False):
        super(adxp_deliveryInstallationArea, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(adxp_deliveryInstallationArea, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(adxp_deliveryInstallationArea, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_AddressPartType(self.partType)    # validate type AddressPartType
        super(adxp_deliveryInstallationArea, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class adxp_deliveryInstallationArea


class adxp_deliveryInstallationQualifier(ADXP):
    member_data_items_ = [
        MemberSpec_('partType', 'AddressPartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ADXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(adxp_deliveryInstallationQualifier, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if adxp_deliveryInstallationQualifier.subclass:
            return adxp_deliveryInstallationQualifier.subclass(*args_, **kwargs_)
        else:
            return adxp_deliveryInstallationQualifier(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_AddressPartType(self, value):
        # Validate type AddressPartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='adxp.deliveryInstallationQualifier', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.deliveryInstallationQualifier')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='adxp.deliveryInstallationQualifier'):
        super(adxp_deliveryInstallationQualifier, self).exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.deliveryInstallationQualifier')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='adxp.deliveryInstallationQualifier', fromsubclass_=False):
        super(adxp_deliveryInstallationQualifier, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(adxp_deliveryInstallationQualifier, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(adxp_deliveryInstallationQualifier, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_AddressPartType(self.partType)    # validate type AddressPartType
        super(adxp_deliveryInstallationQualifier, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class adxp_deliveryInstallationQualifier


class adxp_deliveryMode(ADXP):
    member_data_items_ = [
        MemberSpec_('partType', 'AddressPartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ADXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(adxp_deliveryMode, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if adxp_deliveryMode.subclass:
            return adxp_deliveryMode.subclass(*args_, **kwargs_)
        else:
            return adxp_deliveryMode(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_AddressPartType(self, value):
        # Validate type AddressPartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='adxp.deliveryMode', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.deliveryMode')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='adxp.deliveryMode'):
        super(adxp_deliveryMode, self).exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.deliveryMode')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='adxp.deliveryMode', fromsubclass_=False):
        super(adxp_deliveryMode, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(adxp_deliveryMode, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(adxp_deliveryMode, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_AddressPartType(self.partType)    # validate type AddressPartType
        super(adxp_deliveryMode, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class adxp_deliveryMode


class adxp_deliveryModeIdentifier(ADXP):
    member_data_items_ = [
        MemberSpec_('partType', 'AddressPartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ADXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(adxp_deliveryModeIdentifier, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if adxp_deliveryModeIdentifier.subclass:
            return adxp_deliveryModeIdentifier.subclass(*args_, **kwargs_)
        else:
            return adxp_deliveryModeIdentifier(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_AddressPartType(self, value):
        # Validate type AddressPartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='adxp.deliveryModeIdentifier', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.deliveryModeIdentifier')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='adxp.deliveryModeIdentifier'):
        super(adxp_deliveryModeIdentifier, self).exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.deliveryModeIdentifier')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='adxp.deliveryModeIdentifier', fromsubclass_=False):
        super(adxp_deliveryModeIdentifier, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(adxp_deliveryModeIdentifier, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(adxp_deliveryModeIdentifier, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_AddressPartType(self.partType)    # validate type AddressPartType
        super(adxp_deliveryModeIdentifier, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class adxp_deliveryModeIdentifier


class adxp_buildingNumberSuffix(ADXP):
    member_data_items_ = [
        MemberSpec_('partType', 'AddressPartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ADXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(adxp_buildingNumberSuffix, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if adxp_buildingNumberSuffix.subclass:
            return adxp_buildingNumberSuffix.subclass(*args_, **kwargs_)
        else:
            return adxp_buildingNumberSuffix(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_AddressPartType(self, value):
        # Validate type AddressPartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='adxp.buildingNumberSuffix', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.buildingNumberSuffix')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='adxp.buildingNumberSuffix'):
        super(adxp_buildingNumberSuffix, self).exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.buildingNumberSuffix')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='adxp.buildingNumberSuffix', fromsubclass_=False):
        super(adxp_buildingNumberSuffix, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(adxp_buildingNumberSuffix, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(adxp_buildingNumberSuffix, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_AddressPartType(self.partType)    # validate type AddressPartType
        super(adxp_buildingNumberSuffix, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class adxp_buildingNumberSuffix


class adxp_postBox(ADXP):
    member_data_items_ = [
        MemberSpec_('partType', 'AddressPartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ADXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(adxp_postBox, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if adxp_postBox.subclass:
            return adxp_postBox.subclass(*args_, **kwargs_)
        else:
            return adxp_postBox(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_AddressPartType(self, value):
        # Validate type AddressPartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='adxp.postBox', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.postBox')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='adxp.postBox'):
        super(adxp_postBox, self).exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.postBox')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='adxp.postBox', fromsubclass_=False):
        super(adxp_postBox, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(adxp_postBox, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(adxp_postBox, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_AddressPartType(self.partType)    # validate type AddressPartType
        super(adxp_postBox, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class adxp_postBox


class adxp_precinct(ADXP):
    member_data_items_ = [
        MemberSpec_('partType', 'AddressPartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ADXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(adxp_precinct, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if adxp_precinct.subclass:
            return adxp_precinct.subclass(*args_, **kwargs_)
        else:
            return adxp_precinct(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_AddressPartType(self, value):
        # Validate type AddressPartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='adxp.precinct', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.precinct')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='adxp.precinct'):
        super(adxp_precinct, self).exportAttributes(outfile, level, already_processed, namespace_, name_='adxp.precinct')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='adxp.precinct', fromsubclass_=False):
        super(adxp_precinct, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(adxp_precinct, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(adxp_precinct, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_AddressPartType(self.partType)    # validate type AddressPartType
        super(adxp_precinct, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class adxp_precinct


class AD(ANY):
    """Mailing and home or office addresses. A sequence of address parts,
    such as street or post office Box, city, postal code, country,
    etc. A set of codes advising a system or user which address in a
    set of like addresses to select for a given purpose. A boolean
    value specifying whether the order of the address parts is known
    or not. While the address parts are always a Sequence, the order
    in which they are presented may or may not be known. Where this
    matters, can be used to convey this information."""
    member_data_items_ = [
        MemberSpec_('use', 'set_PostalAddressUse', 0, 1, 0),
        MemberSpec_('isNotOrdered', 'bl', 0, 1, 0),
        MemberSpec_('delimiter', 'adxp.delimiter', 1, 0, 0),
        MemberSpec_('country', 'adxp.country', 1, 0, 0),
        MemberSpec_('state', 'adxp.state', 1, 0, 0),
        MemberSpec_('county', 'adxp.county', 1, 0, 0),
        MemberSpec_('city', 'adxp.city', 1, 0, 0),
        MemberSpec_('postalCode', 'adxp.postalCode', 1, 0, 0),
        MemberSpec_('streetAddressLine', 'adxp.streetAddressLine', 1, 0, 0),
        MemberSpec_('houseNumber', 'adxp.houseNumber', 1, 0, 0),
        MemberSpec_('houseNumberNumeric', 'adxp.houseNumberNumeric', 1, 0, 0),
        MemberSpec_('direction', 'adxp.direction', 1, 0, 0),
        MemberSpec_('streetName', 'adxp.streetName', 1, 0, 0),
        MemberSpec_('streetNameBase', 'adxp.streetNameBase', 1, 0, 0),
        MemberSpec_('streetNameType', 'adxp.streetNameType', 1, 0, 0),
        MemberSpec_('additionalLocator', 'adxp.additionalLocator', 1, 0, 0),
        MemberSpec_('unitID', 'adxp.unitID', 1, 0, 0),
        MemberSpec_('unitType', 'adxp.unitType', 1, 0, 0),
        MemberSpec_('careOf', 'adxp.careOf', 1, 0, 0),
        MemberSpec_('censusTract', 'adxp.censusTract', 1, 0, 0),
        MemberSpec_('deliveryAddressLine', 'adxp.deliveryAddressLine', 1, 0, 0),
        MemberSpec_('deliveryInstallationType', 'adxp.deliveryInstallationType', 1, 0, 0),
        MemberSpec_('deliveryInstallationArea', 'adxp.deliveryInstallationArea', 1, 0, 0),
        MemberSpec_('deliveryInstallationQualifier', 'adxp.deliveryInstallationQualifier', 1, 0, 0),
        MemberSpec_('deliveryMode', 'adxp.deliveryMode', 1, 0, 0),
        MemberSpec_('deliveryModeIdentifier', 'adxp.deliveryModeIdentifier', 1, 0, 0),
        MemberSpec_('buildingNumberSuffix', 'adxp.buildingNumberSuffix', 1, 0, 0),
        MemberSpec_('postBox', 'adxp.postBox', 1, 0, 0),
        MemberSpec_('precinct', 'adxp.precinct', 1, 0, 0),
        MemberSpec_('useablePeriod', 'SXCM_TS', 1, 0, 0),
        MemberSpec_('valueOf_', 'ANY', 0, 0, 0),
        ]
    subclass = None
    superclass = ANY
    def __init__(self, nullFlavor=None, use=None, isNotOrdered=None, delimiter=None, country=None, state=None, county=None, city=None, postalCode=None, streetAddressLine=None, houseNumber=None, houseNumberNumeric=None, direction=None, streetName=None, streetNameBase=None, streetNameType=None, additionalLocator=None, unitID=None, unitType=None, careOf=None, censusTract=None, deliveryAddressLine=None, deliveryInstallationType=None, deliveryInstallationArea=None, deliveryInstallationQualifier=None, deliveryMode=None, deliveryModeIdentifier=None, buildingNumberSuffix=None, postBox=None, precinct=None, useablePeriod=None, valueOf_=None, mixedclass_=None, content_=None):
        super(AD, self).__init__(nullFlavor, valueOf_, mixedclass_, content_, )
        self.use = _cast(None, use)
        self.isNotOrdered = _cast(None, isNotOrdered)
        if delimiter is None:
            self.delimiter = []
        else:
            self.delimiter = delimiter
        if country is None:
            self.country = []
        else:
            self.country = country
        if state is None:
            self.state = []
        else:
            self.state = state
        if county is None:
            self.county = []
        else:
            self.county = county
        if city is None:
            self.city = []
        else:
            self.city = city
        if postalCode is None:
            self.postalCode = []
        else:
            self.postalCode = postalCode
        if streetAddressLine is None:
            self.streetAddressLine = []
        else:
            self.streetAddressLine = streetAddressLine
        if houseNumber is None:
            self.houseNumber = []
        else:
            self.houseNumber = houseNumber
        if houseNumberNumeric is None:
            self.houseNumberNumeric = []
        else:
            self.houseNumberNumeric = houseNumberNumeric
        if direction is None:
            self.direction = []
        else:
            self.direction = direction
        if streetName is None:
            self.streetName = []
        else:
            self.streetName = streetName
        if streetNameBase is None:
            self.streetNameBase = []
        else:
            self.streetNameBase = streetNameBase
        if streetNameType is None:
            self.streetNameType = []
        else:
            self.streetNameType = streetNameType
        if additionalLocator is None:
            self.additionalLocator = []
        else:
            self.additionalLocator = additionalLocator
        if unitID is None:
            self.unitID = []
        else:
            self.unitID = unitID
        if unitType is None:
            self.unitType = []
        else:
            self.unitType = unitType
        if careOf is None:
            self.careOf = []
        else:
            self.careOf = careOf
        if censusTract is None:
            self.censusTract = []
        else:
            self.censusTract = censusTract
        if deliveryAddressLine is None:
            self.deliveryAddressLine = []
        else:
            self.deliveryAddressLine = deliveryAddressLine
        if deliveryInstallationType is None:
            self.deliveryInstallationType = []
        else:
            self.deliveryInstallationType = deliveryInstallationType
        if deliveryInstallationArea is None:
            self.deliveryInstallationArea = []
        else:
            self.deliveryInstallationArea = deliveryInstallationArea
        if deliveryInstallationQualifier is None:
            self.deliveryInstallationQualifier = []
        else:
            self.deliveryInstallationQualifier = deliveryInstallationQualifier
        if deliveryMode is None:
            self.deliveryMode = []
        else:
            self.deliveryMode = deliveryMode
        if deliveryModeIdentifier is None:
            self.deliveryModeIdentifier = []
        else:
            self.deliveryModeIdentifier = deliveryModeIdentifier
        if buildingNumberSuffix is None:
            self.buildingNumberSuffix = []
        else:
            self.buildingNumberSuffix = buildingNumberSuffix
        if postBox is None:
            self.postBox = []
        else:
            self.postBox = postBox
        if precinct is None:
            self.precinct = []
        else:
            self.precinct = precinct
        if useablePeriod is None:
            self.useablePeriod = []
        else:
            self.useablePeriod = useablePeriod
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if AD.subclass:
            return AD.subclass(*args_, **kwargs_)
        else:
            return AD(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_delimiter(self): return self.delimiter
    def set_delimiter(self, delimiter): self.delimiter = delimiter
    def add_delimiter(self, value): self.delimiter.append(value)
    def insert_delimiter(self, index, value): self.delimiter[index] = value
    delimiterProp = property(get_delimiter, set_delimiter)
    def get_country(self): return self.country
    def set_country(self, country): self.country = country
    def add_country(self, value): self.country.append(value)
    def insert_country(self, index, value): self.country[index] = value
    countryProp = property(get_country, set_country)
    def get_state(self): return self.state
    def set_state(self, state): self.state = state
    def add_state(self, value): self.state.append(value)
    def insert_state(self, index, value): self.state[index] = value
    stateProp = property(get_state, set_state)
    def get_county(self): return self.county
    def set_county(self, county): self.county = county
    def add_county(self, value): self.county.append(value)
    def insert_county(self, index, value): self.county[index] = value
    countyProp = property(get_county, set_county)
    def get_city(self): return self.city
    def set_city(self, city): self.city = city
    def add_city(self, value): self.city.append(value)
    def insert_city(self, index, value): self.city[index] = value
    cityProp = property(get_city, set_city)
    def get_postalCode(self): return self.postalCode
    def set_postalCode(self, postalCode): self.postalCode = postalCode
    def add_postalCode(self, value): self.postalCode.append(value)
    def insert_postalCode(self, index, value): self.postalCode[index] = value
    postalCodeProp = property(get_postalCode, set_postalCode)
    def get_streetAddressLine(self): return self.streetAddressLine
    def set_streetAddressLine(self, streetAddressLine): self.streetAddressLine = streetAddressLine
    def add_streetAddressLine(self, value): self.streetAddressLine.append(value)
    def insert_streetAddressLine(self, index, value): self.streetAddressLine[index] = value
    streetAddressLineProp = property(get_streetAddressLine, set_streetAddressLine)
    def get_houseNumber(self): return self.houseNumber
    def set_houseNumber(self, houseNumber): self.houseNumber = houseNumber
    def add_houseNumber(self, value): self.houseNumber.append(value)
    def insert_houseNumber(self, index, value): self.houseNumber[index] = value
    houseNumberProp = property(get_houseNumber, set_houseNumber)
    def get_houseNumberNumeric(self): return self.houseNumberNumeric
    def set_houseNumberNumeric(self, houseNumberNumeric): self.houseNumberNumeric = houseNumberNumeric
    def add_houseNumberNumeric(self, value): self.houseNumberNumeric.append(value)
    def insert_houseNumberNumeric(self, index, value): self.houseNumberNumeric[index] = value
    houseNumberNumericProp = property(get_houseNumberNumeric, set_houseNumberNumeric)
    def get_direction(self): return self.direction
    def set_direction(self, direction): self.direction = direction
    def add_direction(self, value): self.direction.append(value)
    def insert_direction(self, index, value): self.direction[index] = value
    directionProp = property(get_direction, set_direction)
    def get_streetName(self): return self.streetName
    def set_streetName(self, streetName): self.streetName = streetName
    def add_streetName(self, value): self.streetName.append(value)
    def insert_streetName(self, index, value): self.streetName[index] = value
    streetNameProp = property(get_streetName, set_streetName)
    def get_streetNameBase(self): return self.streetNameBase
    def set_streetNameBase(self, streetNameBase): self.streetNameBase = streetNameBase
    def add_streetNameBase(self, value): self.streetNameBase.append(value)
    def insert_streetNameBase(self, index, value): self.streetNameBase[index] = value
    streetNameBaseProp = property(get_streetNameBase, set_streetNameBase)
    def get_streetNameType(self): return self.streetNameType
    def set_streetNameType(self, streetNameType): self.streetNameType = streetNameType
    def add_streetNameType(self, value): self.streetNameType.append(value)
    def insert_streetNameType(self, index, value): self.streetNameType[index] = value
    streetNameTypeProp = property(get_streetNameType, set_streetNameType)
    def get_additionalLocator(self): return self.additionalLocator
    def set_additionalLocator(self, additionalLocator): self.additionalLocator = additionalLocator
    def add_additionalLocator(self, value): self.additionalLocator.append(value)
    def insert_additionalLocator(self, index, value): self.additionalLocator[index] = value
    additionalLocatorProp = property(get_additionalLocator, set_additionalLocator)
    def get_unitID(self): return self.unitID
    def set_unitID(self, unitID): self.unitID = unitID
    def add_unitID(self, value): self.unitID.append(value)
    def insert_unitID(self, index, value): self.unitID[index] = value
    unitIDProp = property(get_unitID, set_unitID)
    def get_unitType(self): return self.unitType
    def set_unitType(self, unitType): self.unitType = unitType
    def add_unitType(self, value): self.unitType.append(value)
    def insert_unitType(self, index, value): self.unitType[index] = value
    unitTypeProp = property(get_unitType, set_unitType)
    def get_careOf(self): return self.careOf
    def set_careOf(self, careOf): self.careOf = careOf
    def add_careOf(self, value): self.careOf.append(value)
    def insert_careOf(self, index, value): self.careOf[index] = value
    careOfProp = property(get_careOf, set_careOf)
    def get_censusTract(self): return self.censusTract
    def set_censusTract(self, censusTract): self.censusTract = censusTract
    def add_censusTract(self, value): self.censusTract.append(value)
    def insert_censusTract(self, index, value): self.censusTract[index] = value
    censusTractProp = property(get_censusTract, set_censusTract)
    def get_deliveryAddressLine(self): return self.deliveryAddressLine
    def set_deliveryAddressLine(self, deliveryAddressLine): self.deliveryAddressLine = deliveryAddressLine
    def add_deliveryAddressLine(self, value): self.deliveryAddressLine.append(value)
    def insert_deliveryAddressLine(self, index, value): self.deliveryAddressLine[index] = value
    deliveryAddressLineProp = property(get_deliveryAddressLine, set_deliveryAddressLine)
    def get_deliveryInstallationType(self): return self.deliveryInstallationType
    def set_deliveryInstallationType(self, deliveryInstallationType): self.deliveryInstallationType = deliveryInstallationType
    def add_deliveryInstallationType(self, value): self.deliveryInstallationType.append(value)
    def insert_deliveryInstallationType(self, index, value): self.deliveryInstallationType[index] = value
    deliveryInstallationTypeProp = property(get_deliveryInstallationType, set_deliveryInstallationType)
    def get_deliveryInstallationArea(self): return self.deliveryInstallationArea
    def set_deliveryInstallationArea(self, deliveryInstallationArea): self.deliveryInstallationArea = deliveryInstallationArea
    def add_deliveryInstallationArea(self, value): self.deliveryInstallationArea.append(value)
    def insert_deliveryInstallationArea(self, index, value): self.deliveryInstallationArea[index] = value
    deliveryInstallationAreaProp = property(get_deliveryInstallationArea, set_deliveryInstallationArea)
    def get_deliveryInstallationQualifier(self): return self.deliveryInstallationQualifier
    def set_deliveryInstallationQualifier(self, deliveryInstallationQualifier): self.deliveryInstallationQualifier = deliveryInstallationQualifier
    def add_deliveryInstallationQualifier(self, value): self.deliveryInstallationQualifier.append(value)
    def insert_deliveryInstallationQualifier(self, index, value): self.deliveryInstallationQualifier[index] = value
    deliveryInstallationQualifierProp = property(get_deliveryInstallationQualifier, set_deliveryInstallationQualifier)
    def get_deliveryMode(self): return self.deliveryMode
    def set_deliveryMode(self, deliveryMode): self.deliveryMode = deliveryMode
    def add_deliveryMode(self, value): self.deliveryMode.append(value)
    def insert_deliveryMode(self, index, value): self.deliveryMode[index] = value
    deliveryModeProp = property(get_deliveryMode, set_deliveryMode)
    def get_deliveryModeIdentifier(self): return self.deliveryModeIdentifier
    def set_deliveryModeIdentifier(self, deliveryModeIdentifier): self.deliveryModeIdentifier = deliveryModeIdentifier
    def add_deliveryModeIdentifier(self, value): self.deliveryModeIdentifier.append(value)
    def insert_deliveryModeIdentifier(self, index, value): self.deliveryModeIdentifier[index] = value
    deliveryModeIdentifierProp = property(get_deliveryModeIdentifier, set_deliveryModeIdentifier)
    def get_buildingNumberSuffix(self): return self.buildingNumberSuffix
    def set_buildingNumberSuffix(self, buildingNumberSuffix): self.buildingNumberSuffix = buildingNumberSuffix
    def add_buildingNumberSuffix(self, value): self.buildingNumberSuffix.append(value)
    def insert_buildingNumberSuffix(self, index, value): self.buildingNumberSuffix[index] = value
    buildingNumberSuffixProp = property(get_buildingNumberSuffix, set_buildingNumberSuffix)
    def get_postBox(self): return self.postBox
    def set_postBox(self, postBox): self.postBox = postBox
    def add_postBox(self, value): self.postBox.append(value)
    def insert_postBox(self, index, value): self.postBox[index] = value
    postBoxProp = property(get_postBox, set_postBox)
    def get_precinct(self): return self.precinct
    def set_precinct(self, precinct): self.precinct = precinct
    def add_precinct(self, value): self.precinct.append(value)
    def insert_precinct(self, index, value): self.precinct[index] = value
    precinctProp = property(get_precinct, set_precinct)
    def get_useablePeriod(self): return self.useablePeriod
    def set_useablePeriod(self, useablePeriod): self.useablePeriod = useablePeriod
    def add_useablePeriod(self, value): self.useablePeriod.append(value)
    def insert_useablePeriod(self, index, value): self.useablePeriod[index] = value
    useablePeriodProp = property(get_useablePeriod, set_useablePeriod)
    def get_use(self): return self.use
    def set_use(self, use): self.use = use
    useProp = property(get_use, set_use)
    def validate_set_PostalAddressUse(self, value):
        # Validate type set_PostalAddressUse, a restriction on PostalAddressUse.
        pass
    def get_isNotOrdered(self): return self.isNotOrdered
    def set_isNotOrdered(self, isNotOrdered): self.isNotOrdered = isNotOrdered
    isNotOrderedProp = property(get_isNotOrdered, set_isNotOrdered)
    def validate_bl(self, value):
        # Validate type bl, a restriction on xs:boolean.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='AD', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='AD')
        if self.hasContent_():
            if self.hasSimpleContent_():
                outfile.write('>')
            else:
                outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            if not self.hasSimpleContent_():
                showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='AD'):
        super(AD, self).exportAttributes(outfile, level, already_processed, namespace_, name_='AD')
        if self.use is not None and 'use' not in already_processed:
            already_processed.append('use')
            outfile.write(' use=%s' % (quote_attrib(self.use), ))
        if self.isNotOrdered is not None and 'isNotOrdered' not in already_processed:
            already_processed.append('isNotOrdered')
            outfile.write(' isNotOrdered=%s' % (quote_attrib(self.isNotOrdered), ))
    def exportChildren(self, outfile, level, namespace_='', name_='AD', fromsubclass_=False):
        super(AD, self).exportChildren(outfile, level, namespace_, name_, True)
        for delimiter_ in self.delimiter:
            delimiter_.export(outfile, level, namespace_, name_='delimiter')
        for country_ in self.country:
            country_.export(outfile, level, namespace_, name_='country')
        for state_ in self.state:
            state_.export(outfile, level, namespace_, name_='state')
        for county_ in self.county:
            county_.export(outfile, level, namespace_, name_='county')
        for city_ in self.city:
            city_.export(outfile, level, namespace_, name_='city')
        for postalCode_ in self.postalCode:
            postalCode_.export(outfile, level, namespace_, name_='postalCode')
        for streetAddressLine_ in self.streetAddressLine:
            streetAddressLine_.export(outfile, level, namespace_, name_='streetAddressLine')
        for houseNumber_ in self.houseNumber:
            houseNumber_.export(outfile, level, namespace_, name_='houseNumber')
        for houseNumberNumeric_ in self.houseNumberNumeric:
            houseNumberNumeric_.export(outfile, level, namespace_, name_='houseNumberNumeric')
        for direction_ in self.direction:
            direction_.export(outfile, level, namespace_, name_='direction')
        for streetName_ in self.streetName:
            streetName_.export(outfile, level, namespace_, name_='streetName')
        for streetNameBase_ in self.streetNameBase:
            streetNameBase_.export(outfile, level, namespace_, name_='streetNameBase')
        for streetNameType_ in self.streetNameType:
            streetNameType_.export(outfile, level, namespace_, name_='streetNameType')
        for additionalLocator_ in self.additionalLocator:
            additionalLocator_.export(outfile, level, namespace_, name_='additionalLocator')
        for unitID_ in self.unitID:
            unitID_.export(outfile, level, namespace_, name_='unitID')
        for unitType_ in self.unitType:
            unitType_.export(outfile, level, namespace_, name_='unitType')
        for careOf_ in self.careOf:
            careOf_.export(outfile, level, namespace_, name_='careOf')
        for censusTract_ in self.censusTract:
            censusTract_.export(outfile, level, namespace_, name_='censusTract')
        for deliveryAddressLine_ in self.deliveryAddressLine:
            deliveryAddressLine_.export(outfile, level, namespace_, name_='deliveryAddressLine')
        for deliveryInstallationType_ in self.deliveryInstallationType:
            deliveryInstallationType_.export(outfile, level, namespace_, name_='deliveryInstallationType')
        for deliveryInstallationArea_ in self.deliveryInstallationArea:
            deliveryInstallationArea_.export(outfile, level, namespace_, name_='deliveryInstallationArea')
        for deliveryInstallationQualifier_ in self.deliveryInstallationQualifier:
            deliveryInstallationQualifier_.export(outfile, level, namespace_, name_='deliveryInstallationQualifier')
        for deliveryMode_ in self.deliveryMode:
            deliveryMode_.export(outfile, level, namespace_, name_='deliveryMode')
        for deliveryModeIdentifier_ in self.deliveryModeIdentifier:
            deliveryModeIdentifier_.export(outfile, level, namespace_, name_='deliveryModeIdentifier')
        for buildingNumberSuffix_ in self.buildingNumberSuffix:
            buildingNumberSuffix_.export(outfile, level, namespace_, name_='buildingNumberSuffix')
        for postBox_ in self.postBox:
            postBox_.export(outfile, level, namespace_, name_='postBox')
        for precinct_ in self.precinct:
            precinct_.export(outfile, level, namespace_, name_='precinct')
        for useablePeriod_ in self.useablePeriod:
            useablePeriod_.export(outfile, level, namespace_, name_='useablePeriod')
        if self.valueOf_ is not None:
            outfile.write(self.valueOf_)
        elif not fromsubclass_:
            for item_ in self.content_:
                item_.export(outfile, level, item_.name, namespace_)
    def hasContent_(self):
        if (
            self.delimiter or
            self.country or
            self.state or
            self.county or
            self.city or
            self.postalCode or
            self.streetAddressLine or
            self.houseNumber or
            self.houseNumberNumeric or
            self.direction or
            self.streetName or
            self.streetNameBase or
            self.streetNameType or
            self.additionalLocator or
            self.unitID or
            self.unitType or
            self.careOf or
            self.censusTract or
            self.deliveryAddressLine or
            self.deliveryInstallationType or
            self.deliveryInstallationArea or
            self.deliveryInstallationQualifier or
            self.deliveryMode or
            self.deliveryModeIdentifier or
            self.buildingNumberSuffix or
            self.postBox or
            self.precinct or
            self.useablePeriod or
            self.valueOf_ or
            super(AD, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(AD, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('use', node)
        if value is not None and 'use' not in already_processed:
            already_processed.append('use')
            self.use = value
            self.validate_set_PostalAddressUse(self.use)    # validate type set_PostalAddressUse
        value = find_attr_value_('isNotOrdered', node)
        if value is not None and 'isNotOrdered' not in already_processed:
            already_processed.append('isNotOrdered')
            if value in ('true', '1'):
                self.isNotOrdered = True
            elif value in ('false', '0'):
                self.isNotOrdered = False
            else:
                raise_parse_error(node, 'Bad boolean attribute')
            self.validate_bl(self.isNotOrdered)    # validate type bl
        super(AD, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'delimiter':
            obj_ = adxp_delimiter.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'delimiter', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_delimiter'):
              self.add_delimiter(obj_.value)
            elif hasattr(self, 'set_delimiter'):
              self.set_delimiter(obj_.value)
        elif nodeName_ == 'country':
            obj_ = adxp_country.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'country', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_country'):
              self.add_country(obj_.value)
            elif hasattr(self, 'set_country'):
              self.set_country(obj_.value)
        elif nodeName_ == 'state':
            obj_ = adxp_state.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'state', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_state'):
              self.add_state(obj_.value)
            elif hasattr(self, 'set_state'):
              self.set_state(obj_.value)
        elif nodeName_ == 'county':
            obj_ = adxp_county.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'county', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_county'):
              self.add_county(obj_.value)
            elif hasattr(self, 'set_county'):
              self.set_county(obj_.value)
        elif nodeName_ == 'city':
            obj_ = adxp_city.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'city', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_city'):
              self.add_city(obj_.value)
            elif hasattr(self, 'set_city'):
              self.set_city(obj_.value)
        elif nodeName_ == 'postalCode':
            obj_ = adxp_postalCode.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'postalCode', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_postalCode'):
              self.add_postalCode(obj_.value)
            elif hasattr(self, 'set_postalCode'):
              self.set_postalCode(obj_.value)
        elif nodeName_ == 'streetAddressLine':
            obj_ = adxp_streetAddressLine.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'streetAddressLine', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_streetAddressLine'):
              self.add_streetAddressLine(obj_.value)
            elif hasattr(self, 'set_streetAddressLine'):
              self.set_streetAddressLine(obj_.value)
        elif nodeName_ == 'houseNumber':
            obj_ = adxp_houseNumber.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'houseNumber', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_houseNumber'):
              self.add_houseNumber(obj_.value)
            elif hasattr(self, 'set_houseNumber'):
              self.set_houseNumber(obj_.value)
        elif nodeName_ == 'houseNumberNumeric':
            obj_ = adxp_houseNumberNumeric.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'houseNumberNumeric', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_houseNumberNumeric'):
              self.add_houseNumberNumeric(obj_.value)
            elif hasattr(self, 'set_houseNumberNumeric'):
              self.set_houseNumberNumeric(obj_.value)
        elif nodeName_ == 'direction':
            obj_ = adxp_direction.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'direction', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_direction'):
              self.add_direction(obj_.value)
            elif hasattr(self, 'set_direction'):
              self.set_direction(obj_.value)
        elif nodeName_ == 'streetName':
            obj_ = adxp_streetName.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'streetName', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_streetName'):
              self.add_streetName(obj_.value)
            elif hasattr(self, 'set_streetName'):
              self.set_streetName(obj_.value)
        elif nodeName_ == 'streetNameBase':
            obj_ = adxp_streetNameBase.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'streetNameBase', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_streetNameBase'):
              self.add_streetNameBase(obj_.value)
            elif hasattr(self, 'set_streetNameBase'):
              self.set_streetNameBase(obj_.value)
        elif nodeName_ == 'streetNameType':
            obj_ = adxp_streetNameType.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'streetNameType', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_streetNameType'):
              self.add_streetNameType(obj_.value)
            elif hasattr(self, 'set_streetNameType'):
              self.set_streetNameType(obj_.value)
        elif nodeName_ == 'additionalLocator':
            obj_ = adxp_additionalLocator.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'additionalLocator', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_additionalLocator'):
              self.add_additionalLocator(obj_.value)
            elif hasattr(self, 'set_additionalLocator'):
              self.set_additionalLocator(obj_.value)
        elif nodeName_ == 'unitID':
            obj_ = adxp_unitID.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'unitID', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_unitID'):
              self.add_unitID(obj_.value)
            elif hasattr(self, 'set_unitID'):
              self.set_unitID(obj_.value)
        elif nodeName_ == 'unitType':
            obj_ = adxp_unitType.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'unitType', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_unitType'):
              self.add_unitType(obj_.value)
            elif hasattr(self, 'set_unitType'):
              self.set_unitType(obj_.value)
        elif nodeName_ == 'careOf':
            obj_ = adxp_careOf.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'careOf', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_careOf'):
              self.add_careOf(obj_.value)
            elif hasattr(self, 'set_careOf'):
              self.set_careOf(obj_.value)
        elif nodeName_ == 'censusTract':
            obj_ = adxp_censusTract.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'censusTract', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_censusTract'):
              self.add_censusTract(obj_.value)
            elif hasattr(self, 'set_censusTract'):
              self.set_censusTract(obj_.value)
        elif nodeName_ == 'deliveryAddressLine':
            obj_ = adxp_deliveryAddressLine.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'deliveryAddressLine', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_deliveryAddressLine'):
              self.add_deliveryAddressLine(obj_.value)
            elif hasattr(self, 'set_deliveryAddressLine'):
              self.set_deliveryAddressLine(obj_.value)
        elif nodeName_ == 'deliveryInstallationType':
            obj_ = adxp_deliveryInstallationType.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'deliveryInstallationType', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_deliveryInstallationType'):
              self.add_deliveryInstallationType(obj_.value)
            elif hasattr(self, 'set_deliveryInstallationType'):
              self.set_deliveryInstallationType(obj_.value)
        elif nodeName_ == 'deliveryInstallationArea':
            obj_ = adxp_deliveryInstallationArea.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'deliveryInstallationArea', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_deliveryInstallationArea'):
              self.add_deliveryInstallationArea(obj_.value)
            elif hasattr(self, 'set_deliveryInstallationArea'):
              self.set_deliveryInstallationArea(obj_.value)
        elif nodeName_ == 'deliveryInstallationQualifier':
            obj_ = adxp_deliveryInstallationQualifier.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'deliveryInstallationQualifier', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_deliveryInstallationQualifier'):
              self.add_deliveryInstallationQualifier(obj_.value)
            elif hasattr(self, 'set_deliveryInstallationQualifier'):
              self.set_deliveryInstallationQualifier(obj_.value)
        elif nodeName_ == 'deliveryMode':
            obj_ = adxp_deliveryMode.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'deliveryMode', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_deliveryMode'):
              self.add_deliveryMode(obj_.value)
            elif hasattr(self, 'set_deliveryMode'):
              self.set_deliveryMode(obj_.value)
        elif nodeName_ == 'deliveryModeIdentifier':
            obj_ = adxp_deliveryModeIdentifier.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'deliveryModeIdentifier', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_deliveryModeIdentifier'):
              self.add_deliveryModeIdentifier(obj_.value)
            elif hasattr(self, 'set_deliveryModeIdentifier'):
              self.set_deliveryModeIdentifier(obj_.value)
        elif nodeName_ == 'buildingNumberSuffix':
            obj_ = adxp_buildingNumberSuffix.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'buildingNumberSuffix', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_buildingNumberSuffix'):
              self.add_buildingNumberSuffix(obj_.value)
            elif hasattr(self, 'set_buildingNumberSuffix'):
              self.set_buildingNumberSuffix(obj_.value)
        elif nodeName_ == 'postBox':
            obj_ = adxp_postBox.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'postBox', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_postBox'):
              self.add_postBox(obj_.value)
            elif hasattr(self, 'set_postBox'):
              self.set_postBox(obj_.value)
        elif nodeName_ == 'precinct':
            obj_ = adxp_precinct.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'precinct', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_precinct'):
              self.add_precinct(obj_.value)
            elif hasattr(self, 'set_precinct'):
              self.set_precinct(obj_.value)
        elif nodeName_ == 'useablePeriod':
            obj_ = self.get_class_obj_(child_, SXCM_TS)
            obj_ = SXCM_TS.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'useablePeriod', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_useablePeriod'):
              self.add_useablePeriod(obj_.value)
            elif hasattr(self, 'set_useablePeriod'):
              self.set_useablePeriod(obj_.value)
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        super(AD, self).buildChildren(child_, node, nodeName_, True)
# end class AD


class ENXP(ST):
    """A character string token representing a part of a name. May have a
    type code signifying the role of the part in the whole entity
    name, and a qualifier code for more detail about the name part
    type. Typical name parts for person names are given names, and
    family names, titles, etc. Indicates whether the name part is a
    given name, family name, prefix, suffix, etc. is a set of codes
    each of which specifies a certain subcategory of the name part
    in addition to the main name part type. For example, a given
    name may be flagged as a nickname, a family name may be a
    pseudonym or a name of public records."""
    member_data_items_ = [
        MemberSpec_('qualifier', 'set_EntityNamePartQualifier', 0, 1, 0),
        MemberSpec_('partType', 'EntityNamePartType', 0, 1, 0),
        MemberSpec_('valueOf_', 'ST', 0, 0, 0),
        ]
    subclass = None
    superclass = ST
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, qualifier=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(ENXP, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, valueOf_, mixedclass_, content_, )
        self.qualifier = _cast(None, qualifier)
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if ENXP.subclass:
            return ENXP.subclass(*args_, **kwargs_)
        else:
            return ENXP(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_qualifier(self): return self.qualifier
    def set_qualifier(self, qualifier): self.qualifier = qualifier
    qualifierProp = property(get_qualifier, set_qualifier)
    def validate_set_EntityNamePartQualifier(self, value):
        # Validate type set_EntityNamePartQualifier, a restriction on EntityNamePartQualifier.
        pass
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_EntityNamePartType(self, value):
        # Validate type EntityNamePartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='ENXP', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='ENXP')
        if self.hasContent_():
            if self.hasSimpleContent_():
                outfile.write('>')
            else:
                outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            if not self.hasSimpleContent_():
                showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='ENXP'):
        super(ENXP, self).exportAttributes(outfile, level, already_processed, namespace_, name_='ENXP')
        if self.qualifier is not None and 'qualifier' not in already_processed:
            already_processed.append('qualifier')
            outfile.write(' qualifier=%s' % (quote_attrib(self.qualifier), ))
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='ENXP', fromsubclass_=False):
        super(ENXP, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(ENXP, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(ENXP, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('qualifier', node)
        if value is not None and 'qualifier' not in already_processed:
            already_processed.append('qualifier')
            self.qualifier = value
            self.validate_set_EntityNamePartQualifier(self.qualifier)    # validate type set_EntityNamePartQualifier
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_EntityNamePartType(self.partType)    # validate type EntityNamePartType
        super(ENXP, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        super(ENXP, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class ENXP


class en_delimiter(ENXP):
    member_data_items_ = [
        MemberSpec_('partType', 'EntityNamePartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ENXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, qualifier=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(en_delimiter, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, qualifier, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if en_delimiter.subclass:
            return en_delimiter.subclass(*args_, **kwargs_)
        else:
            return en_delimiter(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_EntityNamePartType(self, value):
        # Validate type EntityNamePartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='en.delimiter', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='en.delimiter')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='en.delimiter'):
        super(en_delimiter, self).exportAttributes(outfile, level, already_processed, namespace_, name_='en.delimiter')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='en.delimiter', fromsubclass_=False):
        super(en_delimiter, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(en_delimiter, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(en_delimiter, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_EntityNamePartType(self.partType)    # validate type EntityNamePartType
        super(en_delimiter, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class en_delimiter


class en_family(ENXP):
    member_data_items_ = [
        MemberSpec_('partType', 'EntityNamePartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ENXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, qualifier=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(en_family, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, qualifier, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if en_family.subclass:
            return en_family.subclass(*args_, **kwargs_)
        else:
            return en_family(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_EntityNamePartType(self, value):
        # Validate type EntityNamePartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='en.family', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='en.family')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='en.family'):
        super(en_family, self).exportAttributes(outfile, level, already_processed, namespace_, name_='en.family')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='en.family', fromsubclass_=False):
        super(en_family, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(en_family, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(en_family, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_EntityNamePartType(self.partType)    # validate type EntityNamePartType
        super(en_family, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class en_family


class en_given(ENXP):
    member_data_items_ = [
        MemberSpec_('partType', 'EntityNamePartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ENXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, qualifier=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(en_given, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, qualifier, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if en_given.subclass:
            return en_given.subclass(*args_, **kwargs_)
        else:
            return en_given(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_EntityNamePartType(self, value):
        # Validate type EntityNamePartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='en.given', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='en.given')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='en.given'):
        super(en_given, self).exportAttributes(outfile, level, already_processed, namespace_, name_='en.given')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='en.given', fromsubclass_=False):
        super(en_given, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(en_given, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(en_given, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_EntityNamePartType(self.partType)    # validate type EntityNamePartType
        super(en_given, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class en_given


class en_prefix(ENXP):
    member_data_items_ = [
        MemberSpec_('partType', 'EntityNamePartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ENXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, qualifier=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(en_prefix, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, qualifier, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if en_prefix.subclass:
            return en_prefix.subclass(*args_, **kwargs_)
        else:
            return en_prefix(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_EntityNamePartType(self, value):
        # Validate type EntityNamePartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='en.prefix', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='en.prefix')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='en.prefix'):
        super(en_prefix, self).exportAttributes(outfile, level, already_processed, namespace_, name_='en.prefix')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='en.prefix', fromsubclass_=False):
        super(en_prefix, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(en_prefix, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(en_prefix, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_EntityNamePartType(self.partType)    # validate type EntityNamePartType
        super(en_prefix, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class en_prefix


class en_suffix(ENXP):
    member_data_items_ = [
        MemberSpec_('partType', 'EntityNamePartType', 0, 1, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = ENXP
    def __init__(self, nullFlavor=None, representation='TXT', integrityCheckAlgorithm='SHA-1', integrityCheck=None, mediaType='text/plain', language=None, compression=None, reference=None, thumbnail=None, qualifier=None, partType=None, valueOf_=None, mixedclass_=None, content_=None):
        super(en_suffix, self).__init__(nullFlavor, representation, integrityCheckAlgorithm, integrityCheck, mediaType, language, compression, reference, thumbnail, qualifier, partType, valueOf_, mixedclass_, content_, )
        self.partType = _cast(None, partType)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if en_suffix.subclass:
            return en_suffix.subclass(*args_, **kwargs_)
        else:
            return en_suffix(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_partType(self): return self.partType
    def set_partType(self, partType): self.partType = partType
    partTypeProp = property(get_partType, set_partType)
    def validate_EntityNamePartType(self, value):
        # Validate type EntityNamePartType, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='en.suffix', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='en.suffix')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='en.suffix'):
        super(en_suffix, self).exportAttributes(outfile, level, already_processed, namespace_, name_='en.suffix')
        if self.partType is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            outfile.write(' partType=%s' % (quote_attrib(self.partType), ))
    def exportChildren(self, outfile, level, namespace_='', name_='en.suffix', fromsubclass_=False):
        super(en_suffix, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(en_suffix, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(en_suffix, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('partType', node)
        if value is not None and 'partType' not in already_processed:
            already_processed.append('partType')
            self.partType = value
            self.validate_EntityNamePartType(self.partType)    # validate type EntityNamePartType
        super(en_suffix, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        pass
# end class en_suffix


class EN(ANY):
    """A name for a person, organization, place or thing. A sequence of
    name parts, such as given name or family name, prefix, suffix,
    etc. Examples for entity name values are "Jim Bob Walton, Jr.",
    "Health Level Seven, Inc.", "Lake Tahoe", etc. An entity name
    may be as simple as a character string or may consist of several
    entity name parts, such as, "Jim", "Bob", "Walton", and "Jr.",
    "Health Level Seven" and "Inc.", "Lake" and "Tahoe". A set of
    codes advising a system or user which name in a set of like
    names to select for a given purpose. A name without specific use
    code might be a default name useful for any purpose, but a name
    with a specific use code would be preferred for that respective
    purpose."""
    member_data_items_ = [
        MemberSpec_('use', 'set_EntityNameUse', 0, 1, 0),
        MemberSpec_('delimiter', 'en.delimiter', 1, 0, 0),
        MemberSpec_('family', 'en.family', 1, 0, 0),
        MemberSpec_('given', 'en.given', 1, 0, 0),
        MemberSpec_('prefix', 'en.prefix', 1, 0, 0),
        MemberSpec_('suffix', 'en.suffix', 1, 0, 0),
        MemberSpec_('validTime', 'IVL_TS', 0, 0, 0),
        MemberSpec_('valueOf_', 'ANY', 0, 0, 0),
        ]
    subclass = None
    superclass = ANY
    def __init__(self, nullFlavor=None, use=None, delimiter=None, family=None, given=None, prefix=None, suffix=None, validTime=None, valueOf_=None, mixedclass_=None, content_=None, extensiontype_=None):
        super(EN, self).__init__(nullFlavor, valueOf_, mixedclass_, content_, extensiontype_, )
        self.use = _cast(None, use)
        if delimiter is None:
            self.delimiter = []
        else:
            self.delimiter = delimiter
        if family is None:
            self.family = []
        else:
            self.family = family
        if given is None:
            self.given = []
        else:
            self.given = given
        if prefix is None:
            self.prefix = []
        else:
            self.prefix = prefix
        if suffix is None:
            self.suffix = []
        else:
            self.suffix = suffix
        self.validTime = validTime
        self.valueOf_ = valueOf_
        self.extensiontype_ = extensiontype_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if EN.subclass:
            return EN.subclass(*args_, **kwargs_)
        else:
            return EN(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_delimiter(self): return self.delimiter
    def set_delimiter(self, delimiter): self.delimiter = delimiter
    def add_delimiter(self, value): self.delimiter.append(value)
    def insert_delimiter(self, index, value): self.delimiter[index] = value
    delimiterProp = property(get_delimiter, set_delimiter)
    def get_family(self): return self.family
    def set_family(self, family): self.family = family
    def add_family(self, value): self.family.append(value)
    def insert_family(self, index, value): self.family[index] = value
    familyProp = property(get_family, set_family)
    def get_given(self): return self.given
    def set_given(self, given): self.given = given
    def add_given(self, value): self.given.append(value)
    def insert_given(self, index, value): self.given[index] = value
    givenProp = property(get_given, set_given)
    def get_prefix(self): return self.prefix
    def set_prefix(self, prefix): self.prefix = prefix
    def add_prefix(self, value): self.prefix.append(value)
    def insert_prefix(self, index, value): self.prefix[index] = value
    prefixProp = property(get_prefix, set_prefix)
    def get_suffix(self): return self.suffix
    def set_suffix(self, suffix): self.suffix = suffix
    def add_suffix(self, value): self.suffix.append(value)
    def insert_suffix(self, index, value): self.suffix[index] = value
    suffixProp = property(get_suffix, set_suffix)
    def get_validTime(self): return self.validTime
    def set_validTime(self, validTime): self.validTime = validTime
    validTimeProp = property(get_validTime, set_validTime)
    def get_use(self): return self.use
    def set_use(self, use): self.use = use
    useProp = property(get_use, set_use)
    def validate_set_EntityNameUse(self, value):
        # Validate type set_EntityNameUse, a restriction on EntityNameUse.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def get_extensiontype_(self): return self.extensiontype_
    def set_extensiontype_(self, extensiontype_): self.extensiontype_ = extensiontype_
    def export(self, outfile, level, namespace_='', name_='EN', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='EN')
        if self.hasContent_():
            if self.hasSimpleContent_():
                outfile.write('>')
            else:
                outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            if not self.hasSimpleContent_():
                showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='EN'):
        super(EN, self).exportAttributes(outfile, level, already_processed, namespace_, name_='EN')
        if self.use is not None and 'use' not in already_processed:
            already_processed.append('use')
            outfile.write(' use=%s' % (quote_attrib(self.use), ))
        if self.extensiontype_ is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            outfile.write(' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"')
            outfile.write(' xsi:type="%s"' % self.extensiontype_)
    def exportChildren(self, outfile, level, namespace_='', name_='EN', fromsubclass_=False):
        super(EN, self).exportChildren(outfile, level, namespace_, name_, True)
        for delimiter_ in self.delimiter:
            delimiter_.export(outfile, level, namespace_, name_='delimiter')
        for family_ in self.family:
            family_.export(outfile, level, namespace_, name_='family')
        for given_ in self.given:
            given_.export(outfile, level, namespace_, name_='given')
        for prefix_ in self.prefix:
            prefix_.export(outfile, level, namespace_, name_='prefix')
        for suffix_ in self.suffix:
            suffix_.export(outfile, level, namespace_, name_='suffix')
        if self.validTime is not None:
            self.validTime.export(outfile, level, namespace_, name_='validTime')
        if self.valueOf_ is not None:
            outfile.write(self.valueOf_)
        elif not fromsubclass_:
            for item_ in self.content_:
                item_.export(outfile, level, item_.name, namespace_)
    def hasContent_(self):
        if (
            self.delimiter or
            self.family or
            self.given or
            self.prefix or
            self.suffix or
            self.validTime is not None or
            self.valueOf_ or
            super(EN, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(EN, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('use', node)
        if value is not None and 'use' not in already_processed:
            already_processed.append('use')
            self.use = value
            self.validate_set_EntityNameUse(self.use)    # validate type set_EntityNameUse
        value = find_attr_value_('xsi:type', node)
        if value is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            self.extensiontype_ = value
        super(EN, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'delimiter':
            obj_ = en_delimiter.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'delimiter', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_delimiter'):
              self.add_delimiter(obj_.value)
            elif hasattr(self, 'set_delimiter'):
              self.set_delimiter(obj_.value)
        elif nodeName_ == 'family':
            obj_ = en_family.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'family', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_family'):
              self.add_family(obj_.value)
            elif hasattr(self, 'set_family'):
              self.set_family(obj_.value)
        elif nodeName_ == 'given':
            obj_ = en_given.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'given', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_given'):
              self.add_given(obj_.value)
            elif hasattr(self, 'set_given'):
              self.set_given(obj_.value)
        elif nodeName_ == 'prefix':
            obj_ = en_prefix.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'prefix', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_prefix'):
              self.add_prefix(obj_.value)
            elif hasattr(self, 'set_prefix'):
              self.set_prefix(obj_.value)
        elif nodeName_ == 'suffix':
            obj_ = en_suffix.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'suffix', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_suffix'):
              self.add_suffix(obj_.value)
            elif hasattr(self, 'set_suffix'):
              self.set_suffix(obj_.value)
        elif nodeName_ == 'validTime':
            obj_ = IVL_TS.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'validTime', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_validTime'):
              self.add_validTime(obj_.value)
            elif hasattr(self, 'set_validTime'):
              self.set_validTime(obj_.value)
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        super(EN, self).buildChildren(child_, node, nodeName_, True)
# end class EN


class PN(EN):
    """A name for a person. A sequence of name parts, such as given name or
    family name, prefix, suffix, etc. PN differs from EN because the
    qualifier type cannot include LS (Legal Status)."""
    member_data_items_ = [
        MemberSpec_('valueOf_', 'EN', 0, 0, 0),
        ]
    subclass = None
    superclass = EN
    def __init__(self, nullFlavor=None, use=None, delimiter=None, family=None, given=None, prefix=None, suffix=None, validTime=None, valueOf_=None, mixedclass_=None, content_=None):
        super(PN, self).__init__(nullFlavor, use, delimiter, family, given, prefix, suffix, validTime, valueOf_, mixedclass_, content_, )
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if PN.subclass:
            return PN.subclass(*args_, **kwargs_)
        else:
            return PN(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='PN', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='PN')
        if self.hasContent_():
            if self.hasSimpleContent_():
                outfile.write('>')
            else:
                outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            if not self.hasSimpleContent_():
                showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='PN'):
        super(PN, self).exportAttributes(outfile, level, already_processed, namespace_, name_='PN')
    def exportChildren(self, outfile, level, namespace_='', name_='PN', fromsubclass_=False):
        super(PN, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(PN, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(PN, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        super(PN, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        super(PN, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class PN


class ON(EN):
    """A name for an organization. A sequence of name parts. A set of codes
    advising a system or user which name in a set of like names to
    select for a given purpose. A name without specific use code
    might be a default name useful for any purpose, but a name with
    a specific use code would be preferred for that respective
    purpose."""
    member_data_items_ = [
        MemberSpec_('use', 'set_EntityNameUse', 0, 1, 0),
        MemberSpec_('delimiter', 'en.delimiter', 1, 0, 0),
        MemberSpec_('prefix', 'en.prefix', 1, 0, 0),
        MemberSpec_('suffix', 'en.suffix', 1, 0, 0),
        MemberSpec_('validTime', 'IVL_TS', 0, 0, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = EN
    def __init__(self, nullFlavor=None, use=None, delimiter=None, family=None, given=None, prefix=None, suffix=None, validTime=None, valueOf_=None, mixedclass_=None, content_=None):
        super(ON, self).__init__(nullFlavor, use, delimiter, family, given, prefix, suffix, validTime, valueOf_, mixedclass_, content_, )
        self.use = _cast(None, use)
        if delimiter is None:
            self.delimiter = []
        else:
            self.delimiter = delimiter
        if prefix is None:
            self.prefix = []
        else:
            self.prefix = prefix
        if suffix is None:
            self.suffix = []
        else:
            self.suffix = suffix
        self.validTime = validTime
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if ON.subclass:
            return ON.subclass(*args_, **kwargs_)
        else:
            return ON(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_delimiter(self): return self.delimiter
    def set_delimiter(self, delimiter): self.delimiter = delimiter
    def add_delimiter(self, value): self.delimiter.append(value)
    def insert_delimiter(self, index, value): self.delimiter[index] = value
    delimiterProp = property(get_delimiter, set_delimiter)
    def get_prefix(self): return self.prefix
    def set_prefix(self, prefix): self.prefix = prefix
    def add_prefix(self, value): self.prefix.append(value)
    def insert_prefix(self, index, value): self.prefix[index] = value
    prefixProp = property(get_prefix, set_prefix)
    def get_suffix(self): return self.suffix
    def set_suffix(self, suffix): self.suffix = suffix
    def add_suffix(self, value): self.suffix.append(value)
    def insert_suffix(self, index, value): self.suffix[index] = value
    suffixProp = property(get_suffix, set_suffix)
    def get_validTime(self): return self.validTime
    def set_validTime(self, validTime): self.validTime = validTime
    validTimeProp = property(get_validTime, set_validTime)
    def get_use(self): return self.use
    def set_use(self, use): self.use = use
    useProp = property(get_use, set_use)
    def validate_set_EntityNameUse(self, value):
        # Validate type set_EntityNameUse, a restriction on EntityNameUse.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='ON', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='ON')
        if self.hasContent_():
            if self.hasSimpleContent_():
                outfile.write('>')
            else:
                outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            if not self.hasSimpleContent_():
                showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='ON'):
        super(ON, self).exportAttributes(outfile, level, already_processed, namespace_, name_='ON')
        if self.use is not None and 'use' not in already_processed:
            already_processed.append('use')
            outfile.write(' use=%s' % (quote_attrib(self.use), ))
    def exportChildren(self, outfile, level, namespace_='', name_='ON', fromsubclass_=False):
        for delimiter_ in self.delimiter:
            delimiter_.export(outfile, level, namespace_, name_='delimiter')
        for prefix_ in self.prefix:
            prefix_.export(outfile, level, namespace_, name_='prefix')
        for suffix_ in self.suffix:
            suffix_.export(outfile, level, namespace_, name_='suffix')
        if self.validTime is not None:
            self.validTime.export(outfile, level, namespace_, name_='validTime')
        if self.valueOf_ is not None:
            outfile.write(self.valueOf_)
        elif not fromsubclass_:
            for item_ in self.content_:
                item_.export(outfile, level, item_.name, namespace_)
    def hasContent_(self):
        if (
            self.delimiter or
            self.prefix or
            self.suffix or
            self.validTime is not None or
            self.valueOf_ or
            super(ON, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(ON, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('use', node)
        if value is not None and 'use' not in already_processed:
            already_processed.append('use')
            self.use = value
            self.validate_set_EntityNameUse(self.use)    # validate type set_EntityNameUse
        super(ON, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'delimiter':
            obj_ = en_delimiter.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'delimiter', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_delimiter'):
              self.add_delimiter(obj_.value)
            elif hasattr(self, 'set_delimiter'):
              self.set_delimiter(obj_.value)
        elif nodeName_ == 'prefix':
            obj_ = en_prefix.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'prefix', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_prefix'):
              self.add_prefix(obj_.value)
            elif hasattr(self, 'set_prefix'):
              self.set_prefix(obj_.value)
        elif nodeName_ == 'suffix':
            obj_ = en_suffix.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'suffix', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_suffix'):
              self.add_suffix(obj_.value)
            elif hasattr(self, 'set_suffix'):
              self.set_suffix(obj_.value)
        elif nodeName_ == 'validTime':
            obj_ = IVL_TS.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'validTime', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_validTime'):
              self.add_validTime(obj_.value)
            elif hasattr(self, 'set_validTime'):
              self.set_validTime(obj_.value)
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
# end class ON


class TN(EN):
    """A restriction of entity name that is effectively a simple string
    used for a simple name for things and places."""
    member_data_items_ = [
        MemberSpec_('validTime', 'IVL_TS', 0, 0, 0),
        MemberSpec_('valueOf_', [], 0, 0, 0),
        ]
    subclass = None
    superclass = EN
    def __init__(self, nullFlavor=None, use=None, delimiter=None, family=None, given=None, prefix=None, suffix=None, validTime=None, valueOf_=None, mixedclass_=None, content_=None):
        super(TN, self).__init__(nullFlavor, use, delimiter, family, given, prefix, suffix, validTime, valueOf_, mixedclass_, content_, )
        self.validTime = validTime
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if TN.subclass:
            return TN.subclass(*args_, **kwargs_)
        else:
            return TN(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_validTime(self): return self.validTime
    def set_validTime(self, validTime): self.validTime = validTime
    validTimeProp = property(get_validTime, set_validTime)
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='TN', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='TN')
        if self.hasContent_():
            if self.hasSimpleContent_():
                outfile.write('>')
            else:
                outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            if not self.hasSimpleContent_():
                showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='TN'):
        super(TN, self).exportAttributes(outfile, level, already_processed, namespace_, name_='TN')
    def exportChildren(self, outfile, level, namespace_='', name_='TN', fromsubclass_=False):
        if self.validTime is not None:
            self.validTime.export(outfile, level, namespace_, name_='validTime')
        if self.valueOf_ is not None:
            outfile.write(self.valueOf_)
        elif not fromsubclass_:
            for item_ in self.content_:
                item_.export(outfile, level, item_.name, namespace_)
    def hasContent_(self):
        if (
            self.validTime is not None or
            self.valueOf_ or
            super(TN, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(TN, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        super(TN, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'validTime':
            obj_ = IVL_TS.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'validTime', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_validTime'):
              self.add_validTime(obj_.value)
            elif hasattr(self, 'set_validTime'):
              self.set_validTime(obj_.value)
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
# end class TN


class QTY(ANY):
    """is an abstract generalization for all data types (1) whose value set
    has an order relation (less-or-equal) and (2) where difference
    is defined in all of the data type's totally ordered value
    subsets. The quantity type abstraction is needed in defining
    certain other types, such as the interval and the probability
    distribution."""
    member_data_items_ = [
        MemberSpec_('valueOf_', 'ANY', 0, 0, 0),
        ]
    subclass = None
    superclass = ANY
    def __init__(self, nullFlavor=None, valueOf_=None, mixedclass_=None, content_=None, extensiontype_=None):
        super(QTY, self).__init__(nullFlavor, valueOf_, mixedclass_, content_, extensiontype_, )
        self.valueOf_ = valueOf_
        self.extensiontype_ = extensiontype_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if QTY.subclass:
            return QTY.subclass(*args_, **kwargs_)
        else:
            return QTY(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def get_extensiontype_(self): return self.extensiontype_
    def set_extensiontype_(self, extensiontype_): self.extensiontype_ = extensiontype_
    def export(self, outfile, level, namespace_='', name_='QTY', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='QTY')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='QTY'):
        super(QTY, self).exportAttributes(outfile, level, already_processed, namespace_, name_='QTY')
        if self.extensiontype_ is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            outfile.write(' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"')
            outfile.write(' xsi:type="%s"' % self.extensiontype_)
    def exportChildren(self, outfile, level, namespace_='', name_='QTY', fromsubclass_=False):
        super(QTY, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(QTY, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(QTY, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('xsi:type', node)
        if value is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            self.extensiontype_ = value
        super(QTY, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        super(QTY, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class QTY


class INT(QTY):
    """Integer numbers (-1,0,1,2, 100, 3398129, etc.) are precise numbers
    that are results of counting and enumerating. Integer numbers
    are discrete, the set of integers is infinite but countable. No
    arbitrary limit is imposed on the range of integer numbers. Two
    NULL flavors are defined for the positive and negative infinity."""
    member_data_items_ = [
        MemberSpec_('value', 'int', 0, 1, 0),
        MemberSpec_('valueOf_', 'QTY', 0, 0, 0),
        ]
    subclass = None
    superclass = QTY
    def __init__(self, nullFlavor=None, value=None, valueOf_=None, mixedclass_=None, content_=None, extensiontype_=None):
        super(INT, self).__init__(nullFlavor, valueOf_, mixedclass_, content_, extensiontype_, )
        self.value = _cast(None, value)
        self.valueOf_ = valueOf_
        self.extensiontype_ = extensiontype_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if INT.subclass:
            return INT.subclass(*args_, **kwargs_)
        else:
            return INT(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_value(self): return self.value
    def set_value(self, value): self.value = value
    valueProp = property(get_value, set_value)
    def validate_int(self, value):
        # Validate type int, a restriction on xs:integer.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def get_extensiontype_(self): return self.extensiontype_
    def set_extensiontype_(self, extensiontype_): self.extensiontype_ = extensiontype_
    def export(self, outfile, level, namespace_='', name_='INT', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='INT')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='INT'):
        super(INT, self).exportAttributes(outfile, level, already_processed, namespace_, name_='INT')
        if self.value is not None and 'value' not in already_processed:
            already_processed.append('value')
            outfile.write(' value=%s' % (quote_attrib(self.value), ))
        if self.extensiontype_ is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            outfile.write(' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"')
            outfile.write(' xsi:type="%s"' % self.extensiontype_)
    def exportChildren(self, outfile, level, namespace_='', name_='INT', fromsubclass_=False):
        super(INT, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(INT, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(INT, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('value', node)
        if value is not None and 'value' not in already_processed:
            already_processed.append('value')
            try:
                self.value = int(value)
            except ValueError, exp:
                raise_parse_error(node, 'Bad integer attribute: %s' % exp)
            self.validate_int(self.value)    # validate type int
        value = find_attr_value_('xsi:type', node)
        if value is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            self.extensiontype_ = value
        super(INT, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        super(INT, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class INT


class REAL(QTY):
    """Fractional numbers. Typically used whenever quantities are measured,
    estimated, or computed from other real numbers. The typical
    representation is decimal, where the number of significant
    decimal digits is known as the precision. Real numbers are
    needed beyond integers whenever quantities of the real world are
    measured, estimated, or computed from other real numbers. The
    term "Real number" in this specification is used to mean that
    fractional values are covered without necessarily implying the
    full set of the mathematical real numbers."""
    member_data_items_ = [
        MemberSpec_('value', 'real', 0, 1, 0),
        MemberSpec_('valueOf_', 'QTY', 0, 0, 0),
        ]
    subclass = None
    superclass = QTY
    def __init__(self, nullFlavor=None, value=None, valueOf_=None, mixedclass_=None, content_=None, extensiontype_=None):
        super(REAL, self).__init__(nullFlavor, valueOf_, mixedclass_, content_, extensiontype_, )
        self.value = _cast(None, value)
        self.valueOf_ = valueOf_
        self.extensiontype_ = extensiontype_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if REAL.subclass:
            return REAL.subclass(*args_, **kwargs_)
        else:
            return REAL(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_value(self): return self.value
    def set_value(self, value): self.value = value
    valueProp = property(get_value, set_value)
    def validate_real(self, value):
        # Validate type real, a restriction on None.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def get_extensiontype_(self): return self.extensiontype_
    def set_extensiontype_(self, extensiontype_): self.extensiontype_ = extensiontype_
    def export(self, outfile, level, namespace_='', name_='REAL', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='REAL')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='REAL'):
        super(REAL, self).exportAttributes(outfile, level, already_processed, namespace_, name_='REAL')
        if self.value is not None and 'value' not in already_processed:
            already_processed.append('value')
            outfile.write(' value=%s' % (quote_attrib(self.value), ))
        if self.extensiontype_ is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            outfile.write(' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"')
            outfile.write(' xsi:type="%s"' % self.extensiontype_)
    def exportChildren(self, outfile, level, namespace_='', name_='REAL', fromsubclass_=False):
        super(REAL, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(REAL, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(REAL, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('value', node)
        if value is not None and 'value' not in already_processed:
            already_processed.append('value')
            self.value = value
            self.validate_real(self.value)    # validate type real
        value = find_attr_value_('xsi:type', node)
        if value is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            self.extensiontype_ = value
        super(REAL, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        super(REAL, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class REAL


class PQR(CV):
    """A representation of a physical quantity in a unit from any code
    system. Used to show alternative representation for a physical
    quantity. The magnitude of the measurement value in terms of the
    unit specified in the code."""
    member_data_items_ = [
        MemberSpec_('value', 'real', 0, 1, 0),
        ]
    subclass = None
    superclass = CV
    def __init__(self, nullFlavor=None, codeSystemVersion=None, codeSystemName=None, code=None, displayName=None, codeSystem=None, originalText=None, qualifier=None, translation=None, value=None):
        super(PQR, self).__init__(nullFlavor, codeSystemVersion, codeSystemName, code, displayName, codeSystem, originalText, qualifier, translation, )
        self.value = _cast(None, value)
        pass
    def factory(*args_, **kwargs_):
        if PQR.subclass:
            return PQR.subclass(*args_, **kwargs_)
        else:
            return PQR(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_value(self): return self.value
    def set_value(self, value): self.value = value
    valueProp = property(get_value, set_value)
    def validate_real(self, value):
        # Validate type real, a restriction on None.
        pass
    def export(self, outfile, level, namespace_='', name_='PQR', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='PQR')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='PQR'):
        super(PQR, self).exportAttributes(outfile, level, already_processed, namespace_, name_='PQR')
        if self.value is not None and 'value' not in already_processed:
            already_processed.append('value')
            outfile.write(' value=%s' % (quote_attrib(self.value), ))
    def exportChildren(self, outfile, level, namespace_='', name_='PQR', fromsubclass_=False):
        super(PQR, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            super(PQR, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('value', node)
        if value is not None and 'value' not in already_processed:
            already_processed.append('value')
            self.value = value
            self.validate_real(self.value)    # validate type real
        super(PQR, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        super(PQR, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class PQR


class PQ(QTY):
    """A dimensioned quantity expressing the result of a measurement act.
    The magnitude of the quantity measured in terms of the unit. The
    unit of measure specified in the Unified Code for Units of
    Measure (UCUM) [http://aurora.rg.iupui.edu/UCUM]."""
    member_data_items_ = [
        MemberSpec_('unit', 'cs', 0, 1, 0),
        MemberSpec_('value', 'real', 0, 1, 0),
        MemberSpec_('translation', 'PQR', 1, 0, 0),
        MemberSpec_('valueOf_', 'QTY', 0, 0, 0),
        ]
    subclass = None
    superclass = QTY
    def __init__(self, nullFlavor=None, unit='1', value=None, translation=None, valueOf_=None, mixedclass_=None, content_=None, extensiontype_=None):
        super(PQ, self).__init__(nullFlavor, valueOf_, mixedclass_, content_, extensiontype_, )
        self.unit = _cast(None, unit)
        self.value = _cast(None, value)
        if translation is None:
            self.translation = []
        else:
            self.translation = translation
        self.valueOf_ = valueOf_
        self.extensiontype_ = extensiontype_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if PQ.subclass:
            return PQ.subclass(*args_, **kwargs_)
        else:
            return PQ(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_translation(self): return self.translation
    def set_translation(self, translation): self.translation = translation
    def add_translation(self, value): self.translation.append(value)
    def insert_translation(self, index, value): self.translation[index] = value
    translationProp = property(get_translation, set_translation)
    def get_unit(self): return self.unit
    def set_unit(self, unit): self.unit = unit
    unitProp = property(get_unit, set_unit)
    def validate_cs(self, value):
        # Validate type cs, a restriction on xs:token.
        pass
    def get_value(self): return self.value
    def set_value(self, value): self.value = value
    valueProp = property(get_value, set_value)
    def validate_real(self, value):
        # Validate type real, a restriction on None.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def get_extensiontype_(self): return self.extensiontype_
    def set_extensiontype_(self, extensiontype_): self.extensiontype_ = extensiontype_
    def export(self, outfile, level, namespace_='', name_='PQ', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='PQ')
        if self.hasContent_():
            if self.hasSimpleContent_():
                outfile.write('>')
            else:
                outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            if not self.hasSimpleContent_():
                showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='PQ'):
        super(PQ, self).exportAttributes(outfile, level, already_processed, namespace_, name_='PQ')
        if self.unit is not None and 'unit' not in already_processed and self.unit != "1":
            already_processed.append('unit')
            outfile.write(' unit=%s' % (quote_attrib(self.unit), ))
        if self.value is not None and 'value' not in already_processed:
            already_processed.append('value')
            outfile.write(' value=%s' % (quote_attrib(self.value), ))
        if self.extensiontype_ is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            outfile.write(' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"')
            outfile.write(' xsi:type="%s"' % self.extensiontype_)
    def exportChildren(self, outfile, level, namespace_='', name_='PQ', fromsubclass_=False):
        super(PQ, self).exportChildren(outfile, level, namespace_, name_, True)
        for translation_ in self.translation:
            translation_.export(outfile, level, namespace_, name_='translation')
        if self.valueOf_ is not None:
            outfile.write(self.valueOf_)
        elif not fromsubclass_:
            for item_ in self.content_:
                item_.export(outfile, level, item_.name, namespace_)
    def hasContent_(self):
        if (
            self.translation or
            self.valueOf_ or
            super(PQ, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(PQ, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('unit', node)
        if value is not None and 'unit' not in already_processed:
            already_processed.append('unit')
            self.unit = value
            self.unit = ' '.join(self.unit.split())
            self.validate_cs(self.unit)    # validate type cs
        value = find_attr_value_('value', node)
        if value is not None and 'value' not in already_processed:
            already_processed.append('value')
            self.value = value
            self.validate_real(self.value)    # validate type real
        value = find_attr_value_('xsi:type', node)
        if value is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            self.extensiontype_ = value
        super(PQ, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'translation':
            obj_ = PQR.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'translation', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_translation'):
              self.add_translation(obj_.value)
            elif hasattr(self, 'set_translation'):
              self.set_translation(obj_.value)
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        super(PQ, self).buildChildren(child_, node, nodeName_, True)
# end class PQ


class MO(QTY):
    """A monetary amount is a quantity expressing the amount of money in
    some currency. Currencies are the units in which monetary
    amounts are denominated in different economic regions. While the
    monetary amount is a single kind of quantity (money) the
    exchange rates between the different units are variable. This is
    the principle difference between physical quantity and monetary
    amounts, and the reason why currency units are not physical
    units. The magnitude of the monetary amount in terms of the
    currency unit. The currency unit as defined in ISO 4217."""
    member_data_items_ = [
        MemberSpec_('currency', 'cs', 0, 1, 0),
        MemberSpec_('value', 'real', 0, 1, 0),
        MemberSpec_('valueOf_', 'QTY', 0, 0, 0),
        ]
    subclass = None
    superclass = QTY
    def __init__(self, nullFlavor=None, currency=None, value=None, valueOf_=None, mixedclass_=None, content_=None, extensiontype_=None):
        super(MO, self).__init__(nullFlavor, valueOf_, mixedclass_, content_, extensiontype_, )
        self.currency = _cast(None, currency)
        self.value = _cast(None, value)
        self.valueOf_ = valueOf_
        self.extensiontype_ = extensiontype_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if MO.subclass:
            return MO.subclass(*args_, **kwargs_)
        else:
            return MO(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_currency(self): return self.currency
    def set_currency(self, currency): self.currency = currency
    currencyProp = property(get_currency, set_currency)
    def validate_cs(self, value):
        # Validate type cs, a restriction on xs:token.
        pass
    def get_value(self): return self.value
    def set_value(self, value): self.value = value
    valueProp = property(get_value, set_value)
    def validate_real(self, value):
        # Validate type real, a restriction on None.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def get_extensiontype_(self): return self.extensiontype_
    def set_extensiontype_(self, extensiontype_): self.extensiontype_ = extensiontype_
    def export(self, outfile, level, namespace_='', name_='MO', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='MO')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='MO'):
        super(MO, self).exportAttributes(outfile, level, already_processed, namespace_, name_='MO')
        if self.currency is not None and 'currency' not in already_processed:
            already_processed.append('currency')
            outfile.write(' currency=%s' % (quote_attrib(self.currency), ))
        if self.value is not None and 'value' not in already_processed:
            already_processed.append('value')
            outfile.write(' value=%s' % (quote_attrib(self.value), ))
        if self.extensiontype_ is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            outfile.write(' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"')
            outfile.write(' xsi:type="%s"' % self.extensiontype_)
    def exportChildren(self, outfile, level, namespace_='', name_='MO', fromsubclass_=False):
        super(MO, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(MO, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(MO, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('currency', node)
        if value is not None and 'currency' not in already_processed:
            already_processed.append('currency')
            self.currency = value
            self.currency = ' '.join(self.currency.split())
            self.validate_cs(self.currency)    # validate type cs
        value = find_attr_value_('value', node)
        if value is not None and 'value' not in already_processed:
            already_processed.append('value')
            self.value = value
            self.validate_real(self.value)    # validate type real
        value = find_attr_value_('xsi:type', node)
        if value is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            self.extensiontype_ = value
        super(MO, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        super(MO, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class MO


class EIVL_event(CE):
    """A code for a common (periodical) activity of daily living based on
    which the event related periodic interval is specified."""
    member_data_items_ = [
        MemberSpec_('codeSystemName', 'st', 0, 1, 0),
        MemberSpec_('code', 'TimingEvent', 0, 1, 0),
        MemberSpec_('codeSystem', 'uid', 0, 1, 0),
        ]
    subclass = None
    superclass = CE
    def __init__(self, nullFlavor=None, codeSystemVersion=None, codeSystemName=None, code=None, displayName=None, codeSystem=None, originalText=None, qualifier=None, translation=None):
        super(EIVL_event, self).__init__(nullFlavor, codeSystemVersion, codeSystemName, code, displayName, codeSystem, originalText, qualifier, translation, )
        self.codeSystemName = _cast(None, codeSystemName)
        self.code = _cast(None, code)
        self.codeSystem = _cast(None, codeSystem)
        pass
    def factory(*args_, **kwargs_):
        if EIVL_event.subclass:
            return EIVL_event.subclass(*args_, **kwargs_)
        else:
            return EIVL_event(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_codeSystemName(self): return self.codeSystemName
    def set_codeSystemName(self, codeSystemName): self.codeSystemName = codeSystemName
    codeSystemNameProp = property(get_codeSystemName, set_codeSystemName)
    def validate_st(self, value):
        # Validate type st, a restriction on xs:string.
        pass
    def get_code(self): return self.code
    def set_code(self, code): self.code = code
    codeProp = property(get_code, set_code)
    def validate_TimingEvent(self, value):
        # Validate type TimingEvent, a restriction on cs.
        pass
    def get_codeSystem(self): return self.codeSystem
    def set_codeSystem(self, codeSystem): self.codeSystem = codeSystem
    codeSystemProp = property(get_codeSystem, set_codeSystem)
    def validate_uid(self, value):
        # Validate type uid, a restriction on None.
        pass
    def export(self, outfile, level, namespace_='', name_='EIVL.event', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='EIVL.event')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='EIVL.event'):
        super(EIVL_event, self).exportAttributes(outfile, level, already_processed, namespace_, name_='EIVL.event')
        if self.codeSystemName is not None and 'codeSystemName' not in already_processed:
            already_processed.append('codeSystemName')
            outfile.write(' codeSystemName=%s' % (quote_attrib(self.codeSystemName), ))
        if self.code is not None and 'code' not in already_processed:
            already_processed.append('code')
            outfile.write(' code=%s' % (quote_attrib(self.code), ))
        if self.codeSystem is not None and 'codeSystem' not in already_processed:
            already_processed.append('codeSystem')
            outfile.write(' codeSystem=%s' % (quote_attrib(self.codeSystem), ))
    def exportChildren(self, outfile, level, namespace_='', name_='EIVL.event', fromsubclass_=False):
        super(EIVL_event, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            super(EIVL_event, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('codeSystemName', node)
        if value is not None and 'codeSystemName' not in already_processed:
            already_processed.append('codeSystemName')
            self.codeSystemName = value
            self.validate_st(self.codeSystemName)    # validate type st
        value = find_attr_value_('code', node)
        if value is not None and 'code' not in already_processed:
            already_processed.append('code')
            self.code = value
            self.validate_TimingEvent(self.code)    # validate type TimingEvent
        value = find_attr_value_('codeSystem', node)
        if value is not None and 'codeSystem' not in already_processed:
            already_processed.append('codeSystem')
            self.codeSystem = value
            self.validate_uid(self.codeSystem)    # validate type uid
        super(EIVL_event, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        pass
# end class EIVL_event


class RTO_QTY_QTY(QTY):
    member_data_items_ = [
        MemberSpec_('numerator', 'QTY', 0, 0, 0),
        MemberSpec_('denominator', 'QTY', 0, 0, 0),
        MemberSpec_('valueOf_', 'QTY', 0, 0, 0),
        ]
    subclass = None
    superclass = QTY
    def __init__(self, nullFlavor=None, numerator=None, denominator=None, valueOf_=None, mixedclass_=None, content_=None, extensiontype_=None):
        super(RTO_QTY_QTY, self).__init__(nullFlavor, valueOf_, mixedclass_, content_, extensiontype_, )
        self.numerator = numerator
        self.denominator = denominator
        self.valueOf_ = valueOf_
        self.extensiontype_ = extensiontype_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if RTO_QTY_QTY.subclass:
            return RTO_QTY_QTY.subclass(*args_, **kwargs_)
        else:
            return RTO_QTY_QTY(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_numerator(self): return self.numerator
    def set_numerator(self, numerator): self.numerator = numerator
    numeratorProp = property(get_numerator, set_numerator)
    def get_denominator(self): return self.denominator
    def set_denominator(self, denominator): self.denominator = denominator
    denominatorProp = property(get_denominator, set_denominator)
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def get_extensiontype_(self): return self.extensiontype_
    def set_extensiontype_(self, extensiontype_): self.extensiontype_ = extensiontype_
    def export(self, outfile, level, namespace_='', name_='RTO_QTY_QTY', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='RTO_QTY_QTY')
        if self.hasContent_():
            if self.hasSimpleContent_():
                outfile.write('>')
            else:
                outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            if not self.hasSimpleContent_():
                showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='RTO_QTY_QTY'):
        super(RTO_QTY_QTY, self).exportAttributes(outfile, level, already_processed, namespace_, name_='RTO_QTY_QTY')
        if self.extensiontype_ is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            outfile.write(' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"')
            outfile.write(' xsi:type="%s"' % self.extensiontype_)
    def exportChildren(self, outfile, level, namespace_='', name_='RTO_QTY_QTY', fromsubclass_=False):
        super(RTO_QTY_QTY, self).exportChildren(outfile, level, namespace_, name_, True)
        if self.numerator is not None:
            self.numerator.export(outfile, level, namespace_, name_='numerator')
        if self.denominator is not None:
            self.denominator.export(outfile, level, namespace_, name_='denominator')
        if self.valueOf_ is not None:
            outfile.write(self.valueOf_)
        elif not fromsubclass_:
            for item_ in self.content_:
                item_.export(outfile, level, item_.name, namespace_)
    def hasContent_(self):
        if (
            self.numerator is not None or
            self.denominator is not None or
            self.valueOf_ or
            super(RTO_QTY_QTY, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(RTO_QTY_QTY, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('xsi:type', node)
        if value is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            self.extensiontype_ = value
        super(RTO_QTY_QTY, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'numerator':
            type_name_ = child_.attrib.get('{http://www.w3.org/2001/XMLSchema-instance}type')
            if type_name_ is None:
                type_name_ = child_.attrib.get('type')
            if type_name_ is not None:
                type_names_ = type_name_.split(':')
                if len(type_names_) == 1:
                    type_name_ = type_names_[0]
                else:
                    type_name_ = type_names_[1]
                class_ = globals()[type_name_]
                obj_ = class_.factory()
                obj_.build(child_)
            else:
                raise NotImplementedError(
                    'Class not implemented for <numerator> element')
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'numerator', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_numerator'):
              self.add_numerator(obj_.value)
            elif hasattr(self, 'set_numerator'):
              self.set_numerator(obj_.value)
        elif nodeName_ == 'denominator':
            type_name_ = child_.attrib.get('{http://www.w3.org/2001/XMLSchema-instance}type')
            if type_name_ is None:
                type_name_ = child_.attrib.get('type')
            if type_name_ is not None:
                type_names_ = type_name_.split(':')
                if len(type_names_) == 1:
                    type_name_ = type_names_[0]
                else:
                    type_name_ = type_names_[1]
                class_ = globals()[type_name_]
                obj_ = class_.factory()
                obj_.build(child_)
            else:
                raise NotImplementedError(
                    'Class not implemented for <denominator> element')
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'denominator', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_denominator'):
              self.add_denominator(obj_.value)
            elif hasattr(self, 'set_denominator'):
              self.set_denominator(obj_.value)
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        super(RTO_QTY_QTY, self).buildChildren(child_, node, nodeName_, True)
# end class RTO_QTY_QTY


class SXCM_PQ(PQ):
    """A code specifying whether the set component is included (union) or
    excluded (set-difference) from the set, or other set operations
    with the current set component and the set as constructed from
    the representation stream up to the current point."""
    member_data_items_ = [
        MemberSpec_('operator', 'SetOperator', 0, 1, 0),
        ]
    subclass = None
    superclass = PQ
    def __init__(self, nullFlavor=None, unit='1', value=None, translation=None, operator='I', extensiontype_=None):
        super(SXCM_PQ, self).__init__(nullFlavor, unit, value, translation, extensiontype_, )
        self.operator = _cast(None, operator)
        self.extensiontype_ = extensiontype_
    def factory(*args_, **kwargs_):
        if SXCM_PQ.subclass:
            return SXCM_PQ.subclass(*args_, **kwargs_)
        else:
            return SXCM_PQ(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_operator(self): return self.operator
    def set_operator(self, operator): self.operator = operator
    operatorProp = property(get_operator, set_operator)
    def validate_SetOperator(self, value):
        # Validate type SetOperator, a restriction on cs.
        pass
    def get_extensiontype_(self): return self.extensiontype_
    def set_extensiontype_(self, extensiontype_): self.extensiontype_ = extensiontype_
    def export(self, outfile, level, namespace_='', name_='SXCM_PQ', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='SXCM_PQ')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='SXCM_PQ'):
        super(SXCM_PQ, self).exportAttributes(outfile, level, already_processed, namespace_, name_='SXCM_PQ')
        if self.operator is not None and 'operator' not in already_processed and self.operator != "I":
            already_processed.append('operator')
            outfile.write(' operator=%s' % (quote_attrib(self.operator), ))
        if self.extensiontype_ is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            outfile.write(' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"')
            outfile.write(' xsi:type="%s"' % self.extensiontype_)
    def exportChildren(self, outfile, level, namespace_='', name_='SXCM_PQ', fromsubclass_=False):
        super(SXCM_PQ, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            super(SXCM_PQ, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('operator', node)
        if value is not None and 'operator' not in already_processed:
            already_processed.append('operator')
            self.operator = value
            self.validate_SetOperator(self.operator)    # validate type SetOperator
        value = find_attr_value_('xsi:type', node)
        if value is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            self.extensiontype_ = value
        super(SXCM_PQ, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        super(SXCM_PQ, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class SXCM_PQ


class IVXB_PQ(PQ):
    """Specifies whether the limit is included in the interval (interval is
    closed) or excluded from the interval (interval is open)."""
    member_data_items_ = [
        MemberSpec_('inclusive', 'bl', 0, 1, 0),
        ]
    subclass = None
    superclass = PQ
    def __init__(self, nullFlavor=None, unit='1', value=None, translation=None, inclusive='true'):
        super(IVXB_PQ, self).__init__(nullFlavor, unit, value, translation, )
        self.inclusive = _cast(None, inclusive)
        pass
    def factory(*args_, **kwargs_):
        if IVXB_PQ.subclass:
            return IVXB_PQ.subclass(*args_, **kwargs_)
        else:
            return IVXB_PQ(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_inclusive(self): return self.inclusive
    def set_inclusive(self, inclusive): self.inclusive = inclusive
    inclusiveProp = property(get_inclusive, set_inclusive)
    def validate_bl(self, value):
        # Validate type bl, a restriction on xs:boolean.
        pass
    def export(self, outfile, level, namespace_='', name_='IVXB_PQ', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='IVXB_PQ')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='IVXB_PQ'):
        super(IVXB_PQ, self).exportAttributes(outfile, level, already_processed, namespace_, name_='IVXB_PQ')
        if self.inclusive is not None and 'inclusive' not in already_processed and self.inclusive != "true":
            already_processed.append('inclusive')
            outfile.write(' inclusive=%s' % (quote_attrib(self.inclusive), ))
    def exportChildren(self, outfile, level, namespace_='', name_='IVXB_PQ', fromsubclass_=False):
        super(IVXB_PQ, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            super(IVXB_PQ, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('inclusive', node)
        if value is not None and 'inclusive' not in already_processed:
            already_processed.append('inclusive')
            if value in ('true', '1'):
                self.inclusive = True
            elif value in ('false', '0'):
                self.inclusive = False
            else:
                raise_parse_error(node, 'Bad boolean attribute')
            self.validate_bl(self.inclusive)    # validate type bl
        super(IVXB_PQ, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        super(IVXB_PQ, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class IVXB_PQ


class PPD_PQ(PQ):
    """A code specifying the type of probability distribution. Possible
    values are as shown in the attached table. The NULL value
    (unknown) for the type code indicates that the probability
    distribution type is unknown. In that case, the standard
    deviation has the meaning of an informal guess."""
    member_data_items_ = [
        MemberSpec_('distributionType', 'ProbabilityDistributionType', 0, 1, 0),
        MemberSpec_('standardDeviation', 'PQ', 0, 0, 0),
        ]
    subclass = None
    superclass = PQ
    def __init__(self, nullFlavor=None, unit='1', value=None, translation=None, distributionType=None, standardDeviation=None, extensiontype_=None):
        super(PPD_PQ, self).__init__(nullFlavor, unit, value, translation, extensiontype_, )
        self.distributionType = _cast(None, distributionType)
        self.standardDeviation = standardDeviation
        self.extensiontype_ = extensiontype_
    def factory(*args_, **kwargs_):
        if PPD_PQ.subclass:
            return PPD_PQ.subclass(*args_, **kwargs_)
        else:
            return PPD_PQ(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_standardDeviation(self): return self.standardDeviation
    def set_standardDeviation(self, standardDeviation): self.standardDeviation = standardDeviation
    standardDeviationProp = property(get_standardDeviation, set_standardDeviation)
    def get_distributionType(self): return self.distributionType
    def set_distributionType(self, distributionType): self.distributionType = distributionType
    distributionTypeProp = property(get_distributionType, set_distributionType)
    def validate_ProbabilityDistributionType(self, value):
        # Validate type ProbabilityDistributionType, a restriction on cs.
        pass
    def get_extensiontype_(self): return self.extensiontype_
    def set_extensiontype_(self, extensiontype_): self.extensiontype_ = extensiontype_
    def export(self, outfile, level, namespace_='', name_='PPD_PQ', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='PPD_PQ')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='PPD_PQ'):
        super(PPD_PQ, self).exportAttributes(outfile, level, already_processed, namespace_, name_='PPD_PQ')
        if self.distributionType is not None and 'distributionType' not in already_processed:
            already_processed.append('distributionType')
            outfile.write(' distributionType=%s' % (quote_attrib(self.distributionType), ))
        if self.extensiontype_ is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            outfile.write(' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"')
            outfile.write(' xsi:type="%s"' % self.extensiontype_)
    def exportChildren(self, outfile, level, namespace_='', name_='PPD_PQ', fromsubclass_=False):
        super(PPD_PQ, self).exportChildren(outfile, level, namespace_, name_, True)
        if self.standardDeviation is not None:
            self.standardDeviation.export(outfile, level, namespace_, name_='standardDeviation')
    def hasContent_(self):
        if (
            self.standardDeviation is not None or
            super(PPD_PQ, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('distributionType', node)
        if value is not None and 'distributionType' not in already_processed:
            already_processed.append('distributionType')
            self.distributionType = value
            self.validate_ProbabilityDistributionType(self.distributionType)    # validate type ProbabilityDistributionType
        value = find_attr_value_('xsi:type', node)
        if value is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            self.extensiontype_ = value
        super(PPD_PQ, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'standardDeviation':
            obj_ = build_object(child_, 'PQ')
            self.set_standardDeviation(obj_)
        super(PPD_PQ, self).buildChildren(child_, node, nodeName_, True)
# end class PPD_PQ


class SXCM_PPD_PQ(PPD_PQ):
    """A code specifying whether the set component is included (union) or
    excluded (set-difference) from the set, or other set operations
    with the current set component and the set as constructed from
    the representation stream up to the current point."""
    member_data_items_ = [
        MemberSpec_('operator', 'SetOperator', 0, 1, 0),
        ]
    subclass = None
    superclass = PPD_PQ
    def __init__(self, nullFlavor=None, unit='1', value=None, translation=None, distributionType=None, standardDeviation=None, operator='I', extensiontype_=None):
        super(SXCM_PPD_PQ, self).__init__(nullFlavor, unit, value, translation, distributionType, standardDeviation, extensiontype_, )
        self.operator = _cast(None, operator)
        self.extensiontype_ = extensiontype_
    def factory(*args_, **kwargs_):
        if SXCM_PPD_PQ.subclass:
            return SXCM_PPD_PQ.subclass(*args_, **kwargs_)
        else:
            return SXCM_PPD_PQ(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_operator(self): return self.operator
    def set_operator(self, operator): self.operator = operator
    operatorProp = property(get_operator, set_operator)
    def validate_SetOperator(self, value):
        # Validate type SetOperator, a restriction on cs.
        pass
    def get_extensiontype_(self): return self.extensiontype_
    def set_extensiontype_(self, extensiontype_): self.extensiontype_ = extensiontype_
    def export(self, outfile, level, namespace_='', name_='SXCM_PPD_PQ', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='SXCM_PPD_PQ')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='SXCM_PPD_PQ'):
        super(SXCM_PPD_PQ, self).exportAttributes(outfile, level, already_processed, namespace_, name_='SXCM_PPD_PQ')
        if self.operator is not None and 'operator' not in already_processed and self.operator != "I":
            already_processed.append('operator')
            outfile.write(' operator=%s' % (quote_attrib(self.operator), ))
        if self.extensiontype_ is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            outfile.write(' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"')
            outfile.write(' xsi:type="%s"' % self.extensiontype_)
    def exportChildren(self, outfile, level, namespace_='', name_='SXCM_PPD_PQ', fromsubclass_=False):
        super(SXCM_PPD_PQ, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            super(SXCM_PPD_PQ, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('operator', node)
        if value is not None and 'operator' not in already_processed:
            already_processed.append('operator')
            self.operator = value
            self.validate_SetOperator(self.operator)    # validate type SetOperator
        value = find_attr_value_('xsi:type', node)
        if value is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            self.extensiontype_ = value
        super(SXCM_PPD_PQ, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        super(SXCM_PPD_PQ, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class SXCM_PPD_PQ


class IVXB_PPD_PQ(PPD_PQ):
    """Specifies whether the limit is included in the interval (interval is
    closed) or excluded from the interval (interval is open)."""
    member_data_items_ = [
        MemberSpec_('inclusive', 'bl', 0, 1, 0),
        ]
    subclass = None
    superclass = PPD_PQ
    def __init__(self, nullFlavor=None, unit='1', value=None, translation=None, distributionType=None, standardDeviation=None, inclusive='true'):
        super(IVXB_PPD_PQ, self).__init__(nullFlavor, unit, value, translation, distributionType, standardDeviation, )
        self.inclusive = _cast(None, inclusive)
        pass
    def factory(*args_, **kwargs_):
        if IVXB_PPD_PQ.subclass:
            return IVXB_PPD_PQ.subclass(*args_, **kwargs_)
        else:
            return IVXB_PPD_PQ(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_inclusive(self): return self.inclusive
    def set_inclusive(self, inclusive): self.inclusive = inclusive
    inclusiveProp = property(get_inclusive, set_inclusive)
    def validate_bl(self, value):
        # Validate type bl, a restriction on xs:boolean.
        pass
    def export(self, outfile, level, namespace_='', name_='IVXB_PPD_PQ', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='IVXB_PPD_PQ')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='IVXB_PPD_PQ'):
        super(IVXB_PPD_PQ, self).exportAttributes(outfile, level, already_processed, namespace_, name_='IVXB_PPD_PQ')
        if self.inclusive is not None and 'inclusive' not in already_processed and self.inclusive != "true":
            already_processed.append('inclusive')
            outfile.write(' inclusive=%s' % (quote_attrib(self.inclusive), ))
    def exportChildren(self, outfile, level, namespace_='', name_='IVXB_PPD_PQ', fromsubclass_=False):
        super(IVXB_PPD_PQ, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            super(IVXB_PPD_PQ, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('inclusive', node)
        if value is not None and 'inclusive' not in already_processed:
            already_processed.append('inclusive')
            if value in ('true', '1'):
                self.inclusive = True
            elif value in ('false', '0'):
                self.inclusive = False
            else:
                raise_parse_error(node, 'Bad boolean attribute')
            self.validate_bl(self.inclusive)    # validate type bl
        super(IVXB_PPD_PQ, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        super(IVXB_PPD_PQ, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class IVXB_PPD_PQ


class SXCM_CD(CD):
    """A code specifying whether the set component is included (union) or
    excluded (set-difference) from the set, or other set operations
    with the current set component and the set as constructed from
    the representation stream up to the current point."""
    member_data_items_ = [
        MemberSpec_('operator', 'SetOperator', 0, 1, 0),
        ]
    subclass = None
    superclass = CD
    def __init__(self, nullFlavor=None, codeSystemVersion=None, codeSystemName=None, code=None, displayName=None, codeSystem=None, originalText=None, qualifier=None, translation=None, operator='I'):
        super(SXCM_CD, self).__init__(nullFlavor, codeSystemVersion, codeSystemName, code, displayName, codeSystem, originalText, qualifier, translation, )
        self.operator = _cast(None, operator)
        pass
    def factory(*args_, **kwargs_):
        if SXCM_CD.subclass:
            return SXCM_CD.subclass(*args_, **kwargs_)
        else:
            return SXCM_CD(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_operator(self): return self.operator
    def set_operator(self, operator): self.operator = operator
    operatorProp = property(get_operator, set_operator)
    def validate_SetOperator(self, value):
        # Validate type SetOperator, a restriction on cs.
        pass
    def export(self, outfile, level, namespace_='', name_='SXCM_CD', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='SXCM_CD')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='SXCM_CD'):
        super(SXCM_CD, self).exportAttributes(outfile, level, already_processed, namespace_, name_='SXCM_CD')
        if self.operator is not None and 'operator' not in already_processed and self.operator != "I":
            already_processed.append('operator')
            outfile.write(' operator=%s' % (quote_attrib(self.operator), ))
    def exportChildren(self, outfile, level, namespace_='', name_='SXCM_CD', fromsubclass_=False):
        super(SXCM_CD, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            super(SXCM_CD, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('operator', node)
        if value is not None and 'operator' not in already_processed:
            already_processed.append('operator')
            self.operator = value
            self.validate_SetOperator(self.operator)    # validate type SetOperator
        super(SXCM_CD, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        super(SXCM_CD, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class SXCM_CD


class SXCM_MO(MO):
    """A code specifying whether the set component is included (union) or
    excluded (set-difference) from the set, or other set operations
    with the current set component and the set as constructed from
    the representation stream up to the current point."""
    member_data_items_ = [
        MemberSpec_('operator', 'SetOperator', 0, 1, 0),
        ]
    subclass = None
    superclass = MO
    def __init__(self, nullFlavor=None, currency=None, value=None, operator='I', extensiontype_=None):
        super(SXCM_MO, self).__init__(nullFlavor, currency, value, extensiontype_, )
        self.operator = _cast(None, operator)
        self.extensiontype_ = extensiontype_
    def factory(*args_, **kwargs_):
        if SXCM_MO.subclass:
            return SXCM_MO.subclass(*args_, **kwargs_)
        else:
            return SXCM_MO(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_operator(self): return self.operator
    def set_operator(self, operator): self.operator = operator
    operatorProp = property(get_operator, set_operator)
    def validate_SetOperator(self, value):
        # Validate type SetOperator, a restriction on cs.
        pass
    def get_extensiontype_(self): return self.extensiontype_
    def set_extensiontype_(self, extensiontype_): self.extensiontype_ = extensiontype_
    def export(self, outfile, level, namespace_='', name_='SXCM_MO', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='SXCM_MO')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='SXCM_MO'):
        super(SXCM_MO, self).exportAttributes(outfile, level, already_processed, namespace_, name_='SXCM_MO')
        if self.operator is not None and 'operator' not in already_processed and self.operator != "I":
            already_processed.append('operator')
            outfile.write(' operator=%s' % (quote_attrib(self.operator), ))
        if self.extensiontype_ is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            outfile.write(' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"')
            outfile.write(' xsi:type="%s"' % self.extensiontype_)
    def exportChildren(self, outfile, level, namespace_='', name_='SXCM_MO', fromsubclass_=False):
        super(SXCM_MO, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            super(SXCM_MO, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('operator', node)
        if value is not None and 'operator' not in already_processed:
            already_processed.append('operator')
            self.operator = value
            self.validate_SetOperator(self.operator)    # validate type SetOperator
        value = find_attr_value_('xsi:type', node)
        if value is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            self.extensiontype_ = value
        super(SXCM_MO, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        super(SXCM_MO, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class SXCM_MO


class SXCM_INT(INT):
    """A code specifying whether the set component is included (union) or
    excluded (set-difference) from the set, or other set operations
    with the current set component and the set as constructed from
    the representation stream up to the current point."""
    member_data_items_ = [
        MemberSpec_('operator', 'SetOperator', 0, 1, 0),
        ]
    subclass = None
    superclass = INT
    def __init__(self, nullFlavor=None, value=None, operator='I', extensiontype_=None):
        super(SXCM_INT, self).__init__(nullFlavor, value, extensiontype_, )
        self.operator = _cast(None, operator)
        self.extensiontype_ = extensiontype_
    def factory(*args_, **kwargs_):
        if SXCM_INT.subclass:
            return SXCM_INT.subclass(*args_, **kwargs_)
        else:
            return SXCM_INT(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_operator(self): return self.operator
    def set_operator(self, operator): self.operator = operator
    operatorProp = property(get_operator, set_operator)
    def validate_SetOperator(self, value):
        # Validate type SetOperator, a restriction on cs.
        pass
    def get_extensiontype_(self): return self.extensiontype_
    def set_extensiontype_(self, extensiontype_): self.extensiontype_ = extensiontype_
    def export(self, outfile, level, namespace_='', name_='SXCM_INT', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='SXCM_INT')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='SXCM_INT'):
        super(SXCM_INT, self).exportAttributes(outfile, level, already_processed, namespace_, name_='SXCM_INT')
        if self.operator is not None and 'operator' not in already_processed and self.operator != "I":
            already_processed.append('operator')
            outfile.write(' operator=%s' % (quote_attrib(self.operator), ))
        if self.extensiontype_ is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            outfile.write(' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"')
            outfile.write(' xsi:type="%s"' % self.extensiontype_)
    def exportChildren(self, outfile, level, namespace_='', name_='SXCM_INT', fromsubclass_=False):
        super(SXCM_INT, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            super(SXCM_INT, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('operator', node)
        if value is not None and 'operator' not in already_processed:
            already_processed.append('operator')
            self.operator = value
            self.validate_SetOperator(self.operator)    # validate type SetOperator
        value = find_attr_value_('xsi:type', node)
        if value is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            self.extensiontype_ = value
        super(SXCM_INT, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        super(SXCM_INT, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class SXCM_INT


class SXCM_REAL(REAL):
    """A code specifying whether the set component is included (union) or
    excluded (set-difference) from the set, or other set operations
    with the current set component and the set as constructed from
    the representation stream up to the current point."""
    member_data_items_ = [
        MemberSpec_('operator', 'SetOperator', 0, 1, 0),
        ]
    subclass = None
    superclass = REAL
    def __init__(self, nullFlavor=None, value=None, operator='I', extensiontype_=None):
        super(SXCM_REAL, self).__init__(nullFlavor, value, extensiontype_, )
        self.operator = _cast(None, operator)
        self.extensiontype_ = extensiontype_
    def factory(*args_, **kwargs_):
        if SXCM_REAL.subclass:
            return SXCM_REAL.subclass(*args_, **kwargs_)
        else:
            return SXCM_REAL(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_operator(self): return self.operator
    def set_operator(self, operator): self.operator = operator
    operatorProp = property(get_operator, set_operator)
    def validate_SetOperator(self, value):
        # Validate type SetOperator, a restriction on cs.
        pass
    def get_extensiontype_(self): return self.extensiontype_
    def set_extensiontype_(self, extensiontype_): self.extensiontype_ = extensiontype_
    def export(self, outfile, level, namespace_='', name_='SXCM_REAL', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='SXCM_REAL')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='SXCM_REAL'):
        super(SXCM_REAL, self).exportAttributes(outfile, level, already_processed, namespace_, name_='SXCM_REAL')
        if self.operator is not None and 'operator' not in already_processed and self.operator != "I":
            already_processed.append('operator')
            outfile.write(' operator=%s' % (quote_attrib(self.operator), ))
        if self.extensiontype_ is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            outfile.write(' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"')
            outfile.write(' xsi:type="%s"' % self.extensiontype_)
    def exportChildren(self, outfile, level, namespace_='', name_='SXCM_REAL', fromsubclass_=False):
        super(SXCM_REAL, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            super(SXCM_REAL, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('operator', node)
        if value is not None and 'operator' not in already_processed:
            already_processed.append('operator')
            self.operator = value
            self.validate_SetOperator(self.operator)    # validate type SetOperator
        value = find_attr_value_('xsi:type', node)
        if value is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            self.extensiontype_ = value
        super(SXCM_REAL, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        super(SXCM_REAL, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class SXCM_REAL


class IVL_INT(SXCM_INT):
    member_data_items_ = [
        MemberSpec_('low', 'IVXB_INT', 0, 0, 0),
        MemberSpec_('width', 'INT', 0, 0, 0),
        MemberSpec_('high', 'IVXB_INT', 0, 0, 0),
        MemberSpec_('center', 'INT', 0, 0, 0),
        ]
    subclass = None
    superclass = SXCM_INT
    def __init__(self, nullFlavor=None, value=None, operator='I', low=None, width=None, high=None, center=None):
        super(IVL_INT, self).__init__(nullFlavor, value, operator, )
        self.low = low
        self.width = width
        self.high = high
        self.center = center
    def factory(*args_, **kwargs_):
        if IVL_INT.subclass:
            return IVL_INT.subclass(*args_, **kwargs_)
        else:
            return IVL_INT(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_low(self): return self.low
    def set_low(self, low): self.low = low
    lowProp = property(get_low, set_low)
    def get_width(self): return self.width
    def set_width(self, width): self.width = width
    widthProp = property(get_width, set_width)
    def get_high(self): return self.high
    def set_high(self, high): self.high = high
    highProp = property(get_high, set_high)
    def get_center(self): return self.center
    def set_center(self, center): self.center = center
    centerProp = property(get_center, set_center)
    def export(self, outfile, level, namespace_='', name_='IVL_INT', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='IVL_INT')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='IVL_INT'):
        super(IVL_INT, self).exportAttributes(outfile, level, already_processed, namespace_, name_='IVL_INT')
    def exportChildren(self, outfile, level, namespace_='', name_='IVL_INT', fromsubclass_=False):
        super(IVL_INT, self).exportChildren(outfile, level, namespace_, name_, True)
        if self.low is not None:
            self.low.export(outfile, level, namespace_, name_='low', )
        if self.width is not None:
            self.width.export(outfile, level, namespace_, name_='width')
        if self.high is not None:
            self.high.export(outfile, level, namespace_, name_='high')
        if self.center is not None:
            self.center.export(outfile, level, namespace_, name_='center', )
    def hasContent_(self):
        if (
            self.low is not None or
            self.width is not None or
            self.high is not None or
            self.center is not None or
            super(IVL_INT, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        super(IVL_INT, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'low':
            obj_ = build_object(child_, 'IVXB_INT')
            self.set_low(obj_)
        elif nodeName_ == 'width':
            obj_ = build_object(child_, 'INT')
            self.set_width(obj_)
        elif nodeName_ == 'high':
            obj_ = build_object(child_, 'IVXB_INT')
            self.set_high(obj_)
        elif nodeName_ == 'center':
            obj_ = build_object(child_, 'INT')
            self.set_center(obj_)
        super(IVL_INT, self).buildChildren(child_, node, nodeName_, True)
# end class IVL_INT


class IVXB_INT(INT):
    """Specifies whether the limit is included in the interval (interval is
    closed) or excluded from the interval (interval is open)."""
    member_data_items_ = [
        MemberSpec_('inclusive', 'bl', 0, 1, 0),
        ]
    subclass = None
    superclass = INT
    def __init__(self, nullFlavor=None, value=None, inclusive='true'):
        super(IVXB_INT, self).__init__(nullFlavor, value, )
        self.inclusive = _cast(None, inclusive)
        pass
    def factory(*args_, **kwargs_):
        if IVXB_INT.subclass:
            return IVXB_INT.subclass(*args_, **kwargs_)
        else:
            return IVXB_INT(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_inclusive(self): return self.inclusive
    def set_inclusive(self, inclusive): self.inclusive = inclusive
    inclusiveProp = property(get_inclusive, set_inclusive)
    def validate_bl(self, value):
        # Validate type bl, a restriction on xs:boolean.
        pass
    def export(self, outfile, level, namespace_='', name_='IVXB_INT', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='IVXB_INT')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='IVXB_INT'):
        super(IVXB_INT, self).exportAttributes(outfile, level, already_processed, namespace_, name_='IVXB_INT')
        if self.inclusive is not None and 'inclusive' not in already_processed and self.inclusive != "true":
            already_processed.append('inclusive')
            outfile.write(' inclusive=%s' % (quote_attrib(self.inclusive), ))
    def exportChildren(self, outfile, level, namespace_='', name_='IVXB_INT', fromsubclass_=False):
        super(IVXB_INT, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            super(IVXB_INT, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('inclusive', node)
        if value is not None and 'inclusive' not in already_processed:
            already_processed.append('inclusive')
            if value in ('true', '1'):
                self.inclusive = True
            elif value in ('false', '0'):
                self.inclusive = False
            else:
                raise_parse_error(node, 'Bad boolean attribute')
            self.validate_bl(self.inclusive)    # validate type bl
        super(IVXB_INT, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        super(IVXB_INT, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class IVXB_INT


class IVL_REAL(SXCM_REAL):
    member_data_items_ = [
        MemberSpec_('low', 'IVXB_REAL', 0, 0, 0),
        MemberSpec_('width', 'REAL', 0, 0, 0),
        MemberSpec_('high', 'IVXB_REAL', 0, 0, 0),
        MemberSpec_('center', 'REAL', 0, 0, 0),
        ]
    subclass = None
    superclass = SXCM_REAL
    def __init__(self, nullFlavor=None, value=None, operator='I', low=None, width=None, high=None, center=None):
        super(IVL_REAL, self).__init__(nullFlavor, value, operator, )
        self.low = low
        self.width = width
        self.high = high
        self.center = center
    def factory(*args_, **kwargs_):
        if IVL_REAL.subclass:
            return IVL_REAL.subclass(*args_, **kwargs_)
        else:
            return IVL_REAL(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_low(self): return self.low
    def set_low(self, low): self.low = low
    lowProp = property(get_low, set_low)
    def get_width(self): return self.width
    def set_width(self, width): self.width = width
    widthProp = property(get_width, set_width)
    def get_high(self): return self.high
    def set_high(self, high): self.high = high
    highProp = property(get_high, set_high)
    def get_center(self): return self.center
    def set_center(self, center): self.center = center
    centerProp = property(get_center, set_center)
    def export(self, outfile, level, namespace_='', name_='IVL_REAL', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='IVL_REAL')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='IVL_REAL'):
        super(IVL_REAL, self).exportAttributes(outfile, level, already_processed, namespace_, name_='IVL_REAL')
    def exportChildren(self, outfile, level, namespace_='', name_='IVL_REAL', fromsubclass_=False):
        super(IVL_REAL, self).exportChildren(outfile, level, namespace_, name_, True)
        if self.low is not None:
            self.low.export(outfile, level, namespace_, name_='low', )
        if self.width is not None:
            self.width.export(outfile, level, namespace_, name_='width')
        if self.high is not None:
            self.high.export(outfile, level, namespace_, name_='high')
        if self.center is not None:
            self.center.export(outfile, level, namespace_, name_='center', )
    def hasContent_(self):
        if (
            self.low is not None or
            self.width is not None or
            self.high is not None or
            self.center is not None or
            super(IVL_REAL, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        super(IVL_REAL, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'low':
            obj_ = build_object(child_, 'IVXB_REAL')
            self.set_low(obj_)
        elif nodeName_ == 'width':
            obj_ = build_object(child_, 'REAL')
            self.set_width(obj_)
        elif nodeName_ == 'high':
            obj_ = build_object(child_, 'IVXB_REAL')
            self.set_high(obj_)
        elif nodeName_ == 'center':
            obj_ = build_object(child_, 'REAL')
            self.set_center(obj_)
        super(IVL_REAL, self).buildChildren(child_, node, nodeName_, True)
# end class IVL_REAL


class IVXB_REAL(REAL):
    """Specifies whether the limit is included in the interval (interval is
    closed) or excluded from the interval (interval is open)."""
    member_data_items_ = [
        MemberSpec_('inclusive', 'bl', 0, 1, 0),
        ]
    subclass = None
    superclass = REAL
    def __init__(self, nullFlavor=None, value=None, inclusive='true'):
        super(IVXB_REAL, self).__init__(nullFlavor, value, )
        self.inclusive = _cast(None, inclusive)
        pass
    def factory(*args_, **kwargs_):
        if IVXB_REAL.subclass:
            return IVXB_REAL.subclass(*args_, **kwargs_)
        else:
            return IVXB_REAL(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_inclusive(self): return self.inclusive
    def set_inclusive(self, inclusive): self.inclusive = inclusive
    inclusiveProp = property(get_inclusive, set_inclusive)
    def validate_bl(self, value):
        # Validate type bl, a restriction on xs:boolean.
        pass
    def export(self, outfile, level, namespace_='', name_='IVXB_REAL', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='IVXB_REAL')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='IVXB_REAL'):
        super(IVXB_REAL, self).exportAttributes(outfile, level, already_processed, namespace_, name_='IVXB_REAL')
        if self.inclusive is not None and 'inclusive' not in already_processed and self.inclusive != "true":
            already_processed.append('inclusive')
            outfile.write(' inclusive=%s' % (quote_attrib(self.inclusive), ))
    def exportChildren(self, outfile, level, namespace_='', name_='IVXB_REAL', fromsubclass_=False):
        super(IVXB_REAL, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            super(IVXB_REAL, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('inclusive', node)
        if value is not None and 'inclusive' not in already_processed:
            already_processed.append('inclusive')
            if value in ('true', '1'):
                self.inclusive = True
            elif value in ('false', '0'):
                self.inclusive = False
            else:
                raise_parse_error(node, 'Bad boolean attribute')
            self.validate_bl(self.inclusive)    # validate type bl
        super(IVXB_REAL, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        super(IVXB_REAL, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class IVXB_REAL


class IVL_MO(SXCM_MO):
    member_data_items_ = [
        MemberSpec_('low', 'IVXB_MO', 0, 0, 0),
        MemberSpec_('width', 'MO', 0, 0, 0),
        MemberSpec_('high', 'IVXB_MO', 0, 0, 0),
        MemberSpec_('center', 'MO', 0, 0, 0),
        ]
    subclass = None
    superclass = SXCM_MO
    def __init__(self, nullFlavor=None, currency=None, value=None, operator='I', low=None, width=None, high=None, center=None):
        super(IVL_MO, self).__init__(nullFlavor, currency, value, operator, )
        self.low = low
        self.width = width
        self.high = high
        self.center = center
    def factory(*args_, **kwargs_):
        if IVL_MO.subclass:
            return IVL_MO.subclass(*args_, **kwargs_)
        else:
            return IVL_MO(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_low(self): return self.low
    def set_low(self, low): self.low = low
    lowProp = property(get_low, set_low)
    def get_width(self): return self.width
    def set_width(self, width): self.width = width
    widthProp = property(get_width, set_width)
    def get_high(self): return self.high
    def set_high(self, high): self.high = high
    highProp = property(get_high, set_high)
    def get_center(self): return self.center
    def set_center(self, center): self.center = center
    centerProp = property(get_center, set_center)
    def export(self, outfile, level, namespace_='', name_='IVL_MO', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='IVL_MO')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='IVL_MO'):
        super(IVL_MO, self).exportAttributes(outfile, level, already_processed, namespace_, name_='IVL_MO')
    def exportChildren(self, outfile, level, namespace_='', name_='IVL_MO', fromsubclass_=False):
        super(IVL_MO, self).exportChildren(outfile, level, namespace_, name_, True)
        if self.low is not None:
            self.low.export(outfile, level, namespace_, name_='low', )
        if self.width is not None:
            self.width.export(outfile, level, namespace_, name_='width')
        if self.high is not None:
            self.high.export(outfile, level, namespace_, name_='high')
        if self.center is not None:
            self.center.export(outfile, level, namespace_, name_='center', )
    def hasContent_(self):
        if (
            self.low is not None or
            self.width is not None or
            self.high is not None or
            self.center is not None or
            super(IVL_MO, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        super(IVL_MO, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'low':
            obj_ = build_object(child_, 'IVXB_MO')
            self.set_low(obj_)
        elif nodeName_ == 'width':
            obj_ = build_object(child_, 'MO')
            self.set_width(obj_)
        elif nodeName_ == 'high':
            obj_ = build_object(child_, 'IVXB_MO')
            self.set_high(obj_)
        elif nodeName_ == 'center':
            obj_ = build_object(child_, 'MO')
            self.set_center(obj_)
        super(IVL_MO, self).buildChildren(child_, node, nodeName_, True)
# end class IVL_MO


class IVXB_MO(MO):
    """Specifies whether the limit is included in the interval (interval is
    closed) or excluded from the interval (interval is open)."""
    member_data_items_ = [
        MemberSpec_('inclusive', 'bl', 0, 1, 0),
        ]
    subclass = None
    superclass = MO
    def __init__(self, nullFlavor=None, currency=None, value=None, inclusive='true'):
        super(IVXB_MO, self).__init__(nullFlavor, currency, value, )
        self.inclusive = _cast(None, inclusive)
        pass
    def factory(*args_, **kwargs_):
        if IVXB_MO.subclass:
            return IVXB_MO.subclass(*args_, **kwargs_)
        else:
            return IVXB_MO(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_inclusive(self): return self.inclusive
    def set_inclusive(self, inclusive): self.inclusive = inclusive
    inclusiveProp = property(get_inclusive, set_inclusive)
    def validate_bl(self, value):
        # Validate type bl, a restriction on xs:boolean.
        pass
    def export(self, outfile, level, namespace_='', name_='IVXB_MO', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='IVXB_MO')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='IVXB_MO'):
        super(IVXB_MO, self).exportAttributes(outfile, level, already_processed, namespace_, name_='IVXB_MO')
        if self.inclusive is not None and 'inclusive' not in already_processed and self.inclusive != "true":
            already_processed.append('inclusive')
            outfile.write(' inclusive=%s' % (quote_attrib(self.inclusive), ))
    def exportChildren(self, outfile, level, namespace_='', name_='IVXB_MO', fromsubclass_=False):
        super(IVXB_MO, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            super(IVXB_MO, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('inclusive', node)
        if value is not None and 'inclusive' not in already_processed:
            already_processed.append('inclusive')
            if value in ('true', '1'):
                self.inclusive = True
            elif value in ('false', '0'):
                self.inclusive = False
            else:
                raise_parse_error(node, 'Bad boolean attribute')
            self.validate_bl(self.inclusive)    # validate type bl
        super(IVXB_MO, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        super(IVXB_MO, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class IVXB_MO


class HXIT_PQ(PQ):
    member_data_items_ = [
        MemberSpec_('validTime', 'IVL_TS', 0, 0, 0),
        ]
    subclass = None
    superclass = PQ
    def __init__(self, nullFlavor=None, unit='1', value=None, translation=None, validTime=None):
        super(HXIT_PQ, self).__init__(nullFlavor, unit, value, translation, )
        self.validTime = validTime
    def factory(*args_, **kwargs_):
        if HXIT_PQ.subclass:
            return HXIT_PQ.subclass(*args_, **kwargs_)
        else:
            return HXIT_PQ(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_validTime(self): return self.validTime
    def set_validTime(self, validTime): self.validTime = validTime
    validTimeProp = property(get_validTime, set_validTime)
    def export(self, outfile, level, namespace_='', name_='HXIT_PQ', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='HXIT_PQ')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='HXIT_PQ'):
        super(HXIT_PQ, self).exportAttributes(outfile, level, already_processed, namespace_, name_='HXIT_PQ')
    def exportChildren(self, outfile, level, namespace_='', name_='HXIT_PQ', fromsubclass_=False):
        super(HXIT_PQ, self).exportChildren(outfile, level, namespace_, name_, True)
        if self.validTime is not None:
            self.validTime.export(outfile, level, namespace_, name_='validTime')
    def hasContent_(self):
        if (
            self.validTime is not None or
            super(HXIT_PQ, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        super(HXIT_PQ, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'validTime':
            obj_ = build_object(child_, 'IVL_TS')
            self.set_validTime(obj_)
        super(HXIT_PQ, self).buildChildren(child_, node, nodeName_, True)
# end class HXIT_PQ


class HXIT_CE(CE):
    member_data_items_ = [
        MemberSpec_('validTime', 'IVL_TS', 0, 0, 0),
        ]
    subclass = None
    superclass = CE
    def __init__(self, nullFlavor=None, codeSystemVersion=None, codeSystemName=None, code=None, displayName=None, codeSystem=None, originalText=None, qualifier=None, translation=None, validTime=None):
        super(HXIT_CE, self).__init__(nullFlavor, codeSystemVersion, codeSystemName, code, displayName, codeSystem, originalText, qualifier, translation, )
        self.validTime = validTime
    def factory(*args_, **kwargs_):
        if HXIT_CE.subclass:
            return HXIT_CE.subclass(*args_, **kwargs_)
        else:
            return HXIT_CE(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_validTime(self): return self.validTime
    def set_validTime(self, validTime): self.validTime = validTime
    validTimeProp = property(get_validTime, set_validTime)
    def export(self, outfile, level, namespace_='', name_='HXIT_CE', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='HXIT_CE')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='HXIT_CE'):
        super(HXIT_CE, self).exportAttributes(outfile, level, already_processed, namespace_, name_='HXIT_CE')
    def exportChildren(self, outfile, level, namespace_='', name_='HXIT_CE', fromsubclass_=False):
        super(HXIT_CE, self).exportChildren(outfile, level, namespace_, name_, True)
        if self.validTime is not None:
            self.validTime.export(outfile, level, namespace_, name_='validTime')
    def hasContent_(self):
        if (
            self.validTime is not None or
            super(HXIT_CE, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        super(HXIT_CE, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'validTime':
            obj_ = build_object(child_, 'IVL_TS')
            self.set_validTime(obj_)
        super(HXIT_CE, self).buildChildren(child_, node, nodeName_, True)
# end class HXIT_CE


class BXIT_CD(CD):
    """The quantity in which the bag item occurs in its containing bag."""
    member_data_items_ = [
        MemberSpec_('qty', 'int', 0, 1, 0),
        ]
    subclass = None
    superclass = CD
    def __init__(self, nullFlavor=None, codeSystemVersion=None, codeSystemName=None, code=None, displayName=None, codeSystem=None, originalText=None, qualifier=None, translation=None, qty='1'):
        super(BXIT_CD, self).__init__(nullFlavor, codeSystemVersion, codeSystemName, code, displayName, codeSystem, originalText, qualifier, translation, )
        self.qty = _cast(None, qty)
        pass
    def factory(*args_, **kwargs_):
        if BXIT_CD.subclass:
            return BXIT_CD.subclass(*args_, **kwargs_)
        else:
            return BXIT_CD(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_qty(self): return self.qty
    def set_qty(self, qty): self.qty = qty
    qtyProp = property(get_qty, set_qty)
    def validate_int(self, value):
        # Validate type int, a restriction on xs:integer.
        pass
    def export(self, outfile, level, namespace_='', name_='BXIT_CD', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='BXIT_CD')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='BXIT_CD'):
        super(BXIT_CD, self).exportAttributes(outfile, level, already_processed, namespace_, name_='BXIT_CD')
        if self.qty is not None and 'qty' not in already_processed and self.qty != "1":
            already_processed.append('qty')
            outfile.write(' qty=%s' % (quote_attrib(self.qty), ))
    def exportChildren(self, outfile, level, namespace_='', name_='BXIT_CD', fromsubclass_=False):
        super(BXIT_CD, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            super(BXIT_CD, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('qty', node)
        if value is not None and 'qty' not in already_processed:
            already_processed.append('qty')
            try:
                self.qty = int(value)
            except ValueError, exp:
                raise_parse_error(node, 'Bad integer attribute: %s' % exp)
            self.validate_int(self.qty)    # validate type int
        super(BXIT_CD, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        super(BXIT_CD, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class BXIT_CD


class SLIST_PQ(ANY):
    member_data_items_ = [
        MemberSpec_('origin', 'PQ', 0, 0, 0),
        MemberSpec_('scale', 'PQ', 0, 0, 0),
        MemberSpec_('digits', ['list_int', 'int', 'xs:integer'], 0, 0, 0),
        ]
    subclass = None
    superclass = ANY
    def __init__(self, nullFlavor=None, origin=None, scale=None, digits=None):
        super(SLIST_PQ, self).__init__(nullFlavor, )
        self.origin = origin
        self.scale = scale
        self.digits = digits
    def factory(*args_, **kwargs_):
        if SLIST_PQ.subclass:
            return SLIST_PQ.subclass(*args_, **kwargs_)
        else:
            return SLIST_PQ(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_origin(self): return self.origin
    def set_origin(self, origin): self.origin = origin
    originProp = property(get_origin, set_origin)
    def get_scale(self): return self.scale
    def set_scale(self, scale): self.scale = scale
    scaleProp = property(get_scale, set_scale)
    def get_digits(self): return self.digits
    def set_digits(self, digits): self.digits = digits
    digitsProp = property(get_digits, set_digits)
    def validate_list_int(self, value):
        # Validate type list_int, a restriction on int.
        pass
    def export(self, outfile, level, namespace_='', name_='SLIST_PQ', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='SLIST_PQ')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='SLIST_PQ'):
        super(SLIST_PQ, self).exportAttributes(outfile, level, already_processed, namespace_, name_='SLIST_PQ')
    def exportChildren(self, outfile, level, namespace_='', name_='SLIST_PQ', fromsubclass_=False):
        super(SLIST_PQ, self).exportChildren(outfile, level, namespace_, name_, True)
        if self.origin is not None:
            self.origin.export(outfile, level, namespace_, name_='origin', )
        if self.scale is not None:
            self.scale.export(outfile, level, namespace_, name_='scale', )
        if self.digits is not None:
            showIndent(outfile, level)
            outfile.write('<%sdigits>%s</%sdigits>\n' % (namespace_, self.gds_format_integer_list(self.digits, input_name='digits'), namespace_))
    def hasContent_(self):
        if (
            self.origin is not None or
            self.scale is not None or
            self.digits is not None or
            super(SLIST_PQ, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        super(SLIST_PQ, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'origin':
            obj_ = build_object(child_, 'PQ')
            self.set_origin(obj_)
        elif nodeName_ == 'scale':
            obj_ = build_object(child_, 'PQ')
            self.set_scale(obj_)
        elif nodeName_ == 'digits':
            digits_ = child_.text
            digits_ = self.gds_validate_integer_list(digits_, node, 'digits')
            self.digits = digits_
            self.digits = self.digits.split()
            self.validate_list_int(self.digits)    # validate type list_int
        super(SLIST_PQ, self).buildChildren(child_, node, nodeName_, True)
# end class SLIST_PQ


class SLIST_TS(ANY):
    member_data_items_ = [
        MemberSpec_('origin', 'TS', 0, 0, 0),
        MemberSpec_('scale', 'PQ', 0, 0, 0),
        MemberSpec_('digits', ['list_int', 'int', 'xs:integer'], 0, 0, 0),
        ]
    subclass = None
    superclass = ANY
    def __init__(self, nullFlavor=None, origin=None, scale=None, digits=None):
        super(SLIST_TS, self).__init__(nullFlavor, )
        self.origin = origin
        self.scale = scale
        self.digits = digits
    def factory(*args_, **kwargs_):
        if SLIST_TS.subclass:
            return SLIST_TS.subclass(*args_, **kwargs_)
        else:
            return SLIST_TS(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_origin(self): return self.origin
    def set_origin(self, origin): self.origin = origin
    originProp = property(get_origin, set_origin)
    def get_scale(self): return self.scale
    def set_scale(self, scale): self.scale = scale
    scaleProp = property(get_scale, set_scale)
    def get_digits(self): return self.digits
    def set_digits(self, digits): self.digits = digits
    digitsProp = property(get_digits, set_digits)
    def validate_list_int(self, value):
        # Validate type list_int, a restriction on int.
        pass
    def export(self, outfile, level, namespace_='', name_='SLIST_TS', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='SLIST_TS')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='SLIST_TS'):
        super(SLIST_TS, self).exportAttributes(outfile, level, already_processed, namespace_, name_='SLIST_TS')
    def exportChildren(self, outfile, level, namespace_='', name_='SLIST_TS', fromsubclass_=False):
        super(SLIST_TS, self).exportChildren(outfile, level, namespace_, name_, True)
        if self.origin is not None:
            self.origin.export(outfile, level, namespace_, name_='origin', )
        if self.scale is not None:
            self.scale.export(outfile, level, namespace_, name_='scale', )
        if self.digits is not None:
            showIndent(outfile, level)
            outfile.write('<%sdigits>%s</%sdigits>\n' % (namespace_, self.gds_format_integer_list(self.digits, input_name='digits'), namespace_))
    def hasContent_(self):
        if (
            self.origin is not None or
            self.scale is not None or
            self.digits is not None or
            super(SLIST_TS, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        super(SLIST_TS, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'origin':
            obj_ = build_object(child_, 'TS')
            self.set_origin(obj_)
        elif nodeName_ == 'scale':
            obj_ = build_object(child_, 'PQ')
            self.set_scale(obj_)
        elif nodeName_ == 'digits':
            digits_ = child_.text
            digits_ = self.gds_validate_integer_list(digits_, node, 'digits')
            self.digits = digits_
            self.digits = self.digits.split()
            self.validate_list_int(self.digits)    # validate type list_int
        super(SLIST_TS, self).buildChildren(child_, node, nodeName_, True)
# end class SLIST_TS


class GLIST_TS(ANY):
    """If non-NULL, specifies that the sequence alternates, i.e., after
    this many increments, the sequence item values roll over to
    start from the initial sequence item value. For example, the
    sequence (1; 2; 3; 1; 2; 3; 1; 2; 3; ...) has period 3; also the
    sequence (1; 1; 2; 2; 3; 3; 1; 1; 2; 2; 3; 3; ...) has period 3
    too. The integer by which the index for the sequence is divided,
    effectively the number of times the sequence generates the same
    sequence item value before incrementing to the next sequence
    item value. For example, to generate the sequence (1; 1; 1; 2;
    2; 2; 3; 3; 3; ...) the denominator is 3."""
    member_data_items_ = [
        MemberSpec_('denominator', 'int', 0, 1, 0),
        MemberSpec_('period', 'int', 0, 1, 0),
        MemberSpec_('head', 'TS', 0, 0, 0),
        MemberSpec_('increment', 'PQ', 0, 0, 0),
        ]
    subclass = None
    superclass = ANY
    def __init__(self, nullFlavor=None, denominator=None, period=None, head=None, increment=None):
        super(GLIST_TS, self).__init__(nullFlavor, )
        self.denominator = _cast(None, denominator)
        self.period = _cast(None, period)
        self.head = head
        self.increment = increment
    def factory(*args_, **kwargs_):
        if GLIST_TS.subclass:
            return GLIST_TS.subclass(*args_, **kwargs_)
        else:
            return GLIST_TS(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_head(self): return self.head
    def set_head(self, head): self.head = head
    headProp = property(get_head, set_head)
    def get_increment(self): return self.increment
    def set_increment(self, increment): self.increment = increment
    incrementProp = property(get_increment, set_increment)
    def get_denominator(self): return self.denominator
    def set_denominator(self, denominator): self.denominator = denominator
    denominatorProp = property(get_denominator, set_denominator)
    def validate_int(self, value):
        # Validate type int, a restriction on xs:integer.
        pass
    def get_period(self): return self.period
    def set_period(self, period): self.period = period
    periodProp = property(get_period, set_period)
    def export(self, outfile, level, namespace_='', name_='GLIST_TS', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='GLIST_TS')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='GLIST_TS'):
        super(GLIST_TS, self).exportAttributes(outfile, level, already_processed, namespace_, name_='GLIST_TS')
        if self.denominator is not None and 'denominator' not in already_processed:
            already_processed.append('denominator')
            outfile.write(' denominator=%s' % (quote_attrib(self.denominator), ))
        if self.period is not None and 'period' not in already_processed:
            already_processed.append('period')
            outfile.write(' period=%s' % (quote_attrib(self.period), ))
    def exportChildren(self, outfile, level, namespace_='', name_='GLIST_TS', fromsubclass_=False):
        super(GLIST_TS, self).exportChildren(outfile, level, namespace_, name_, True)
        if self.head is not None:
            self.head.export(outfile, level, namespace_, name_='head', )
        if self.increment is not None:
            self.increment.export(outfile, level, namespace_, name_='increment', )
    def hasContent_(self):
        if (
            self.head is not None or
            self.increment is not None or
            super(GLIST_TS, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('denominator', node)
        if value is not None and 'denominator' not in already_processed:
            already_processed.append('denominator')
            try:
                self.denominator = int(value)
            except ValueError, exp:
                raise_parse_error(node, 'Bad integer attribute: %s' % exp)
            self.validate_int(self.denominator)    # validate type int
        value = find_attr_value_('period', node)
        if value is not None and 'period' not in already_processed:
            already_processed.append('period')
            try:
                self.period = int(value)
            except ValueError, exp:
                raise_parse_error(node, 'Bad integer attribute: %s' % exp)
            self.validate_int(self.period)    # validate type int
        super(GLIST_TS, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'head':
            obj_ = build_object(child_, 'TS')
            self.set_head(obj_)
        elif nodeName_ == 'increment':
            obj_ = build_object(child_, 'PQ')
            self.set_increment(obj_)
        super(GLIST_TS, self).buildChildren(child_, node, nodeName_, True)
# end class GLIST_TS


class GLIST_PQ(ANY):
    """If non-NULL, specifies that the sequence alternates, i.e., after
    this many increments, the sequence item values roll over to
    start from the initial sequence item value. For example, the
    sequence (1; 2; 3; 1; 2; 3; 1; 2; 3; ...) has period 3; also the
    sequence (1; 1; 2; 2; 3; 3; 1; 1; 2; 2; 3; 3; ...) has period 3
    too. The integer by which the index for the sequence is divided,
    effectively the number of times the sequence generates the same
    sequence item value before incrementing to the next sequence
    item value. For example, to generate the sequence (1; 1; 1; 2;
    2; 2; 3; 3; 3; ...) the denominator is 3."""
    member_data_items_ = [
        MemberSpec_('denominator', 'int', 0, 1, 0),
        MemberSpec_('period', 'int', 0, 1, 0),
        MemberSpec_('head', 'PQ', 0, 0, 0),
        MemberSpec_('increment', 'PQ', 0, 0, 0),
        ]
    subclass = None
    superclass = ANY
    def __init__(self, nullFlavor=None, denominator=None, period=None, head=None, increment=None):
        super(GLIST_PQ, self).__init__(nullFlavor, )
        self.denominator = _cast(None, denominator)
        self.period = _cast(None, period)
        self.head = head
        self.increment = increment
    def factory(*args_, **kwargs_):
        if GLIST_PQ.subclass:
            return GLIST_PQ.subclass(*args_, **kwargs_)
        else:
            return GLIST_PQ(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_head(self): return self.head
    def set_head(self, head): self.head = head
    headProp = property(get_head, set_head)
    def get_increment(self): return self.increment
    def set_increment(self, increment): self.increment = increment
    incrementProp = property(get_increment, set_increment)
    def get_denominator(self): return self.denominator
    def set_denominator(self, denominator): self.denominator = denominator
    denominatorProp = property(get_denominator, set_denominator)
    def validate_int(self, value):
        # Validate type int, a restriction on xs:integer.
        pass
    def get_period(self): return self.period
    def set_period(self, period): self.period = period
    periodProp = property(get_period, set_period)
    def export(self, outfile, level, namespace_='', name_='GLIST_PQ', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='GLIST_PQ')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='GLIST_PQ'):
        super(GLIST_PQ, self).exportAttributes(outfile, level, already_processed, namespace_, name_='GLIST_PQ')
        if self.denominator is not None and 'denominator' not in already_processed:
            already_processed.append('denominator')
            outfile.write(' denominator=%s' % (quote_attrib(self.denominator), ))
        if self.period is not None and 'period' not in already_processed:
            already_processed.append('period')
            outfile.write(' period=%s' % (quote_attrib(self.period), ))
    def exportChildren(self, outfile, level, namespace_='', name_='GLIST_PQ', fromsubclass_=False):
        super(GLIST_PQ, self).exportChildren(outfile, level, namespace_, name_, True)
        if self.head is not None:
            self.head.export(outfile, level, namespace_, name_='head', )
        if self.increment is not None:
            self.increment.export(outfile, level, namespace_, name_='increment', )
    def hasContent_(self):
        if (
            self.head is not None or
            self.increment is not None or
            super(GLIST_PQ, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('denominator', node)
        if value is not None and 'denominator' not in already_processed:
            already_processed.append('denominator')
            try:
                self.denominator = int(value)
            except ValueError, exp:
                raise_parse_error(node, 'Bad integer attribute: %s' % exp)
            self.validate_int(self.denominator)    # validate type int
        value = find_attr_value_('period', node)
        if value is not None and 'period' not in already_processed:
            already_processed.append('period')
            try:
                self.period = int(value)
            except ValueError, exp:
                raise_parse_error(node, 'Bad integer attribute: %s' % exp)
            self.validate_int(self.period)    # validate type int
        super(GLIST_PQ, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'head':
            obj_ = build_object(child_, 'PQ')
            self.set_head(obj_)
        elif nodeName_ == 'increment':
            obj_ = build_object(child_, 'PQ')
            self.set_increment(obj_)
        super(GLIST_PQ, self).buildChildren(child_, node, nodeName_, True)
# end class GLIST_PQ


class RTO_PQ_PQ(QTY):
    member_data_items_ = [
        MemberSpec_('numerator', 'PQ', 0, 0, 0),
        MemberSpec_('denominator', 'PQ', 0, 0, 0),
        ]
    subclass = None
    superclass = QTY
    def __init__(self, nullFlavor=None, numerator=None, denominator=None):
        super(RTO_PQ_PQ, self).__init__(nullFlavor, )
        self.numerator = numerator
        self.denominator = denominator
    def factory(*args_, **kwargs_):
        if RTO_PQ_PQ.subclass:
            return RTO_PQ_PQ.subclass(*args_, **kwargs_)
        else:
            return RTO_PQ_PQ(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_numerator(self): return self.numerator
    def set_numerator(self, numerator): self.numerator = numerator
    numeratorProp = property(get_numerator, set_numerator)
    def get_denominator(self): return self.denominator
    def set_denominator(self, denominator): self.denominator = denominator
    denominatorProp = property(get_denominator, set_denominator)
    def export(self, outfile, level, namespace_='', name_='RTO_PQ_PQ', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='RTO_PQ_PQ')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='RTO_PQ_PQ'):
        super(RTO_PQ_PQ, self).exportAttributes(outfile, level, already_processed, namespace_, name_='RTO_PQ_PQ')
    def exportChildren(self, outfile, level, namespace_='', name_='RTO_PQ_PQ', fromsubclass_=False):
        super(RTO_PQ_PQ, self).exportChildren(outfile, level, namespace_, name_, True)
        if self.numerator is not None:
            self.numerator.export(outfile, level, namespace_, name_='numerator', )
        if self.denominator is not None:
            self.denominator.export(outfile, level, namespace_, name_='denominator', )
    def hasContent_(self):
        if (
            self.numerator is not None or
            self.denominator is not None or
            super(RTO_PQ_PQ, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        super(RTO_PQ_PQ, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'numerator':
            obj_ = build_object(child_, 'PQ')
            self.set_numerator(obj_)
        elif nodeName_ == 'denominator':
            obj_ = build_object(child_, 'PQ')
            self.set_denominator(obj_)
        super(RTO_PQ_PQ, self).buildChildren(child_, node, nodeName_, True)
# end class RTO_PQ_PQ


class RTO_MO_PQ(QTY):
    member_data_items_ = [
        MemberSpec_('numerator', 'MO', 0, 0, 0),
        MemberSpec_('denominator', 'PQ', 0, 0, 0),
        ]
    subclass = None
    superclass = QTY
    def __init__(self, nullFlavor=None, numerator=None, denominator=None):
        super(RTO_MO_PQ, self).__init__(nullFlavor, )
        self.numerator = numerator
        self.denominator = denominator
    def factory(*args_, **kwargs_):
        if RTO_MO_PQ.subclass:
            return RTO_MO_PQ.subclass(*args_, **kwargs_)
        else:
            return RTO_MO_PQ(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_numerator(self): return self.numerator
    def set_numerator(self, numerator): self.numerator = numerator
    numeratorProp = property(get_numerator, set_numerator)
    def get_denominator(self): return self.denominator
    def set_denominator(self, denominator): self.denominator = denominator
    denominatorProp = property(get_denominator, set_denominator)
    def export(self, outfile, level, namespace_='', name_='RTO_MO_PQ', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='RTO_MO_PQ')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='RTO_MO_PQ'):
        super(RTO_MO_PQ, self).exportAttributes(outfile, level, already_processed, namespace_, name_='RTO_MO_PQ')
    def exportChildren(self, outfile, level, namespace_='', name_='RTO_MO_PQ', fromsubclass_=False):
        super(RTO_MO_PQ, self).exportChildren(outfile, level, namespace_, name_, True)
        if self.numerator is not None:
            self.numerator.export(outfile, level, namespace_, name_='numerator', )
        if self.denominator is not None:
            self.denominator.export(outfile, level, namespace_, name_='denominator', )
    def hasContent_(self):
        if (
            self.numerator is not None or
            self.denominator is not None or
            super(RTO_MO_PQ, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        super(RTO_MO_PQ, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'numerator':
            obj_ = build_object(child_, 'MO')
            self.set_numerator(obj_)
        elif nodeName_ == 'denominator':
            obj_ = build_object(child_, 'PQ')
            self.set_denominator(obj_)
        super(RTO_MO_PQ, self).buildChildren(child_, node, nodeName_, True)
# end class RTO_MO_PQ


class TS(QTY):
    """A quantity specifying a point on the axis of natural time. A point
    in time is most often represented as a calendar expression."""
    member_data_items_ = [
        MemberSpec_('value', 'ts', 0, 1, 0),
        MemberSpec_('valueOf_', 'QTY', 0, 0, 0),
        ]
    subclass = None
    superclass = QTY
    def __init__(self, nullFlavor=None, value=None, valueOf_=None, mixedclass_=None, content_=None, extensiontype_=None):
        super(TS, self).__init__(nullFlavor, valueOf_, mixedclass_, content_, extensiontype_, )
        self.value = _cast(None, value)
        self.valueOf_ = valueOf_
        self.extensiontype_ = extensiontype_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if TS.subclass:
            return TS.subclass(*args_, **kwargs_)
        else:
            return TS(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_value(self): return self.value
    def set_value(self, value): self.value = value
    valueProp = property(get_value, set_value)
    def validate_ts(self, value):
        # Validate type ts, a restriction on xs:string.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def get_extensiontype_(self): return self.extensiontype_
    def set_extensiontype_(self, extensiontype_): self.extensiontype_ = extensiontype_
    def export(self, outfile, level, namespace_='', name_='TS', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='TS')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='TS'):
        super(TS, self).exportAttributes(outfile, level, already_processed, namespace_, name_='TS')
        if self.value is not None and 'value' not in already_processed:
            already_processed.append('value')
            outfile.write(' value=%s' % (quote_attrib(self.value), ))
        if self.extensiontype_ is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            outfile.write(' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"')
            outfile.write(' xsi:type="%s"' % self.extensiontype_)
    def exportChildren(self, outfile, level, namespace_='', name_='TS', fromsubclass_=False):
        super(TS, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(TS, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(TS, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('value', node)
        if value is not None and 'value' not in already_processed:
            already_processed.append('value')
            self.value = value
            self.validate_ts(self.value)    # validate type ts
        value = find_attr_value_('xsi:type', node)
        if value is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            self.extensiontype_ = value
        super(TS, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        super(TS, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class TS


class RTO(RTO_QTY_QTY):
    """A quantity constructed as the quotient of a numerator quantity
    divided by a denominator quantity. Common factors in the
    numerator and denominator are not automatically cancelled out.
    supports titers (e.g., "1:128") and other quantities produced by
    laboratories that truly represent ratios. Ratios are not simply
    "structured numerics", particularly blood pressure measurements
    (e.g. "120/60") are not ratios. In many cases REAL should be
    used instead of ."""
    member_data_items_ = [
        MemberSpec_('valueOf_', 'RTO_QTY_QTY', 0, 0, 0),
        ]
    subclass = None
    superclass = RTO_QTY_QTY
    def __init__(self, nullFlavor=None, numerator=None, denominator=None, valueOf_=None, mixedclass_=None, content_=None):
        super(RTO, self).__init__(nullFlavor, numerator, denominator, valueOf_, mixedclass_, content_, )
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if RTO.subclass:
            return RTO.subclass(*args_, **kwargs_)
        else:
            return RTO(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='RTO', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='RTO')
        if self.hasContent_():
            if self.hasSimpleContent_():
                outfile.write('>')
            else:
                outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            if not self.hasSimpleContent_():
                showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='RTO'):
        super(RTO, self).exportAttributes(outfile, level, already_processed, namespace_, name_='RTO')
    def exportChildren(self, outfile, level, namespace_='', name_='RTO', fromsubclass_=False):
        super(RTO, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(RTO, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(RTO, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        super(RTO, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        super(RTO, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class RTO


class SXCM_TS(TS):
    """A code specifying whether the set component is included (union) or
    excluded (set-difference) from the set, or other set operations
    with the current set component and the set as constructed from
    the representation stream up to the current point."""
    member_data_items_ = [
        MemberSpec_('operator', 'SetOperator', 0, 1, 0),
        MemberSpec_('valueOf_', 'TS', 0, 0, 0),
        ]
    subclass = None
    superclass = TS
    def __init__(self, nullFlavor=None, value=None, operator='I', valueOf_=None, mixedclass_=None, content_=None, extensiontype_=None):
        super(SXCM_TS, self).__init__(nullFlavor, value, valueOf_, mixedclass_, content_, extensiontype_, )
        self.operator = _cast(None, operator)
        self.valueOf_ = valueOf_
        self.extensiontype_ = extensiontype_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if SXCM_TS.subclass:
            return SXCM_TS.subclass(*args_, **kwargs_)
        else:
            return SXCM_TS(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_operator(self): return self.operator
    def set_operator(self, operator): self.operator = operator
    operatorProp = property(get_operator, set_operator)
    def validate_SetOperator(self, value):
        # Validate type SetOperator, a restriction on cs.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def get_extensiontype_(self): return self.extensiontype_
    def set_extensiontype_(self, extensiontype_): self.extensiontype_ = extensiontype_
    def export(self, outfile, level, namespace_='', name_='SXCM_TS', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='SXCM_TS')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='SXCM_TS'):
        super(SXCM_TS, self).exportAttributes(outfile, level, already_processed, namespace_, name_='SXCM_TS')
        if self.operator is not None and 'operator' not in already_processed and self.operator != "I":
            already_processed.append('operator')
            outfile.write(' operator=%s' % (quote_attrib(self.operator), ))
        if self.extensiontype_ is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            outfile.write(' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"')
            outfile.write(' xsi:type="%s"' % self.extensiontype_)
    def exportChildren(self, outfile, level, namespace_='', name_='SXCM_TS', fromsubclass_=False):
        super(SXCM_TS, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(SXCM_TS, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(SXCM_TS, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('operator', node)
        if value is not None and 'operator' not in already_processed:
            already_processed.append('operator')
            self.operator = value
            self.validate_SetOperator(self.operator)    # validate type SetOperator
        value = find_attr_value_('xsi:type', node)
        if value is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            self.extensiontype_ = value
        super(SXCM_TS, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        super(SXCM_TS, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class SXCM_TS


class IVL_TS(SXCM_TS):
    member_data_items_ = [
        MemberSpec_('low', 'IVXB_TS', 0, 0, 0),
        MemberSpec_('width', 'PQ', 0, 0, 0),
        MemberSpec_('high', 'IVXB_TS', 0, 0, 0),
        MemberSpec_('center', 'TS', 0, 0, 0),
        MemberSpec_('valueOf_', 'SXCM_TS', 0, 0, 0),
        ]
    subclass = None
    superclass = SXCM_TS
    def __init__(self, nullFlavor=None, value=None, operator='I', low=None, width=None, high=None, center=None, valueOf_=None, mixedclass_=None, content_=None):
        super(IVL_TS, self).__init__(nullFlavor, value, operator, valueOf_, mixedclass_, content_, )
        self.low = low
        self.width = width
        self.high = high
        self.center = center
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if IVL_TS.subclass:
            return IVL_TS.subclass(*args_, **kwargs_)
        else:
            return IVL_TS(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_low(self): return self.low
    def set_low(self, low): self.low = low
    lowProp = property(get_low, set_low)
    def get_width(self): return self.width
    def set_width(self, width): self.width = width
    widthProp = property(get_width, set_width)
    def get_high(self): return self.high
    def set_high(self, high): self.high = high
    highProp = property(get_high, set_high)
    def get_center(self): return self.center
    def set_center(self, center): self.center = center
    centerProp = property(get_center, set_center)
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='IVL_TS', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='IVL_TS')
        if self.hasContent_():
            if self.hasSimpleContent_():
                outfile.write('>')
            else:
                outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            if not self.hasSimpleContent_():
                showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='IVL_TS'):
        super(IVL_TS, self).exportAttributes(outfile, level, already_processed, namespace_, name_='IVL_TS')
    def exportChildren(self, outfile, level, namespace_='', name_='IVL_TS', fromsubclass_=False):
        super(IVL_TS, self).exportChildren(outfile, level, namespace_, name_, True)
        if self.low is not None:
            self.low.export(outfile, level, namespace_, name_='low', )
        if self.width is not None:
            self.width.export(outfile, level, namespace_, name_='width')
        if self.high is not None:
            self.high.export(outfile, level, namespace_, name_='high')
        if self.center is not None:
            self.center.export(outfile, level, namespace_, name_='center', )
        if self.valueOf_ is not None:
            outfile.write(self.valueOf_)
        elif not fromsubclass_:
            for item_ in self.content_:
                item_.export(outfile, level, item_.name, namespace_)
    def hasContent_(self):
        if (
            self.low is not None or
            self.width is not None or
            self.high is not None or
            self.center is not None or
            self.valueOf_ or
            super(IVL_TS, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(IVL_TS, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        super(IVL_TS, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'low':
            obj_ = IVXB_TS.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'low', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_low'):
              self.add_low(obj_.value)
            elif hasattr(self, 'set_low'):
              self.set_low(obj_.value)
        elif nodeName_ == 'width':
            obj_ = self.get_class_obj_(child_, PQ)
            obj_ = PQ.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'width', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_width'):
              self.add_width(obj_.value)
            elif hasattr(self, 'set_width'):
              self.set_width(obj_.value)
        elif nodeName_ == 'high':
            obj_ = IVXB_TS.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'high', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_high'):
              self.add_high(obj_.value)
            elif hasattr(self, 'set_high'):
              self.set_high(obj_.value)
        elif nodeName_ == 'center':
            obj_ = self.get_class_obj_(child_, TS)
            obj_ = TS.factory()
            obj_.build(child_)
            obj_ = self.mixedclass_(MixedContainer.CategoryComplex,
                MixedContainer.TypeNone, 'center', obj_)
            self.content_.append(obj_)
            if hasattr(self, 'add_center'):
              self.add_center(obj_.value)
            elif hasattr(self, 'set_center'):
              self.set_center(obj_.value)
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        super(IVL_TS, self).buildChildren(child_, node, nodeName_, True)
# end class IVL_TS


class IVXB_TS(TS):
    """Specifies whether the limit is included in the interval (interval is
    closed) or excluded from the interval (interval is open)."""
    member_data_items_ = [
        MemberSpec_('inclusive', 'bl', 0, 1, 0),
        MemberSpec_('valueOf_', 'TS', 0, 0, 0),
        ]
    subclass = None
    superclass = TS
    def __init__(self, nullFlavor=None, value=None, inclusive='true', valueOf_=None, mixedclass_=None, content_=None):
        super(IVXB_TS, self).__init__(nullFlavor, value, valueOf_, mixedclass_, content_, )
        self.inclusive = _cast(None, inclusive)
        self.valueOf_ = valueOf_
        if mixedclass_ is None:
            self.mixedclass_ = MixedContainer
        else:
            self.mixedclass_ = mixedclass_
        if content_ is None:
            self.content_ = []
        else:
            self.content_ = content_
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if IVXB_TS.subclass:
            return IVXB_TS.subclass(*args_, **kwargs_)
        else:
            return IVXB_TS(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_inclusive(self): return self.inclusive
    def set_inclusive(self, inclusive): self.inclusive = inclusive
    inclusiveProp = property(get_inclusive, set_inclusive)
    def validate_bl(self, value):
        # Validate type bl, a restriction on xs:boolean.
        pass
    def get_valueOf_(self): return self.valueOf_
    def set_valueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='IVXB_TS', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='IVXB_TS')
        if self.valueOf_ is not None:
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='IVXB_TS'):
        super(IVXB_TS, self).exportAttributes(outfile, level, already_processed, namespace_, name_='IVXB_TS')
        if self.inclusive is not None and 'inclusive' not in already_processed and self.inclusive != "true":
            already_processed.append('inclusive')
            outfile.write(' inclusive=%s' % (quote_attrib(self.inclusive), ))
    def exportChildren(self, outfile, level, namespace_='', name_='IVXB_TS', fromsubclass_=False):
        super(IVXB_TS, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            self.valueOf_ or
            super(IVXB_TS, self).hasContent_()
            ):
            return True
        else:
            return False
    def hasSimpleContent_(self):
        if (
            self.valueOf_ or
            super(IVXB_TS, self).hasSimpleContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        self.valueOf_ = get_all_text_(node)
        if node.text is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', node.text)
            self.content_.append(obj_)
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('inclusive', node)
        if value is not None and 'inclusive' not in already_processed:
            already_processed.append('inclusive')
            if value in ('true', '1'):
                self.inclusive = True
            elif value in ('false', '0'):
                self.inclusive = False
            else:
                raise_parse_error(node, 'Bad boolean attribute')
            self.validate_bl(self.inclusive)    # validate type bl
        super(IVXB_TS, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if not fromsubclass_ and child_.tail is not None:
            obj_ = self.mixedclass_(MixedContainer.CategoryText,
                MixedContainer.TypeNone, '', child_.tail)
            self.content_.append(obj_)
        super(IVXB_TS, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class IVXB_TS


class PIVL_TS(SXCM_TS):
    """Note: because this type is defined as an extension of SXCM_T, all of
    the attributes and elements accepted for T are also accepted by
    this definition. However, they are NOT allowed by the normative
    description of this type. Unfortunately, we cannot write a
    general purpose schematron contraints to provide that extra
    validation, thus applications must be aware that instance
    (fragments) that pass validation with this might might still not
    be legal. Specifies if and how the repetitions are aligned to
    the cycles of the underlying calendar (e.g., to distinguish
    every 30 days from "the 5th of every month".) A non-aligned
    periodic interval recurs independently from the calendar. An
    aligned periodic interval is synchronized with the calendar.
    Indicates whether the exact timing is up to the party executing
    the schedule (e.g., to distinguish "every 8 hours" from "3 times
    a day".)"""
    member_data_items_ = [
        MemberSpec_('institutionSpecified', 'bl', 0, 1, 0),
        MemberSpec_('alignment', 'CalendarCycle', 0, 1, 0),
        MemberSpec_('phase', 'IVL_TS', 0, 0, 0),
        MemberSpec_('period', 'PQ', 0, 0, 0),
        ]
    subclass = None
    superclass = SXCM_TS
    def __init__(self, nullFlavor=None, value=None, operator='I', institutionSpecified='false', alignment=None, phase=None, period=None):
        super(PIVL_TS, self).__init__(nullFlavor, value, operator, )
        self.institutionSpecified = _cast(None, institutionSpecified)
        self.alignment = _cast(None, alignment)
        self.phase = phase
        self.period = period
    def factory(*args_, **kwargs_):
        if PIVL_TS.subclass:
            return PIVL_TS.subclass(*args_, **kwargs_)
        else:
            return PIVL_TS(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_phase(self): return self.phase
    def set_phase(self, phase): self.phase = phase
    phaseProp = property(get_phase, set_phase)
    def get_period(self): return self.period
    def set_period(self, period): self.period = period
    periodProp = property(get_period, set_period)
    def get_institutionSpecified(self): return self.institutionSpecified
    def set_institutionSpecified(self, institutionSpecified): self.institutionSpecified = institutionSpecified
    institutionSpecifiedProp = property(get_institutionSpecified, set_institutionSpecified)
    def validate_bl(self, value):
        # Validate type bl, a restriction on xs:boolean.
        pass
    def get_alignment(self): return self.alignment
    def set_alignment(self, alignment): self.alignment = alignment
    alignmentProp = property(get_alignment, set_alignment)
    def validate_CalendarCycle(self, value):
        # Validate type CalendarCycle, a restriction on cs.
        pass
    def export(self, outfile, level, namespace_='', name_='PIVL_TS', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='PIVL_TS')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='PIVL_TS'):
        super(PIVL_TS, self).exportAttributes(outfile, level, already_processed, namespace_, name_='PIVL_TS')
        if self.institutionSpecified is not None and 'institutionSpecified' not in already_processed and self.institutionSpecified != "false":
            already_processed.append('institutionSpecified')
            outfile.write(' institutionSpecified=%s' % (quote_attrib(self.institutionSpecified), ))
        if self.alignment is not None and 'alignment' not in already_processed:
            already_processed.append('alignment')
            outfile.write(' alignment=%s' % (quote_attrib(self.alignment), ))
    def exportChildren(self, outfile, level, namespace_='', name_='PIVL_TS', fromsubclass_=False):
        super(PIVL_TS, self).exportChildren(outfile, level, namespace_, name_, True)
        if self.phase is not None:
            self.phase.export(outfile, level, namespace_, name_='phase')
        if self.period is not None:
            self.period.export(outfile, level, namespace_, name_='period')
    def hasContent_(self):
        if (
            self.phase is not None or
            self.period is not None or
            super(PIVL_TS, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('institutionSpecified', node)
        if value is not None and 'institutionSpecified' not in already_processed:
            already_processed.append('institutionSpecified')
            if value in ('true', '1'):
                self.institutionSpecified = True
            elif value in ('false', '0'):
                self.institutionSpecified = False
            else:
                raise_parse_error(node, 'Bad boolean attribute')
            self.validate_bl(self.institutionSpecified)    # validate type bl
        value = find_attr_value_('alignment', node)
        if value is not None and 'alignment' not in already_processed:
            already_processed.append('alignment')
            self.alignment = value
            self.validate_CalendarCycle(self.alignment)    # validate type CalendarCycle
        super(PIVL_TS, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'phase':
            obj_ = build_object(child_, 'IVL_TS')
            self.set_phase(obj_)
        elif nodeName_ == 'period':
            obj_ = build_object(child_, 'PQ')
            self.set_period(obj_)
        super(PIVL_TS, self).buildChildren(child_, node, nodeName_, True)
# end class PIVL_TS


class EIVL_TS(SXCM_TS):
    """Note: because this type is defined as an extension of SXCM_T, all of
    the attributes and elements accepted for T are also accepted by
    this definition. However, they are NOT allowed by the normative
    description of this type. Unfortunately, we cannot write a
    general purpose schematron contraints to provide that extra
    validation, thus applications must be aware that instance
    (fragments) that pass validation with this might might still not
    be legal."""
    member_data_items_ = [
        MemberSpec_('event', 'EIVL.event', 0, 0, 0),
        MemberSpec_('offset', 'IVL_PQ', 0, 0, 0),
        ]
    subclass = None
    superclass = SXCM_TS
    def __init__(self, nullFlavor=None, value=None, operator='I', event=None, offset=None):
        super(EIVL_TS, self).__init__(nullFlavor, value, operator, )
        self.event = event
        self.offset = offset
    def factory(*args_, **kwargs_):
        if EIVL_TS.subclass:
            return EIVL_TS.subclass(*args_, **kwargs_)
        else:
            return EIVL_TS(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_event(self): return self.event
    def set_event(self, event): self.event = event
    eventProp = property(get_event, set_event)
    def get_offset(self): return self.offset
    def set_offset(self, offset): self.offset = offset
    offsetProp = property(get_offset, set_offset)
    def export(self, outfile, level, namespace_='', name_='EIVL_TS', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='EIVL_TS')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='EIVL_TS'):
        super(EIVL_TS, self).exportAttributes(outfile, level, already_processed, namespace_, name_='EIVL_TS')
    def exportChildren(self, outfile, level, namespace_='', name_='EIVL_TS', fromsubclass_=False):
        super(EIVL_TS, self).exportChildren(outfile, level, namespace_, name_, True)
        if self.event is not None:
            self.event.export(outfile, level, namespace_, name_='event')
        if self.offset is not None:
            self.offset.export(outfile, level, namespace_, name_='offset')
    def hasContent_(self):
        if (
            self.event is not None or
            self.offset is not None or
            super(EIVL_TS, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        super(EIVL_TS, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'event':
            obj_ = build_object(child_, 'EIVL_event')
            self.set_event(obj_)
        elif nodeName_ == 'offset':
            obj_ = build_object(child_, 'IVL_PQ')
            self.set_offset(obj_)
        super(EIVL_TS, self).buildChildren(child_, node, nodeName_, True)
# end class EIVL_TS


class IVL_PQ(SXCM_PQ):
    member_data_items_ = [
        MemberSpec_('low', 'IVXB_PQ', 0, 0, 0),
        MemberSpec_('width', 'PQ', 0, 0, 0),
        MemberSpec_('high', 'IVXB_PQ', 0, 0, 0),
        MemberSpec_('center', 'PQ', 0, 0, 0),
        ]
    subclass = None
    superclass = SXCM_PQ
    def __init__(self, nullFlavor=None, unit='1', value=None, translation=None, operator='I', low=None, width=None, high=None, center=None, extensiontype_=None):
        super(IVL_PQ, self).__init__(nullFlavor, unit, value, translation, operator, extensiontype_, )
        self.low = low
        self.width = width
        self.high = high
        self.center = center
        self.extensiontype_ = extensiontype_
    def factory(*args_, **kwargs_):
        if IVL_PQ.subclass:
            return IVL_PQ.subclass(*args_, **kwargs_)
        else:
            return IVL_PQ(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_low(self): return self.low
    def set_low(self, low): self.low = low
    lowProp = property(get_low, set_low)
    def get_width(self): return self.width
    def set_width(self, width): self.width = width
    widthProp = property(get_width, set_width)
    def get_high(self): return self.high
    def set_high(self, high): self.high = high
    highProp = property(get_high, set_high)
    def get_center(self): return self.center
    def set_center(self, center): self.center = center
    centerProp = property(get_center, set_center)
    def get_extensiontype_(self): return self.extensiontype_
    def set_extensiontype_(self, extensiontype_): self.extensiontype_ = extensiontype_
    def export(self, outfile, level, namespace_='', name_='IVL_PQ', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='IVL_PQ')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='IVL_PQ'):
        super(IVL_PQ, self).exportAttributes(outfile, level, already_processed, namespace_, name_='IVL_PQ')
        if self.extensiontype_ is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            outfile.write(' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"')
            outfile.write(' xsi:type="%s"' % self.extensiontype_)
    def exportChildren(self, outfile, level, namespace_='', name_='IVL_PQ', fromsubclass_=False):
        super(IVL_PQ, self).exportChildren(outfile, level, namespace_, name_, True)
        if self.low is not None:
            self.low.export(outfile, level, namespace_, name_='low', )
        if self.width is not None:
            self.width.export(outfile, level, namespace_, name_='width')
        if self.high is not None:
            self.high.export(outfile, level, namespace_, name_='high')
        if self.center is not None:
            self.center.export(outfile, level, namespace_, name_='center', )
    def hasContent_(self):
        if (
            self.low is not None or
            self.width is not None or
            self.high is not None or
            self.center is not None or
            super(IVL_PQ, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('xsi:type', node)
        if value is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            self.extensiontype_ = value
        super(IVL_PQ, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'low':
            obj_ = build_object(child_, 'IVXB_PQ')
            self.set_low(obj_)
        elif nodeName_ == 'width':
            obj_ = build_object(child_, 'PQ')
            self.set_width(obj_)
        elif nodeName_ == 'high':
            obj_ = build_object(child_, 'IVXB_PQ')
            self.set_high(obj_)
        elif nodeName_ == 'center':
            obj_ = build_object(child_, 'PQ')
            self.set_center(obj_)
        super(IVL_PQ, self).buildChildren(child_, node, nodeName_, True)
# end class IVL_PQ


class PPD_TS(TS):
    """A code specifying the type of probability distribution. Possible
    values are as shown in the attached table. The NULL value
    (unknown) for the type code indicates that the probability
    distribution type is unknown. In that case, the standard
    deviation has the meaning of an informal guess."""
    member_data_items_ = [
        MemberSpec_('distributionType', 'ProbabilityDistributionType', 0, 1, 0),
        MemberSpec_('standardDeviation', 'PQ', 0, 0, 0),
        ]
    subclass = None
    superclass = TS
    def __init__(self, nullFlavor=None, value=None, distributionType=None, standardDeviation=None, extensiontype_=None):
        super(PPD_TS, self).__init__(nullFlavor, value, extensiontype_, )
        self.distributionType = _cast(None, distributionType)
        self.standardDeviation = standardDeviation
        self.extensiontype_ = extensiontype_
    def factory(*args_, **kwargs_):
        if PPD_TS.subclass:
            return PPD_TS.subclass(*args_, **kwargs_)
        else:
            return PPD_TS(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_standardDeviation(self): return self.standardDeviation
    def set_standardDeviation(self, standardDeviation): self.standardDeviation = standardDeviation
    standardDeviationProp = property(get_standardDeviation, set_standardDeviation)
    def get_distributionType(self): return self.distributionType
    def set_distributionType(self, distributionType): self.distributionType = distributionType
    distributionTypeProp = property(get_distributionType, set_distributionType)
    def validate_ProbabilityDistributionType(self, value):
        # Validate type ProbabilityDistributionType, a restriction on cs.
        pass
    def get_extensiontype_(self): return self.extensiontype_
    def set_extensiontype_(self, extensiontype_): self.extensiontype_ = extensiontype_
    def export(self, outfile, level, namespace_='', name_='PPD_TS', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='PPD_TS')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='PPD_TS'):
        super(PPD_TS, self).exportAttributes(outfile, level, already_processed, namespace_, name_='PPD_TS')
        if self.distributionType is not None and 'distributionType' not in already_processed:
            already_processed.append('distributionType')
            outfile.write(' distributionType=%s' % (quote_attrib(self.distributionType), ))
        if self.extensiontype_ is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            outfile.write(' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"')
            outfile.write(' xsi:type="%s"' % self.extensiontype_)
    def exportChildren(self, outfile, level, namespace_='', name_='PPD_TS', fromsubclass_=False):
        super(PPD_TS, self).exportChildren(outfile, level, namespace_, name_, True)
        if self.standardDeviation is not None:
            self.standardDeviation.export(outfile, level, namespace_, name_='standardDeviation')
    def hasContent_(self):
        if (
            self.standardDeviation is not None or
            super(PPD_TS, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('distributionType', node)
        if value is not None and 'distributionType' not in already_processed:
            already_processed.append('distributionType')
            self.distributionType = value
            self.validate_ProbabilityDistributionType(self.distributionType)    # validate type ProbabilityDistributionType
        value = find_attr_value_('xsi:type', node)
        if value is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            self.extensiontype_ = value
        super(PPD_TS, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'standardDeviation':
            obj_ = build_object(child_, 'PQ')
            self.set_standardDeviation(obj_)
        super(PPD_TS, self).buildChildren(child_, node, nodeName_, True)
# end class PPD_TS


class SXCM_PPD_TS(PPD_TS):
    """A code specifying whether the set component is included (union) or
    excluded (set-difference) from the set, or other set operations
    with the current set component and the set as constructed from
    the representation stream up to the current point."""
    member_data_items_ = [
        MemberSpec_('operator', 'SetOperator', 0, 1, 0),
        ]
    subclass = None
    superclass = PPD_TS
    def __init__(self, nullFlavor=None, value=None, distributionType=None, standardDeviation=None, operator='I', extensiontype_=None):
        super(SXCM_PPD_TS, self).__init__(nullFlavor, value, distributionType, standardDeviation, extensiontype_, )
        self.operator = _cast(None, operator)
        self.extensiontype_ = extensiontype_
    def factory(*args_, **kwargs_):
        if SXCM_PPD_TS.subclass:
            return SXCM_PPD_TS.subclass(*args_, **kwargs_)
        else:
            return SXCM_PPD_TS(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_operator(self): return self.operator
    def set_operator(self, operator): self.operator = operator
    operatorProp = property(get_operator, set_operator)
    def validate_SetOperator(self, value):
        # Validate type SetOperator, a restriction on cs.
        pass
    def get_extensiontype_(self): return self.extensiontype_
    def set_extensiontype_(self, extensiontype_): self.extensiontype_ = extensiontype_
    def export(self, outfile, level, namespace_='', name_='SXCM_PPD_TS', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='SXCM_PPD_TS')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='SXCM_PPD_TS'):
        super(SXCM_PPD_TS, self).exportAttributes(outfile, level, already_processed, namespace_, name_='SXCM_PPD_TS')
        if self.operator is not None and 'operator' not in already_processed and self.operator != "I":
            already_processed.append('operator')
            outfile.write(' operator=%s' % (quote_attrib(self.operator), ))
        if self.extensiontype_ is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            outfile.write(' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"')
            outfile.write(' xsi:type="%s"' % self.extensiontype_)
    def exportChildren(self, outfile, level, namespace_='', name_='SXCM_PPD_TS', fromsubclass_=False):
        super(SXCM_PPD_TS, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            super(SXCM_PPD_TS, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('operator', node)
        if value is not None and 'operator' not in already_processed:
            already_processed.append('operator')
            self.operator = value
            self.validate_SetOperator(self.operator)    # validate type SetOperator
        value = find_attr_value_('xsi:type', node)
        if value is not None and 'xsi:type' not in already_processed:
            already_processed.append('xsi:type')
            self.extensiontype_ = value
        super(SXCM_PPD_TS, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        super(SXCM_PPD_TS, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class SXCM_PPD_TS


class IVL_PPD_TS(SXCM_PPD_TS):
    member_data_items_ = [
        MemberSpec_('low', 'IVXB_PPD_TS', 0, 0, 0),
        MemberSpec_('width', 'PPD_PQ', 0, 0, 0),
        MemberSpec_('high', 'IVXB_PPD_TS', 0, 0, 0),
        MemberSpec_('center', 'PPD_TS', 0, 0, 0),
        ]
    subclass = None
    superclass = SXCM_PPD_TS
    def __init__(self, nullFlavor=None, value=None, distributionType=None, standardDeviation=None, operator='I', low=None, width=None, high=None, center=None):
        super(IVL_PPD_TS, self).__init__(nullFlavor, value, distributionType, standardDeviation, operator, )
        self.low = low
        self.width = width
        self.high = high
        self.center = center
    def factory(*args_, **kwargs_):
        if IVL_PPD_TS.subclass:
            return IVL_PPD_TS.subclass(*args_, **kwargs_)
        else:
            return IVL_PPD_TS(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_low(self): return self.low
    def set_low(self, low): self.low = low
    lowProp = property(get_low, set_low)
    def get_width(self): return self.width
    def set_width(self, width): self.width = width
    widthProp = property(get_width, set_width)
    def get_high(self): return self.high
    def set_high(self, high): self.high = high
    highProp = property(get_high, set_high)
    def get_center(self): return self.center
    def set_center(self, center): self.center = center
    centerProp = property(get_center, set_center)
    def export(self, outfile, level, namespace_='', name_='IVL_PPD_TS', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='IVL_PPD_TS')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='IVL_PPD_TS'):
        super(IVL_PPD_TS, self).exportAttributes(outfile, level, already_processed, namespace_, name_='IVL_PPD_TS')
    def exportChildren(self, outfile, level, namespace_='', name_='IVL_PPD_TS', fromsubclass_=False):
        super(IVL_PPD_TS, self).exportChildren(outfile, level, namespace_, name_, True)
        if self.low is not None:
            self.low.export(outfile, level, namespace_, name_='low', )
        if self.width is not None:
            self.width.export(outfile, level, namespace_, name_='width')
        if self.high is not None:
            self.high.export(outfile, level, namespace_, name_='high')
        if self.center is not None:
            self.center.export(outfile, level, namespace_, name_='center', )
    def hasContent_(self):
        if (
            self.low is not None or
            self.width is not None or
            self.high is not None or
            self.center is not None or
            super(IVL_PPD_TS, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        super(IVL_PPD_TS, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'low':
            obj_ = build_object(child_, 'IVXB_PPD_TS')
            self.set_low(obj_)
        elif nodeName_ == 'width':
            obj_ = build_object(child_, 'PPD_PQ')
            self.set_width(obj_)
        elif nodeName_ == 'high':
            obj_ = build_object(child_, 'IVXB_PPD_TS')
            self.set_high(obj_)
        elif nodeName_ == 'center':
            obj_ = build_object(child_, 'PPD_TS')
            self.set_center(obj_)
        super(IVL_PPD_TS, self).buildChildren(child_, node, nodeName_, True)
# end class IVL_PPD_TS


class IVXB_PPD_TS(PPD_TS):
    """Specifies whether the limit is included in the interval (interval is
    closed) or excluded from the interval (interval is open)."""
    member_data_items_ = [
        MemberSpec_('inclusive', 'bl', 0, 1, 0),
        ]
    subclass = None
    superclass = PPD_TS
    def __init__(self, nullFlavor=None, value=None, distributionType=None, standardDeviation=None, inclusive='true'):
        super(IVXB_PPD_TS, self).__init__(nullFlavor, value, distributionType, standardDeviation, )
        self.inclusive = _cast(None, inclusive)
        pass
    def factory(*args_, **kwargs_):
        if IVXB_PPD_TS.subclass:
            return IVXB_PPD_TS.subclass(*args_, **kwargs_)
        else:
            return IVXB_PPD_TS(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_inclusive(self): return self.inclusive
    def set_inclusive(self, inclusive): self.inclusive = inclusive
    inclusiveProp = property(get_inclusive, set_inclusive)
    def validate_bl(self, value):
        # Validate type bl, a restriction on xs:boolean.
        pass
    def export(self, outfile, level, namespace_='', name_='IVXB_PPD_TS', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='IVXB_PPD_TS')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='IVXB_PPD_TS'):
        super(IVXB_PPD_TS, self).exportAttributes(outfile, level, already_processed, namespace_, name_='IVXB_PPD_TS')
        if self.inclusive is not None and 'inclusive' not in already_processed and self.inclusive != "true":
            already_processed.append('inclusive')
            outfile.write(' inclusive=%s' % (quote_attrib(self.inclusive), ))
    def exportChildren(self, outfile, level, namespace_='', name_='IVXB_PPD_TS', fromsubclass_=False):
        super(IVXB_PPD_TS, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            super(IVXB_PPD_TS, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('inclusive', node)
        if value is not None and 'inclusive' not in already_processed:
            already_processed.append('inclusive')
            if value in ('true', '1'):
                self.inclusive = True
            elif value in ('false', '0'):
                self.inclusive = False
            else:
                raise_parse_error(node, 'Bad boolean attribute')
            self.validate_bl(self.inclusive)    # validate type bl
        super(IVXB_PPD_TS, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        super(IVXB_PPD_TS, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class IVXB_PPD_TS


class EIVL_PPD_TS(SXCM_PPD_TS):
    """Note: because this type is defined as an extension of SXCM_T, all of
    the attributes and elements accepted for T are also accepted by
    this definition. However, they are NOT allowed by the normative
    description of this type. Unfortunately, we cannot write a
    general purpose schematron contraints to provide that extra
    validation, thus applications must be aware that instance
    (fragments) that pass validation with this might might still not
    be legal."""
    member_data_items_ = [
        MemberSpec_('event', 'EIVL.event', 0, 0, 0),
        MemberSpec_('offset', 'IVL_PPD_PQ', 0, 0, 0),
        ]
    subclass = None
    superclass = SXCM_PPD_TS
    def __init__(self, nullFlavor=None, value=None, distributionType=None, standardDeviation=None, operator='I', event=None, offset=None):
        super(EIVL_PPD_TS, self).__init__(nullFlavor, value, distributionType, standardDeviation, operator, )
        self.event = event
        self.offset = offset
    def factory(*args_, **kwargs_):
        if EIVL_PPD_TS.subclass:
            return EIVL_PPD_TS.subclass(*args_, **kwargs_)
        else:
            return EIVL_PPD_TS(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_event(self): return self.event
    def set_event(self, event): self.event = event
    eventProp = property(get_event, set_event)
    def get_offset(self): return self.offset
    def set_offset(self, offset): self.offset = offset
    offsetProp = property(get_offset, set_offset)
    def export(self, outfile, level, namespace_='', name_='EIVL_PPD_TS', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='EIVL_PPD_TS')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='EIVL_PPD_TS'):
        super(EIVL_PPD_TS, self).exportAttributes(outfile, level, already_processed, namespace_, name_='EIVL_PPD_TS')
    def exportChildren(self, outfile, level, namespace_='', name_='EIVL_PPD_TS', fromsubclass_=False):
        super(EIVL_PPD_TS, self).exportChildren(outfile, level, namespace_, name_, True)
        if self.event is not None:
            self.event.export(outfile, level, namespace_, name_='event')
        if self.offset is not None:
            self.offset.export(outfile, level, namespace_, name_='offset')
    def hasContent_(self):
        if (
            self.event is not None or
            self.offset is not None or
            super(EIVL_PPD_TS, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        super(EIVL_PPD_TS, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'event':
            obj_ = build_object(child_, 'EIVL_event')
            self.set_event(obj_)
        elif nodeName_ == 'offset':
            obj_ = build_object(child_, 'IVL_PPD_PQ')
            self.set_offset(obj_)
        super(EIVL_PPD_TS, self).buildChildren(child_, node, nodeName_, True)
# end class EIVL_PPD_TS


class IVL_PPD_PQ(SXCM_PPD_PQ):
    member_data_items_ = [
        MemberSpec_('low', 'IVXB_PPD_PQ', 0, 0, 0),
        MemberSpec_('width', 'PPD_PQ', 0, 0, 0),
        MemberSpec_('high', 'IVXB_PPD_PQ', 0, 0, 0),
        MemberSpec_('center', 'PPD_PQ', 0, 0, 0),
        ]
    subclass = None
    superclass = SXCM_PPD_PQ
    def __init__(self, nullFlavor=None, unit='1', value=None, translation=None, distributionType=None, standardDeviation=None, operator='I', low=None, width=None, high=None, center=None):
        super(IVL_PPD_PQ, self).__init__(nullFlavor, unit, value, translation, distributionType, standardDeviation, operator, )
        self.low = low
        self.width = width
        self.high = high
        self.center = center
    def factory(*args_, **kwargs_):
        if IVL_PPD_PQ.subclass:
            return IVL_PPD_PQ.subclass(*args_, **kwargs_)
        else:
            return IVL_PPD_PQ(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_low(self): return self.low
    def set_low(self, low): self.low = low
    lowProp = property(get_low, set_low)
    def get_width(self): return self.width
    def set_width(self, width): self.width = width
    widthProp = property(get_width, set_width)
    def get_high(self): return self.high
    def set_high(self, high): self.high = high
    highProp = property(get_high, set_high)
    def get_center(self): return self.center
    def set_center(self, center): self.center = center
    centerProp = property(get_center, set_center)
    def export(self, outfile, level, namespace_='', name_='IVL_PPD_PQ', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='IVL_PPD_PQ')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='IVL_PPD_PQ'):
        super(IVL_PPD_PQ, self).exportAttributes(outfile, level, already_processed, namespace_, name_='IVL_PPD_PQ')
    def exportChildren(self, outfile, level, namespace_='', name_='IVL_PPD_PQ', fromsubclass_=False):
        super(IVL_PPD_PQ, self).exportChildren(outfile, level, namespace_, name_, True)
        if self.low is not None:
            self.low.export(outfile, level, namespace_, name_='low', )
        if self.width is not None:
            self.width.export(outfile, level, namespace_, name_='width')
        if self.high is not None:
            self.high.export(outfile, level, namespace_, name_='high')
        if self.center is not None:
            self.center.export(outfile, level, namespace_, name_='center', )
    def hasContent_(self):
        if (
            self.low is not None or
            self.width is not None or
            self.high is not None or
            self.center is not None or
            super(IVL_PPD_PQ, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        super(IVL_PPD_PQ, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'low':
            obj_ = build_object(child_, 'IVXB_PPD_PQ')
            self.set_low(obj_)
        elif nodeName_ == 'width':
            obj_ = build_object(child_, 'PPD_PQ')
            self.set_width(obj_)
        elif nodeName_ == 'high':
            obj_ = build_object(child_, 'IVXB_PPD_PQ')
            self.set_high(obj_)
        elif nodeName_ == 'center':
            obj_ = build_object(child_, 'PPD_PQ')
            self.set_center(obj_)
        super(IVL_PPD_PQ, self).buildChildren(child_, node, nodeName_, True)
# end class IVL_PPD_PQ


class SXPR_TS(SXCM_TS):
    member_data_items_ = [
        MemberSpec_('comp', 'SXCM_TS', 1, 0, 0),
        ]
    subclass = None
    superclass = SXCM_TS
    def __init__(self, nullFlavor=None, value=None, operator='I', comp=None):
        super(SXPR_TS, self).__init__(nullFlavor, value, operator, )
        if comp is None:
            self.comp = []
        else:
            self.comp = comp
    def factory(*args_, **kwargs_):
        if SXPR_TS.subclass:
            return SXPR_TS.subclass(*args_, **kwargs_)
        else:
            return SXPR_TS(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_comp(self): return self.comp
    def set_comp(self, comp): self.comp = comp
    def add_comp(self, value): self.comp.append(value)
    def insert_comp(self, index, value): self.comp[index] = value
    compProp = property(get_comp, set_comp)
    def export(self, outfile, level, namespace_='', name_='SXPR_TS', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='SXPR_TS')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='SXPR_TS'):
        super(SXPR_TS, self).exportAttributes(outfile, level, already_processed, namespace_, name_='SXPR_TS')
    def exportChildren(self, outfile, level, namespace_='', name_='SXPR_TS', fromsubclass_=False):
        super(SXPR_TS, self).exportChildren(outfile, level, namespace_, name_, True)
        for comp_ in self.comp:
            comp_.export(outfile, level, namespace_, name_='comp')
    def hasContent_(self):
        if (
            self.comp or
            super(SXPR_TS, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        super(SXPR_TS, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'comp':
            obj_ = build_object(child_, 'SXCM_TS')
            self.comp.append(obj_)
        super(SXPR_TS, self).buildChildren(child_, node, nodeName_, True)
# end class SXPR_TS


class BXIT_IVL_PQ(IVL_PQ):
    """The quantity in which the bag item occurs in its containing bag."""
    member_data_items_ = [
        MemberSpec_('qty', 'int', 0, 1, 0),
        ]
    subclass = None
    superclass = IVL_PQ
    def __init__(self, nullFlavor=None, unit='1', value=None, translation=None, operator='I', low=None, width=None, high=None, center=None, qty='1'):
        super(BXIT_IVL_PQ, self).__init__(nullFlavor, unit, value, translation, operator, low, width, high, center, )
        self.qty = _cast(None, qty)
        pass
    def factory(*args_, **kwargs_):
        if BXIT_IVL_PQ.subclass:
            return BXIT_IVL_PQ.subclass(*args_, **kwargs_)
        else:
            return BXIT_IVL_PQ(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_qty(self): return self.qty
    def set_qty(self, qty): self.qty = qty
    qtyProp = property(get_qty, set_qty)
    def validate_int(self, value):
        # Validate type int, a restriction on xs:integer.
        pass
    def export(self, outfile, level, namespace_='', name_='BXIT_IVL_PQ', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='BXIT_IVL_PQ')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='BXIT_IVL_PQ'):
        super(BXIT_IVL_PQ, self).exportAttributes(outfile, level, already_processed, namespace_, name_='BXIT_IVL_PQ')
        if self.qty is not None and 'qty' not in already_processed and self.qty != "1":
            already_processed.append('qty')
            outfile.write(' qty=%s' % (quote_attrib(self.qty), ))
    def exportChildren(self, outfile, level, namespace_='', name_='BXIT_IVL_PQ', fromsubclass_=False):
        super(BXIT_IVL_PQ, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            super(BXIT_IVL_PQ, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('qty', node)
        if value is not None and 'qty' not in already_processed:
            already_processed.append('qty')
            try:
                self.qty = int(value)
            except ValueError, exp:
                raise_parse_error(node, 'Bad integer attribute: %s' % exp)
            self.validate_int(self.qty)    # validate type int
        super(BXIT_IVL_PQ, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        super(BXIT_IVL_PQ, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class BXIT_IVL_PQ


class UVP_TS(TS):
    """The probability assigned to the value, a decimal number between 0
    (very uncertain) and 1 (certain)."""
    member_data_items_ = [
        MemberSpec_('probability', 'probability', 0, 1, 0),
        ]
    subclass = None
    superclass = TS
    def __init__(self, nullFlavor=None, value=None, probability=None):
        super(UVP_TS, self).__init__(nullFlavor, value, )
        self.probability = _cast(None, probability)
        pass
    def factory(*args_, **kwargs_):
        if UVP_TS.subclass:
            return UVP_TS.subclass(*args_, **kwargs_)
        else:
            return UVP_TS(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_probability(self): return self.probability
    def set_probability(self, probability): self.probability = probability
    probabilityProp = property(get_probability, set_probability)
    def validate_probability(self, value):
        # Validate type probability, a restriction on xs:double.
        pass
    def export(self, outfile, level, namespace_='', name_='UVP_TS', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='UVP_TS')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='UVP_TS'):
        super(UVP_TS, self).exportAttributes(outfile, level, already_processed, namespace_, name_='UVP_TS')
        if self.probability is not None and 'probability' not in already_processed:
            already_processed.append('probability')
            outfile.write(' probability=%s' % (quote_attrib(self.probability), ))
    def exportChildren(self, outfile, level, namespace_='', name_='UVP_TS', fromsubclass_=False):
        super(UVP_TS, self).exportChildren(outfile, level, namespace_, name_, True)
    def hasContent_(self):
        if (
            super(UVP_TS, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('probability', node)
        if value is not None and 'probability' not in already_processed:
            already_processed.append('probability')
            try:
                self.probability = float(value)
            except ValueError, exp:
                raise ValueError('Bad float/double attribute (probability): %s' % exp)
            self.validate_probability(self.probability)    # validate type probability
        super(UVP_TS, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        super(UVP_TS, self).buildChildren(child_, node, nodeName_, True)
        pass
# end class UVP_TS


class PIVL_PPD_TS(SXCM_PPD_TS):
    """Note: because this type is defined as an extension of SXCM_T, all of
    the attributes and elements accepted for T are also accepted by
    this definition. However, they are NOT allowed by the normative
    description of this type. Unfortunately, we cannot write a
    general purpose schematron contraints to provide that extra
    validation, thus applications must be aware that instance
    (fragments) that pass validation with this might might still not
    be legal. Specifies if and how the repetitions are aligned to
    the cycles of the underlying calendar (e.g., to distinguish
    every 30 days from "the 5th of every month".) A non-aligned
    periodic interval recurs independently from the calendar. An
    aligned periodic interval is synchronized with the calendar.
    Indicates whether the exact timing is up to the party executing
    the schedule (e.g., to distinguish "every 8 hours" from "3 times
    a day".)"""
    member_data_items_ = [
        MemberSpec_('institutionSpecified', 'bl', 0, 1, 0),
        MemberSpec_('alignment', 'CalendarCycle', 0, 1, 0),
        MemberSpec_('phase', 'IVL_PPD_TS', 0, 0, 0),
        MemberSpec_('period', 'PPD_PQ', 0, 0, 0),
        ]
    subclass = None
    superclass = SXCM_PPD_TS
    def __init__(self, nullFlavor=None, value=None, distributionType=None, standardDeviation=None, operator='I', institutionSpecified='false', alignment=None, phase=None, period=None):
        super(PIVL_PPD_TS, self).__init__(nullFlavor, value, distributionType, standardDeviation, operator, )
        self.institutionSpecified = _cast(None, institutionSpecified)
        self.alignment = _cast(None, alignment)
        self.phase = phase
        self.period = period
    def factory(*args_, **kwargs_):
        if PIVL_PPD_TS.subclass:
            return PIVL_PPD_TS.subclass(*args_, **kwargs_)
        else:
            return PIVL_PPD_TS(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_phase(self): return self.phase
    def set_phase(self, phase): self.phase = phase
    phaseProp = property(get_phase, set_phase)
    def get_period(self): return self.period
    def set_period(self, period): self.period = period
    periodProp = property(get_period, set_period)
    def get_institutionSpecified(self): return self.institutionSpecified
    def set_institutionSpecified(self, institutionSpecified): self.institutionSpecified = institutionSpecified
    institutionSpecifiedProp = property(get_institutionSpecified, set_institutionSpecified)
    def validate_bl(self, value):
        # Validate type bl, a restriction on xs:boolean.
        pass
    def get_alignment(self): return self.alignment
    def set_alignment(self, alignment): self.alignment = alignment
    alignmentProp = property(get_alignment, set_alignment)
    def validate_CalendarCycle(self, value):
        # Validate type CalendarCycle, a restriction on cs.
        pass
    def export(self, outfile, level, namespace_='', name_='PIVL_PPD_TS', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        already_processed = []
        self.exportAttributes(outfile, level, already_processed, namespace_, name_='PIVL_PPD_TS')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, already_processed, namespace_='', name_='PIVL_PPD_TS'):
        super(PIVL_PPD_TS, self).exportAttributes(outfile, level, already_processed, namespace_, name_='PIVL_PPD_TS')
        if self.institutionSpecified is not None and 'institutionSpecified' not in already_processed and self.institutionSpecified != "false":
            already_processed.append('institutionSpecified')
            outfile.write(' institutionSpecified=%s' % (quote_attrib(self.institutionSpecified), ))
        if self.alignment is not None and 'alignment' not in already_processed:
            already_processed.append('alignment')
            outfile.write(' alignment=%s' % (quote_attrib(self.alignment), ))
    def exportChildren(self, outfile, level, namespace_='', name_='PIVL_PPD_TS', fromsubclass_=False):
        super(PIVL_PPD_TS, self).exportChildren(outfile, level, namespace_, name_, True)
        if self.phase is not None:
            self.phase.export(outfile, level, namespace_, name_='phase')
        if self.period is not None:
            self.period.export(outfile, level, namespace_, name_='period')
    def hasContent_(self):
        if (
            self.phase is not None or
            self.period is not None or
            super(PIVL_PPD_TS, self).hasContent_()
            ):
            return True
        else:
            return False
    def build(self, node):
        self.buildAttributes(node, node.attrib, [])
        for child in node:
            nodeName_ = Tag_pattern_.match(child.tag).groups()[-1]
            self.buildChildren(child, node, nodeName_)
    def buildAttributes(self, node, attrs, already_processed):
        value = find_attr_value_('institutionSpecified', node)
        if value is not None and 'institutionSpecified' not in already_processed:
            already_processed.append('institutionSpecified')
            if value in ('true', '1'):
                self.institutionSpecified = True
            elif value in ('false', '0'):
                self.institutionSpecified = False
            else:
                raise_parse_error(node, 'Bad boolean attribute')
            self.validate_bl(self.institutionSpecified)    # validate type bl
        value = find_attr_value_('alignment', node)
        if value is not None and 'alignment' not in already_processed:
            already_processed.append('alignment')
            self.alignment = value
            self.validate_CalendarCycle(self.alignment)    # validate type CalendarCycle
        super(PIVL_PPD_TS, self).buildAttributes(node, attrs, already_processed)
    def buildChildren(self, child_, node, nodeName_, fromsubclass_=False):
        if nodeName_ == 'phase':
            obj_ = build_object(child_, 'IVL_PPD_TS')
            self.set_phase(obj_)
        elif nodeName_ == 'period':
            obj_ = build_object(child_, 'PPD_PQ')
            self.set_period(obj_)
        super(PIVL_PPD_TS, self).buildChildren(child_, node, nodeName_, True)
# end class PIVL_PPD_TS


USAGE_TEXT = """
Usage: python <Parser>.py [ -s ] <in_xml_file>
"""

def usage():
    print USAGE_TEXT
    sys.exit(1)


def get_root_tag(node):
    tag = Tag_pattern_.match(node.tag).groups()[-1]
    if (tag.find('.') > -1):
        tag = tag.replace('.', '_')
    rootClass = globals().get(tag)
    return tag, rootClass


def parse(inFileName):
    doc = parsexml_(inFileName)
    rootNode = doc.getroot()
    rootTag, rootClass = get_root_tag(rootNode)
    if rootClass is None:
        rootTag = 'PatientUpdate'
        rootClass = TZDU_MT000003UV_PatientUpdate
    rootObj = rootClass.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
##     sys.stdout.write('<?xml version="1.0" ?>\n')
##     rootObj.export(sys.stdout, 0, name_=rootTag, 
##         namespacedef_='')
    return rootObj


def parseString(inString):
    from StringIO import StringIO
    doc = parsexml_(StringIO(inString))
    rootNode = doc.getroot()
    rootTag, rootClass = get_root_tag(rootNode)
    if rootClass is None:
        rootTag = 'PatientUpdate'
        rootClass = TZDU_MT000003UV_PatientUpdate
    rootObj = rootClass.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
##     sys.stdout.write('<?xml version="1.0" ?>\n')
##     rootObj.export(sys.stdout, 0, name_="PatientUpdate",
##         namespacedef_='')
    return rootObj


def parseLiteral(inFileName):
    doc = parsexml_(inFileName)
    rootNode = doc.getroot()
    rootTag, rootClass = get_root_tag(rootNode)
    if rootClass is None:
        rootTag = 'PatientUpdate'
        rootClass = TZDU_MT000003UV_PatientUpdate
    rootObj = rootClass.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
##     sys.stdout.write('#from TZDU_IN000003UV_parser import *\n\n')
##     sys.stdout.write('import TZDU_IN000003UV_parser as model_\n\n')
##     sys.stdout.write('rootObj = model_.rootTag(\n')
##     rootObj.exportLiteral(sys.stdout, 0, name_=rootTag)
##     sys.stdout.write(')\n')
    return rootObj


def main():
    args = sys.argv[1:]
    if len(args) == 1:
        parse(args[0])
    else:
        usage()


if __name__ == '__main__':
    #import pdb; pdb.set_trace()
    main()


__all__ = [
    "AD",
    "ADXP",
    "ANY",
    "ANYNonNull",
    "BIN",
    "BL",
    "BN",
    "BXIT_CD",
    "BXIT_IVL_PQ",
    "CD",
    "CE",
    "CO",
    "CR",
    "CS",
    "CV",
    "ED",
    "EIVL_PPD_TS",
    "EIVL_TS",
    "EIVL_event",
    "EN",
    "ENXP",
    "GLIST_PQ",
    "GLIST_TS",
    "HXIT_CE",
    "HXIT_PQ",
    "II",
    "INT",
    "IVL_INT",
    "IVL_MO",
    "IVL_PPD_PQ",
    "IVL_PPD_TS",
    "IVL_PQ",
    "IVL_REAL",
    "IVL_TS",
    "IVXB_INT",
    "IVXB_MO",
    "IVXB_PPD_PQ",
    "IVXB_PPD_TS",
    "IVXB_PQ",
    "IVXB_REAL",
    "IVXB_TS",
    "MO",
    "ON",
    "PIVL_PPD_TS",
    "PIVL_TS",
    "PN",
    "PPD_PQ",
    "PPD_TS",
    "PQ",
    "PQR",
    "QTY",
    "REAL",
    "RTO",
    "RTO_MO_PQ",
    "RTO_PQ_PQ",
    "RTO_QTY_QTY",
    "SC",
    "SLIST_PQ",
    "SLIST_TS",
    "ST",
    "SXCM_CD",
    "SXCM_INT",
    "SXCM_MO",
    "SXCM_PPD_PQ",
    "SXCM_PPD_TS",
    "SXCM_PQ",
    "SXCM_REAL",
    "SXCM_TS",
    "SXPR_TS",
    "TEL",
    "TN",
    "TS",
    "TZDU_MT000003UV_CareGiver",
    "TZDU_MT000003UV_CareProvider",
    "TZDU_MT000003UV_Insurer",
    "TZDU_MT000003UV_Organization",
    "TZDU_MT000003UV_Patient",
    "TZDU_MT000003UV_PatientUpdate",
    "TZDU_MT000003UV_Person",
    "TZDU_MT000003UV_PolicyHolder",
    "TZDU_MT000003UV_RecordTarget",
    "URL",
    "UVP_TS",
    "adxp_additionalLocator",
    "adxp_buildingNumberSuffix",
    "adxp_careOf",
    "adxp_censusTract",
    "adxp_city",
    "adxp_country",
    "adxp_county",
    "adxp_delimiter",
    "adxp_deliveryAddressLine",
    "adxp_deliveryInstallationArea",
    "adxp_deliveryInstallationQualifier",
    "adxp_deliveryInstallationType",
    "adxp_deliveryMode",
    "adxp_deliveryModeIdentifier",
    "adxp_direction",
    "adxp_houseNumber",
    "adxp_houseNumberNumeric",
    "adxp_postBox",
    "adxp_postalCode",
    "adxp_precinct",
    "adxp_state",
    "adxp_streetAddressLine",
    "adxp_streetName",
    "adxp_streetNameBase",
    "adxp_streetNameType",
    "adxp_unitID",
    "adxp_unitType",
    "en_delimiter",
    "en_family",
    "en_given",
    "en_prefix",
    "en_suffix",
    "thumbnail"
    ]
