parent = {
'Account' : 'Act',
'ContextStructure' : 'Act',
'ControlAct' : 'Act',
'DeviceTask' : 'Act',
'Exposure' : 'Act',
'FinancialContract' : 'Act',
'FinancialTransaction' : 'Act',
'InvoiceElement' : 'Act',
'ManagedParticipation' : 'Participation',
'Observation' : 'Act',
'PatientEncounter' : 'Act',
'Procedure' : 'Act',
'Supply' : 'Act',
'WorkingList' : 'Act',
'LivingSubject' : 'Entity',
'Material' : 'Entity',
'Organization' : 'Entity',
'Place' : 'Entity',
'Access' : 'Role',
'Employee' : 'Role',
'LicensedEntity' : 'Role',
'Patient' : 'Role',
'QualifiedEntity' : 'Role',
'Batch' : 'Transmission',
'Message' : 'Transmission',
'ParameterItem' : 'Parameter',
'ParameterList' : 'Parameter',
'QueryAck' : 'QueryEvent',
'QueryContinuation' : 'QueryEvent',
'QuerySpec' : 'QueryEvent',
'Document' : 'ContextStructure',
'DiagnosticImage' : 'Observation',
'Diet' : 'Supply',
'PublicHealthCase' : 'Observation',
'SubstanceAdministration' : 'Procedure',
'ManufacturedMaterial' : 'Material',
'NonPersonLivingSubject' : 'LivingSubject',
'Person' : 'LivingSubject',
'QueryByParameter' : 'QuerySpec',
'Container' : 'ManufacturedMaterial',
'Device' : 'ManufacturedMaterial',
}

attributes = {
	'Access' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'player' : '''bigint''', 'scoper' : '''bigint''', 'classCode' : '''hl7.cv('RoleClass','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''hl7.cv('RoleCode','CNE')''', 'negationInd' : '''hl7.bl''', 'name' : '''r1."BAG_EN"''', 'addr' : '''r1."BAG_AD"''', 'telecom' : '''r1."BAG_TEL"''', 'statusCode' : '''hl7.cv('RoleStatus','CNE')''', 'effectiveTime' : '''r1."GTS"''', 'certificateText' : '''r1."ED"''', 'confidentialityCode' : '''hl7.set('Confidentiality')''', 'quantity' : '''r1."RTO"''', 'priorityNumber' : '''integer''', 'positionNumber' : '''r1.list_int''', 'approachSiteCode' : '''r1."CD"''', 'targetSiteCode' : '''r1."CD"''', 'gaugeQuantity' : '''hl7.pq'''},
	'Account' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('ActClass','CNE')''', 'moodCode' : '''hl7.cv('ActMood','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'actionNegationInd' : '''hl7.bl''', 'negationInd' : '''hl7.bl''', 'derivationExpr' : '''r1.st''', 'title' : '''r1."ED"''', 'text' : '''r1."ED"''', 'statusCode' : '''hl7.cv('ActStatus','CNE')''', 'effectiveTime' : '''r1."GTS"''', 'activityTime' : '''r1."GTS"''', 'availabilityTime' : '''hl7.ts''', 'priorityCode' : '''hl7.set('ActPriority')''', 'confidentialityCode' : '''hl7.set('Confidentiality')''', 'repeatNumber' : '''r1.ivl_int''', 'interruptibleInd' : '''hl7.bl''', 'levelCode' : '''hl7.cv('ActContextLevel','CNE')''', 'independentInd' : '''hl7.bl''', 'uncertaintyCode' : '''hl7.cv('ActUncertainty','CNE')''', 'reasonCode' : '''hl7.set('ActReason')''', 'languageCode' : '''hl7.cv('HumanLanguage','CNE')''', 'isCriterionInd' : '''hl7.bl''', 'balanceAmt' : '''r1."MO"''', 'currencyCode' : '''hl7.cv('Currency','CNE')''', 'interestRateQuantity' : '''r1."RTO"''', 'allowedBalanceQuantity' : '''r1."IVL_MO"'''},
	'Acknowledgement' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'acknowledges' : '''bigint''', 'conveyingTransmission' : '''bigint''', 'typeCode' : '''hl7.cv('AcknowledgementType','CNE')''', 'expectedSequenceNumber' : '''integer''', 'messageWaitingNumber' : '''integer''', 'messageWaitingPriorityCode' : '''hl7.cv('MessageWaitingPriority','CNE')'''},
	'AcknowledgementDetail' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'acknowledgement' : '''bigint''', 'typeCode' : '''hl7.cv('AcknowledgementDetailType','CNE')''', 'code' : '''hl7.cv('AcknowledgementDetailCode','CNE')''', 'text' : '''r1."ED"''', 'location' : '''r1."SET_ST"'''},
	'Act' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('ActClass','CNE')''', 'moodCode' : '''hl7.cv('ActMood','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'actionNegationInd' : '''hl7.bl''', 'negationInd' : '''hl7.bl''', 'derivationExpr' : '''r1.st''', 'title' : '''r1."ED"''', 'text' : '''r1."ED"''', 'statusCode' : '''hl7.cv('ActStatus','CNE')''', 'effectiveTime' : '''r1."GTS"''', 'activityTime' : '''r1."GTS"''', 'availabilityTime' : '''hl7.ts''', 'priorityCode' : '''hl7.set('ActPriority')''', 'confidentialityCode' : '''hl7.set('Confidentiality')''', 'repeatNumber' : '''r1.ivl_int''', 'interruptibleInd' : '''hl7.bl''', 'levelCode' : '''hl7.cv('ActContextLevel','CNE')''', 'independentInd' : '''hl7.bl''', 'uncertaintyCode' : '''hl7.cv('ActUncertainty','CNE')''', 'reasonCode' : '''hl7.set('ActReason')''', 'languageCode' : '''hl7.cv('HumanLanguage','CNE')''', 'isCriterionInd' : '''hl7.bl'''},
	'ActRelationship' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'source' : '''bigint''', 'target' : '''bigint''', 'typeCode' : '''hl7.cv('ActRelationshipType','CNE')''', 'inversionInd' : '''hl7.bl''', 'blockedContextActRelationshipType' : '''hl7.set('ActRelationshipType')''', 'blockedContextParticipationType' : '''hl7.set('ParticipationType')''', 'contextControlCode' : '''hl7.cv('ContextControl','CNE')''', 'contextConductionInd' : '''hl7.bl''', 'sequenceNumber' : '''integer''', 'priorityNumber' : '''r1."REAL"''', 'pauseQuantity' : '''hl7.pq''', 'checkpointCode' : '''hl7.cv('ActRelationshipCheckpoint','CNE')''', 'splitCode' : '''hl7.cv('ActRelationshipSplit','CNE')''', 'joinCode' : '''hl7.cv('ActRelationshipJoin','CNE')''', 'negationInd' : '''hl7.bl''', 'conjunctionCode' : '''hl7.cv('RelationshipConjunction','CNE')''', 'localVariableName' : '''r1.st''', 'seperatableInd' : '''hl7.bl''', 'subsetCode' : '''hl7.cv('ActRelationshipSubset','CNE')''', 'uncertaintyCode' : '''hl7.cv('ActUncertainty','CNE')'''},
	'Attachment' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'transmission' : '''bigint''', 'id' : '''r1."II"''', 'text' : '''r1."ED"'''},
	'AttentionLine' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'transmission' : '''bigint''', 'keyWordText' : '''r1."SC"''', 'value' : '''hl7."ANY"'''},
	'Batch' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'batch' : '''bigint''', 'id' : '''r1."II"''', 'creationTime' : '''hl7.ts''', 'securityText' : '''r1.st''', 'responseModeCode' : '''hl7.cv('ResponseMode','CNE')''', 'versionCode' : '''hl7.cv('HL7StandardVersionCode','CNE')''', 'interactionId' : '''r1."II"''', 'profileId' : '''r1."LIST_II"''', 'referenceControlId' : '''r1."II"''', 'name' : '''r1."SC"''', 'batchComment' : '''r1."SET_ST"''', 'transmissionQuantity' : '''integer''', 'batchTotalNumber' : '''r1.set_int''', 'contentProcessingModeCode' : '''hl7.cv('ContentProcessingMode','CNE')'''},
	'CommunicationFunction' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'typeCode' : '''hl7.cv('CommunicationFunctionType','CNE')''', 'telecom' : '''r1."TEL"'''},
	'Container' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('EntityClass','CNE')''', 'determinerCode' : '''hl7.cv('EntityDeterminer','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'quantity' : '''hl7.pq''', 'name' : '''r1."BAG_EN"''', 'desc' : '''r1."ED"''', 'statusCode' : '''hl7.cv('EntityStatus','CNE')''', 'existenceTime' : '''hl7.ivl_ts''', 'telecom' : '''r1."BAG_TEL"''', 'riskCode' : '''hl7.set('EntityRisk')''', 'handlingCode' : '''hl7.set('EntityHandling')''', 'formCode' : '''hl7.cv('MaterialForm','CNE')''', 'lotNumberText' : '''r1.st''', 'expirationTime' : '''hl7.ivl_ts''', 'stabilityTime' : '''hl7.ivl_ts''', 'capacityQuantity' : '''hl7.pq''', 'heightQuantity' : '''hl7.pq''', 'diameterQuantity' : '''hl7.pq''', 'capTypeCode' : '''hl7.cv('ContainerCap','CNE')''', 'separatorTypeCode' : '''hl7.cv('ContainerSeparator','CNE')''', 'barrierDeltaQuantity' : '''hl7.pq''', 'bottomDeltaQuantity' : '''hl7.pq'''},
	'ContextStructure' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('ActClass','CNE')''', 'moodCode' : '''hl7.cv('ActMood','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'actionNegationInd' : '''hl7.bl''', 'negationInd' : '''hl7.bl''', 'derivationExpr' : '''r1.st''', 'title' : '''r1."ED"''', 'text' : '''r1."ED"''', 'statusCode' : '''hl7.cv('ActStatus','CNE')''', 'effectiveTime' : '''r1."GTS"''', 'activityTime' : '''r1."GTS"''', 'availabilityTime' : '''hl7.ts''', 'priorityCode' : '''hl7.set('ActPriority')''', 'confidentialityCode' : '''hl7.set('Confidentiality')''', 'repeatNumber' : '''r1.ivl_int''', 'interruptibleInd' : '''hl7.bl''', 'levelCode' : '''hl7.cv('ActContextLevel','CNE')''', 'independentInd' : '''hl7.bl''', 'uncertaintyCode' : '''hl7.cv('ActUncertainty','CNE')''', 'reasonCode' : '''hl7.set('ActReason')''', 'languageCode' : '''hl7.cv('HumanLanguage','CNE')''', 'isCriterionInd' : '''hl7.bl''', 'setId' : '''r1."II"''', 'versionNumber' : '''r1.st'''},
	'ControlAct' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('ActClass','CNE')''', 'moodCode' : '''hl7.cv('ActMood','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'actionNegationInd' : '''hl7.bl''', 'negationInd' : '''hl7.bl''', 'derivationExpr' : '''r1.st''', 'title' : '''r1."ED"''', 'text' : '''r1."ED"''', 'statusCode' : '''hl7.cv('ActStatus','CNE')''', 'effectiveTime' : '''r1."GTS"''', 'activityTime' : '''r1."GTS"''', 'availabilityTime' : '''hl7.ts''', 'priorityCode' : '''hl7.set('ActPriority')''', 'confidentialityCode' : '''hl7.set('Confidentiality')''', 'repeatNumber' : '''r1.ivl_int''', 'interruptibleInd' : '''hl7.bl''', 'levelCode' : '''hl7.cv('ActContextLevel','CNE')''', 'independentInd' : '''hl7.bl''', 'uncertaintyCode' : '''hl7.cv('ActUncertainty','CNE')''', 'reasonCode' : '''hl7.set('ActReason')''', 'languageCode' : '''hl7.cv('HumanLanguage','CNE')''', 'isCriterionInd' : '''hl7.bl''', 'payload' : '''bigint''', 'queryEvent' : '''bigint'''},
	'Device' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('EntityClass','CNE')''', 'determinerCode' : '''hl7.cv('EntityDeterminer','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'quantity' : '''hl7.pq''', 'name' : '''r1."BAG_EN"''', 'desc' : '''r1."ED"''', 'statusCode' : '''hl7.cv('EntityStatus','CNE')''', 'existenceTime' : '''hl7.ivl_ts''', 'telecom' : '''r1."BAG_TEL"''', 'riskCode' : '''hl7.set('EntityRisk')''', 'handlingCode' : '''hl7.set('EntityHandling')''', 'formCode' : '''hl7.cv('MaterialForm','CNE')''', 'lotNumberText' : '''r1.st''', 'expirationTime' : '''hl7.ivl_ts''', 'stabilityTime' : '''hl7.ivl_ts''', 'manufacturerModelName' : '''r1."SC"''', 'softwareName' : '''r1."SC"''', 'localRemoteControlStateCode' : '''hl7.cv('LocalRemoteControlState','CNE')''', 'alertLevelCode' : '''hl7.cv('DeviceAlertLevel','CNE')''', 'lastCalibrationTime' : '''hl7.ts'''},
	'DeviceTask' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('ActClass','CNE')''', 'moodCode' : '''hl7.cv('ActMood','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'actionNegationInd' : '''hl7.bl''', 'negationInd' : '''hl7.bl''', 'derivationExpr' : '''r1.st''', 'title' : '''r1."ED"''', 'text' : '''r1."ED"''', 'statusCode' : '''hl7.cv('ActStatus','CNE')''', 'effectiveTime' : '''r1."GTS"''', 'activityTime' : '''r1."GTS"''', 'availabilityTime' : '''hl7.ts''', 'priorityCode' : '''hl7.set('ActPriority')''', 'confidentialityCode' : '''hl7.set('Confidentiality')''', 'repeatNumber' : '''r1.ivl_int''', 'interruptibleInd' : '''hl7.bl''', 'levelCode' : '''hl7.cv('ActContextLevel','CNE')''', 'independentInd' : '''hl7.bl''', 'uncertaintyCode' : '''hl7.cv('ActUncertainty','CNE')''', 'reasonCode' : '''hl7.set('ActReason')''', 'languageCode' : '''hl7.cv('HumanLanguage','CNE')''', 'isCriterionInd' : '''hl7.bl''', 'parameterValue' : '''r1."LIST_ANY"'''},
	'DiagnosticImage' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('ActClass','CNE')''', 'moodCode' : '''hl7.cv('ActMood','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'actionNegationInd' : '''hl7.bl''', 'negationInd' : '''hl7.bl''', 'derivationExpr' : '''r1.st''', 'title' : '''r1."ED"''', 'text' : '''r1."ED"''', 'statusCode' : '''hl7.cv('ActStatus','CNE')''', 'effectiveTime' : '''r1."GTS"''', 'activityTime' : '''r1."GTS"''', 'availabilityTime' : '''hl7.ts''', 'priorityCode' : '''hl7.set('ActPriority')''', 'confidentialityCode' : '''hl7.set('Confidentiality')''', 'repeatNumber' : '''r1.ivl_int''', 'interruptibleInd' : '''hl7.bl''', 'levelCode' : '''hl7.cv('ActContextLevel','CNE')''', 'independentInd' : '''hl7.bl''', 'uncertaintyCode' : '''hl7.cv('ActUncertainty','CNE')''', 'reasonCode' : '''hl7.set('ActReason')''', 'languageCode' : '''hl7.cv('HumanLanguage','CNE')''', 'isCriterionInd' : '''hl7.bl''', 'value' : '''hl7."ANY"''', 'valueNegationInd' : '''hl7.bl''', 'interpretationCode' : '''hl7.set('ObservationInterpretation')''', 'methodCode' : '''hl7.set('ObservationMethod')''', 'targetSiteCode' : '''r1."SET_CD"''', 'subjectOrientationCode' : '''hl7.cv('ImagingSubjectOrientation','CNE')'''},
	'Diet' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('ActClass','CNE')''', 'moodCode' : '''hl7.cv('ActMood','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'actionNegationInd' : '''hl7.bl''', 'negationInd' : '''hl7.bl''', 'derivationExpr' : '''r1.st''', 'title' : '''r1."ED"''', 'text' : '''r1."ED"''', 'statusCode' : '''hl7.cv('ActStatus','CNE')''', 'effectiveTime' : '''r1."GTS"''', 'activityTime' : '''r1."GTS"''', 'availabilityTime' : '''hl7.ts''', 'priorityCode' : '''hl7.set('ActPriority')''', 'confidentialityCode' : '''hl7.set('Confidentiality')''', 'repeatNumber' : '''r1.ivl_int''', 'interruptibleInd' : '''hl7.bl''', 'levelCode' : '''hl7.cv('ActContextLevel','CNE')''', 'independentInd' : '''hl7.bl''', 'uncertaintyCode' : '''hl7.cv('ActUncertainty','CNE')''', 'reasonCode' : '''hl7.set('ActReason')''', 'languageCode' : '''hl7.cv('HumanLanguage','CNE')''', 'isCriterionInd' : '''hl7.bl''', 'quantity' : '''hl7.pq''', 'expectedUseTime' : '''hl7.ivl_ts''', 'energyQuantity' : '''hl7.pq''', 'carbohydrateQuantity' : '''hl7.pq'''},
	'Document' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('ActClass','CNE')''', 'moodCode' : '''hl7.cv('ActMood','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'actionNegationInd' : '''hl7.bl''', 'negationInd' : '''hl7.bl''', 'derivationExpr' : '''r1.st''', 'title' : '''r1."ED"''', 'text' : '''r1."ED"''', 'statusCode' : '''hl7.cv('ActStatus','CNE')''', 'effectiveTime' : '''r1."GTS"''', 'activityTime' : '''r1."GTS"''', 'availabilityTime' : '''hl7.ts''', 'priorityCode' : '''hl7.set('ActPriority')''', 'confidentialityCode' : '''hl7.set('Confidentiality')''', 'repeatNumber' : '''r1.ivl_int''', 'interruptibleInd' : '''hl7.bl''', 'levelCode' : '''hl7.cv('ActContextLevel','CNE')''', 'independentInd' : '''hl7.bl''', 'uncertaintyCode' : '''hl7.cv('ActUncertainty','CNE')''', 'reasonCode' : '''hl7.set('ActReason')''', 'languageCode' : '''hl7.cv('HumanLanguage','CNE')''', 'isCriterionInd' : '''hl7.bl''', 'setId' : '''r1."II"''', 'versionNumber' : '''r1.st''', 'completionCode' : '''hl7.cv('DocumentCompletion','CNE')''', 'storageCode' : '''hl7.cv('DocumentStorage','CNE')''', 'copyTime' : '''hl7.ts''', 'bibliographicDesignationText' : '''r1."SET_ED"'''},
	'Employee' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'player' : '''bigint''', 'scoper' : '''bigint''', 'classCode' : '''hl7.cv('RoleClass','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''hl7.cv('RoleCode','CNE')''', 'negationInd' : '''hl7.bl''', 'name' : '''r1."BAG_EN"''', 'addr' : '''r1."BAG_AD"''', 'telecom' : '''r1."BAG_TEL"''', 'statusCode' : '''hl7.cv('RoleStatus','CNE')''', 'effectiveTime' : '''r1."GTS"''', 'certificateText' : '''r1."ED"''', 'confidentialityCode' : '''hl7.set('Confidentiality')''', 'quantity' : '''r1."RTO"''', 'priorityNumber' : '''integer''', 'positionNumber' : '''r1.list_int''', 'jobCode' : '''hl7.cv('EmployeeJob','CNE')''', 'jobTitleName' : '''r1."SC"''', 'jobClassCode' : '''hl7.cv('EmployeeJobClass','CNE')''', 'occupationCode' : '''hl7.cv('EmployeeOccupationCode','CNE')''', 'salaryTypeCode' : '''hl7.cv('EmployeeSalaryType','CNE')''', 'salaryQuantity' : '''r1."MO"''', 'hazardExposureText' : '''r1."ED"''', 'protectiveEquipmentText' : '''r1."ED"'''},
	'Entity' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('EntityClass','CNE')''', 'determinerCode' : '''hl7.cv('EntityDeterminer','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'quantity' : '''hl7.pq''', 'name' : '''r1."BAG_EN"''', 'desc' : '''r1."ED"''', 'statusCode' : '''hl7.cv('EntityStatus','CNE')''', 'existenceTime' : '''hl7.ivl_ts''', 'telecom' : '''r1."BAG_TEL"''', 'riskCode' : '''hl7.set('EntityRisk')''', 'handlingCode' : '''hl7.set('EntityHandling')'''},
	'Entity_CommunicationFunction' : {'entity' : '''bigint''', 'communicationFunction' : '''bigint'''},
	'Exposure' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('ActClass','CNE')''', 'moodCode' : '''hl7.cv('ActMood','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'actionNegationInd' : '''hl7.bl''', 'negationInd' : '''hl7.bl''', 'derivationExpr' : '''r1.st''', 'title' : '''r1."ED"''', 'text' : '''r1."ED"''', 'statusCode' : '''hl7.cv('ActStatus','CNE')''', 'effectiveTime' : '''r1."GTS"''', 'activityTime' : '''r1."GTS"''', 'availabilityTime' : '''hl7.ts''', 'priorityCode' : '''hl7.set('ActPriority')''', 'confidentialityCode' : '''hl7.set('Confidentiality')''', 'repeatNumber' : '''r1.ivl_int''', 'interruptibleInd' : '''hl7.bl''', 'levelCode' : '''hl7.cv('ActContextLevel','CNE')''', 'independentInd' : '''hl7.bl''', 'uncertaintyCode' : '''hl7.cv('ActUncertainty','CNE')''', 'reasonCode' : '''hl7.set('ActReason')''', 'languageCode' : '''hl7.cv('HumanLanguage','CNE')''', 'isCriterionInd' : '''hl7.bl''', 'routeCode' : '''hl7.cv('RouteOfAdministration','CNE')''', 'exposureLevel' : '''hl7.cv('ActExposureLevelCode','CNE')''', 'exposureModeCode' : '''hl7.cv('ExposureMode','CNE')'''},
	'FinancialContract' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('ActClass','CNE')''', 'moodCode' : '''hl7.cv('ActMood','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'actionNegationInd' : '''hl7.bl''', 'negationInd' : '''hl7.bl''', 'derivationExpr' : '''r1.st''', 'title' : '''r1."ED"''', 'text' : '''r1."ED"''', 'statusCode' : '''hl7.cv('ActStatus','CNE')''', 'effectiveTime' : '''r1."GTS"''', 'activityTime' : '''r1."GTS"''', 'availabilityTime' : '''hl7.ts''', 'priorityCode' : '''hl7.set('ActPriority')''', 'confidentialityCode' : '''hl7.set('Confidentiality')''', 'repeatNumber' : '''r1.ivl_int''', 'interruptibleInd' : '''hl7.bl''', 'levelCode' : '''hl7.cv('ActContextLevel','CNE')''', 'independentInd' : '''hl7.bl''', 'uncertaintyCode' : '''hl7.cv('ActUncertainty','CNE')''', 'reasonCode' : '''hl7.set('ActReason')''', 'languageCode' : '''hl7.cv('HumanLanguage','CNE')''', 'isCriterionInd' : '''hl7.bl''', 'paymentTermsCode' : '''hl7.cv('PaymentTerms','CNE')'''},
	'FinancialTransaction' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('ActClass','CNE')''', 'moodCode' : '''hl7.cv('ActMood','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'actionNegationInd' : '''hl7.bl''', 'negationInd' : '''hl7.bl''', 'derivationExpr' : '''r1.st''', 'title' : '''r1."ED"''', 'text' : '''r1."ED"''', 'statusCode' : '''hl7.cv('ActStatus','CNE')''', 'effectiveTime' : '''r1."GTS"''', 'activityTime' : '''r1."GTS"''', 'availabilityTime' : '''hl7.ts''', 'priorityCode' : '''hl7.set('ActPriority')''', 'confidentialityCode' : '''hl7.set('Confidentiality')''', 'repeatNumber' : '''r1.ivl_int''', 'interruptibleInd' : '''hl7.bl''', 'levelCode' : '''hl7.cv('ActContextLevel','CNE')''', 'independentInd' : '''hl7.bl''', 'uncertaintyCode' : '''hl7.cv('ActUncertainty','CNE')''', 'reasonCode' : '''hl7.set('ActReason')''', 'languageCode' : '''hl7.cv('HumanLanguage','CNE')''', 'isCriterionInd' : '''hl7.bl''', 'amt' : '''r1."MO"''', 'creditExchangeRateQuantity' : '''r1."REAL"''', 'debitExchangeRateQuantity' : '''r1."REAL"'''},
	'InfrastructureRoot' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"'''},
	'InvoiceElement' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('ActClass','CNE')''', 'moodCode' : '''hl7.cv('ActMood','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'actionNegationInd' : '''hl7.bl''', 'negationInd' : '''hl7.bl''', 'derivationExpr' : '''r1.st''', 'title' : '''r1."ED"''', 'text' : '''r1."ED"''', 'statusCode' : '''hl7.cv('ActStatus','CNE')''', 'effectiveTime' : '''r1."GTS"''', 'activityTime' : '''r1."GTS"''', 'availabilityTime' : '''hl7.ts''', 'priorityCode' : '''hl7.set('ActPriority')''', 'confidentialityCode' : '''hl7.set('Confidentiality')''', 'repeatNumber' : '''r1.ivl_int''', 'interruptibleInd' : '''hl7.bl''', 'levelCode' : '''hl7.cv('ActContextLevel','CNE')''', 'independentInd' : '''hl7.bl''', 'uncertaintyCode' : '''hl7.cv('ActUncertainty','CNE')''', 'reasonCode' : '''hl7.set('ActReason')''', 'languageCode' : '''hl7.cv('HumanLanguage','CNE')''', 'isCriterionInd' : '''hl7.bl''', 'modifierCode' : '''hl7.set('InvoiceElementModifier')''', 'unitQuantity' : '''r1."RTO"''', 'unitPriceAmt' : '''r1."RTO"''', 'netAmt' : '''r1."MO"''', 'factorNumber' : '''r1."REAL"''', 'pointsNumber' : '''r1."REAL"'''},
	'LanguageCommunication' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'entity' : '''bigint''', 'languageCode' : '''hl7.cv('HumanLanguage','CNE')''', 'modeCode' : '''hl7.cv('LanguageAbilityMode','CNE')''', 'proficiencyLevelCode' : '''hl7.cv('LanguageAbilityProficiency','CNE')''', 'preferenceInd' : '''hl7.bl'''},
	'LicensedEntity' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'player' : '''bigint''', 'scoper' : '''bigint''', 'classCode' : '''hl7.cv('RoleClass','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''hl7.cv('RoleCode','CNE')''', 'negationInd' : '''hl7.bl''', 'name' : '''r1."BAG_EN"''', 'addr' : '''r1."BAG_AD"''', 'telecom' : '''r1."BAG_TEL"''', 'statusCode' : '''hl7.cv('RoleStatus','CNE')''', 'effectiveTime' : '''r1."GTS"''', 'certificateText' : '''r1."ED"''', 'confidentialityCode' : '''hl7.set('Confidentiality')''', 'quantity' : '''r1."RTO"''', 'priorityNumber' : '''integer''', 'positionNumber' : '''r1.list_int''', 'recertificationTime' : '''hl7.ts'''},
	'LivingSubject' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('EntityClass','CNE')''', 'determinerCode' : '''hl7.cv('EntityDeterminer','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'quantity' : '''hl7.pq''', 'name' : '''r1."BAG_EN"''', 'desc' : '''r1."ED"''', 'statusCode' : '''hl7.cv('EntityStatus','CNE')''', 'existenceTime' : '''hl7.ivl_ts''', 'telecom' : '''r1."BAG_TEL"''', 'riskCode' : '''hl7.set('EntityRisk')''', 'handlingCode' : '''hl7.set('EntityHandling')''', 'administrativeGenderCode' : '''hl7.cv('AdministrativeGender','CNE')''', 'birthTime' : '''hl7.ts''', 'deceasedInd' : '''hl7.bl''', 'deceasedTime' : '''hl7.ts''', 'multipleBirthInd' : '''hl7.bl''', 'multipleBirthOrderNumber' : '''integer''', 'organDonorInd' : '''hl7.bl'''},
	'ManagedParticipation' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'act' : '''bigint''', 'role' : '''bigint''', 'typeCode' : '''hl7.cv('ParticipationType','CNE')''', 'functionCode' : '''r1."CD"''', 'contextControlCode' : '''hl7.cv('ContextControl','CNE')''', 'sequenceNumber' : '''integer''', 'priorityNumber' : '''integer''', 'negationInd' : '''hl7.bl''', 'noteText' : '''r1."ED"''', 'time' : '''hl7.ivl_ts''', 'modeCode' : '''hl7.cv('ParticipationMode','CNE')''', 'awarenessCode' : '''hl7.cv('TargetAwareness','CNE')''', 'signatureCode' : '''hl7.cv('ParticipationSignature','CNE')''', 'signatureText' : '''r1."ED"''', 'performInd' : '''hl7.bl''', 'substitutionConditionCode' : '''hl7.cv('SubstitutionCondition','CNE')''', 'subsetCode' : '''hl7.cv('ParticipationSubset','CNE')''', 'quantity' : '''hl7.pq''', 'id' : '''r1."SET_II"''', 'statusCode' : '''hl7.cv('ManagedParticipationStatus','CNE')'''},
	'ManufacturedMaterial' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('EntityClass','CNE')''', 'determinerCode' : '''hl7.cv('EntityDeterminer','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'quantity' : '''hl7.pq''', 'name' : '''r1."BAG_EN"''', 'desc' : '''r1."ED"''', 'statusCode' : '''hl7.cv('EntityStatus','CNE')''', 'existenceTime' : '''hl7.ivl_ts''', 'telecom' : '''r1."BAG_TEL"''', 'riskCode' : '''hl7.set('EntityRisk')''', 'handlingCode' : '''hl7.set('EntityHandling')''', 'formCode' : '''hl7.cv('MaterialForm','CNE')''', 'lotNumberText' : '''r1.st''', 'expirationTime' : '''hl7.ivl_ts''', 'stabilityTime' : '''hl7.ivl_ts'''},
	'Material' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('EntityClass','CNE')''', 'determinerCode' : '''hl7.cv('EntityDeterminer','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'quantity' : '''hl7.pq''', 'name' : '''r1."BAG_EN"''', 'desc' : '''r1."ED"''', 'statusCode' : '''hl7.cv('EntityStatus','CNE')''', 'existenceTime' : '''hl7.ivl_ts''', 'telecom' : '''r1."BAG_TEL"''', 'riskCode' : '''hl7.set('EntityRisk')''', 'handlingCode' : '''hl7.set('EntityHandling')''', 'formCode' : '''hl7.cv('MaterialForm','CNE')'''},
	'Message' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'batch' : '''bigint''', 'id' : '''r1."II"''', 'creationTime' : '''hl7.ts''', 'securityText' : '''r1.st''', 'responseModeCode' : '''hl7.cv('ResponseMode','CNE')''', 'versionCode' : '''hl7.cv('HL7StandardVersionCode','CNE')''', 'interactionId' : '''r1."II"''', 'profileId' : '''r1."LIST_II"''', 'processingCode' : '''hl7.cv('ProcessingID','CNE')''', 'processingModeCode' : '''hl7.cv('ProcessingMode','CNE')''', 'acceptAckCode' : '''hl7.cv('AcknowledgementCondition','CNE')''', 'responseCode' : '''hl7.cv('ResponseLevel','CNE')''', 'sequenceNumber' : '''integer''', 'attachmentText' : '''r1."SET_ED"'''},
	'NonPersonLivingSubject' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('EntityClass','CNE')''', 'determinerCode' : '''hl7.cv('EntityDeterminer','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'quantity' : '''hl7.pq''', 'name' : '''r1."BAG_EN"''', 'desc' : '''r1."ED"''', 'statusCode' : '''hl7.cv('EntityStatus','CNE')''', 'existenceTime' : '''hl7.ivl_ts''', 'telecom' : '''r1."BAG_TEL"''', 'riskCode' : '''hl7.set('EntityRisk')''', 'handlingCode' : '''hl7.set('EntityHandling')''', 'administrativeGenderCode' : '''hl7.cv('AdministrativeGender','CNE')''', 'birthTime' : '''hl7.ts''', 'deceasedInd' : '''hl7.bl''', 'deceasedTime' : '''hl7.ts''', 'multipleBirthInd' : '''hl7.bl''', 'multipleBirthOrderNumber' : '''integer''', 'organDonorInd' : '''hl7.bl''', 'strainText' : '''r1."ED"''', 'genderStatusCode' : '''hl7.cv('GenderStatus','CNE')'''},
	'Observation' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('ActClass','CNE')''', 'moodCode' : '''hl7.cv('ActMood','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'actionNegationInd' : '''hl7.bl''', 'negationInd' : '''hl7.bl''', 'derivationExpr' : '''r1.st''', 'title' : '''r1."ED"''', 'text' : '''r1."ED"''', 'statusCode' : '''hl7.cv('ActStatus','CNE')''', 'effectiveTime' : '''r1."GTS"''', 'activityTime' : '''r1."GTS"''', 'availabilityTime' : '''hl7.ts''', 'priorityCode' : '''hl7.set('ActPriority')''', 'confidentialityCode' : '''hl7.set('Confidentiality')''', 'repeatNumber' : '''r1.ivl_int''', 'interruptibleInd' : '''hl7.bl''', 'levelCode' : '''hl7.cv('ActContextLevel','CNE')''', 'independentInd' : '''hl7.bl''', 'uncertaintyCode' : '''hl7.cv('ActUncertainty','CNE')''', 'reasonCode' : '''hl7.set('ActReason')''', 'languageCode' : '''hl7.cv('HumanLanguage','CNE')''', 'isCriterionInd' : '''hl7.bl''', 'value' : '''hl7."ANY"''', 'valueNegationInd' : '''hl7.bl''', 'interpretationCode' : '''hl7.set('ObservationInterpretation')''', 'methodCode' : '''hl7.set('ObservationMethod')''', 'targetSiteCode' : '''r1."SET_CD"'''},
	'Organization' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('EntityClass','CNE')''', 'determinerCode' : '''hl7.cv('EntityDeterminer','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'quantity' : '''hl7.pq''', 'name' : '''r1."BAG_EN"''', 'desc' : '''r1."ED"''', 'statusCode' : '''hl7.cv('EntityStatus','CNE')''', 'existenceTime' : '''hl7.ivl_ts''', 'telecom' : '''r1."BAG_TEL"''', 'riskCode' : '''hl7.set('EntityRisk')''', 'handlingCode' : '''hl7.set('EntityHandling')''', 'addr' : '''r1."BAG_AD"''', 'standardIndustryClassCode' : '''hl7.cv('OrganizationIndustryClass','CNE')'''},
	'Parameter' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'queryByParameter' : '''bigint''', 'parameterList' : '''bigint''', 'id' : '''r1."II"'''},
	'ParameterItem' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'queryByParameter' : '''bigint''', 'parameterList' : '''bigint''', 'id' : '''r1."II"''', 'value' : '''hl7."ANY"''', 'semanticsText' : '''r1.st'''},
	'ParameterList' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'queryByParameter' : '''bigint''', 'parameterList' : '''bigint''', 'id' : '''r1."II"'''},
	'Participation' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'act' : '''bigint''', 'role' : '''bigint''', 'typeCode' : '''hl7.cv('ParticipationType','CNE')''', 'functionCode' : '''r1."CD"''', 'contextControlCode' : '''hl7.cv('ContextControl','CNE')''', 'sequenceNumber' : '''integer''', 'priorityNumber' : '''integer''', 'negationInd' : '''hl7.bl''', 'noteText' : '''r1."ED"''', 'time' : '''hl7.ivl_ts''', 'modeCode' : '''hl7.cv('ParticipationMode','CNE')''', 'awarenessCode' : '''hl7.cv('TargetAwareness','CNE')''', 'signatureCode' : '''hl7.cv('ParticipationSignature','CNE')''', 'signatureText' : '''r1."ED"''', 'performInd' : '''hl7.bl''', 'substitutionConditionCode' : '''hl7.cv('SubstitutionCondition','CNE')''', 'subsetCode' : '''hl7.cv('ParticipationSubset','CNE')''', 'quantity' : '''hl7.pq'''},
	'Patient' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'player' : '''bigint''', 'scoper' : '''bigint''', 'classCode' : '''hl7.cv('RoleClass','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''hl7.cv('RoleCode','CNE')''', 'negationInd' : '''hl7.bl''', 'name' : '''r1."BAG_EN"''', 'addr' : '''r1."BAG_AD"''', 'telecom' : '''r1."BAG_TEL"''', 'statusCode' : '''hl7.cv('RoleStatus','CNE')''', 'effectiveTime' : '''r1."GTS"''', 'certificateText' : '''r1."ED"''', 'confidentialityCode' : '''hl7.set('Confidentiality')''', 'quantity' : '''r1."RTO"''', 'priorityNumber' : '''integer''', 'positionNumber' : '''r1.list_int''', 'veryImportantPersonCode' : '''hl7.cv('PatientImportance','CNE')'''},
	'PatientEncounter' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('ActClass','CNE')''', 'moodCode' : '''hl7.cv('ActMood','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'actionNegationInd' : '''hl7.bl''', 'negationInd' : '''hl7.bl''', 'derivationExpr' : '''r1.st''', 'title' : '''r1."ED"''', 'text' : '''r1."ED"''', 'statusCode' : '''hl7.cv('ActStatus','CNE')''', 'effectiveTime' : '''r1."GTS"''', 'activityTime' : '''r1."GTS"''', 'availabilityTime' : '''hl7.ts''', 'priorityCode' : '''hl7.set('ActPriority')''', 'confidentialityCode' : '''hl7.set('Confidentiality')''', 'repeatNumber' : '''r1.ivl_int''', 'interruptibleInd' : '''hl7.bl''', 'levelCode' : '''hl7.cv('ActContextLevel','CNE')''', 'independentInd' : '''hl7.bl''', 'uncertaintyCode' : '''hl7.cv('ActUncertainty','CNE')''', 'reasonCode' : '''hl7.set('ActReason')''', 'languageCode' : '''hl7.cv('HumanLanguage','CNE')''', 'isCriterionInd' : '''hl7.bl''', 'admissionReferralSourceCode' : '''hl7.cv('EncounterReferralSource','CNE')''', 'lengthOfStayQuantity' : '''hl7.pq''', 'dischargeDispositionCode' : '''hl7.cv('EncounterDischargeDisposition','CNE')''', 'acuityLevelCode' : '''hl7.cv('EncounterAcuity','CNE')''', 'preAdmitTestInd' : '''hl7.bl''', 'specialCourtesiesCode' : '''hl7.set('EncounterSpecialCourtesy')''', 'specialArrangementCode' : '''hl7.set('SpecialArrangement')'''},
	'Person' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('EntityClass','CNE')''', 'determinerCode' : '''hl7.cv('EntityDeterminer','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'quantity' : '''hl7.pq''', 'name' : '''r1."BAG_EN"''', 'desc' : '''r1."ED"''', 'statusCode' : '''hl7.cv('EntityStatus','CNE')''', 'existenceTime' : '''hl7.ivl_ts''', 'telecom' : '''r1."BAG_TEL"''', 'riskCode' : '''hl7.set('EntityRisk')''', 'handlingCode' : '''hl7.set('EntityHandling')''', 'administrativeGenderCode' : '''hl7.cv('AdministrativeGender','CNE')''', 'birthTime' : '''hl7.ts''', 'deceasedInd' : '''hl7.bl''', 'deceasedTime' : '''hl7.ts''', 'multipleBirthInd' : '''hl7.bl''', 'multipleBirthOrderNumber' : '''integer''', 'organDonorInd' : '''hl7.bl''', 'addr' : '''r1."BAG_AD"''', 'maritalStatusCode' : '''hl7.cv('MaritalStatus','CNE')''', 'educationLevelCode' : '''hl7.cv('EducationLevel','CNE')''', 'disabilityCode' : '''hl7.set('PersonDisabilityType')''', 'livingArrangementCode' : '''hl7.cv('LivingArrangement','CNE')''', 'religiousAffiliationCode' : '''hl7.cv('ReligiousAffiliation','CNE')''', 'raceCode' : '''hl7.set('Race')''', 'ethnicGroupCode' : '''hl7.set('Ethnicity')'''},
	'Place' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('EntityClass','CNE')''', 'determinerCode' : '''hl7.cv('EntityDeterminer','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'quantity' : '''hl7.pq''', 'name' : '''r1."BAG_EN"''', 'desc' : '''r1."ED"''', 'statusCode' : '''hl7.cv('EntityStatus','CNE')''', 'existenceTime' : '''hl7.ivl_ts''', 'telecom' : '''r1."BAG_TEL"''', 'riskCode' : '''hl7.set('EntityRisk')''', 'handlingCode' : '''hl7.set('EntityHandling')''', 'mobileInd' : '''hl7.bl''', 'addr' : '''r1."AD"''', 'directionsText' : '''r1."ED"''', 'positionText' : '''r1."ED"''', 'gpsText' : '''r1.st'''},
	'Procedure' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('ActClass','CNE')''', 'moodCode' : '''hl7.cv('ActMood','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'actionNegationInd' : '''hl7.bl''', 'negationInd' : '''hl7.bl''', 'derivationExpr' : '''r1.st''', 'title' : '''r1."ED"''', 'text' : '''r1."ED"''', 'statusCode' : '''hl7.cv('ActStatus','CNE')''', 'effectiveTime' : '''r1."GTS"''', 'activityTime' : '''r1."GTS"''', 'availabilityTime' : '''hl7.ts''', 'priorityCode' : '''hl7.set('ActPriority')''', 'confidentialityCode' : '''hl7.set('Confidentiality')''', 'repeatNumber' : '''r1.ivl_int''', 'interruptibleInd' : '''hl7.bl''', 'levelCode' : '''hl7.cv('ActContextLevel','CNE')''', 'independentInd' : '''hl7.bl''', 'uncertaintyCode' : '''hl7.cv('ActUncertainty','CNE')''', 'reasonCode' : '''hl7.set('ActReason')''', 'languageCode' : '''hl7.cv('HumanLanguage','CNE')''', 'isCriterionInd' : '''hl7.bl''', 'methodCode' : '''r1."SET_CD"''', 'approachSiteCode' : '''r1."SET_CD"''', 'targetSiteCode' : '''r1."SET_CD"'''},
	'PublicHealthCase' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('ActClass','CNE')''', 'moodCode' : '''hl7.cv('ActMood','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'actionNegationInd' : '''hl7.bl''', 'negationInd' : '''hl7.bl''', 'derivationExpr' : '''r1.st''', 'title' : '''r1."ED"''', 'text' : '''r1."ED"''', 'statusCode' : '''hl7.cv('ActStatus','CNE')''', 'effectiveTime' : '''r1."GTS"''', 'activityTime' : '''r1."GTS"''', 'availabilityTime' : '''hl7.ts''', 'priorityCode' : '''hl7.set('ActPriority')''', 'confidentialityCode' : '''hl7.set('Confidentiality')''', 'repeatNumber' : '''r1.ivl_int''', 'interruptibleInd' : '''hl7.bl''', 'levelCode' : '''hl7.cv('ActContextLevel','CNE')''', 'independentInd' : '''hl7.bl''', 'uncertaintyCode' : '''hl7.cv('ActUncertainty','CNE')''', 'reasonCode' : '''hl7.set('ActReason')''', 'languageCode' : '''hl7.cv('HumanLanguage','CNE')''', 'isCriterionInd' : '''hl7.bl''', 'value' : '''hl7."ANY"''', 'valueNegationInd' : '''hl7.bl''', 'interpretationCode' : '''hl7.set('ObservationInterpretation')''', 'methodCode' : '''hl7.set('ObservationMethod')''', 'targetSiteCode' : '''r1."SET_CD"''', 'detectionMethodCode' : '''hl7.cv('CaseDetectionMethod','CNE')''', 'transmissionModeCode' : '''hl7.cv('CaseTransmissionMode','CNE')''', 'diseaseImportedCode' : '''hl7.cv('CaseDiseaseImported','CNE')'''},
	'QualifiedEntity' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'player' : '''bigint''', 'scoper' : '''bigint''', 'classCode' : '''hl7.cv('RoleClass','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''hl7.cv('RoleCode','CNE')''', 'negationInd' : '''hl7.bl''', 'name' : '''r1."BAG_EN"''', 'addr' : '''r1."BAG_AD"''', 'telecom' : '''r1."BAG_TEL"''', 'statusCode' : '''hl7.cv('RoleStatus','CNE')''', 'effectiveTime' : '''r1."GTS"''', 'certificateText' : '''r1."ED"''', 'confidentialityCode' : '''hl7.set('Confidentiality')''', 'quantity' : '''r1."RTO"''', 'priorityNumber' : '''integer''', 'positionNumber' : '''r1.list_int''', 'equivalenceInd' : '''hl7.bl'''},
	'QueryAck' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'controlAct' : '''bigint''', 'queryId' : '''r1."II"''', 'statusCode' : '''hl7.cv('QueryStatusCode','CNE')''', 'queryResponseCode' : '''hl7.cv('QueryResponse','CNE')''', 'resultTotalQuantity' : '''integer''', 'resultCurrentQuantity' : '''integer''', 'resultRemainingQuantity' : '''integer''', 'continuationToken' : '''r1.st'''},
	'QueryByParameter' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'controlAct' : '''bigint''', 'queryId' : '''r1."II"''', 'statusCode' : '''hl7.cv('QueryStatusCode','CNE')''', 'modifyCode' : '''hl7.cv('ModifyIndicator','CNE')''', 'responseElementGroupId' : '''r1."SET_II"''', 'responseModalityCode' : '''hl7.cv('ResponseModality','CNE')''', 'responsePriorityCode' : '''hl7.cv('QueryPriority','CNE')''', 'initialQuantity' : '''integer''', 'initialQuantityCode' : '''hl7.cv('QueryRequestLimit','CNE')''', 'executionAndDeliveryTime' : '''hl7.ts'''},
	'QueryContinuation' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'controlAct' : '''bigint''', 'queryId' : '''r1."II"''', 'statusCode' : '''hl7.cv('QueryStatusCode','CNE')''', 'startResultNumber' : '''integer''', 'continuationQuantity' : '''integer''', 'continuationToken' : '''r1.st'''},
	'QueryEvent' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'controlAct' : '''bigint''', 'queryId' : '''r1."II"''', 'statusCode' : '''hl7.cv('QueryStatusCode','CNE')'''},
	'QuerySpec' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'controlAct' : '''bigint''', 'queryId' : '''r1."II"''', 'statusCode' : '''hl7.cv('QueryStatusCode','CNE')''', 'modifyCode' : '''hl7.cv('ModifyIndicator','CNE')''', 'responseElementGroupId' : '''r1."SET_II"''', 'responseModalityCode' : '''hl7.cv('ResponseModality','CNE')''', 'responsePriorityCode' : '''hl7.cv('QueryPriority','CNE')''', 'initialQuantity' : '''integer''', 'initialQuantityCode' : '''hl7.cv('QueryRequestLimit','CNE')''', 'executionAndDeliveryTime' : '''hl7.ts'''},
	'Role' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'player' : '''bigint''', 'scoper' : '''bigint''', 'classCode' : '''hl7.cv('RoleClass','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''hl7.cv('RoleCode','CNE')''', 'negationInd' : '''hl7.bl''', 'name' : '''r1."BAG_EN"''', 'addr' : '''r1."BAG_AD"''', 'telecom' : '''r1."BAG_TEL"''', 'statusCode' : '''hl7.cv('RoleStatus','CNE')''', 'effectiveTime' : '''r1."GTS"''', 'certificateText' : '''r1."ED"''', 'confidentialityCode' : '''hl7.set('Confidentiality')''', 'quantity' : '''r1."RTO"''', 'priorityNumber' : '''integer''', 'positionNumber' : '''r1.list_int'''},
	'RoleLink' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'source' : '''bigint''', 'target' : '''bigint''', 'typeCode' : '''hl7.cv('RoleLinkType','CNE')''', 'priorityNumber' : '''integer''', 'effectiveTime' : '''hl7.ivl_ts'''},
	'SortControl' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'querySpec' : '''bigint''', 'sequenceNumber' : '''integer''', 'elementName' : '''r1."SC"''', 'directionCode' : '''hl7.cv('Sequencing','CNE')'''},
	'SubstanceAdministration' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('ActClass','CNE')''', 'moodCode' : '''hl7.cv('ActMood','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'actionNegationInd' : '''hl7.bl''', 'negationInd' : '''hl7.bl''', 'derivationExpr' : '''r1.st''', 'title' : '''r1."ED"''', 'text' : '''r1."ED"''', 'statusCode' : '''hl7.cv('ActStatus','CNE')''', 'effectiveTime' : '''r1."GTS"''', 'activityTime' : '''r1."GTS"''', 'availabilityTime' : '''hl7.ts''', 'priorityCode' : '''hl7.set('ActPriority')''', 'confidentialityCode' : '''hl7.set('Confidentiality')''', 'repeatNumber' : '''r1.ivl_int''', 'interruptibleInd' : '''hl7.bl''', 'levelCode' : '''hl7.cv('ActContextLevel','CNE')''', 'independentInd' : '''hl7.bl''', 'uncertaintyCode' : '''hl7.cv('ActUncertainty','CNE')''', 'reasonCode' : '''hl7.set('ActReason')''', 'languageCode' : '''hl7.cv('HumanLanguage','CNE')''', 'isCriterionInd' : '''hl7.bl''', 'methodCode' : '''r1."SET_CD"''', 'approachSiteCode' : '''r1."SET_CD"''', 'targetSiteCode' : '''r1."SET_CD"''', 'routeCode' : '''hl7.cv('RouteOfAdministration','CNE')''', 'doseQuantity' : '''hl7.ivl_pq''', 'rateQuantity' : '''hl7.ivl_pq''', 'doseCheckQuantity' : '''r1."SET_RTO"''', 'maxDoseQuantity' : '''r1."SET_RTO"''', 'administrationUnitCode' : '''hl7.cv('AdministrableDrugForm','CNE')'''},
	'Supply' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('ActClass','CNE')''', 'moodCode' : '''hl7.cv('ActMood','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'actionNegationInd' : '''hl7.bl''', 'negationInd' : '''hl7.bl''', 'derivationExpr' : '''r1.st''', 'title' : '''r1."ED"''', 'text' : '''r1."ED"''', 'statusCode' : '''hl7.cv('ActStatus','CNE')''', 'effectiveTime' : '''r1."GTS"''', 'activityTime' : '''r1."GTS"''', 'availabilityTime' : '''hl7.ts''', 'priorityCode' : '''hl7.set('ActPriority')''', 'confidentialityCode' : '''hl7.set('Confidentiality')''', 'repeatNumber' : '''r1.ivl_int''', 'interruptibleInd' : '''hl7.bl''', 'levelCode' : '''hl7.cv('ActContextLevel','CNE')''', 'independentInd' : '''hl7.bl''', 'uncertaintyCode' : '''hl7.cv('ActUncertainty','CNE')''', 'reasonCode' : '''hl7.set('ActReason')''', 'languageCode' : '''hl7.cv('HumanLanguage','CNE')''', 'isCriterionInd' : '''hl7.bl''', 'quantity' : '''hl7.pq''', 'expectedUseTime' : '''hl7.ivl_ts'''},
	'Transmission' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'batch' : '''bigint''', 'id' : '''r1."II"''', 'creationTime' : '''hl7.ts''', 'securityText' : '''r1.st''', 'responseModeCode' : '''hl7.cv('ResponseMode','CNE')''', 'versionCode' : '''hl7.cv('HL7StandardVersionCode','CNE')''', 'interactionId' : '''r1."II"''', 'profileId' : '''r1."LIST_II"'''},
	'TransmissionRelationship' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'source' : '''bigint''', 'target' : '''bigint''', 'typeCode' : '''hl7.cv('TransmissionRelationshipType','CNE')'''},
	'Transmission_CommunicationFunction' : {'transmission' : '''bigint''', 'communicationFunction' : '''bigint'''},
	'WorkingList' : {'_id' : '''bigint''', '_mif' : '''text''', '_clonename' : '''text''', 'nullFlavor' : '''hl7.cv('NullFlavor','CNE')''', 'realmCode' : '''hl7.set('Realm')''', 'typeId' : '''r1."II"''', 'templateId' : '''r1."LIST_II"''', 'classCode' : '''hl7.cv('ActClass','CNE')''', 'moodCode' : '''hl7.cv('ActMood','CNE')''', 'id' : '''r1."SET_II"''', 'code' : '''r1."CD"''', 'actionNegationInd' : '''hl7.bl''', 'negationInd' : '''hl7.bl''', 'derivationExpr' : '''r1.st''', 'title' : '''r1."ED"''', 'text' : '''r1."ED"''', 'statusCode' : '''hl7.cv('ActStatus','CNE')''', 'effectiveTime' : '''r1."GTS"''', 'activityTime' : '''r1."GTS"''', 'availabilityTime' : '''hl7.ts''', 'priorityCode' : '''hl7.set('ActPriority')''', 'confidentialityCode' : '''hl7.set('Confidentiality')''', 'repeatNumber' : '''r1.ivl_int''', 'interruptibleInd' : '''hl7.bl''', 'levelCode' : '''hl7.cv('ActContextLevel','CNE')''', 'independentInd' : '''hl7.bl''', 'uncertaintyCode' : '''hl7.cv('ActUncertainty','CNE')''', 'reasonCode' : '''hl7.set('ActReason')''', 'languageCode' : '''hl7.cv('HumanLanguage','CNE')''', 'isCriterionInd' : '''hl7.bl''', 'ownershipLevelCode' : '''hl7.cv('ListOwnershipLevel','CNE')'''},
}

bridges = {
'CommunicationFunction' : ['Entity_CommunicationFunction', 'Transmission_CommunicationFunction'],
'Entity' : ['Entity_CommunicationFunction'],
'Transmission' : ['Transmission_CommunicationFunction'],
}

